    //
//  TwitterSplitViewController.m
//  app_builder
//
//  Created by ivan bejarano on 8/18/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "TwitterSplitViewController.h"
#import "TwitterViewController.h"
#import "TwitterDetailViewController.h"
#import "SilSplitViewController.h"
#import "Config.h"
#import "Functions.h"
#import "SA_OAuthTwitterEngine.h"
#import <QuartzCore/QuartzCore.h>

@implementation TwitterSplitViewController

@synthesize kAppId, kOAuthConsumerKey, kOAuthConsumerSecret;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;

/*		[[NSNotificationCenter defaultCenter] addObserver:self
												 selector:@selector(willRotate:)
													 name:UIApplicationWillChangeStatusBarOrientationNotification object:nil];
		[[NSNotificationCenter defaultCenter] addObserver:self
												 selector:@selector(didRotate:)
													 name:UIApplicationDidChangeStatusBarOrientationNotification object:nil];	
*/

    	TwitterViewController *root = [[[TwitterViewController alloc] 
									 initWithData:infoData
									 nibName:@"TwitterViewController" bundle:[NSBundle mainBundle]] autorelease];
		// root.view.tag = 17001;
		TwitterViewController *pop = [[[TwitterViewController alloc] 
									initWithData:infoData
									nibName:@"TwitterViewController" bundle:[NSBundle mainBundle]] autorelease];
		// TwitterDetailViewController *detail = [[[TwitterDetailViewController alloc] init] autorelease]; 
		// detail.view.tag = 17002;
		TwitterDetailViewController *detail = [[[TwitterDetailViewController alloc] 
                                                initWithData:infoData
                                                nibName:@"TwitterDetailViewController" bundle:[NSBundle mainBundle]] autorelease];
		
		SilSplitViewController * splitViewController = self; // [[SilSplitViewController alloc] initwithLeftVC:root rightVC:detail];
		splitViewController.leftController = root;
		splitViewController.rightController = detail;
		root.delegate = detail;
		pop.delegate = detail;
		detail.twitterViewController = pop;
		// detail.parentView = splitViewController;
		[root setParent:splitViewController];
    }
    return self;
}

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
    SilSplitViewController * splitViewController = self; // [[SilSplitViewController alloc] initwithLeftVC:root rightVC:detail];
    [splitViewController viewWillAppear:YES];
    [splitViewController viewDidAppear:YES];

	/*
     UISplitViewController * splitViewController = self; // [[UISplitViewController alloc] init];
	
	TwitterViewController *root = [[[TwitterViewController alloc] 
									initWithData:infoData
									nibName:@"TwitterViewController" bundle:[NSBundle mainBundle]] autorelease];
	TwitterViewController *pop = [[[TwitterViewController alloc] 
									initWithData:infoData
									nibName:@"TwitterViewController" bundle:[NSBundle mainBundle]] autorelease];
	TwitterDetailViewController *detail = [[[TwitterDetailViewController alloc] 
									initWithData:infoData
									nibName:@"TwitterDetailViewController" bundle:[NSBundle mainBundle]] autorelease];
	// TwitterDetailViewController *detail = [[[TwitterDetailViewController alloc] init] autorelease]; 
	root.delegate = detail;
	pop.delegate = detail;
	
	splitViewController.viewControllers = [NSArray arrayWithObjects:root, detail, nil];
	splitViewController.delegate = detail;
	detail.twitterViewController = pop;
	
	splitViewController.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	root.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	detail.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	
	splitViewController.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
	
	// [self.view addSubview:splitViewController.view];
    */
	
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
    return YES;
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	@try {
		[[NSNotificationCenter defaultCenter] removeObserver:self];
	}
	@catch (NSException * e) {
		NSLog(@"IntelligentSplitViewController DE-OBSERVING CRASHED: %@ ... error:%@", self.title, [e description]);
	}
    [super dealloc];
}

- (void)awakeFromNib {
	[super awakeFromNib];
	//debug_NSLog(@"IntelligentSplitViewController awaking from a NIB: %@", self.title);
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(willRotate:)
												 name:UIApplicationWillChangeStatusBarOrientationNotification object:nil];
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(didRotate:)
												 name:UIApplicationDidChangeStatusBarOrientationNotification object:nil];	
	
}


- (void)willRotate:(id)sender {
	
    /*
     if (![self isViewLoaded]) // we haven't even loaded up yet, let's turn away from this place
		return;
	
	NSNotification *notification = sender;
	if (!notification)
		return;
	
	UIInterfaceOrientation toOrientation = [[notification.userInfo valueForKey:UIApplicationStatusBarOrientationUserInfoKey] integerValue];
	//UIInterfaceOrientation fromOrientation = [UIApplication sharedApplication].statusBarOrientation;
	
	UITabBarController *tabBar = self.tabBarController;
	BOOL notModal = (!tabBar.modalViewController);
	BOOL isSelectedTab = [self.tabBarController.selectedViewController isEqual:self];
	
	NSTimeInterval duration = [[UIApplication sharedApplication] statusBarOrientationAnimationDuration];
	
	
	if (!isSelectedTab || !notModal)  { 
		// Looks like we're not "visible" ... propogate rotation info
		[super willRotateToInterfaceOrientation:toOrientation duration:duration];
		
		UIViewController *master = [self.viewControllers objectAtIndex:0];
		NSObject *theDelegate = (NSObject *)self.delegate;
		
		
#define YOU_DONT_FEEL_QUEAZY_ABOUT_THIS_BECAUSE_IT_PASSES_THE_APP_STORE 1		
		
#if YOU_DONT_FEEL_QUEAZY_ABOUT_THIS_BECAUSE_IT_PASSES_THE_APP_STORE
		UIBarButtonItem *button = [super valueForKey:@"_barButtonItem"];
		
#else //YOU_DO_FEEL_QUEAZY_AND_FOR_SOME_REASON_YOU_PREFER_THE_LESSER_EVIL_____FRIGHTENING_STUFF
		UIBarButtonItem *button = [[[[[self.viewControllers objectAtIndex:1] 
									  viewControllers] objectAtIndex:0] 
									navigationItem] rightBarButtonItem];
#endif
		
		if (UIInterfaceOrientationIsPortrait(toOrientation)) {
			if (theDelegate && [theDelegate respondsToSelector:@selector(splitViewController:willHideViewController:withBarButtonItem:forPopoverController:)]) {
				
				@try {
					UIPopoverController *popover = [super valueForKey:@"_hiddenPopoverController"];
					objc_msgSend(theDelegate, @selector(splitViewController:willHideViewController:withBarButtonItem:forPopoverController:), self, master, button, popover);
				}
				@catch (NSException * e) {
					NSLog(@"There was a nasty error while notifyng splitviewcontrollers of an orientation change: %@", [e description]);
				}
			}
		}
		else if (UIInterfaceOrientationIsLandscape(toOrientation)) {
			if (theDelegate && [theDelegate respondsToSelector:@selector(splitViewController:willShowViewController:invalidatingBarButtonItem:)]) {
				@try {
					objc_msgSend(theDelegate, @selector(splitViewController:willShowViewController:invalidatingBarButtonItem:), self, master, button);
				}
				@catch (NSException * e) {
					NSLog(@"There was a nasty error while notifyng splitviewcontrollers of an orientation change: %@", [e description]);
				}
			}
		}
	}
	
	NSLog(@"MINE WillRotate ---- sender = %@  to = %d   from = %d", [sender class], toOrientation, toOrientation );
     */
}

/*
 - (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration {
 [super willRotateToInterfaceOrientation:toInterfaceOrientation duration:duration];
 //debug_NSLog(@"Theirs --- will rotate");
 }
 */

- (void)didRotate:(id)sender {
	if (![self isViewLoaded]) // we haven't even loaded up yet, let's turn away from this place
		return;
	
	NSNotification *notification = sender;
	if (!notification)
		return;
	UIInterfaceOrientation fromOrientation = [[notification.userInfo valueForKey:UIApplicationStatusBarOrientationUserInfoKey] integerValue];
	//UIInterfaceOrientation toOrientation = [UIApplication sharedApplication].statusBarOrientation;
	
	UITabBarController *tabBar = self.tabBarController;
	BOOL notModal = (!tabBar.modalViewController);
	BOOL isSelectedTab = [self.tabBarController.selectedViewController isEqual:self];
	
	if (!isSelectedTab || !notModal)  { 
		// Looks like we're not "visible" ... propogate rotation info
		[super didRotateFromInterfaceOrientation:fromOrientation];
	}
	
	NSLog(@"MINE DidRotate ---- sender = %@  from = %d   to = %d", [sender class], fromOrientation, fromOrientation );
}

/*
 - (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
 [super didRotateFromInterfaceOrientation:fromInterfaceOrientation];
 //debug_NSLog(@"Theirs --- did rotate");
 }
 */

# pragma mark -

#pragma mark twt

// twitter
-(void) goTwt
{
	
	Config *cnf = [[Config alloc] init];
	// kOAuthConsumerKey = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_key"]];
	// kOAuthConsumerSecret = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_secret"]];
	kOAuthConsumerKey = [cnf loadValue:@"twitter_consumer_key"];
	kOAuthConsumerSecret = [cnf loadValue:@"twitter_consumer_secret"];
	[cnf release];
	
	NSLog(@"t2:  %@ %@", kOAuthConsumerKey, kOAuthConsumerSecret);
	
	// if (_engine) return;
	_engine = [[SA_OAuthTwitterEngine alloc] initOAuthWithDelegate: self];
	_engine.consumerKey = kOAuthConsumerKey;
	_engine.consumerSecret = kOAuthConsumerSecret;
	
	UIViewController *controller = [SA_OAuthTwitterController controllerToEnterCredentialsWithTwitterEngine: _engine delegate: self];
	
	if (controller) 
    {
		[self presentModalViewController: controller animated: YES];
    }
	else {
		// snd update
		[self createTwitterView];
	}
}

-(void) closeTwitter {
	if (twitterView != nil) {
		[twitterView removeFromSuperview];
		twitterView = nil;
	} 
}

-(IBAction) sendTwitter: (id) sender {
	NSString *message = [NSString stringWithFormat:@"%@", twitterMessageText.text];
	
	
	NSLog(@"send %@", message);
	[_engine sendUpdate: message];
}

-(void) createTwitterView {
	twitterView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 370)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
    twitterView.frame = CGRectMake(0, 50, self.view.frame.size.width, self.view.frame.size.height-90);
    twitterView.autoresizesSubviews = YES;
	twitterView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	// [twitterView setBackgroundColor:[Functions colorForHex:@"#9AE4E8"]];
	
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	[button addTarget:self action:@selector(closeTwitter) forControlEvents:UIControlEventTouchUpInside];
	// btnImage = [UIImage alloc];
	button.frame = CGRectMake(300, 5, 20, 20);
	UIImage * btnImage = [UIImage imageNamed:@"close.png"];
	button.backgroundColor = [UIColor clearColor];
	[button setImage:btnImage forState:UIControlStateNormal];
	[twitterView addSubview:button];
	
	twitterMessageText = [[UITextView alloc] initWithFrame:CGRectMake(10,30,300,80)];
	// twitterMessageText.delegate = self;
	// twitterMessageText.text = [NSString stringWithFormat:@"%@ : %@ - %@", 
	//						   twitterDescription, twitterTitle, twitterLink];
	twitterMessageText.layer.cornerRadius = 5;
	//twitterMessageText.clipsToBounds = YES;
	//twitterMessageText.layer.masksToBounds = YES;
	twitterMessageText.layer.borderColor = [[UIColor blackColor] CGColor];
	twitterMessageText.layer.borderWidth = 1.0f;
	
	UIButton   * updateButton;
	updateButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[updateButton setFrame:CGRectMake(10,130,60,30)];
	[updateButton setTitle:@"Update" forState:UIControlStateNormal];
	updateButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[updateButton addTarget:self action:@selector(sendTwitter:) forControlEvents:UIControlEventTouchUpInside];
	
	[twitterView addSubview:twitterMessageText];
	[twitterView addSubview:updateButton];
	
	[self.view addSubview:twitterView];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterEngineDelegate
- (void) storeCachedTwitterOAuthData: (NSString *) data forUsername: (NSString *) username {
	NSUserDefaults			*defaults = [NSUserDefaults standardUserDefaults];
	
	[defaults setObject: data forKey: @"authData"];
	[defaults synchronize];
}

- (NSString *) cachedTwitterOAuthDataForUsername: (NSString *) username {
	return [[NSUserDefaults standardUserDefaults] objectForKey: @"authData"];
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterControllerDelegate
- (void) OAuthTwitterController: (SA_OAuthTwitterController *) controller authenticatedWithUsername: (NSString *) username {
	NSLog(@"Authenicated for %@", username);
    // snd update
	[self performSelector:@selector(createTwitterView) withObject:nil afterDelay:0.5];
}

- (void) OAuthTwitterControllerFailed: (SA_OAuthTwitterController *) controller {
	NSLog(@"Authentication Failed!");
}

- (void) OAuthTwitterControllerCanceled: (SA_OAuthTwitterController *) controller {
	NSLog(@"Authentication Canceled.");
}

//=============================================================================================================================
#pragma mark TwitterEngineDelegate
- (void) requestSucceeded: (NSString *) requestIdentifier {
	NSLog(@"Request %@ succeeded", requestIdentifier);
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle:@"Information sent."
						  message:nil
						  delegate:nil
						  cancelButtonTitle:nil
						  otherButtonTitles:@"OK", nil];
	[alert show];
    [alert release];
	[self closeTwitter];
    TwitterViewController * root = (TwitterViewController *)self.leftController;
    [root goDownload];
}

# pragma mark -


@end
