    //
//  app_builderViewController-iPad.m
//  app_builder
//
//  Created by ivan bejarano on 7/18/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "app_builderViewController-iPad.h"
#import "SplashViewController.h"
#import "MenuViewController.h"
#import "GalleryViewController.h"
#import "ListViewController.h"
#import "PollViewController.h"
#import "PollResultsViewController.h"
#import "TabBarViewController.h"
#import "DetailViewController.h"
#import "VideoViewController.h"
#import "WebViewController.h"
#import "AboutViewController.h"
#import "MapViewController.h"
#import "ConfigViewController.h"
#import "AddressViewController.h"
#import "LoginViewController.h"
#import "Config.h"

@implementation app_builderViewController_iPad

 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
#if (__IPHONE_OS_VERSION_MAX_ALLOWED >= 30200)
	
	/*
	 NSString *str;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        str = [NSString stringWithString:@"Running as an iPad application"];
    } else {
        str = [NSString stringWithString:
			   @"Running as an iPhone/iPod touch application"];
    }
	
    UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Platform"
                                                    message:str
                                                   delegate:nil
                                          cancelButtonTitle:@"OK" 
                                          otherButtonTitles:nil];
    [alert show];
    [alert release]; */    
	
#endif    
    [super viewDidLoad];

	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(displayView2:) name:@"onDisplayView" object:nil];
	[self showSplash];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Overriden to allow any orientation.
	// NSLog(@"v? : %@", self.view);

    return YES;
}


- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}


- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

// show splash screen
-(void)showSplash
{
	NSLog(@"show");
	/*currentView = [[SplashViewController alloc] initWithNibName:@"SplashViewController" bundle:nil];
	 [self.view addSubview: currentView.view];
	 [self performSelector:@selector(hideSplash) withObject:nil afterDelay:5.0];*/
	Config *cnf = [[Config alloc] init];
	NSString * authenticationId = [cnf loadValue:@"authentication_id"];
	[cnf release];
	
	if ([authenticationId intValue] != 0) {
		// Login
		currentView = [[LoginViewController alloc] initWithNibName:@"LoginViewController" bundle:[NSBundle mainBundle]];
		[self.view addSubview: currentView.view];
	} else
	{
		[self displayView:@"1"];
	}
}

// hide splash screen
- (void)hideSplash{
	NSLog(@"hide");
	[self displayView:@"1"];
}

- (void) displayView:(NSString *)sNewView 
{
	[currentView.view removeFromSuperview];
	currentView = nil;
	//	[currentView release];
	
	int intNewView = [sNewView intValue];
	
	NSNumber *newViewVal = [NSNumber numberWithInt:intNewView];
	
	NSDictionary *userInfo = [NSDictionary dictionaryWithObjectsAndKeys:newViewVal, @"intNewView", nil];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"onDisplayView" object:self userInfo:userInfo];
}


-(void) displayView2:(NSNotification *)notification
{
	[currentView.view removeFromSuperview];
	currentView = nil;
	NSDictionary *userInfo = [notification userInfo];
	NSNumber *newViewVal = (NSNumber *)[userInfo objectForKey:@"intNewView"];
	int intNewView = [newViewVal intValue];
	// intNewView = 6;
	
	switch (intNewView) {
		case 1:
			// Menu
			currentView = [[MenuViewController alloc] initWithNibName:@"MenuViewController" bundle:[NSBundle mainBundle]];
			break;
		case 2:
			// List
			currentView = [[ListViewController alloc] initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
			// currentView = [ListViewController sharedManager];
			break;
		case 3:
			// Map
			// currentView = [[TabBarViewController alloc] initWithNibName:@"TabBarViewController" bundle:nil];
			// currentView = [[MapViewController alloc] initWithNibName:@"MapViewController" bundle:nil];
			currentView = [[AddressViewController alloc] initWithNibName:@"AddressViewController" bundle:[NSBundle mainBundle]];
			break;
		case 4:
			// Images
			currentView = [[GalleryViewController alloc] initWithNibName:@"GalleryViewController" bundle:[NSBundle mainBundle]];
			break;
		case 5:
			// Web
			currentView = [[WebViewController alloc] initWithNibName:@"WebViewController" bundle:[NSBundle mainBundle]];
			break;
		case 6:
			// Video
			currentView = [[VideoViewController alloc] initWithNibName:@"VideoViewController" bundle:[NSBundle mainBundle]];
			break;
		case 7:
			// Detail
			currentView = [[DetailViewController alloc] initWithNibName:@"DetailViewController" bundle:[NSBundle mainBundle]];
			break;
		case 8:
			// Poll
			currentView = [[PollViewController alloc] initWithNibName:@"PollViewController" bundle:[NSBundle mainBundle]];
			// currentView = [[PollResultsViewController alloc] initWithNibName:@"PollResultsViewController" bundle:nil];
			break;
		case 9:
			// About
			currentView = [[AboutViewController alloc] initWithNibName:@"AboutViewController" bundle:[NSBundle mainBundle]];
			break;
		case 10:
			// tabbar
			currentView = [[TabBarViewController alloc] initWithNibName:@"TabBarViewController" bundle:[NSBundle mainBundle]];
			break;
		case 11:
			// user config
			currentView = [[ConfigViewController alloc] initWithNibName:@"ConfigViewController" bundle:[NSBundle mainBundle]];
			break;
		case 13:
			// Address
			currentView = [[AddressViewController alloc] initWithNibName:@"AddressViewController" bundle:[NSBundle mainBundle]];
			break;
	}

	BOOL landscape = NO;
	[[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
	UIDeviceOrientation orientation = [[UIDevice currentDevice] orientation];
	if (orientation == UIDeviceOrientationLandscapeLeft)
	{
		NSLog(@"myController viewDidLoad called for LANDSCAPE LEFT");
		landscape = YES;
	}
	else if (orientation == UIDeviceOrientationLandscapeRight)
	{
		NSLog(@"myController viewDidLoad called for LANDSCAPE RIGHT");
		landscape = YES;
	}
	CGRect frame;
	frame.origin = CGPointMake(0, 0);
	/*frame.size = CGSizeMake(
									self.view.frame.size.width,
									self.view.frame.size.height  );*/
	if (landscape)
		frame.size = CGSizeMake(1024, 748);
		// frame = CGRectMake(0, 0, 1024, 768);
	else
		frame.size = CGSizeMake(768, 1004);
		// frame = CGRectMake(0, 0, 768, 1024);
	currentView.view.frame = frame; // 
	// currentView.view.frame = CGRectMake(0, 0, 768, 1024);

	// currentView.view.frame = CGRectMake(0, 0, 1024, 768);

	/*	CGRect frame = currentView.view.frame;
	if (frame.size.width == 748)
	{
		NSLog(@"748");
		currentView.view.frame = CGRectMake(0, 0, 1024, 768);
	}
	else
		if (frame.size.width == 768)
        {
            NSLog(@"1024");
            currentView.view.frame = CGRectMake(0, 0, 768, 1024);
			//			currentView.view.frame = CGRectMake(0, 0, 1024, 748);
        }
*/
	/*
    //if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
    //{
        if (self.view.frame.size.width == 748)
        {
            NSLog(@"748");
            currentView.view.frame = CGRectMake(0, 0, 1024, 768);
        }
        else
			if (self.view.frame.size.width == 768)
        {
            NSLog(@"1024");
            currentView.view.frame = CGRectMake(0, 0, 768, 1024);
//			currentView.view.frame = CGRectMake(0, 0, 1024, 748);
        }
//        currentView.view.frame = CGRectMake(0, 0, 1024, 768);
        // currentView.view.frame = CGRectMake(0, 0, 768, 1024);
    //}
	//	currentView.view.frame = CGRectMake(0, 0,self.view.frame.size.width, self.view.frame.size.height);
*/
    //UIScreen *screen = [UIScreen mainScreen];
    //[currentView.view	 setFrame:[screen applicationFrame]];

	//currentView.view.frame = CGRectMake(0, 0, 1024, 768);
	/*currentView.view.frame = CGRectMake(0, 0,self.view.frame.size.width, self.view.frame.size.height);
	[self setWantsFullScreenLayout:NO];
	[currentView.view setNeedsLayout];* /
	[self setWantsFullScreenLayout:NO];
	[currentView.view setNeedsLayout];

	// UIScreen *screen = [UIScreen mainScreen];
    // [self.view setFrame:[screen applicationFrame]];

	/ *currentView.view.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);*/
	
	// [self.view setFrame:[[UIScreen mainScreen ]applicationFrame]];

// ipad ...
	[currentView setWantsFullScreenLayout:YES];
	[currentView.view setNeedsLayout];
	self.wantsFullScreenLayout = YES;
	self.navigationController.navigationBar.translucent = YES;
	
    [self.view addSubview:currentView.view];
}

- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation   
										 duration:(NSTimeInterval)duration {  
	
	
	NSLog(@"will will rotate rotate rotate rotate rotate rotate rotate rotate rotate rotate rotate ");
	UIInterfaceOrientation nowOrientation = self.interfaceOrientation;  
	
	if (nowOrientation == UIInterfaceOrientationPortrait || nowOrientation == UIInterfaceOrientationPortraitUpsideDown) {  
		//moving towards portrait orientation  
	}  
	else {  
		//moving to landscape orientation  
	}

	[currentView willAnimateRotationToInterfaceOrientation:interfaceOrientation   
												  duration:duration];
}  

@end
