//
//  AboutViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 11/11/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "AboutViewController.h"
#import "TBXML.h"
#import "MenuItem.h"
#import "Functions.h"
#import "AppAboutViewController.h"

@implementation AboutViewController

#define USE_CUSTOM_DRAWING 1

@synthesize waitLabel;
@synthesize menuItems;
@synthesize tableView; // = _tableView;
@synthesize imageView;
@synthesize pattern;
@synthesize supportSubject, supportEmail;

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	[Functions initToolBar:self.view withTitle:@" "];
	[Functions addStatusBar:self.view withTabBar:YES];

	tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-85);
	tableView.autoresizingMask = ( 
								  UIViewAutoresizingFlexibleHeight
								   
								  | UIViewAutoresizingFlexibleWidth);
	tableView.delegate = self;
	tableView.dataSource = self;
	// [tableView setDataSource:self];
	// [tableView setDelegate:self];
	[self.view addSubview:tableView];
	self.tableView.rowHeight = 70;
	[self initWaitView];
	[self showAnimated:nil];
	
	NSString * title = @"About";
	// NSString * actualId = @"0";

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	TBXMLElement * menuXMLElement;
	NSString * titleStyle = @"";
    pattern = @"";

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				if ([@"9" isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));

		if (f) {
			// actualId = [TBXML valueOfAttributeNamed:@"id" forElement:feedsXMLElement];
			NSString *idAbout;
			NSString *idContact;
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"about"]) {
									idAbout = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"contact"]) {
									idContact = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}

					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:idAbout]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"about_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}

					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:idContact]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"contact_email"]) {
									supportEmail = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"contact_subject"]) {
									supportSubject = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	
	// read list
		childXMLElement = root->firstChild;
		
		f = FALSE;
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *typeItem = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"type: %@ ", typeItem);
				if ([typeItem isEqualToString:@"1"]) {
					f = TRUE;
					menuXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		// NSString *style = [TBXML valueOfAttributeNamed:@"style_id" forElement:child];
        if (f)
        {
		pattern = [TBXML valueOfAttributeNamed:@"template_id" forElement:menuXMLElement];
		
		TBXMLElement * child = menuXMLElement->firstChild;
		f = FALSE;
		NSMutableArray * listMenuItems = [[[NSMutableArray alloc] init] autorelease];
		do {
			NSLog(@":: %@ .. %@", [TBXML elementName:child], [TBXML valueOfAttributeNamed:@"id" forElement:child]);
			if ([[TBXML elementName:child] isEqualToString:@"field_set"]) {
				if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:@"0"]) {
					f = TRUE;
					TBXMLElement * childXMLElement = child->firstChild;
					do {
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement] isEqualToString:@"menu_item"]) {
							NSArray *menuObject = [NSArray 
												   arrayWithObjects: [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement], 
												   [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement], nil];
							[listMenuItems addObject:menuObject];
						}
					} while ((childXMLElement = childXMLElement->nextSibling));
				}
			}
		} while ((child = child->nextSibling) && !f);
		
		for(NSArray * menuObject in listMenuItems) {
			f = FALSE;
			child = menuXMLElement->firstChild;
			do {
				if ([[TBXML elementName:child] isEqualToString:@"field_set"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:[menuObject objectAtIndex:0]]) {
						f = TRUE;
						TBXMLElement * childXMLElement = child->firstChild;
						// NSString * idItem;
						do {
							NSString * attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
							if ([attribItem isEqualToString:@"menu_title"]) {
								if ([[TBXML valueOfAttributeNamed:@"visible" forElement:childXMLElement] isEqualToString:@"0"]) {
									titleStyle = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								} else {
									titleStyle = @"";
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((child = child->nextSibling) && !f);
		}
		// read list

        }
	}
			
			
#if USE_CUSTOM_DRAWING
	self.tableView.rowHeight = 80;
	self.tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
	self.tableView.backgroundColor = [UIColor clearColor];
#endif
	
	menuItems = [[NSMutableArray alloc] init];
	
	MenuItem *menuItem = [[MenuItem alloc] initWithName:title];
	menuItem.description = @"";
	menuItem.nameStyle = titleStyle; // [TBXML textForElement:tStyleXMLElement];
	menuItem.descriptionStyle = @""; // [TBXML textForElement:dStyleXMLElement];
	menuItem.idItem = @"1";
	menuItem.pattern = pattern;
	menuItem.icon = @"";
	[menuItems addObject:menuItem];
    [menuItem release];

	menuItem = [[MenuItem alloc] initWithName:@"Email Support"];
	menuItem.description = @"";
	menuItem.nameStyle = titleStyle; // [TBXML textForElement:tStyleXMLElement];
	menuItem.descriptionStyle = @""; // [TBXML textForElement:dStyleXMLElement];
	menuItem.idItem = @"2";
	menuItem.pattern = pattern;
	menuItem.icon = @"";
	menuItem.tmpOne = supportEmail;
	menuItem.tmpTwo = supportSubject;
	[menuItems addObject:menuItem];
    [menuItem release];
	
	// [Functions initToolBar:self.view withTitle:title]; // withTitle:@"" withView:NO];
 	// [Functions addToolBar:self.view withTitle:title actualId:actualId];
	UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
	toolbarTitle.text = title;
	
	[self initStatusBar:self.view];
	[self stopAnimated:nil];

		
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[supportSubject release];
	[supportEmail release];
	[menuItems release];
	[tableView release];
	[pattern release];
	[imageView release];
    [super dealloc];
}

#pragma mark Table view methods

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return menuItems.count;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)aTableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
#if USE_CUSTOM_DRAWING
	const NSInteger TOP_LABEL_TAG = 1001;
	const NSInteger BOTTOM_LABEL_TAG = 1002;
	const NSInteger IMAGE_TAG = 1003;
	UILabel *topLabel;
	UILabel *bottomLabel;
	UIImageView *image;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:indexPath.row];
#endif
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [aTableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        // cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
		
#if USE_CUSTOM_DRAWING
		FontItem * font;
	
		NSString *fileName = @"/indicator.png"; // button_right.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		NSData *imgData = [[NSData alloc] initWithContentsOfFile:filePath];
		UIImage *indicatorImage = [[UIImage alloc] initWithData:imgData];
		
		// UIImage *indicatorImage = [UIImage imageNamed:@"button_right.png"];
		cell.accessoryView =
		[[[UIImageView alloc]
		  initWithImage:indicatorImage]
		 autorelease];

        [indicatorImage release];
        [imgData release];

		
		const CGFloat LABEL_HEIGHT = 20;
		NSInteger leftMargin = 0;
		if ([menuItem.pattern isEqualToString:@"0"])
			leftMargin = 50;
		
		// image
		image = [[[UIImageView alloc] initWithFrame:CGRectMake(15, 15, 50, 50)] autorelease];
        image.tag = IMAGE_TAG;
		// NSLog(@"pattern %@", menuItem.pattern);
		if ([menuItem.pattern isEqualToString:@"1"]) {
			image.frame = CGRectMake(230, 15, 50, 50);
		}
        // image.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleHeight;
        [cell.contentView addSubview:image];
		
		//
		// Create the label for the top row of text
		//
		topLabel =
		[[[UILabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*64 + 50*/leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT),
					 aTableView.bounds.size.width -
					 /*image.size.width 64 -  50*/leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:topLabel];
		
		//
		// Configure the properties for the text that are the same on every row
		//
		topLabel.tag = TOP_LABEL_TAG;
		topLabel.backgroundColor = [UIColor clearColor];
		topLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		topLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		topLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize]];
		font = [Functions loadFont:menuItem.nameStyle]; 
		
		[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		topLabel.textColor = [Functions colorForHex:font.colorFont];
		topLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];

		/*
		 textView.font = [UIFont boldSystemFontOfSize:24];
		 [myStringName drawAtPoint:NSMakePoint(150,150)
		 withAttributes:[NSDictionary dictionaryWithObject:[[NSFontManager
		 sharedFontManager]
		 fontWithFamily:@"Helvetica"
		 traits:NSBoldFontMask | NSItalicFontMask
		 weight:9 size:12.0]
		 forKey:NSFontAttributeName]];
		 */
		
		//
		// Create the label for the top row of text
		//
		bottomLabel =
		[[[UILabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*image.size.width + */ leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
					 aTableView.bounds.size.width -
					 /*image.size.width - */ leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:bottomLabel];
		
		//
		// Configure the properties for the text that are the same on every row
		//
		bottomLabel.tag = BOTTOM_LABEL_TAG;
		bottomLabel.backgroundColor = [UIColor clearColor];
		bottomLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		bottomLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		bottomLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize] - 2];
		
		font = [Functions loadFont:menuItem.descriptionStyle]; 
		
		[bottomLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		bottomLabel.textColor = [Functions colorForHex:font.colorFont];
		bottomLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];
		
		//
		// Create a background image view.
		//
		cell.backgroundView =
		[[[UIImageView alloc] init] autorelease];
		cell.selectedBackgroundView =
		[[[UIImageView alloc] init] autorelease];
#endif
    }
#if USE_CUSTOM_DRAWING
	else
	{
		topLabel = (UILabel *)[cell viewWithTag:TOP_LABEL_TAG];
		bottomLabel = (UILabel *)[cell viewWithTag:BOTTOM_LABEL_TAG];
        // image = (UIImageView *)[cell.contentView viewWithTag:IMAGE_TAG];
	}
	
	// NSLog(@"m: %@", menuItem.name);
	
	FontItem *font;
	
	topLabel.text = menuItem.name;
	font = [Functions loadFont:menuItem.nameStyle]; 
	
	[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	topLabel.textColor = [Functions colorForHex:font.colorFont];
	
	bottomLabel.text = menuItem.description;
	font = [Functions loadFont:menuItem.descriptionStyle]; 
	[bottomLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	bottomLabel.textColor = [Functions colorForHex:font.colorFont];

	if (menuItem.description == nil ||
		[menuItem.description isEqualToString:@""]) {
		int imageSize = 0;
		//if ([menuItem.pattern isEqualToString:@"1"])
		//	imageSize = 50;
		topLabel.frame = CGRectMake(
									/*64 + 50*/imageSize + 2.0 * cell.indentationWidth,
									0.5 * (tableView.rowHeight - 2 * 20),
									tableView.bounds.size.width -
									/*image.size.width 64 -  50*/imageSize - 4.0 * cell.indentationWidth
									- 20,
									20*2);
	}
	// topLabel.backgroundColor = [UIColor blackColor];
	
	//
	// Set the background and selected background images for the text.
	// Since we will round the corners at the top and bottom of sections, we
	// need to conditionally choose the images based on the row index and the
	// number of rows in the section.
	//
	UIImage *rowBackground;
	NSString * fileName;
	// UIImage *selectionBackground;
	NSInteger sectionRows = [aTableView numberOfRowsInSection:[indexPath section]];
	NSInteger row = [indexPath row];
	if (row == 0 && row == sectionRows - 1)
	{
		fileName = @"/topAndBottomRow.png";
		// rowBackground = [UIImage imageNamed:@"topAndBottomRow.png"];
		// selectionBackground = [UIImage imageNamed:@"topAndBottomRowSelected.png"];
	}
	else if (row == 0)
	{
		fileName = @"/topRow.png";
		// rowBackground = [UIImage imageNamed:@"topRow.png"];
		// selectionBackground = [UIImage imageNamed:@"topRowSelected.png"];
	}
	else if (row == sectionRows - 1)
	{
		fileName = @"/bottomRow.png";
		// rowBackground = [UIImage imageNamed:@"bottomRow.png"];
		// selectionBackground = [UIImage imageNamed:@"bottomRowSelected.png"];
	}
	else
	{
		fileName = @"/middleRow.png";
		// rowBackground = [UIImage imageNamed:@"middleRow.png"];
		// selectionBackground = [UIImage imageNamed:@"middleRowSelected.png"];
	}
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	// NSLog(@"show %@", filePath);
	NSData *imgData = [[NSData alloc] initWithContentsOfFile:filePath];
	rowBackground = [[UIImage alloc] initWithData:imgData];
	((UIImageView *)cell.backgroundView).image = rowBackground;
	((UIImageView *)cell.selectedBackgroundView).image = rowBackground;
    [rowBackground release];
    [imgData release];
	// ((UIImageView *)cell.selectedBackgroundView).image = selectionBackground;
	
	//
	// Here I set an image based on the row. This is just to have something
	// colorful to show on each row.
	//

	if ([menuItem.pattern isEqualToString:@"1"] ||
		[menuItem.pattern isEqualToString:@"0"]) {
		/*
		if ([menuItem.type isEqualToString:@"2"] == TRUE) {
			fileName = @"/icoList.png";
		}
		else if ([menuItem.type isEqualToString:@"3"] == TRUE)
		{
			fileName = @"/icoMap.png";
		}
		else if ([menuItem.type isEqualToString:@"4"] == TRUE)
		{
			fileName = @"/icoSlide.png";
		}
		fileName = @""; // menuItem.icon;
		if([fileName isEqualToString:@""] == FALSE) {
			filePath = [documentsDir stringByAppendingPathComponent:fileName];
			// imgData = [[NSData alloc] initWithContentsOfFile:filePath];
			NSURL *imgURL     = [NSURL URLWithString:fileName];
			imgData   = [NSData dataWithContentsOfURL:imgURL];
			// cell.image = [[UIImage alloc] initWithData:imgData];
			// cell.imageView.image = [[UIImage alloc] initWithData:imgData];
			UIImage *img    = [[UIImage alloc] initWithData:imgData];
			image.image = img;
		}
		 */
	}
	/*
	 if ((row % 3) == 0)
	 {
	 cell.image = [UIImage imageNamed:@"imageA.png"];
	 }
	 else if ((row % 3) == 1)
	 {
	 cell.image = [UIImage imageNamed:@"imageB.png"];
	 }
	 else
	 {
	 cell.image = [UIImage imageNamed:@"imageC.png"];
	 }
	 */
#else
    // Set up the cell...
	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:indexPath.row];
	NSLog(@"m: %@", menuItem.name);
	// [cell setText: menuItem.name];
	cell.textLabel.text = menuItem.name;
	
	// NSString *subtitle = [NSString stringWithString: @"All about the color "];
	// subtitle = [subtitle stringByAppendingFormat:colorString];
	
	cell.detailTextLabel.text = menuItem.description; // subtitle;
#endif
    
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	MenuItem *menuItem = (MenuItem *)[menuItems objectAtIndex:indexPath.row];

	if ([menuItem.idItem isEqualToString:@"1"]) {
		AppAboutViewController * aboutView = [[AppAboutViewController alloc] initWithNibName:@"AppAboutViewController" bundle:nil];

		[self.view addSubview:aboutView.view];
		
		aboutView.view.frame = CGRectMake(0,460,320,460);
        aboutView.view.frame = CGRectMake(0, self.view.frame.size.height, self.view.frame.size.width, self.view.frame.size.height);
		[UIView beginAnimations:@"animateImageOn" context:NULL]; // Begin animation
		[aboutView.view setFrame:CGRectOffset([aboutView.view frame], 0, -aboutView.view.frame.size.height)]; // Move imageView on screen
		[UIView commitAnimations]; // End animations
	}
	
	if ([menuItem.idItem isEqualToString:@"2"]) {
		
		NSString * message = @"";
		NSArray *toRecipients = [NSArray arrayWithObject:menuItem.tmpOne]; //@"support@arch.com"]; 
		
		MFMailComposeViewController *picker = [[MFMailComposeViewController alloc] init];
		picker.mailComposeDelegate = self;
		
		// [picker setSubject:@"I have a pencil for you"];
		[picker setSubject:menuItem.tmpTwo]; // @"Architectural Support"];
		[picker setToRecipients:toRecipients];
		
		//UIImage *roboPic = [UIImage imageNamed:@"RobotWithPencil.jpg"];
		//NSData *imageData = UIImageJPEGRepresentation(roboPic, 1);
		//[picker addAttachmentData:imageData mimeType:@"image/jpg" fileName:@"RobotWithPencil.jpg"];
		
		// NSString *emailBody = @"This is a cool image of a robot I found.  Check it out!";
		// [picker setMessageBody:emailBody isHTML:YES];
		[picker setMessageBody:message isHTML:YES];
		
		[self presentModalViewController:picker animated:YES];
		[picker release];
	}
	
	// [waitView stopAnimating];
}

-(void)mailComposeController:(MFMailComposeViewController*)controller didFinishWithResult:(MFMailComposeResult)result error:(NSError*)error {
	NSLog(@"end mail");
	[self dismissModalViewControllerAnimated:YES];
}

-(void)goToMenu:(MenuItem *) menuItem{}


- (void) initStatusBar:(UIView *)actualView {
	// NSString *title =@"Video";

	/*UIToolbar *toolbar = [UIToolbar new];
	 CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];*/

	UIToolbar *toolbar = (UIToolbar *)[actualView viewWithTag:11003];

	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,10,50,26)];
	[backButton setFrame:CGRectMake(5,4,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack:) forControlEvents:UIControlEventTouchUpInside];
	[toolbar addSubview:backButton];
	// [backButton release];
	
}

- (IBAction)goBack:(id) sender{
	/*
	 NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	 selector:@selector(showAnimated:) object:self];
	 [thrAni start];
	 */
	[Functions goMenu:nil];
}

@end
