//
//  AppAboutViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/19/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "AppAboutViewController.h"
#import "Functions.h"
#import "NSString+HTML.h"

@implementation AppAboutViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	
	NSString * titleText = @"";
	NSString * aboutText = @"";
	
    [super viewDidLoad];

    // [self initToolBar:self.view];
    [Functions addStatusBar:self.view withTabBar:NO];
	[self initStatusBar:self.view];
	[Functions initToolBar:self.view withTitle:@" "];

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				if ([@"9" isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			NSString *idAbout = @"";
			// NSString *idContact = @"";
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"about"]) {
									idAbout = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"contact"]) {
									// idContact = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:idAbout]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"about_title"]) {
									titleText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"about_desc"]) {
									aboutText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}
		
	// Web View
	UIWebView *aWebView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 370)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	aWebView.autoresizesSubviews = YES;
	aWebView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
    [aWebView setOpaque:NO];
    [aWebView setBackgroundColor:[UIColor clearColor]];
	
	NSString *myHtml = [NSString stringWithFormat:@"<html> \n"
						"<head> \n"
						"<style type=\"text/css\"> \n"
                        "* {\n"
                        "margin-top: 0em;\n"
                        "margin-bottom: 0em;\n"
                        "}\n"
                        "body{background-color:transparent;}\n"
						"h1 { \n"
						"font-family:Arial; \n"
						"font-size: 18px;\n"
						"font-color: #000000; \n"
						"font-weight: bold; \n"
						"}\n"   
						".textData { \n"
						"font-family:Arial; \n"
						"font-size: 11px;\n"
						"font-color: #000000; \n"
						"font-weight: normal; \n"
						"}\n"   
						"</style> \n"
						"</head> \n"
						"<body><h1>%@<h1>"
						"<div class=\"textData\">%@</div></body> \n"
						"</html>",
						titleText,
						[aboutText htmlUnescapedString]];
	// NSLog(@"html: %@", myHtml);
	[aWebView loadHTMLString:myHtml baseURL:nil];

	//add the web view to the content view
	[self.view addSubview:aWebView];
    [aWebView release];
	// Web View

	// [Functions initToolBar:self.view withTitle:titleText];
    UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
    toolbarTitle.text = titleText;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

- (IBAction) hideAbout:(id)sender {
	[self.view removeFromSuperview];
}

- (void) initToolBar:(UIView *)actualView {
	// NSString *title =@"Video";
	UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[actualView addSubview:toolbar];
		
	NSArray *paths = NSSearchPathForDirectoriesInDomains(
														 NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *docDirectory = [paths objectAtIndex:0];
    docDirectory = [docDirectory stringByAppendingPathComponent:@"/logo.png"];
	NSData *imgData = [[NSData alloc] initWithContentsOfFile:docDirectory];
	UIImage *img    = [[UIImage alloc] initWithData:imgData];
	CGRect myImageRect = CGRectMake(100, 10, 120, 30);
	UIImageView *logoImage = [[UIImageView alloc] initWithFrame:myImageRect];
	[logoImage setImage:img];
	[toolbar addSubview:logoImage];
    [logoImage release];
    [imgData release];
    [img release];
    [toolbar release];
	
	/*
		UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		[button setFrame:CGRectMake(10,10,50,26)];
		[button setTitle:@"Back" forState:UIControlStateNormal];
		[button addTarget:self action:@selector(hideAbout:) forControlEvents:UIControlEventTouchUpInside];
		button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
		[toolbar addSubview:button];
		// [button release];
	*/
}

- (void) initStatusBar:(UIView *)actualView {
	// NSString *title =@"Video";
	/*
     CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
     UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
     [actualView addSubview:toolbar];
	*/
    
    UIToolbar * toolbar = (UIToolbar *)[actualView viewWithTag:11003];

	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,10,50,26)];
	[backButton setFrame:CGRectMake(5,4,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(hideAbout:) forControlEvents:UIControlEventTouchUpInside];
	// backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[toolbar addSubview:backButton];
	// [backButton release];
	
}

- (IBAction)goBack:(id) sender{
	/*
	NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];
	*/
	[Functions goMenu:nil];
}

@end
