//
//  ConfigViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 12/7/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ConfigViewController.h"
#import "Functions.h"
#import "Config.h"
#import "TBXML.h"
#import "CustomTextField.h"

@implementation ConfigViewController

#define USE_CUSTOM_DRAWING 1

@synthesize sortFields, filterFields, pageItems, lastIndexPath;
@synthesize scrollView;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
 // Custom initialization
 }
 return self;
 }
 */

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	//imageViewChecked = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"checkbox-checked.png"]]; 
	//imageViewNoChecked =  [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"checkbox.png"]];
	//NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init]; 
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	
	Config * cnf;
	//cnf = [[Config alloc] init];
	//[cnf loadValue: @"actualId"];
	//NSString * actualId = cnf.value;
	
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	
	NSString * perPage = @"true";
	NSString * sortSettings = @"true";
	NSString * filterSettings = @"true";
	
	self.pageItems = [[NSMutableArray alloc] init];
	self.sortFields = [[NSMutableArray alloc] init];
	self.filterFields = [[NSMutableArray alloc] init];
	tmpData = [[NSMutableDictionary alloc] init];
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				//NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		TBXMLElement * appXMLElement;
		// NSString * perPageId = @""; // [[NSString alloc] init];
		NSString * sortSettingsId = @""; // [[NSString alloc] init];
		NSString * filterSettingsId = @""; // [[NSString alloc] init];
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"per_page"]) {
									// perPageId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									perPage = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"sort_settings"]) {
									sortSettingsId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									sortSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"filter_settings"]) {
									filterSettingsId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
									filterSettings = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:sortSettingsId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								[sortFields addObject:attribItem];
								//NSString * fieldName = [NSString stringWithFormat:@"sort_%@_%@", 
								//						actualId, attribItem];
								
								NSString * value = [cnf loadValue:[NSString stringWithFormat:@"sort_%@_%@", actualId, attribItem]];
								[tmpData setObject:value forKey:[NSString stringWithFormat:@"sort_%@_%@", actualId, attribItem]];
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:filterSettingsId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								[filterFields addObject:attribItem];
								//NSString * fieldName = [NSString stringWithFormat:@"filter_", 
								//						actualId, attribItem];
								//cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"filter_%@_%@", actualId, attribItem]];
								
								NSString * value = [cnf loadValue:[NSString stringWithFormat:@"filter_%@_%@", actualId, attribItem]];
								[tmpData setObject:value forKey:[NSString stringWithFormat:@"filter_%@_%@", actualId, attribItem]];
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}
	
	//cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"perPage_%@", actualId]];
	
	NSString * perPageVal = [cnf loadValue:[NSString stringWithFormat:@"perPage_%@", actualId]];
	// [tmpData setObject:cnf.value forKey:[NSString stringWithFormat:@"perPage_%@", actualId]];
	[tmpData setObject:perPageVal
				forKey:[NSString stringWithFormat:@"perPage_%@", actualId]];
	
	// NSLog(@"%@" , tmpData);
	
	[pageItems addObject:@"All items"];
	[pageItems addObject:@"10 items per page"];
	[pageItems addObject:@"20 items per page"];
	[pageItems addObject:@"30 items per page"];
	
	int yPos = 0;
	int yIni = 0;
	
	scrollView = [[UIScrollView alloc] initWithFrame:CGRectMake(0, 44, 320, 370)];
	// scrollView.maindelegate = self;
	scrollView.pagingEnabled = YES;
	scrollView.contentSize = CGSizeMake(scrollView.frame.size.width, 2000.0f /*scrollView.frame.size.height*/);
	scrollView.showsHorizontalScrollIndicator = NO;
	scrollView.showsVerticalScrollIndicator = YES;
	scrollView.scrollsToTop = YES;
	scrollView.delegate = self;
	scrollView.userInteractionEnabled = YES;
	scrollView.multipleTouchEnabled = YES;
	[self.view addSubview:scrollView];
	
	if ([perPage isEqualToString:@"true"]) {
		yPos = 10;
		yIni = 30;
		UILabel *label = [[UILabel alloc] initWithFrame:
						  CGRectMake(10,yPos,300,yIni)];
		label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		label.text = @"Items per Page";
		label.backgroundColor = [UIColor clearColor];
		label.textColor = [UIColor blackColor];
		label.font = [UIFont boldSystemFontOfSize:16];
		label.textAlignment = UITextAlignmentLeft;
		[scrollView addSubview:label];
		
		yPos += yIni;
		yIni = 80*pageItems.count;
		UITableView *itemsTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, yPos, 320, yIni)];
		itemsTableView.delegate = self;
		itemsTableView.dataSource = self;
		itemsTableView.tag = 1001;
		itemsTableView.scrollEnabled = NO;
		// [tableView setDataSource:self];
		// [tableView setDelegate:self];
		// [self.view addSubview:itemsTableView];
		[scrollView addSubview:itemsTableView];
#if USE_CUSTOM_DRAWING
		itemsTableView.rowHeight = 80;
		itemsTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
		itemsTableView.backgroundColor = [UIColor clearColor];
#endif
		
		// [label release];
		// [itemsTableView release];
	}
	
	if ([sortSettings isEqualToString:@"true"]) {
		yPos += yIni+10;
		yIni = 30;
		UILabel *label = [[UILabel alloc] initWithFrame:
						  CGRectMake(10,yPos,300,yIni)];
		label.text = @"Sort by";
		label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		label.backgroundColor = [UIColor clearColor];
		label.textColor = [UIColor blackColor];
		label.font = [UIFont boldSystemFontOfSize:16];
		label.textAlignment = UITextAlignmentLeft;
		[scrollView addSubview:label];
		
		yPos += yIni;
		yIni = 80*sortFields.count;
		UITableView *sortTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, yPos, 320, yIni)];
		sortTableView.delegate = self;
		sortTableView.dataSource = self;
		sortTableView.tag = 1002;
		sortTableView.scrollEnabled = NO;
		// [tableView setDataSource:self];
		// [tableView setDelegate:self];
		// [self.view addSubview:sortTableView];
		[scrollView addSubview:sortTableView];
		
#if USE_CUSTOM_DRAWING
		sortTableView.rowHeight = 80;
		sortTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
		sortTableView.backgroundColor = [UIColor clearColor];
#endif
		
		// [label release];
		// [sortTableView release];
	}
	
	if ([filterSettings isEqualToString:@"true"]) {
		yPos += yIni+10;
		yIni = 30;
		UILabel *label = [[UILabel alloc] initWithFrame:
						  CGRectMake(10,yPos,300,yIni)];
		label.text = @"Filter by";
		label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		label.backgroundColor = [UIColor clearColor];
		label.textColor = [UIColor blackColor];
		label.font = [UIFont boldSystemFontOfSize:16];
		label.textAlignment = UITextAlignmentLeft;
		[scrollView addSubview:label];
		
		yPos += yIni;
		yIni = 80*filterFields.count;
		UITableView *filterTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, yPos, 320, yIni)];
		filterTableView.delegate = self;
		filterTableView.dataSource = self;
		filterTableView.tag = 1003;
		filterTableView.scrollEnabled = NO;
		// [tableView setDataSource:self];
		// [tableView setDelegate:self];
		// [self.view addSubview:sortTableView];
		[scrollView addSubview:filterTableView];
#if USE_CUSTOM_DRAWING
		filterTableView.rowHeight = 80;
		filterTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
		filterTableView.backgroundColor = [UIColor clearColor];
#endif
		// [label release];
		// [filterTableView release];
	}
	
	scrollView.contentSize = CGSizeMake(320, yPos+yIni+30);
	[Functions initToolBar:self.view withTitle:@"User Settings"];
	[self initStatusBar:self.view];
	[cnf release];
	//[pool release];
}

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[lastIndexPath release];
	[pageItems release];
	[sortFields release];
	[filterFields release];
    [super dealloc];
}

- (void) initStatusBar:(UIView *)actualView {
	// NSString *title =@"Video";
	UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];
	
	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,7,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack:) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[toolbar addSubview:backButton];
	// [backButton release];
	
}

- (IBAction)goBack:(id) sender{
	[Functions goMenu:nil];
}

#pragma mark Table view methods


/*
- (BOOL)textFieldShouldReturn:(UITextField *)textField{
	[textField resignFirstResponder];
	
    return YES;
}
*/
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
	return nil;
}

- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
	return nil;
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	// NSLog(@"t: %@" , tableView);
	// NSLog(@"t: %d" , tableView.tag);
	int numRows = 1;
	switch (tableView.tag) {
		case 1002:
			numRows = sortFields.count;
			break;
		case 1003:
			numRows = filterFields.count;
			break;
		default:
			numRows = pageItems.count;
			break;
	}
	return numRows;
}

- (BOOL) cellChecked:(UITableView *)tableView cell:(NSIndexPath *)indexPath {
	
	Config * cnf = [[Config alloc] init];
	
	NSString * actualId = [cnf loadValue:@"actualId"];
	// NSString * value;
	BOOL checked = FALSE;
	
	if (tableView.tag == 1001) {
		NSString * fieldName = [NSString stringWithFormat:@"perPage_%@", actualId];
		NSString *perPageVal=[cnf loadValue:fieldName];

		if (indexPath.row == [perPageVal intValue] ||
			(
			 ((perPageVal == nil) || [perPageVal isEqualToString:@""])
			 && indexPath.row ==0)) {
				self.lastIndexPath = indexPath;
				checked = TRUE;

			}
	}
	else if (tableView.tag == 1002) {
		NSString * value=[cnf loadValue:[NSString stringWithFormat:@"sort_%@_%@", 
						actualId, [sortFields objectAtIndex:indexPath.row]]];
		
		if ([value isEqualToString:@"1"])
			checked = TRUE;
	}
	else if (tableView.tag == 1003) {
		NSString  *value =  [cnf loadValue:[NSString stringWithFormat:@"filter_%@_%@", 
						actualId, [filterFields objectAtIndex:indexPath.row]]];
		
		if ([value isEqualToString:@"1"])
			checked = TRUE;
	}
	
	[cnf release];
	
	return checked;
}




-(NSString *) cellText:(UITableView *)tableView cell:(NSIndexPath *)indexPath {
	NSString *text = [[[NSString alloc] init] autorelease];
	switch (tableView.tag) {
		case 1002:
			text = [sortFields objectAtIndex:indexPath.row];
			break;
		case 1003:
			text = [filterFields objectAtIndex:indexPath.row];
			break;
		default:
			text = [pageItems objectAtIndex:indexPath.row];
			break;
	}
	return text;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
#if USE_CUSTOM_DRAWING
	const NSInteger TOP_LABEL_TAG = 1101;
	UILabel *topLabel;
#endif
	
	static NSString *CellIdentifier = @"Cell";
	
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        // cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
#if USE_CUSTOM_DRAWING
		FontItem * font;
		if (tableView.tag<=1002){
			BOOL checked = [self cellChecked:tableView cell:indexPath];
			if (checked){
				[cell setAccessoryType:UITableViewCellAccessoryCheckmark];
			}
			else {
				[cell setAccessoryType:UITableViewCellAccessoryNone];
			}
		}
		const CGFloat LABEL_HEIGHT = 25;
		NSInteger leftMargin = 0;
		topLabel =
		[[[UILabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*64 + 50*/leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (tableView.rowHeight - 2 * LABEL_HEIGHT),
					 tableView.bounds.size.width -
					 /*image.size.width 64 -  50*/leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:topLabel];
		if (tableView.tag==1003) {

			// UITextField 
			CustomTextField * tfInput=[[[CustomTextField alloc] initWithFrame:CGRectMake(
																			   leftMargin + 2 * cell.indentationWidth,
																			   0.5 * (tableView.rowHeight - 2 * LABEL_HEIGHT)+20,
																			   tableView.bounds.size.width -leftMargin - 4.0 * cell.indentationWidth
																			   - 20,
																			   LABEL_HEIGHT)] autorelease];
			[tfInput setBackgroundColor:[UIColor whiteColor]];
			tfInput.delegate=self;
			tfInput.placeholder = @"<Enter Value Filter>";
			tfInput.textAlignment = UITextAlignmentCenter;
			
			tfInput.tag = 5005;
			// NSLog(@"nam %@", [self cellText:tableView cell:indexPath]);
			NSString * fieldName = [self cellText:tableView cell:indexPath];
			tfInput.fieldName = fieldName; // [self cellText:tableView cell:indexPath];;
			NSString * format=@"filter_%@_%@";
			Config * cnf = [[Config alloc] init];
			NSString * actualId = [cnf loadValue:@"actualId"];
			NSString * value = [cnf loadValue:[NSString stringWithFormat:format, actualId, fieldName]];
			tfInput.text = value;

			[cell.contentView addSubview:tfInput];
			
			[cnf release];
		}
		//
		// Configure the properties for the text that are the same on every row
		//
		topLabel.tag = TOP_LABEL_TAG;
		topLabel.backgroundColor = [UIColor clearColor];
		topLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		topLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		topLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize]];
		
		font = [Functions loadFont:@"17"]; 
		
		[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		topLabel.textColor = [Functions colorForHex:font.colorFont];
		topLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];
		
		//
		// Create a background image view.
		//
		cell.backgroundView =
		[[[UIImageView alloc] init] autorelease];
		cell.selectedBackgroundView =
		[[[UIImageView alloc] init] autorelease];
#endif
	}
#if USE_CUSTOM_DRAWING
	else
	{
		topLabel = (UILabel *)[cell viewWithTag:TOP_LABEL_TAG];
	}
	
	FontItem *font;
	
	topLabel.text = [self cellText:tableView cell:indexPath];

	font = [Functions loadFont:@"17"]; 
	
	[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	topLabel.textColor = [Functions colorForHex:font.colorFont];
	
	//
	// Set the background and selected background images for the text.
	// Since we will round the corners at the top and bottom of sections, we
	// need to conditionally choose the images based on the row index and the
	// number of rows in the section.
	//
	UIImage *rowBackground;
	NSString * fileName;
	// UIImage *selectionBackground;
	NSInteger sectionRows = [tableView numberOfRowsInSection:[indexPath section]];
	NSInteger row = [indexPath row];
	if (row == 0 && row == sectionRows - 1)
	{
		fileName = @"/topAndBottomRow.png";
	}
	else if (row == 0)
	{
		fileName = @"/topRow.png";
	}
	else if (row == sectionRows - 1)
	{
		fileName = @"/bottomRow.png";
	}
	else
	{
		fileName = @"/middleRow.png";
	}
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	NSData *imgData = [[NSData alloc] initWithContentsOfFile:filePath];
	rowBackground = [[UIImage alloc] initWithData:imgData];
	((UIImageView *)cell.backgroundView).image = rowBackground;
	((UIImageView *)cell.selectedBackgroundView).image = rowBackground;
	
#else
	[cell.textLabel setText:[self cellText:tableView cell:indexPath]];
#endif
    return cell;
	
}

/*
 - (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
 return 80.0f;
 }
 */

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	[self tableView: tableView accessoryButtonTappedForRowWithIndexPath: indexPath];
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
}

- (void)tableView:(UITableView *)tableView accessoryButtonTappedForRowWithIndexPath:(NSIndexPath *)indexPath {
	
	Config * cnf = [[Config alloc] init];
	
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * value;
	NSString * format;
	BOOL checked = FALSE;
	switch (tableView.tag) {
			
		case 1001:
			
			
			format=@"perPage_%@";
			value=[cnf loadValue:[NSString stringWithFormat:format, actualId]];
			checked = TRUE;
			
			
			if([value isEqualToString:@""] == TRUE) {
				[cnf insertValue:[NSString stringWithFormat:format, actualId] value:[NSString stringWithFormat:@"%d", indexPath.row]];
				
				[self removeFile:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
			} else {
				lastIndexPath = [NSIndexPath indexPathForRow:[value intValue] inSection:0];
				
				NSLog(@"%@", lastIndexPath);
				UITableViewCell *oldCell = [tableView cellForRowAtIndexPath:lastIndexPath];
				[oldCell setAccessoryType:UITableViewCellAccessoryNone];
				
				if ([value intValue]==indexPath.row){
					checked = FALSE;
					[cnf updateValue:[NSString stringWithFormat:format, actualId] value:[NSString stringWithFormat:@"%d", 0]];
					
					lastIndexPath = [NSIndexPath indexPathForRow:0 inSection:0];
					UITableViewCell *oldCell = [tableView cellForRowAtIndexPath:lastIndexPath];
					[oldCell setAccessoryType:UITableViewCellAccessoryCheckmark];
				}
				else {
					[cnf updateValue:[NSString stringWithFormat:format, actualId] value:[NSString stringWithFormat:@"%d", indexPath.row]];
				}
				[self removeFile:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
				
			}
			
			break;
			
		case 1002:
			format=@"sort_%@_%@";
			value=[cnf loadValue:[NSString stringWithFormat:format, actualId, [sortFields objectAtIndex:indexPath.row]]];
			//cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"sort_%@_%@", actualId, [sortFields objectAtIndex:indexPath.row]]];
			
			
			if ([value isEqualToString:@"0"] || value == nil || [value isEqualToString:@""]) {
				checked = TRUE;
				if([value isEqualToString:@""]) {
					[cnf insertValue:[NSString stringWithFormat:format, actualId, [sortFields objectAtIndex:indexPath.row]] value:@"1"];
					
				} else {
					[cnf updateValue:[NSString stringWithFormat:format, actualId, [sortFields objectAtIndex:indexPath.row]] value:@"1"];
				}
				[self removeFile:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
			}
			else {
				checked = FALSE;
				if([value isEqualToString:@""]) {
					[cnf insertValue:[NSString stringWithFormat:format, actualId, [sortFields objectAtIndex:indexPath.row]] value:@"0"];
					
				} else {
					[cnf updateValue:[NSString stringWithFormat:format, actualId, [sortFields objectAtIndex:indexPath.row]] value:@"0"];
				}
				[self removeFile:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
			}
			
			break;
			
		case 1003:
			format=@"filter_%@_%@";
			/*
			value=[cnf loadValue:[NSString stringWithFormat:format, 
								  actualId, [filterFields objectAtIndex:indexPath.row]]];
			
			 if ([value isEqualToString:@"0"] || value == nil || [value isEqualToString:@""]) {
				checked = TRUE;
				if([value isEqualToString:@""]  ) {
					[Config insertValue:[NSString stringWithFormat:format, actualId, [filterFields objectAtIndex:indexPath.row]] value:@"1"];
				} else {
					[Config updateValue:[NSString stringWithFormat:format, actualId, [filterFields objectAtIndex:indexPath.row]] value:@"1"];
				}
			}
			else {
				checked = FALSE;
				if([value isEqualToString:@""]) {
					[Config insertValue:[NSString stringWithFormat:format, actualId, [filterFields objectAtIndex:indexPath.row]] value:@"0"];
					
				} else {
					[Config updateValue:[NSString stringWithFormat:format, actualId, [filterFields objectAtIndex:indexPath.row]] value:@"0"];
				}
				
			}

			 */
			
			break;
	}
	
	
	UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
	if (checked){
		[cell setAccessoryType:UITableViewCellAccessoryCheckmark];
	}
	else {
		[cell setAccessoryType:UITableViewCellAccessoryNone];
	}
	
	[cnf release];
}

#pragma mark <UITextFieldDelegate> Methods

- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField
{
	// activeTextField = textField;
	NSLog(@"textFieldShouldBeginEditing: sender = %d, %@",  [textField tag], [textField text]);
    return YES;
}

- (void)textFieldDidEndEditing:(CustomTextField *)textField
{
	NSLog(@"textFieldDidEndEditing: sender = %d, %@",  [textField tag], [textField text]);
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * format=@"filter_%@_%@";
	NSLog(@"filter_%@_%@", actualId, [textField fieldName]);
	NSString *value=[cnf loadValue:[NSString stringWithFormat:format, actualId, [textField fieldName]]];

	if (![[textField text] isEqualToString:@""] 
		&& ([textField text] != nil)
		&& !([[textField fieldName] isEqualToString:value])) {
		if([value isEqualToString:@""]  ) {
			[cnf insertValue:[NSString stringWithFormat:format, actualId, [textField fieldName]] value:[textField text]];
		} else {
			[cnf updateValue:[NSString stringWithFormat:format, actualId, [textField fieldName]] value:[textField text]];
		}
		[self removeFile:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
	}
	else {
		/*
		if([value isEqualToString:@""]) {
			[Config insertValue:[NSString stringWithFormat:format, actualId, [textField fieldName]] value:[textField text]];
		} else {
			[Config updateValue:[NSString stringWithFormat:format, actualId, [textField fieldName]] value:[textField text]];
		}
		 */
		if (!([[textField fieldName] isEqualToString:value])) {
			if ([[textField text] isEqualToString:@""] 
				|| ([textField text] == nil)) {
				/*
				 if([value isEqualToString:@""]) {
					[Config insertValue:[NSString stringWithFormat:format, actualId, [textField fieldName]] value:[textField text]];
				} else {
					[Config updateValue:[NSString stringWithFormat:format, actualId, [textField fieldName]] value:[textField text]];
				}
				 */
				[cnf deleteValue:[NSString stringWithFormat:format, actualId, [textField fieldName]]];
			}
			[self removeFile:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
		}
	}
	
	[cnf release];
	
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
	NSLog(@"textFieldShouldReturn: sender = %d, %@",  [textField tag], [textField text]);
	// activeTextField = nil;
    [textField resignFirstResponder];
    return YES;
}

- (void) removeFile:(NSString *) filename
{
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); 
	NSString *documentsDirectoryPath = [paths objectAtIndex:0];
	NSString *databaseFile = [documentsDirectoryPath stringByAppendingPathComponent:filename];
	
	NSFileManager *fileManager = [NSFileManager defaultManager];
	[fileManager removeItemAtPath:databaseFile error:NULL];
}

@end