//
//  ImageViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 10/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "imageInfo.h"
#import "ImageViewController.h"
#import "StylePageControl.h"
#import "CustomScrollView.h"

@interface GalleryViewController : UIViewController <UIScrollViewDelegate>
{
	int						pageIndex;
	int						maxPages;
	
	Boolean					zoomMode;
	
	NSMutableArray		*	imagesArray;
	NSMutableArray		*	contArray;
	CustomScrollView	*	scrollView;
	StylePageControl	*	pageControl;
	
    // To be used when scrolls originate from the UIPageControl
    BOOL pageControlUsed;

	BOOL goEnd;

	NSDictionary * infoData;
	UILabel * label;
	UIToolbar *toolbar;
	UILabel *counter;

	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
	
	int currentFeedPage;
	int maxSlideNumber;
	
}

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (imageInfo*)			getCurrentImage;
- (ImageViewController*) getCurrentController;
- (void)				addImageFromName:(NSString*)imagename withFolder:(NSString *)foldername;
- (void)				changePage:(id)sender;
- (void)				setCurrentPage:(NSUInteger)page;
- (void)				setZoomMode:(Boolean)status;
- (void)				initStatusBar:(UIView *)actualView;
- (void)				goRefresh;
- (void)				goDetail;
- (void)				processInfo;
-(void) nextFeedPage;
-(void) previousFeedPage;

@end