//
//  ImageViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 10/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "GalleryViewController.h"
#import "TBXML.h"
#import "Functions.h"
#import "Config.h"
#import "app_builderAppDelegate.h"
#import "NSString+HTML.h"

@implementation GalleryViewController

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) hideAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

- (void) stopAnimated
{
	// [self hideAnimated:nil];
	[Functions stopAnimated:self.view];
}

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        infoData = data;
    }
    return self;
}

- (id) init 
{
	if((self = [super init])) 
	{
		pageIndex = 0;
		zoomMode = NO;
		
		maxPages = 0;
		
    }
    return self;
}

- (void)viewDidLoad {
	
	pageIndex = 0;			
	zoomMode = NO;
	goEnd = NO;

	[Functions initToolBar:self.view withTitle:@" "];
    [Functions initWaitView:self.view];
    [Functions showAnimated:self.view];
	// [self initWaitView];
	// // [self showAnimated:nil];
	[self performSelector:@selector(processInfo) withObject:nil afterDelay:0.5];
	// [self processInfo];
}

- (void)processInfo {
	// [self showAnimated:nil];
	maxPages = 0;
	// bh	
	NSMutableArray * aImages; // = [[NSMutableArray init] alloc];
	NSMutableArray * aTitles; // = [[NSMutableArray init] alloc];
	// NSString *feedSource; // = [[NSString init] alloc];
	// UILabel *counter;
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	//tabbar
	NSString * currentFeed = [cnf loadValue:@"currentFeedPage"];
	currentFeedPage=1;
	if ([currentFeed intValue] != currentFeedPage)
		currentFeedPage = [currentFeed intValue];
	if (currentFeedPage == 0) currentFeedPage = 1;
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * title = @"Gallery";
	NSString * url = @"";
	NSString * perPage = @"10";
	NSString * imageName = @"";
	NSString * titleName = @"";
	NSString * imageIdItem = @"";
	// NSString * titleIdItem = @"";
	NSString * imageIdType = @"";
	// NSString * titleIdType = @"";
	NSLog(@"root");
	if (root) {
		BOOL f = FALSE;
		
		childXMLElement = root->firstChild;
		
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"slide_title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"slide_image"]) {
									imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			
			imageIdItem = @"";
			imageIdType = @"";
			// titleIdItem = @"";
			// titleIdType = @"";
			
		}
		
	}
	
	aImages = [[NSMutableArray alloc] init];
	aTitles = [[NSMutableArray alloc] init];
	
	// feedSource = url;
	//NSURL *u = [NSURL URLWithString:url];
	url=[url stringByReplacingOccurrencesOfString:@"page_num=1"
									   withString:@"page_num=%i"];
	NSLog(@"URL - FINAL %@", [NSString stringWithFormat:url, currentFeedPage]);
	
	NSURL *u = [NSURL URLWithString:[NSString stringWithFormat:url, currentFeedPage]];
	// NSString *xmlFile = [NSString stringWithContentsOfURL:u];
	NSData *myXMLData; //   = [NSData dataWithContentsOfURL:u];
	// [myXMLData writeToFile:databasePath atomically:YES];
	
	NSDate *date = [NSDate date];
	NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, currentFeedPage];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage]];
	
	NSString *databaseNameValue = [cnf loadValue:databaseName];
	
	if([databaseNameValue isEqualToString:@""] || databaseNameValue == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		myXMLData = [NSData dataWithContentsOfURL:u];
		NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		[dateFormat release];
		[cnf updateValue:databaseName value:dateString];
	} else {
		
		NSLog(@"use ... ");
		NSTimeInterval dateTime;		
		// NSDateFormatter *
		NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:databaseNameValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);  
		if(dateTime > 1) {
			NSLog(@"down (2)... ");
			myXMLData = [NSData dataWithContentsOfURL:u];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage] value:dateString];
			
			NSFileManager* fileManager = [NSFileManager defaultManager];
			fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]];
			[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
			
			NSError *error = nil;
			for (NSString *file in [fileManager contentsOfDirectoryAtPath:fileName error:&error]) {
				BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", fileName, file] error:&error];
				if (!success || error) {
					// it failed.
					// NSLog(@"err: %@%@", fileName, file);
				} else {
					// NSLog(@"del: %@%@", fileName, file);
				}
			}
		} else {
			myXMLData = [NSData dataWithContentsOfFile:fileName];
		}
		[dateFormat release];
	}

	// NSLog(@"bk: %@", fileName);
	[myXMLData writeToFile:fileName atomically:YES];
	// fill images
	imagesArray = [[NSMutableArray alloc] init];
	// [self addImageFromName:@"1.png"];
	// [self addImageFromName:@"2.png"];
	// [self addImageFromName:@"3.png"];
	// [self addImageFromName:@"4.png"];
	// [self addImageFromName:@"5.png"];
	
	NSFileManager* fileManager = [NSFileManager defaultManager];
	fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]];
	[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
	
	/*
	 NSFileManager* fileManager = [NSFileManager defaultManager];
	 NSString* documentsDir = [filePath stringByDeletingLastPathComponent];
	 NSString *tmpPath = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage]];
	 [fileManager createDirectoryAtPath:tmpPath attributes:nil];
	 */
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	root = tbxml.rootXMLElement;
	[tbxml release];
	if (root) {
		childXMLElement = root->firstChild;
		do {
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				NSString * num_items = [TBXML valueOfAttributeNamed:@"num_items" forElement:childXMLElement];
				maxSlideNumber=[num_items intValue];
				do {
					TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
					NSString * image = @"";
					NSString * imgTitle = @"";
					do {
						if ([[TBXML elementName:itemXMLElement] isEqualToString:imageName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							// element.image = [TBXML textForElement:itemXMLElement];
							image = [TBXML textForElement:itemXMLElement];
							[self addImageFromName:image 
										withFolder:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]
							 ];
							// NSLog(@"u: %@", image);
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							// element.image = [TBXML textForElement:itemXMLElement];
							imgTitle = [TBXML textForElement:itemXMLElement];
							// NSLog(@"t: %@", title);
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
					// [self.aImages addObject: image];
					NSMutableArray *imageData = [NSArray arrayWithObjects: image, imageIdItem, imageIdType, nil];
					// NSLog(@"img: %@ ** %@ ** %@ ** ...", image, imageIdItem, imageIdType);
					[aImages addObject: imageData];
					// NSMutableArray *titleData = [NSArray arrayWithObjects: title, titleIdItem, titleIdType, nil];
					// [aTitles addObject: titleData];
					[aTitles addObject: imgTitle];
					// [image release];
					// [images addObject:[TBXML valueOfAttributeNamed:@"url" forElement:childXMLElement]];
					maxPages++;
					// NSString *str = [[NSString alloc] initWithString:@"blah"]; 
					// [array addObject: str];
					// [str release];
				} while ((dataXMLElement = dataXMLElement->nextSibling));
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
		
	}
	
	// maxPages = [imagesArray count];
	[aImages release];
	
	/*int tabSpace = 25;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 73;*/
	
	// UIView * mainview = [[UIView alloc] initWithFrame:CGRectMake(0, 44, 320, 460-tabSpace)];
	UIView * mainview = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];
	mainview.backgroundColor = [UIColor clearColor];
	mainview.backgroundColor = [UIColor blackColor];
    [Functions initWaitView:mainview];
    [Functions showAnimated:mainview];
	
		mainview.autoresizingMask = UIViewAutoresizingFlexibleRightMargin
		| UIViewAutoresizingFlexibleLeftMargin
        | UIViewAutoresizingFlexibleWidth
        | UIViewAutoresizingFlexibleHeight;
	
	// a page is the width of the scroll view
	// scrollView = [[CustomScrollView alloc] initWithFrame:CGRectMake(0, 0, 320, 460-tabSpace)];
		scrollView = [[CustomScrollView alloc] initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];
		scrollView.frame = CGRectMake(0, 0, mainview.frame.size.width, mainview.frame.size.height);
        scrollView.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth
        | UIViewAutoresizingFlexibleBottomMargin | UIViewAutoresizingFlexibleTopMargin
        | UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;
	scrollView.hidden = YES;
	scrollView.maindelegate = self;
	scrollView.pagingEnabled = YES;
	scrollView.contentSize = CGSizeMake(scrollView.frame.size.width * (maxPages+2), scrollView.frame.size.height);
	scrollView.showsHorizontalScrollIndicator = NO;
	scrollView.showsVerticalScrollIndicator = NO;
	scrollView.scrollsToTop = NO;
	scrollView.delegate = self;
	scrollView.userInteractionEnabled = YES;
	scrollView.multipleTouchEnabled = YES;
	[mainview addSubview:scrollView];
	// [mainview sendSubviewToBack:scrollView];
	// [self.view addSubview:scrollView];
	// [self.view sendSubviewToBack:scrollView];
	[Functions addToolBar:mainview withTitle:@" " actualId:actualId];
	[Functions addStatusBar:mainview withTabBar:[tabbar intValue]];
    [Functions showAnimated:mainview];

	contArray = [[NSMutableArray alloc] init];

	ImageViewController * imgCont = [[ImageViewController alloc] 
									 initWithThumb:nil
									 withTitle:@""
									 withFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];
	
	[contArray addObject:imgCont];
	CGRect frame = scrollView.frame;
	frame.origin.x = frame.size.width;
	frame.origin.y = 0;
	imgCont.view.frame = frame;
	[scrollView addSubview:imgCont.view];
	[imgCont release];
	
	for(int i=0 ; i<[imagesArray count] ; i++) {
		imageInfo * thumb = [imagesArray objectAtIndex:i];
		// ImageViewController * imgCont = [[ImageViewController alloc] 
		// 								 initWithThumb:thumb
		// 						 withTitle:[aTitles objectAtIndex:i]
		// 						 withFrame:CGRectMake(0, 0, 320, 460-44-tabSpace)];
		ImageViewController * imgCont = [[ImageViewController alloc] initWithThumb:thumb
			withTitle:[aTitles objectAtIndex:i]
			withFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];

		[imgCont setPageIndex:i];
		imgCont.view.userInteractionEnabled = NO; //
		[contArray addObject:imgCont];
			thumb.autoresizingMask = UIViewAutoresizingFlexibleRightMargin
			| UIViewAutoresizingFlexibleLeftMargin
			| UIViewAutoresizingFlexibleTopMargin
			| UIViewAutoresizingFlexibleBottomMargin;
		
		// add the controller's view to the scroll view
		if (nil == imgCont.view.superview) {
			CGRect frame = scrollView.frame;
			frame.origin.x = frame.size.width * (i+1);
			frame.origin.y = 0;
			imgCont.view.frame = frame;
			[scrollView addSubview:imgCont.view];
		}
		[imgCont release];
	}		

	imgCont = [[ImageViewController alloc] 
									 initWithThumb:nil
									 withTitle:@""
			   withFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];
	
	[aTitles release];
	
	[contArray addObject:imgCont];
	frame = scrollView.frame;
	frame.origin.x = frame.size.width * ([imagesArray count]+1);
	frame.origin.y = 0;
	imgCont.view.frame = frame;
	[scrollView addSubview:imgCont.view];
	[imgCont release];
	
	if (pageControl == nil)
	{
	pageControl = [[StylePageControl alloc] init];
	pageControl.numberOfPages = maxPages+2;
	pageControl.currentPage = 1;
	pageControl.hidesForSinglePage = NO;
	pageControl.frame = CGRectMake(0, 440, 320, 20);
		pageControl.frame = CGRectMake(0, 440, self.view.bounds.size.width, 20);
	}
	pageControl.userInteractionEnabled = YES;
	[pageControl addTarget:self action:@selector(changePage:)forControlEvents:UIControlEventValueChanged];
	// [mainview addSubview:pageControl];
	
	counter = [[UILabel alloc] initWithFrame:
			   CGRectMake(0,44,self.view.bounds.size.width,15)];
	counter.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	counter.text = [NSString stringWithFormat: @"Slide %i of %i",((currentFeedPage-1)*10)+1 , maxSlideNumber];
	counter.backgroundColor = [UIColor blackColor];
	counter.textColor = [UIColor whiteColor];
	counter.font = [UIFont boldSystemFontOfSize:12];
	counter.textAlignment = UITextAlignmentCenter;
	[mainview addSubview:counter];
	// [self.view addSubview:counter];
	
	UIButton *btnNext = (UIButton *)[self.view viewWithTag:5991];
	UIButton *btnPrev = (UIButton *)[self.view viewWithTag:5992];

	if (btnNext == nil)
	{
	btnNext = [UIButton buttonWithType:UIButtonTypeCustom];
		btnNext.tag = 5991;
	}
	if (btnPrev == nil)
	{
	btnPrev = [UIButton buttonWithType:UIButtonTypeCustom];
		btnPrev.tag = 5992;
	}
	btnNext.backgroundColor = [UIColor clearColor];
	btnNext.frame = CGRectMake(240, 45, 80, 15);
	[btnNext  setTitle:@"Next" forState:UIControlStateNormal];
	btnNext.titleLabel.font=[UIFont boldSystemFontOfSize:12];
	[btnNext setTitleColor:[UIColor whiteColor] forState: UIControlStateNormal];
	[btnNext setTitleColor:[UIColor colorWithRed:0xff/255.0 green:0xa2/255.0 blue:0x53/255.0 alpha:1.0] forState: UIControlStateHighlighted];
	[btnNext addTarget:self action:@selector(nextFeedPage) forControlEvents:UIControlEventTouchUpInside];
	btnNext.reversesTitleShadowWhenHighlighted=YES;
	
	
	[btnPrev setTitleColor:[UIColor whiteColor] forState: UIControlStateNormal];
	btnPrev.backgroundColor = [UIColor clearColor];
	btnPrev.frame = CGRectMake(0, 45, 80, 15);
	[btnPrev  setTitle:@"Previous" forState:UIControlStateNormal];
	[btnPrev setTitleColor:[UIColor colorWithRed:0xff/255.0 green:0xa2/255.0 blue:0x53/255.0 alpha:1.0] forState: UIControlStateHighlighted];
	btnPrev.titleLabel.font=[UIFont boldSystemFontOfSize:12];
	[btnPrev addTarget:self action:@selector(previousFeedPage) forControlEvents:UIControlEventTouchUpInside];
	btnPrev.reversesTitleShadowWhenHighlighted=YES;
	
    btnNext.hidden = NO;
    btnPrev.hidden = NO;
    NSLog(@"pp mn ** %i %i %i", currentFeedPage, (currentFeedPage-1)*[perPage intValue], maxSlideNumber);
    NSLog(@"if %i <= %i", maxSlideNumber, currentFeedPage*[perPage intValue]);
	if (maxSlideNumber <= currentFeedPage*[perPage intValue]-2)
		btnNext.hidden = YES;
	if (currentFeedPage == 1)
		btnPrev.hidden = YES;
	[mainview addSubview:btnPrev];
	[mainview addSubview:btnNext];
// bh delete it...
	btnNext.hidden = YES;

 	self.view = mainview;
	[mainview release];		
	
	[self initStatusBar:self.view];
	[self initWaitView];
	// [self showAnimated:nil];

	NSString * selectedItem = [cnf loadValue:@"selectedListItem"];
	[cnf updateValue:@"selectedListItem" value:@"0"];
	if (![selectedItem isEqualToString:@"0"]) {
		pageControl.currentPage = [selectedItem intValue]+1;
		pageControlUsed = YES;
		[self changePage:nil];
	}
	else {
		pageControl.currentPage = 1;
		[self changePage:nil];
	}

	// [Functions initToolBar:self.view withTitle:title]; // withTitle:@"Gallery" withView:NO];
	// [self hideAnimated:nil];
	UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
	toolbarTitle.text = title;

	[cnf release];

	if (goEnd)
	{
		goEnd = NO;
		NSLog(@"03294802348 20394802 948203948 02394820 39482094 8203948 021984 029348 0239148 023948120 3498 0291348 ");
		// scrollView.contentOffset = CGPointMake(320*9, 0);
		scrollView.contentOffset = CGPointMake(320*9, 0);
		pageControlUsed = YES;
		pageControl.currentPage = 10;
		// [self setCurrentPage:10];
		[self changePage:nil];
	}
	scrollView.hidden = NO;
	[self performSelector:@selector(stopAnimated) withObject:nil afterDelay:1];
	
}

- (void) changePage:(id)sender
{
	[Functions showAnimated:self.view];

	int page = (int)pageControl.currentPage;
	[self setCurrentPage:page];
	
	// NSLog(@"changePage %d",page);
	// counter.text = [NSString stringWithFormat: @"Slide %i of %i",((currentFeedPage-1)*10)+1 , maxSlideNumber];

	CGRect frame = scrollView.frame;
	frame.origin.x = frame.size.width * page;
	frame.origin.y = 0;
	[scrollView scrollRectToVisible:frame animated:YES];
	[Functions stopAnimated:self.view];

}

- (void) setCurrentPage:(NSUInteger)page 
{
	if (page == pageIndex)
		return;

	[Functions showAnimated:self.view];

	int actualPage;
	// if (page == 0) page = 1; 
	actualPage = page+1;
	//NSLog(@"set Current Page %d",actualPage);
	counter.text = [NSString stringWithFormat: @"Slide %i of %i",(((currentFeedPage-1)*10)+actualPage-1), maxSlideNumber];
	//NSLog(@"currentPage:%d", page);
	pageIndex = page;
	pageControl.currentPage = page;
	
	UIButton *btnNext = (UIButton *)[self.view viewWithTag:5991];
	UIButton *btnPrev = (UIButton *)[self.view viewWithTag:5992];

	NSString *perPage = @"12";

	btnNext.hidden = YES;
    btnPrev.hidden = YES;
    //NSLog(@"pp mn -- %i %i %i", currentFeedPage, (currentFeedPage-1)*[perPage intValue], maxSlideNumber);
    //NSLog(@"if %i <= %i page %i == 10", maxSlideNumber, currentFeedPage*[perPage intValue], page);
	if (maxSlideNumber > currentFeedPage*[perPage intValue] && page == 10)
	{
		btnNext.hidden = NO;
	}
	if (maxSlideNumber > currentFeedPage*[perPage intValue] && page == 11)
	{
		[self nextFeedPage];
	}
	if (currentFeedPage > 1 && page == 1)
	{
		btnPrev.hidden = NO;
	}
	if (currentFeedPage > 1 && page == -1)
	{
		[self previousFeedPage];
	}
	

}

- (imageInfo*) getCurrentImage
{
	return [imagesArray objectAtIndex:pageIndex];
}

- (ImageViewController*) getCurrentController
{
	return [contArray objectAtIndex:pageIndex];
}

- (void) addImageFromName:(NSString*)imagename
			   withFolder:(NSString *)foldername
{
	imageInfo * thumb = [[imageInfo alloc] initWithName:imagename withFolder:foldername withParentFrame:self.view.frame]; 
	[imagesArray addObject:thumb];	
	[thumb release];
}


// -------- Touch Events from CustomScrollView delegate --------

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event 
{
	UITouch *aTouch = [touches anyObject];
    if (aTouch.tapCount == 2) {
		[NSObject cancelPreviousPerformRequestsWithTarget:self];
	}	
	if(zoomMode == YES) {
		ImageViewController * imagecont = [self getCurrentController];
		[imagecont touchesBegan:touches withEvent:event];
	}
}

- (void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event 
{
	UITouch *theTouch = [touches anyObject];
	//CGPoint currentTouchPosition = [theTouch locationInView:self.view];
	NSDictionary *touchLoc = [NSDictionary dictionaryWithObject:
							  [NSValue valueWithCGPoint:[theTouch locationInView:self.view]] forKey:@"location"];
	
    if (theTouch.tapCount == 1) {
		[self performSelector:@selector(handleSingleTap:) withObject:touchLoc afterDelay:0.3];
	} 
	else if (theTouch.tapCount == 2) {
		[self performSelector:@selector(handleDoubleTap:) withObject:touchLoc afterDelay:0.01];
	}	
	
	if(zoomMode == YES) {
		ImageViewController * imagecont = [self getCurrentController];
		[imagecont touchesEnded:touches withEvent:event];
	}
}

- (void) touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event 
{
	// NSLog(@"touchesMoved");
	NSSet *allTouches = [event allTouches];
	NSArray *t = [allTouches allObjects];
	NSInteger numberOfTouches = [t count];
	// NSLog(@"no. %i", numberOfTouches);
	switch(numberOfTouches)
	{					
		case 1:
		{	
			[self setZoomMode:YES];
		}
			break;
		case 2:
		{	
			[self setZoomMode:YES];
		}
			break;
	}
	
	if(zoomMode == YES) {
		ImageViewController * imagecont = [self getCurrentController];
		[imagecont touchesMoved:touches withEvent:event];
	}
}

- (void) touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event 
{
	NSLog(@"touchesCancelled");
	//[self clearTouches];	
	//[scrollView touchesCancelled:touches withEvent:event];
	if(zoomMode == YES) {
		ImageViewController * imagecont = [self getCurrentController];
		[imagecont touchesCancelled:touches withEvent:event];
	}
}

- (void) handleSingleTap:(NSDictionary *)touches 
{
	NSLog(@"simpleTap");
	// [self setZoomMode:YES];
	ImageViewController * imagecont = [self getCurrentController];
	[imagecont handleDoubleTap:touches]; //
	zoomMode = [imagecont getZoomMode];
	[self setZoomMode:zoomMode];
}

- (void) handleDoubleTap:(NSDictionary *)touches 
{
	NSLog(@"doubleTap");
	/*
	 ImageViewController * imagecont = [self getCurrentController];
	 [imagecont handleDoubleTap:touches]; //
	 zoomMode = [imagecont getZoomMode];
	 [self setZoomMode:zoomMode];
	 */
	[self goDetail];
}

- (void) setZoomMode:(Boolean)status
{
	zoomMode = status;
	if(zoomMode) {
		// pageControl.hidden = YES;
		// pageControl.userInteractionEnabled = NO;
		scrollView.pagingEnabled = NO;
		scrollView.showsVerticalScrollIndicator = scrollView.showsHorizontalScrollIndicator = YES;
		scrollView.bouncesZoom = YES;
		scrollView.scrollEnabled = NO;
		// bh
		//		scrollView.pagingEnabled = YES;
		//		scrollView.showsVerticalScrollIndicator = scrollView.showsHorizontalScrollIndicator = NO;
		//		scrollView.scrollEnabled = YES;
	}
	else {
		// pageControl.hidden = NO;
		// pageControl.userInteractionEnabled = YES;
		scrollView.pagingEnabled = YES;
		scrollView.showsVerticalScrollIndicator = scrollView.showsHorizontalScrollIndicator = NO;
		scrollView.scrollEnabled = YES;
	}
}

// -------- delegates UIScrollView  ---------

- (UIView *) viewForZoomingInScrollView:(UIScrollView *)scrollView {
	NSLog(@"viewForZoomingInScrollView");
	if(zoomMode == NO) {
		[self setZoomMode:YES];
	}
	ImageViewController * imagecont = [self getCurrentController];
	return imagecont.view;
}

- (void) scrollViewWillBeginZooming:(UIScrollView *)scrollView withView:(UIView *)view { //__OSX_AVAILABLE_STARTING(__MAC_NA,__IPHONE_3_2); // called before the scroll view begins zooming its content
	NSLog(@"scrollViewWillBeginZooming");
}

- (void) scrollViewDidEndZooming:(UIScrollView *)scrollView withView:(UIView *)view atScale:(float)scale {
	NSLog(@"scrollViewDidEndZooming");
}

- (void) scrollViewDidScroll:(UIScrollView *)sender {
	// NSLog(@"scrollViewDidScroll");
    // We don't want a "feedback loop" between the UIPageControl and the scroll delegate in
    // which a scroll event generated from the user hitting the page control triggers updates from
    // the delegate method. We use a boolean to disable the delegate logic when the page control is used.
	if (pageControlUsed) {
        // do nothing - the scroll was initiated from the page control, not the user dragging
        return;
    }
	
	[Functions showAnimated:self.view];

	if(zoomMode == NO) {
		// int p = roundf(scrollView.contentOffset.x / 320);
		int p = roundf(scrollView.contentOffset.x / self.view.bounds.size.width);
		// NSLog(@"scrollViewDidScroll mode : %f %d p : %d", (float)scrollView.contentOffset.x, (int)(320), p);
		if (p == 0 && currentFeedPage == 1) 
		{
			p = 1;
			pageControl.currentPage = p;
			[self changePage:nil];
		}
		if (p == 0 && currentFeedPage > 1 && pageControl.currentPage == 1) 
		{
			p = -1;
			pageControl.currentPage = 10;
			[self changePage:nil];
		}
		if (((currentFeedPage-1)*10)+p == maxSlideNumber+1)
		{
			//currentFeedPage = maxSlideNumber%10;
			p -= 1;
			pageControl.currentPage = p;
			[self changePage:nil];
		}
		[self setCurrentPage:p];		
	}

    // Switch the indicator when more than 50% of the previous/next page is visible
    CGFloat pageWidth = scrollView.frame.size.width;
    int page = floor((scrollView.contentOffset.x - pageWidth / 2) / pageWidth) + 1;
    pageControl.currentPage = page;

}

// At the begin of scroll dragging, reset the boolean used when scrolls originate from the UIPageControl
- (void) scrollViewWillBeginDragging:(UIScrollView *)scrollView {
	NSLog(@"scrollViewWillBeginDragging");
    pageControlUsed = NO;
}

// At the end of scroll animation, reset the boolean used when scrolls originate from the UIPageControl
- (void) scrollViewDidEndDecelerating:(UIScrollView *)scrollView {
	NSLog(@"scrollViewDidEndDecelerating");
    pageControlUsed = NO;
	[Functions stopAnimated:self.view];
}

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void) dealloc 
{
	[imagesArray release];
	[contArray release];
	[scrollView release];
	[pageControl release];
	[infoData release];
	[label release];
	[toolbar release];
	[counter release];
	[waitView release];
	[waitLabel release];
    [super dealloc];
}

- (void) initStatusBar:(UIView *)actualView {
	Config *cnf = [[Config alloc] init];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	/*int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 48;
	
	/ *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 25; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 435-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	*/
	toolbar = (UIToolbar *)[actualView viewWithTag:11003];

	/*
	 // info
	 UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
	 [infoButton addTarget:self action:@selector(goDetail) forControlEvents:UIControlEventTouchUpInside];
	 // const NSInteger IMAGE_TAG = 1003;
	 // UIImage * btnImage = [UIImage alloc];
	 infoButton.frame = CGRectMake(290, 2, 20, 20);
	 UIImage * btnImage = [UIImage imageNamed:@"info_icon.png"];
	 // infoButton.tag = IMAGE_TAG;
	 infoButton.backgroundColor = [UIColor clearColor];
	 [infoButton setImage:btnImage forState:UIControlStateNormal];
	 // [btnImage release];
	 [toolbar addSubview:infoButton];
	 // [infoButton release];
	 // info
	 */
	[actualView addSubview:toolbar];
	
	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goRefresh) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	// btnImage = [[UIImage alloc] init];
	button.frame = CGRectMake(288, 2, 20, 20);
	[button setFrame:CGRectMake([toolbar frame].size.width -32, 2, 30, 30)];
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage * btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	
	[toolbar addSubview:button];
	
	// [button release];
	
	// info
	UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[infoButton addTarget:self action:@selector(goInfo) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	infoButton.frame = CGRectMake(14, 2, 20, 20);
	btnImage = [UIImage imageNamed:@"info_icon.png"];
	// infoButton.tag = IMAGE_TAG;
	infoButton.backgroundColor = [UIColor clearColor];
	[infoButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:infoButton];
	// [infoButton release];
	// info
	
	// detail
	UIButton *detailButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[detailButton addTarget:self action:@selector(goDetail) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	detailButton.frame = CGRectMake(45, 2, 20, 20);
	btnImage = [UIImage imageNamed:@"icon_detailview.png"];
	// detailButton.tag = IMAGE_TAG;
	detailButton.backgroundColor = [UIColor clearColor];
	[detailButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:detailButton];
	// [detailButton release];
	// detail
	
	
	// UILabel *
	label = [[UILabel alloc] initWithFrame:
			 CGRectMake(100,3,185,20)];
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	label.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
							  | UIViewAutoresizingFlexibleRightMargin 
							  | UIViewAutoresizingFlexibleLeftMargin 
							  | UIViewAutoresizingFlexibleTopMargin 
							  | UIViewAutoresizingFlexibleWidth);
	[label setFrame:CGRectMake([toolbar frame].size.width-225, 3, 185, 30)];
	[label setFrame:CGRectMake(self.view.frame.size.width-225, 3, 185, 30)];

    /*
	 NSDateFormatter *formatter = [[[NSDateFormatter alloc] init] autorelease];
	 NSDate *date = [NSDate date];
	 [formatter setDateFormat:@"MM/dd/YY HH:mm"];
	 // [label setText:[formatter stringFromDate:date]];
	 [label setText:[NSString stringWithFormat:@"Updated: %@", [formatter stringFromDate:date]]];
	 */
	NSString * displayId = [cnf loadValue:@"actualId"];
	if ([tabbar isEqualToString:@"1"])
		displayId = [infoData valueForKey:@"idTab"];
	
	// NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", displayId,currentFeedPage];
	
	NSString *newName = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", displayId,currentFeedPage];
	NSString *newNameValue = [cnf loadValue:newName];
	
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"yyyyMMddHHmm"];
	NSDate *lastCheck = [dateFormat dateFromString:newNameValue];
	
	[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
	[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
	[dateFormat release];
    label.backgroundColor = [UIColor clearColor];
    // label.backgroundColor = [UIColor blueColor];
    label.textColor = [UIColor whiteColor];
    label.font = [UIFont boldSystemFontOfSize:11];
    label.textAlignment = UITextAlignmentRight;
	
	
	[toolbar addSubview:label];
    // [label release];
	
	[cnf release];
}

-(void) nextFeedPage{
	currentFeedPage++;
	Config *cnf = [[Config alloc] init];
	[cnf updateValue:@"currentFeedPage" value:[NSString stringWithFormat:@"%i", currentFeedPage]];
	[cnf release];
	// [self showAnimated:nil];
	// [self performSelector:@selector(startProcess) withObject:nil afterDelay:0.5];

	[self processInfo];
}

-(void) previousFeedPage{

	if (currentFeedPage>1)
	{
		goEnd = YES;
		// [self showAnimated:nil];
		currentFeedPage--;
		Config *cnf = [[Config alloc] init];
		[cnf updateValue:@"currentFeedPage" value:[NSString stringWithFormat:@"%i", currentFeedPage]];
		[cnf release];
		// [self showAnimated:nil];
		// [self performSelector:@selector(startProcess) withObject:nil afterDelay:0.5];
		[self processInfo];
	}
}

- (void) goRefresh {
	// [self showAnimated:nil];
	
	maxPages = 0;
	NSString * url = @"";
	NSString * imageName = @"";
	NSString * titleName = @"";
	NSString * perPage = @"10";
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	
	NSString * title = @"Gallery";

	// UIView * mainview = [[UIView alloc] initWithFrame:CGRectMake(0, 44, 320, 460-tabSpace)];
	// mainview.backgroundColor = [UIColor blackColor];
	// UIView * mainview = [[UIView alloc] initWithFrame:CGRectMake(0, 44, 320, 460-tabSpace)];
	UIView * mainview = [[UIView alloc] initWithFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];
	[Functions addToolBar:mainview withTitle:@" " actualId:actualId];
	[Functions addStatusBar:mainview withTabBar:[tabbar intValue]];
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"slide_title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"slide_image"]) {
									imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			
			// imageIdItem = @"";
			// imageIdType = @"";
			// titleIdItem = @"";
			// titleIdType = @"";
		}
	}
	
	// NSMutableArray * aImages; // = [[NSMutableArray alloc] init];
	NSMutableArray * aTitles = [[NSMutableArray alloc] init];
	// NSURL *u = [NSURL URLWithString:url];
	// NSLog(@"URL - FINAL %@", [NSString stringWithFormat:url, currentFeedPage]);
	NSURL *u = [NSURL URLWithString:[NSString stringWithFormat:url, currentFeedPage]];
	// NSString *xmlFile = [NSString stringWithContentsOfURL:u];
	NSData *myXMLData; //   = [NSData dataWithContentsOfURL:u];
	// [myXMLData writeToFile:databasePath atomically:YES];
	
	/*NSString * displayId = [cnf loadValue:@"actualId"];
	if ([tabbar isEqualToString:@"1"])
		displayId = [infoData valueForKey:@"idTab"];*/
	
	// NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_4.xml", displayId];
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage]];
	
	NSLog(@"down ... ");
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	myXMLData = [NSData dataWithContentsOfURL:u];
	[dateFormat setDateFormat:@"yyyyMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	NSString *currentXmlValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage]];
	if([currentXmlValue isEqualToString:@""] || currentXmlValue == nil)
		[cnf insertValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage] value:dateString];
	else
		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId,currentFeedPage] value:dateString];
	
	[myXMLData writeToFile:fileName atomically:YES];
	imagesArray = [[NSMutableArray alloc] init];
	maxPages = 0;
	
	NSFileManager* fileManager = [NSFileManager defaultManager];
	fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]];
	[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
	
	NSError *error = nil;
	for (NSString *file in [fileManager contentsOfDirectoryAtPath:fileName error:&error]) {
		BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", fileName, file] error:&error];
		if (!success || error) {
			// it failed.
			// NSLog(@"err: %@%@", fileName, file);
		} else {
			// NSLog(@"del: %@%@", fileName, file);
		}
	}
	
	// NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	// [dateFormat setDateFormat:@"yyyyMMddHHmm"];
	// NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
	
	[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
	[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:date]]];
	
	[dateFormat release];
	
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	root = tbxml.rootXMLElement;
	[tbxml release];
	if (root) {
		childXMLElement = root->firstChild;
		do {
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				
				do {
					TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
					NSString * image = @"";
					NSString * title = @"";
					do {
						if ([[TBXML elementName:itemXMLElement] isEqualToString:imageName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							// element.image = [TBXML textForElement:itemXMLElement];
							image = [TBXML textForElement:itemXMLElement];
							[self addImageFromName:image 
										withFolder:[NSString stringWithFormat:@"tmp_%@_4_%i", actualId,currentFeedPage]
							 ];
							// NSLog(@"u: %@", image);
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							// element.image = [TBXML textForElement:itemXMLElement];
							title = [TBXML textForElement:itemXMLElement];
							// NSLog(@"t: %@", title);
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
					// NSMutableArray *imageData = [NSArray arrayWithObjects: image, @"", @"", nil];
					// [aImages addObject: imageData];
					// NSMutableArray *titleData = [NSArray arrayWithObjects: title, @"", @"", nil];
					[aTitles addObject: title];
					maxPages++;
					// [image release];
					// [images addObject:[TBXML valueOfAttributeNamed:@"url" forElement:childXMLElement]];
					// NSString *str = [[NSString alloc] initWithString:@"blah"]; 
					// [array addObject: str];
					// [str release];
				} while ((dataXMLElement = dataXMLElement->nextSibling));
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
		
	}
	// NSLog(@"total: %i", maxPages);
	
	/*
	 scrollView.pagingEnabled = YES;
	 scrollView.showsHorizontalScrollIndicator = NO;
	 scrollView.showsVerticalScrollIndicator = NO;
	 scrollView.scrollsToTop = NO;
	 scrollView.delegate = self;
	 
	 pageControl = [[StylePageControl alloc] init];
	 pageControl.numberOfPages = maxPages;
	 pageControl.currentPage = 0;
	 pageControl.hidesForSinglePage = NO;
	 pageControl.frame = CGRectMake(0, 60, 320, 20);
	 pageControl.userInteractionEnabled = YES;
	 [pageControl addTarget:self action:@selector(changePage:)forControlEvents:UIControlEventValueChanged];
	 // [self.view addSubview:pageControl];
	 */
	counter.text = [NSString stringWithFormat: @"Slide %i of %i",((currentFeedPage-1)*10)+1 , maxSlideNumber];
	
	int tabSpace = 25;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 73;
	
	
	// a page is the width of the scroll view
	scrollView = [[CustomScrollView alloc] initWithFrame:CGRectMake(0, 0, 320, 460-tabSpace)];
	scrollView.maindelegate = self;
	scrollView.pagingEnabled = YES;
	scrollView.contentSize = CGSizeMake(scrollView.frame.size.width * maxPages, scrollView.frame.size.height);
	scrollView.showsHorizontalScrollIndicator = NO;
	scrollView.showsVerticalScrollIndicator = NO;
	scrollView.scrollsToTop = NO;
	scrollView.delegate = self;
	scrollView.userInteractionEnabled = YES;
	scrollView.multipleTouchEnabled = YES;
	[mainview addSubview:scrollView];
	
	contArray = [[NSMutableArray alloc] init];
	for(int i=0 ; i<[imagesArray count] ; i++) {
		imageInfo * thumb = [imagesArray objectAtIndex:i];
		ImageViewController * imgCont = [[ImageViewController alloc] 
										 initWithThumb:thumb
										 withTitle:[aTitles objectAtIndex:i] 
										 withFrame:CGRectMake(0, 0, 320, 460-44-tabSpace)];
		
		[imgCont setPageIndex:i];
		imgCont.view.userInteractionEnabled = NO; //
		[contArray addObject:imgCont];
		
		// add the controller's view to the scroll view
		if (nil == imgCont.view.superview) {
			CGRect frame = scrollView.frame;
			frame.origin.x = frame.size.width * i;
			frame.origin.y = 0;
			imgCont.view.frame = frame;
			[scrollView addSubview:imgCont.view];
		}
		[imgCont release];
	}		
	
	[aTitles release];
	
	pageControl = [[StylePageControl alloc] init];
	pageControl.numberOfPages = maxPages+2;
	pageControl.currentPage = 0;
	pageControl.hidesForSinglePage = NO;
	pageControl.frame = CGRectMake(0, 440, 320, 20);
	pageControl.userInteractionEnabled = YES;
	[pageControl addTarget:self action:@selector(changePage:)forControlEvents:UIControlEventValueChanged];
	// [mainview addSubview:pageControl];
	
	counter = [[UILabel alloc] initWithFrame:
			   CGRectMake(0,44,320,15)];
	counter.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	counter.text = [NSString stringWithFormat: @"Slide %i of %i",((currentFeedPage-1)*10)+1 , maxSlideNumber];
	counter.backgroundColor = [UIColor blackColor];
	counter.textColor = [UIColor whiteColor];
	counter.font = [UIFont boldSystemFontOfSize:12];
	counter.textAlignment = UITextAlignmentCenter;
	[mainview addSubview:counter];
	
	// UIButton *btnNext = [UIButton buttonWithType:UIButtonTypeCustom];
	// UIButton *btnPrev = [UIButton buttonWithType:UIButtonTypeCustom];
	UIButton *btnNext = (UIButton *)[self.view viewWithTag:5991];
	UIButton *btnPrev = (UIButton *)[self.view viewWithTag:5992];
/*
	UIButton *btnNext = [UIButton buttonWithType:UIButtonTypeCustom];
	UIButton *btnPrev = [UIButton buttonWithType:UIButtonTypeCustom];
	btnNext.backgroundColor = [UIColor clearColor];
	btnNext.frame = CGRectMake(240, 45, 80, 15);
	[btnNext  setTitle:@"Next" forState:UIControlStateNormal];
	btnNext.titleLabel.font=[UIFont boldSystemFontOfSize:12];
	[btnNext setTitleColor:[UIColor whiteColor] forState: UIControlStateNormal];
	[btnNext setTitleColor:[UIColor colorWithRed:0xff/255.0 green:0xa2/255.0 blue:0x53/255.0 alpha:1.0] forState: UIControlStateHighlighted];
	[btnNext addTarget:self action:@selector(nextFeedPage) forControlEvents:UIControlEventTouchUpInside];
	btnNext.reversesTitleShadowWhenHighlighted=YES;
	
	
	[btnPrev setTitleColor:[UIColor whiteColor] forState: UIControlStateNormal];
	btnPrev.backgroundColor = [UIColor clearColor];
	btnPrev.frame = CGRectMake(0, 45, 80, 15);
	[btnPrev  setTitle:@"Previous" forState:UIControlStateNormal];
	[btnPrev setTitleColor:[UIColor colorWithRed:0xff/255.0 green:0xa2/255.0 blue:0x53/255.0 alpha:1.0] forState: UIControlStateHighlighted];
	btnPrev.titleLabel.font=[UIFont boldSystemFontOfSize:12];
	[btnPrev addTarget:self action:@selector(previousFeedPage) forControlEvents:UIControlEventTouchUpInside];
	btnPrev.reversesTitleShadowWhenHighlighted=YES;
	*/

    btnNext.hidden = NO;
    btnPrev.hidden = NO;
    NSLog(@"pp mn -- %i %i %i", currentFeedPage, (currentFeedPage-1)*[perPage intValue], maxSlideNumber);
    NSLog(@"if %i <= %i", maxSlideNumber, currentFeedPage*[perPage intValue]);
	if (maxSlideNumber <= currentFeedPage*[perPage intValue])
		btnNext.hidden = YES;
	if (currentFeedPage == 1)
		btnPrev.hidden = YES;
	[mainview addSubview:btnPrev];
	[mainview addSubview:btnNext];
	
	self.view = mainview;
	[mainview release];		
	
	[self changePage:nil];
	[self initStatusBar:self.view];
	
	[self hideAnimated:nil];
	
	[cnf release];
	
	// [Functions initToolBar:self.view withTitle:title];
	UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
	toolbarTitle.text = title;
	
}

- (void) goDetail {
	// [self showAnimated:nil];
	maxPages = 0;
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	
	
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * detailId = @"0";
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"slide_detail"]) {
									detailId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
		}		
	}
	
	NSLog(@"detail %@", detailId);
	
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	
	[cnf updateValue:@"selectedListItem" value:[NSString stringWithFormat:@"%i", (int)(pageControl.currentPage)-1]];
	[cnf updateValue:@"goUrl" value:@"---"];
	[cnf updateValue:@"displayId" value:detailId];
	[cnf updateValue:@"feedSource" value:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, currentFeedPage]];
	[cnf updateValue:@"currentFeedPage" value:[NSString stringWithFormat:@"%i", currentFeedPage]];
	
	[cnf release];
	
	[appDelegate displayView:@"7"];
}

- (void) goInfo {
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];*/
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"9"];
}

- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation   
										 duration:(NSTimeInterval)duration {  
	NSLog(@"rotate dc");
	// [scrollView willAnimateRotationToInterfaceOrientation:interfaceOrientation
	//												  duration:duration];
	
	NSLog(@"m1: %@", NSStringFromCGRect(CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)));
	NSLog(@"m1: %@", NSStringFromCGRect(CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height)));
	
	NSLog(@"sv: %@", NSStringFromCGRect(CGRectMake(0, 0, scrollView.frame.size.width * maxPages, scrollView.frame.size.height)));
	scrollView.contentSize = CGSizeMake(scrollView.frame.size.width * maxPages, scrollView.frame.size.height);
	
	UIView * mainview = self.view;
	NSLog(@"m1: %@", NSStringFromCGRect(mainview.frame));
	mainview.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
	
	NSLog(@"m2: %@", NSStringFromCGRect(mainview.frame));
	
	for (int i = 0; i < [contArray count]; i++)
	{
		ImageViewController * view = [contArray objectAtIndex:i];
		NSLog(@"v? %i %@", i, view);
		view.view.frame = CGRectMake(self.view.bounds.size.width*i, 0, self.view.bounds.size.width, self.view.bounds.size.height);
		[view setFrame:view.view.frame
		   parentFrame:CGRectMake(0, 0, self.view.bounds.size.width, self.view.bounds.size.height)];
		[view willAnimateRotationToInterfaceOrientation:interfaceOrientation
											   duration:duration];
	}
	
	// pageIndex = (int)pageControl.currentPage;
	// pageControl.currentPage = (int)pageControl.currentPage;
	[self changePage:nil];
	
}

@end
