//
//  GraphViewController.m
//  app_builder
//
//  Created by ivan bejarano on 9/13/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "GraphViewController.h"
#import "Functions.h"
#import "TBXML.h"
#import "Config.h"
#import "NSString+HTML.h"
#import "BarGraph.h"
#import "LineGraph.h"
#import "PieChartView.h"

@implementation GraphViewController

@synthesize waitLabel;

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	NSLog(@"start");
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	NSLog(@"stop");
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
		addedBars = NO;
    }
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
    
	// if (addedBars == NO)
	// {
	//	addedBars = YES;
		[Functions addToolBar:self.view withTitle:@" " actualId:actualId];
	//}
	[cnf release];


	/*
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	UIImage *tempImg = [[UIImage alloc] initWithData:imgData];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	[tempImg release];
	imageView.frame = CGRectMake(0, 0, 320, 410);
	[self.view addSubview:imageView];
	[imageView release];*/
	
	UIButton * prevButt = [UIButton buttonWithType:UIButtonTypeCustom];
	prevButt.tag = 2001;
	// btnImage = [UIImage alloc];
	prevButt.frame = CGRectMake(240, 350, 30, 30);
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
        prevButt.frame = CGRectMake(650, 650, 30, 30);
    prevButt.autoresizingMask = UIViewAutoresizingFlexibleRightMargin;
	UIImage * btnImage = [UIImage imageNamed:@"prev.png"];
	prevButt.backgroundColor = [UIColor clearColor];
	btnImage = [Functions resizeImage:btnImage width:30 height:30];
	[prevButt setImage:btnImage forState:UIControlStateNormal];
	[prevButt addTarget:self
				 action:@selector(prevPoll)
	   forControlEvents:UIControlEventTouchUpInside];
	[self.view addSubview:prevButt];
   
    
    UIButton * nextButt = [UIButton buttonWithType:UIButtonTypeCustom];
	nextButt.tag = 2002;
	nextButt.frame = CGRectMake(280, 350, 30, 30);
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
        nextButt.frame = CGRectMake(690, 650, 30, 30);
	btnImage = [UIImage imageNamed:@"next.png"];
	btnImage = [Functions resizeImage:btnImage width:30 height:30];
	nextButt.backgroundColor = [UIColor clearColor];
	[nextButt setImage:btnImage forState:UIControlStateNormal];
	[nextButt addTarget:self
				 action:@selector(nextPoll)
	   forControlEvents:UIControlEventTouchUpInside];
	[self.view addSubview:nextButt];

	UIWebView * webView = [[UIWebView alloc] initWithFrame:CGRectMake(13, 290, 217, 100)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	webView.tag = 5005;
	webView.autoresizesSubviews = YES;
	webView.backgroundColor = [UIColor clearColor];
	webView.opaque = NO;
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        webView.autoresizingMask=(UIViewAutoresizingFlexibleWidth  );
        CGRect frame = webView.frame;
        frame.origin.y = 450;
        frame.size.width = 294;
        webView.frame = frame;
    }
	[self.view addSubview:webView];
	[webView release];

	UILabel * questLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 50, 260, 60)];
	questLabel.tag = 5006;
	questLabel.text = @"";
	questLabel.backgroundColor = [UIColor clearColor];
	[questLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:16]];
	questLabel.textColor = [Functions colorForHex:@"#000000"];
	questLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	questLabel.lineBreakMode = UILineBreakModeWordWrap;
	questLabel.numberOfLines = 0;
	questLabel.shadowColor = [UIColor grayColor];
	questLabel.shadowOffset = CGSizeMake(1,1);
	// questLabel.textColor = [UIColor blueColor];
	questLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[self.view addSubview:questLabel];
	[questLabel release];

	UILabel * questDesc = [[UILabel alloc] initWithFrame:CGRectMake(10, 350, 220, 50)];
	questDesc.tag = 5007;
	questDesc.text = @"";
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
    {
        questDesc.autoresizingMask = UIViewAutoresizingFlexibleWidth;
        CGRect frame = questDesc.frame;
        frame.origin.y = 550;
        frame.size.width = 300;
        questDesc.frame = frame;
    }
    [questDesc setBackgroundColor:[UIColor clearColor]];
	[questDesc setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@""] size:13]];
	questDesc.textColor = [Functions colorForHex:@"#000000"];
	questDesc.textAlignment = UITextAlignmentLeft; // UITextAlignmentCenter; // UIControlContentHorizontalAlignmentLeft;
	questDesc.lineBreakMode = UILineBreakModeWordWrap;
	questDesc.numberOfLines = 0;
	// questDesc.shadowColor = [UIColor grayColor];
	// questDesc.shadowOffset = CGSizeMake(1,1);
	// questDesc.textColor = [UIColor blueColor];
	// questDesc.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleTopMargin;
	[self.view addSubview:questDesc];
	[questDesc release];
	
	currentGraph = 0;
	totalGraph = 0;
	// [self initWaitView];
	// [self showAnimated:nil];
    [Functions initWaitView:self.view];
    [Functions showAnimated:self.view];
	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

- (void) showView
{

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSString * title = @"";
	
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * graphUrl = @"";
	NSString * graphType = @"";

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		if (f) {

			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"graph_url"]) {
									graphUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									graphUrl = [graphUrl urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"type_graph"]) {
									graphType = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}
	NSLog(@"graphUrl: %@", graphUrl);

	NSURL *u = [NSURL URLWithString:graphUrl];
	NSData *myXMLData; // = [[NSData alloc] init];

	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_23.xml", actualId];
	[cnf updateValue:@"feedSource" value:databaseName];
	NSString *databaseNameValue = [cnf loadValue:databaseName];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_23.xml", actualId]];
	
	if([databaseNameValue isEqualToString:@""] || databaseNameValue == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		myXMLData = [NSData dataWithContentsOfURL:u];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_23.xml", actualId] value:dateString];
	} else {
		
		NSLog(@"use ... ");
		NSTimeInterval dateTime;		
		// NSDateFormatter *
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:databaseNameValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);  
		if(dateTime > 1) {
			NSLog(@"down (2)... ");
			myXMLData = [NSData dataWithContentsOfURL:u];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_23.xml", actualId] value:dateString];
			
			NSFileManager* fileManager = [NSFileManager defaultManager];
			fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_23", actualId]];
			[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
			
			NSError *error = nil;
			for (NSString *file in [fileManager contentsOfDirectoryAtPath:fileName error:&error]) {
				BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", fileName, file] error:&error];
				if (!success || error) {
					// it failed.
					// NSLog(@"err: %@%@", fileName, file);
				} else {
					// NSLog(@"del: %@%@", fileName, file);
				}
			}
		} else {
			myXMLData = [NSData dataWithContentsOfFile:fileName];
		}
	}
	[dateFormat release];
	// NSLog(@"bk: %@", fileName);
	[myXMLData writeToFile:fileName atomically:YES];
	[cnf release];
	[self showGraphic:graphType];


	/*if (addedBars == NO)
	{
		addedBars = YES;
		[Functions addToolBar:self.view withTitle:title actualId:actualId];
	}*/
	UILabel * toolbarTitle = (UILabel *)[self.view viewWithTag:10002];
	toolbarTitle.text = title;


	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2002];
	if (currentGraph >= totalGraph-1) tmpBt.hidden = TRUE;
	else tmpBt.hidden = FALSE;
	tmpBt = (UIButton *)[self.view viewWithTag:2001];
	if (currentGraph > 0) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	
}

- (void) showGraphic:(NSString *)graphType
{

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[cnf release];

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_23.xml", actualId]];

	NSData *Data = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:Data encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];

	NSMutableArray * graphNames = [[NSMutableArray alloc] init];
	NSMutableArray * graphValues = [[NSMutableArray alloc] init];

	NSString * graphTitle = @"";
	NSString * graphDescription = @"";

	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	[tbxml release];
	TBXMLElement * childXMLElement;
	// BOOL f = FALSE;
	int count = 0;

	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"graph"]) {
				totalGraph++;
				NSLog(@"total %i", totalGraph);
				// NSString * pollId = [TBXML valueOfAttributeNamed:@"poll_id" forElement:childXMLElement];
				// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"poll_%@", pollId]];
				if ( count == currentGraph ) {
					NSLog(@"current %i %i", count, currentGraph);
					// question = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
					// f = TRUE;
					TBXMLElement * itemXMLElement = childXMLElement->firstChild;
					do {
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"title"]) {
							graphTitle = [TBXML textForElement:itemXMLElement];
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"desc"]) {
							graphDescription = [TBXML textForElement:itemXMLElement];
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:@"data"]) {
							TBXMLElement * statXMLElement = itemXMLElement->firstChild;
							do {
								if ([[TBXML elementName:statXMLElement] isEqualToString:@"value"]) {
									// NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:statXMLElement];
									NSString * valueText = [TBXML valueOfAttributeNamed:@"value" forElement:statXMLElement];
									NSLog(@"val: %@", valueText);
									[graphValues addObject:valueText];
									valueText = [TBXML valueOfAttributeNamed:@"name" forElement:statXMLElement];
									[graphNames addObject:valueText];
								}
							} while ((statXMLElement = statXMLElement->nextSibling));
						}
					} while ((itemXMLElement = itemXMLElement->nextSibling));
					// break;
				}
				count++;
			}
			// } while ((childXMLElement = childXMLElement->nextSibling));
		} while ((childXMLElement = childXMLElement->nextSibling)
				 );
	}

	UILabel * questLabel = (UILabel *)[self.view viewWithTag:5006];
	// questLabel.backgroundColor = [UIColor redColor];
	questLabel.text = graphTitle;
	UILabel * questDesc = (UILabel *)[self.view viewWithTag:5007];
	// questDesc.backgroundColor = [UIColor redColor];
	questDesc.text = graphDescription;

	NSLog(@"qst: %@", graphValues);
	NSLog(@"opt: %@", graphNames);
	NSLog(@"type: %@", graphType);

	if ([graphType isEqualToString:@"0"])
		[self paintLineChart:graphValues];
	else if ([graphType isEqualToString:@"1"])
		[self paintPieChart:graphValues andNames:graphNames];
	else if ([graphType isEqualToString:@"2"])
		[self paintBarChart:graphValues andNames:graphNames];
	
	[graphNames release];
	[graphValues release];
	// [self stopAnimated:nil];
    [Functions stopAnimated:self.view];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

-(void) nextPoll {
	NSLog(@"Next -> cur: %i %i", currentGraph, totalGraph);
	if (currentGraph >= totalGraph-1) return;
	int tmpTotsl = totalGraph;
	totalGraph = 0;
	currentGraph++;
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2002];
	if (currentGraph >= tmpTotsl-1) tmpBt.hidden = TRUE;
	else tmpBt.hidden = FALSE;
	tmpBt = (UIButton *)[self.view viewWithTag:2001];
	if (currentGraph > 0) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	[self showView];
}

-(void) prevPoll {
	NSLog(@"Prev -> cur: %i %i", currentGraph, totalGraph);
	if (currentGraph <= 0) return;
	int tmpTotsl = totalGraph;
	totalGraph = 0;
	currentGraph--;
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2001];
	if (currentGraph > 0) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	tmpBt = (UIButton *)[self.view viewWithTag:2002];
	if (currentGraph <= tmpTotsl-1) tmpBt.hidden = FALSE;
	else tmpBt.hidden = TRUE;
	[self showView];
}

# pragma mark Paint


- (void) paintPieChart:(NSMutableArray *)values andNames:(NSMutableArray *)names
{
	
	PieChartView *_pieChart = (PieChartView *)[self.view viewWithTag:8008];
    if (_pieChart != nil) 
	{
		[_pieChart removeFromSuperview];
		_pieChart = nil;
		[_pieChart release];
	}
	_pieChart = [[PieChartView alloc] initWithFrame:CGRectMake(10,100,300,190)]; // 230
	_pieChart.tag = 8008;
	[_pieChart clearItems];
	
	[_pieChart setGradientFillStart:0.3 andEnd:1.0];
	[_pieChart setGradientFillColor:PieChartItemColorMake(0.0, 0.0, 0.0, 0.7)];
	
	int total = 0;
	for (int i=0;i<values.count;i++) {
		int value = [[values objectAtIndex:i] intValue];
		total += value;
	}

	NSArray * barColors = [NSArray 
						   arrayWithObjects:
						   @"#3e70a2",@"#ad132e",
						   @"#f6c521",@"#e86608",
						   @"#6109b8",@"#999999",
						   @"#cc33dd",@"#aa5577",
						   @"#ccaa33",@"#11cc22",
						   @"#2233ee",@"#22eeaa",
						   nil];

	
	NSString * myHtml = @"<html>"
	"<head> \n"
	"<style type=\"text/css\"> \n"
	"* { \n"
	"margin: 0;\n"
	"padding: 0;\n"
	"font-family:Arial; \n"
	"font-size: 11px;\n"
	"font-color: #000000; \n"
	"font-weight: normal; \n"
	"}\n"
	"body{background-color:transparent;}\n"
	"table\n"
	"{\n"
	"border-style: none;"
	"}"
	"td\n"
	"{\n" 
	"border-style: none;"
	"vertical-align: top;\n"
	"}\n"
	"</style> \n"
	"</head> \n"
	"<body><table>\n";
	
	int j = 0;
	for (int i=0;i<values.count;i++) {
		NSString * name = [names objectAtIndex:i];
		float value = (float)[[values objectAtIndex:i] intValue] / (float)total;
		NSLog(@"va t: %f %i / %i", value, [[values objectAtIndex:i] intValue], total);
		// [_pieChart addItemValue:value withColor:PieChartItemColorMake(1.0, 0.5, 1.0, 0.8)];
		;

		
		NSString * hexColor = [[barColors objectAtIndex:j] uppercaseString];  
		
		// strip # if it appears  
		if ([hexColor hasPrefix:@"#"]) 
			hexColor = [hexColor substringFromIndex:1];  

		// Separate into r, g, b substrings  
		NSRange range;  
		range.location = 0;  
		range.length = 2; 
		
		NSString *rString = [hexColor substringWithRange:range];  
		
		range.location = 2;  
		NSString *gString = [hexColor substringWithRange:range];  
		
		range.location = 4;  
		NSString *bString = [hexColor substringWithRange:range];  
		
		// Scan values  
		unsigned int r, g, b;  
		[[NSScanner scannerWithString:rString] scanHexInt:&r];  
		[[NSScanner scannerWithString:gString] scanHexInt:&g];  
		[[NSScanner scannerWithString:bString] scanHexInt:&b];  
		

		[_pieChart addItemValue:value withColor:PieChartItemColorMake((float) r / 255.0f, (float) g / 255.0f, 
																	  (float) b / 255.0f, 0.8)];
		
		if (i%2)
			myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:j], name];
		else
			myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td>", myHtml, [barColors objectAtIndex:j], name];
		
		j++;
		if (j == barColors.count)
			j = 0;
	}
	// [NSString stringWithFormat:@"%.1f", f]
	
	// [_pieChart addItemValue:0.3 withColor:PieChartItemColorMake(0.5, 0.5, 1.0, 0.8)];
	
	//	_pieChart.alpha = 0.0;
	[_pieChart setHidden:NO];
	[_pieChart setNeedsDisplay];
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
		_pieChart.frame = CGRectMake(50, 110, self.view.frame.size.width-100, 350);
    //		graph.frame = CGRectMake(50, 110, self.view.frame.size.width-100, self.view.frame.size.height-400);
	// graph.autoresizesSubviews = YES;
	/*_pieChart.autoresizingMask=(
							
                            UIViewAutoresizingFlexibleBottomMargin
							| UIViewAutoresizingFlexibleLeftMargin
							| UIViewAutoresizingFlexibleRightMargin
							
							);
*/
    
    [self.view addSubview:_pieChart];
	[_pieChart release];

	if (values.count%2)
		myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span>&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>&nbsp;</td></tr>", myHtml];

	UIWebView * webView = (UIWebView *)[self.view viewWithTag:5005];
	[webView loadHTMLString:myHtml baseURL:nil];
	
}

- (void) paintBarChart:(NSMutableArray *)values andNames:(NSMutableArray *)names
{

	BarGraph * graph = (BarGraph *)[self.view viewWithTag:8008];
    if (graph != nil) 
	{
		[graph removeFromSuperview];
		graph = nil;
		[graph release];
	}
	
	graph = [[BarGraph alloc] initWithFrame:CGRectMake(0, 100, 320, 190)]; // 220
	graph.tag = 8008;
	graph.autoresizesSubviews = YES;
	graph.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	[graph setBackgroundColor:[UIColor whiteColor]];
	// [graph removeAllBars];
	// graph.drawBarHighlight = TRUE;
	
	// setuo the graph title and axis names
	graph.verticalAxisName		= @""; // @"Vertical Axis";
	graph.horizontalAxisName	= @""; // question; // @"Horazontal Axis";
	graph.fillColor = [UIColor whiteColor];
	
	// new
	graph.showValueInside = FALSE;
	graph.showPercengages = TRUE;
	graph.drawBarNames = NO;
	graph.drawScale = FALSE;

	// graph.drawLabels = TRUE;
	
	graph.fillColor = [Functions colorForHex:@"#eeeeee"];
	graph.gridLineColor = [Functions colorForHex:@"#dddddd"];
	graph.barOutlineColor = [Functions colorForHex:@"#cccccc"]; // bar outline
	graph.barHighlightColor = [Functions colorForHex:@"#3534ae"];
	graph.fontColor = [Functions colorForHex:@"#444444"];
	graph.barShadowColor = [Functions colorForHex:@"#657687"]; // shadow
	graph.lineColor = [Functions colorForHex:@"#dddddd"];
	
	
	NSArray * barColors = [NSArray 
						   arrayWithObjects:
						   @"#3e70a2",@"#ad132e",
						   @"#f6c521",@"#e86608",
						   @"#6109b8",@"#999999",
						   /*@"#cc33dd",@"#aa5577",
						   @"#ccaa33",@"#11cc22",
						   @"#2233ee",@"#22eeaa",*/
						   nil];
	
	NSArray * imgColors = [NSArray 
						   arrayWithObjects:
						   @"chart_blue",@"chart_red01",
						   @"chart_yellow",@"chart_orange",
						   @"chart_purple",@"chart_green",
						   nil];

	NSString * myHtml = @"<html>"
	"<head> \n"
	"<style type=\"text/css\"> \n"
	"* { \n"
	"margin: 0;\n"
	"padding: 0;\n"
	"font-family:Arial; \n"
	"font-size: 11px;\n"
	"font-color: #000000; \n"
	"font-weight: normal; \n"
	"}\n"
	"body{background-color:transparent;}\n"
	"table\n"
	"{\n"
	"border-style: none;"
	"}"
	"td\n"
	"{\n" 
	"border-style: none;"
	"vertical-align: top;\n"
	"}\n"
	"</style> \n"
	"</head> \n"
	"<body><table>\n";
	
	int j = 0;
	for (int i=0;i<values.count;i++) {
		NSString * name = [names objectAtIndex:i];
		// myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:j], name];
		if (i%2)
			myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td></tr>", myHtml, [barColors objectAtIndex:j], name];
		else
			myHtml = [NSString stringWithFormat:@"%@<tr><td style=\"width: 10px;\"><span style=\"background-color:%@\">&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>%@</td>", myHtml, [barColors objectAtIndex:j], name];
		
		//if (name.length > 6) {
		//	name = [name substringWithRange:NSMakeRange(0, 6)];
		//	[name stringByAppendingString:@"..."];
		//}
		[graph addBarWithName:name // [optionsId objectAtIndex:i] 
					WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
				 WithImgColor:[imgColors objectAtIndex:j]
					 AndValue:[[values objectAtIndex:i] intValue]];
		// NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
		j++;
		if (j >= barColors.count) j = 0;
		if (j >= imgColors.count) j = 0;
	}
	if (values.count%2)
		myHtml = [NSString stringWithFormat:@"%@<td style=\"width: 10px;\"><span>&nbsp;&nbsp;&nbsp;</span></td><td>&nbsp;</td><td>&nbsp;</td></tr>", myHtml];
		
	if (values.count < 5) {
		for (int i=values.count;i<5;i++) {
			[graph addBarWithName:@" " 
						WithColor:[Functions colorForHex:[barColors objectAtIndex:j]]
					 WithImgColor:[imgColors objectAtIndex:i]
						 AndValue:0];
			// NSLog(@"name: %@ %@", name, [barColors objectAtIndex:j]);
			j++;
			if (j >= barColors.count) j = 0;
		}
	}
	myHtml = [NSString stringWithFormat:@"%@</table></body></html>", myHtml];

    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
    {
		graph.frame = CGRectMake(50, 110, self.view.frame.size.width-100, 300);
	graph.autoresizingMask=(
							
                            UIViewAutoresizingFlexibleBottomMargin
							| UIViewAutoresizingFlexibleLeftMargin
							| UIViewAutoresizingFlexibleRightMargin
							
							);
    }

    [self.view addSubview:graph];
	[graph release];

	UIWebView * webView = (UIWebView *)[self.view viewWithTag:5005];

	/*[[webView layer] setCornerRadius:10];
	 [webView setClipsToBounds:YES];
	 [[webView layer] setBorderColor:
	 [[UIColor colorWithRed:0.52 green:0.09 blue:0.07 alpha:1] CGColor]];
	 [[webView layer] setBorderWidth:2.75];*/
	
	// [webView setDelegate:self];
	// NSLog(@"html: %@", myHtml);
	[webView loadHTMLString:myHtml baseURL:nil];
	
}

- (void) paintLineChart:(NSMutableArray *)values
{
	
	LineGraph * graph = (LineGraph *)[self.view viewWithTag:8008];
    if (graph != nil) 
	{
		[graph removeFromSuperview];
		graph = nil;
		[graph release];
	}
	
	graph = [[LineGraph alloc] initWithFrame:CGRectMake(0, 100, 320, 190)]; // 230
	graph.tag = 8008;
	[graph setOrientation:LineGraphOrientationPortrait];
	[graph setMinNumEntries:values.count];
	[graph setMaxNumEntries:values.count];
	graph.drawKey = NO;
	
	// graph.title					= @"Title"; 
	graph.verticalAxisName		= @"Vertical Axis";
	graph.horizontalAxisName	= @"Horazontal Axis";
	graph.backgroundColor = [UIColor clearColor];
	[graph addLineWithName:@"Line One" WithColor:[UIColor redColor] AndWidth:5.0f];
	Line * line = [graph lineAtIndex:0];

	for (int i=0;i<values.count;i++) {
		[line add:[[values objectAtIndex:i] intValue]];
	}

    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
		graph.frame = CGRectMake(50, 110, self.view.frame.size.width-100, 350);
	[self.view addSubview:graph];
	[graph release];
}
	
@end
