//
//  ImageSliderView.m
//  app_builder
//
//  Created by Ihonahan Buitrago on 2/27/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ImageSliderView.h"
#import "app_builderAppDelegate.h"
#import "Functions.h"
#import "Config.h"
#import "NSString+HTML.h"
#import "ShareViewController.h"
#import "ImageScrollerThumbs.h"


#define ZOOM_STEP 1.5 


@interface ImageSliderView (UtilityMethods)  
- (CGRect)zoomRectForScale:(float)scale withCenter:(CGPoint)center;  
@end  



@implementation ImageSliderView


@synthesize detailView;
@synthesize detailImage;

@synthesize imagesSliderArray;

@synthesize titlesSliderArray;
@synthesize shareUrlsSliderArray;

/* bh */
@synthesize test, myTextView;
/* bh */

- (id)initWithFrame:(CGRect)frame Image:(UIImage *)img
{
    CGRect myFrame = frame;
	
	if(myFrame.size.width < 320) myFrame.size.width = 320;
	if(myFrame.size.height < 460) myFrame.size.height = 460; // 480
	
	//CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	//if(myFrame.size.width < mainViewBounds.size.width) myFrame.size.width = mainViewBounds.size.width;
	//if(myFrame.size.height < mainViewBounds.size.height) myFrame.size.height = mainViewBounds.size.height; // 480
	
	//myFrame.size.width = 250;
	//myFrame.size.height = 400;
	
//    self = [super initWithFrame:frame];
    self = [super initWithFrame:myFrame];
    if (self) 
	{
        detailImage = [[UIImage alloc] initWithCGImage:img.CGImage];
		detailView = [[UIImageView alloc] initWithImage:detailImage];
        
		[self addSubview:detailView];
		
		// add gesture recognizers to the image view  
		UITapGestureRecognizer *singleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleSingleTap:)];  
		UITapGestureRecognizer *doubleTap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleDoubleTap:)];  
		UIPinchGestureRecognizer *twoFingerTap = [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(handleTwoFingerTap:)];
		UIPanGestureRecognizer *panMove = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(handleSlide:)];
		
		[doubleTap setNumberOfTapsRequired:2];  
		
		[self addGestureRecognizer:singleTap];  
		[self addGestureRecognizer:doubleTap];  
		[self addGestureRecognizer:twoFingerTap];  
		[self addGestureRecognizer:panMove];
		

		[singleTap release];  
		[doubleTap release];  
		[twoFingerTap release];  
		[panMove release];
		
		// calculate minimum scale to perfectly fit image width, and begin at that scale  
		self.minimumZoomScale = 0.4;  
		self.zoomScale = 1;  
		self.maximumZoomScale = 4;
		
		self.opaque = YES;
		self.backgroundColor = [UIColor blackColor];
		//self.backgroundColor = [UIColor redColor];
		
		loadingView = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
		[loadingView setFrame:CGRectMake(140, 220, 40, 40)];
		loadingView.hidesWhenStopped = YES;
		
//		[self addSubview:loadingView];

		int tabSpace = 100; // 93 // 48
		/*UIView *titleBar;
		titleBar.tag = 5000;
		titleBar = [[UIView alloc] initWithFrame:CGRectMake(0, 460-tabSpace, 320, 15)]; // autorelease];
		titleBar.backgroundColor = [UIColor grayColor];
		// [self addSubview:titleBar];
		[titleBar setAlpha:0.5];
		
		
		imgTitle = [[UILabel alloc] initWithFrame:
					CGRectMake(10,3,300,9)];
		imgTitle.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		imgTitle.text = @"";
		imgTitle.backgroundColor = [UIColor clearColor];
		imgTitle.textColor = [UIColor whiteColor];
		imgTitle.font = [UIFont boldSystemFontOfSize:12];
		imgTitle.textAlignment = UITextAlignmentCenter;
		[titleBar addSubview:imgTitle];
		[self addSubview:titleBar];*/
		
		UITextView * tmpTextView = [[UITextView alloc]initWithFrame:CGRectMake(0, 460-tabSpace, 320, 20)];
/*		CGRect frame = tmpTextView.frame;
		frame.origin.y = mainViewBounds.size.height-tabSpace;
		frame.size.width = mainViewBounds.size.width;
		tmpTextView.frame = frame;*/
		tmpTextView.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin |
		UIViewAutoresizingFlexibleRightMargin 
		| UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
		// do whatever adjustments 
		tmpTextView.backgroundColor = [UIColor grayColor]; // show area explicitly (dev  
		// purpose) 
		self.myTextView = tmpTextView; 
		self.myTextView.editable = NO; 
		self.myTextView.scrollEnabled = NO; 
		self.myTextView.multipleTouchEnabled = NO; 
		self.myTextView.userInteractionEnabled = NO; // pass on events to parentview 
		self.myTextView.font = [UIFont boldSystemFontOfSize:12.0];
		self.myTextView.textColor = [UIColor whiteColor]; 
		self.myTextView.textAlignment = UITextAlignmentCenter;
		self.myTextView.autoresizingMask = UIViewAutoresizingFlexibleWidth;
//		[self.myTextView setAlpha:0.5];
		tmpTextView.backgroundColor = [UIColor redColor]; // show area explicitly (dev  
		// self.myTextView.text = @"12";
		// [self.myTextView sizeToFit];
		
		
		[tmpTextView release]; 
		// [self addSubview:self.myTextView]; 
		
	}
    return self;
}


-(void)changeImageDetail:(int)urlIndex
{
	if(urlIndex >= 0 && urlIndex < [imagesSliderArray count])
	{
		Config *cnf = [[Config alloc] init];
		currentUrlIndex = urlIndex;
		[cnf updateValue:@"selectedListItem" value:[NSString stringWithFormat:@"%i", currentUrlIndex]];
		NSURL *imgURL = (NSURL *)[imagesSliderArray objectAtIndex:currentUrlIndex];
		
		NSString *title = [titlesSliderArray objectAtIndex:currentUrlIndex];

		[cnf release];
		
		//if (title != nil && ![title isEqualToString:@""]) {
		//	NSLog(@"mybar...");
		//	[self addSubview:titleBar];
		//}
		
		// self.myTextView.text = title;
		// UITextView *tv = object;
		//CGFloat topCorrect = ([self.myTextView bounds].size.height - [self.myTextView contentSize].height * [self.myTextView zoomScale])  / 2.0;
		//NSLog(@"ff %f", topCorrect);
		//topCorrect = ( topCorrect < 0.0 ? 0.0 : topCorrect );
		//self.myTextView.contentOffset = (CGPoint){.x = 0, .y = -topCorrect+4};
		NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:imgURL, @"imgURL",
							 title, @"imgTitle",
							 nil];
		[self loadImagefromURL:dic];
		
	}
}


#pragma mark multi thread loads

/*This is the thread selector. Images will be opened here*/
-(void)loadImage:(NSDictionary *)myDic 
{
	
	/*You need this for all threads you create or you will leak! */
	NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
	
	
	[NSThread sleepForTimeInterval:.01];
	@synchronized(myDic)
	{
		NSURL *theUrl = (NSURL *)[myDic objectForKey:@"imgURL"];
		
		NSData* imageData = [[NSData alloc]initWithContentsOfURL:theUrl];
		
		if(imageData !=nil)
		{
			[detailView removeFromSuperview];
			[detailView release];
			[detailImage release];
			detailImage = [[UIImage alloc] initWithData:imageData];
			
			detailView = [[UIImageView alloc] initWithImage:detailImage];

			CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
			NSLog(@"detailVif : %@", NSStringFromCGRect(self.frame));
			NSLog(@"detailVif : %@", NSStringFromCGRect(detailView.frame));
			CGRect frame = self.frame;
			frame.size.height -= 150;
			[self scaleToFitRect:frame];
			NSLog(@"detailVif : %@", NSStringFromCGRect(detailView.frame));
			[self addSubview:detailView];
            [self sendSubviewToBack:detailView];


			float w2 = (detailView.frame.size.width/2);
			float h2 = (detailView.frame.size.height/2);
			
			// float ubicX = 160 - w2;
			// float ubicY = 200 - h2;
			float ubicX = (mainViewBounds.size.width / 2) - w2; 
			float ubicY = (mainViewBounds.size.height / 2) - h2;
			
			float newW = (detailView.frame.size.width<320)?320:detailView.frame.size.width;
			float newH = (detailView.frame.size.height<460)?460:detailView.frame.size.height; // 480
			
			if(detailView.frame.size.width < mainViewBounds.size.width) newW = mainViewBounds.size.width;
			if(detailView.frame.size.height < mainViewBounds.size.height) newH = mainViewBounds.size.height; // 480
			
			curRect = CGRectMake(ubicX, ubicY, detailView.frame.size.width, detailView.frame.size.height);
			NSLog(@"CR %@", NSStringFromCGRect(curRect));
			detailView.frame = curRect;
			NSLog(@"DV %@", NSStringFromCGRect(detailView.frame));
			
			self.contentSize = CGSizeMake(newW, newH);
			self.contentSize = CGSizeMake(320, 960);
		}
		else
		{
		}

		[imageData release];
		
		
		//Tell our callback what we've done
	}
	[self performSelectorOnMainThread:@selector(loadComplete:)
						   withObject:myDic waitUntilDone:NO];
	
	//remove our pool and free the memory collected by it
	[pool release];
	[(ImageScrollerThumbs *)test stopAnimated:nil];

}

- (void) changeView:(UIViewController *)theView
{
	test = theView;
}

- (void)loadComplete:(NSDictionary *)theDic 
{
	/* Callback for when the image load is completed.
	 * Good for working on the image after it's loaded like
	 * putting it in the view, etc.
	 */
	//NSLog(@"loaded %@", fileName);
//	[self.loader stopAnimating];

	
	self.myTextView.text = @"";
	self.myTextView = nil;
	[myTextView release];
	int tabSpace = 100;
	myTextView = [[UITextView alloc] init];
	myTextView.backgroundColor = [UIColor grayColor];
	myTextView.editable = NO; 
	myTextView.scrollEnabled = NO; 
	myTextView.multipleTouchEnabled = NO; 
	myTextView.userInteractionEnabled = NO; // pass on events to parentview 
	myTextView.font = [UIFont boldSystemFontOfSize:12.0];
	myTextView.textColor = [UIColor whiteColor]; 
	myTextView.textAlignment = UITextAlignmentCenter;
	myTextView.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[myTextView setAlpha:0.5];
	// self.myTextView.text = @"12";
	// [self.myTextView sizeToFit];
	
	[self addSubview:myTextView]; 
	myTextView.frame = CGRectMake(0, 460-tabSpace, 320, 20); 
	myTextView.frame = CGRectMake(0, self.frame.size.height-20-tabSpace, self.frame.size.width, 20); 

	 myTextView.text = [theDic objectForKey:@"imgTitle"];
	CGFloat topCorrect = ([myTextView bounds].size.height - [myTextView contentSize].height * [myTextView zoomScale])  / 2.0;
	topCorrect = ( topCorrect < 0.0 ? 0.0 : topCorrect );
	myTextView.contentOffset = (CGPoint){.x = 0, .y = -topCorrect+4};
	
	
	changeImg = NO;
}

- (void)loadImagefromURL :(NSDictionary *)sliderDic
{
	
	[NSThread detachNewThreadSelector:@selector(loadImage:) toTarget:self
						   withObject:sliderDic];
	
	
}





#pragma mark UIScrollViewDelegate methods  

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView 
{  
	return detailView;  
}  


- (void)scrollViewDidEndZooming:(UIScrollView*)scrollView withView:(UIView*)view atScale:(float)relScale
{
	// Cache offset before zoom scale is reset
	CGPoint offset = self.contentOffset;
	
	// Transfer zoom from scroll view to world->view transform; resize content at the new scale
//	self.zoomScale = 1.0;
//	scale *= relScale;
//	[self sizeContent];
	
	// Restore the old offset
	self.contentOffset = offset;
	
	// Re-render
//	[self reload];
	
	// Flash
	[self flashScrollIndicators];
}

#pragma mark scale

- (void) scaleToFitRect:(CGRect)rect
{
	CGFloat newwidth, newheight;
	CGFloat ratio = detailView.frame.size.width / detailView.frame.size.height;
	if(ratio >= 1.0) {
		newwidth = rect.size.width;
		newheight = rect.size.width/ratio;
	}
	else {
		newwidth = rect.size.height*ratio;
		newheight = rect.size.height;
	}
	
	CGRect fullScreenRect = rect; // [[UIScreen mainScreen] applicationFrame];
	CGFloat xoffset = (fullScreenRect.size.width - newwidth) / 2.0;
	CGFloat yoffset = (fullScreenRect.size.height - newheight) / 2.0;
	
	detailView.frame = CGRectMake(xoffset, yoffset, newwidth, newheight);
}

- (void) centerImage:(CGRect)parentFrame
{
	CGRect fullScreenRect = parentFrame; // [[UIScreen mainScreen] applicationFrame];
	CGFloat xoffset = (fullScreenRect.size.width - self.frame.size.width) / 2.0;
	CGFloat yoffset = (fullScreenRect.size.height - self.frame.size.height) / 2.0;
	self.frame = CGRectMake(xoffset, yoffset, self.frame.size.width, self.frame.size.height);
}

#pragma mark TapDetectingImageViewDelegate methods  

- (void)handleDoubleTap:(UIGestureRecognizer *)gestureRecognizer 
{  
	// single tap does nothing for now  
	NSLog(@"double tap");
	[self goDetail];
}  

- (void)handleSingleTap:(UIGestureRecognizer *)gestureRecognizer 
{  
	NSLog(@"single tap");
	
	NSLog(@"1.zoomScale: %f", [self zoomScale]);
	
	
	// zoom in  
	float newScale = [self zoomScale] * ZOOM_STEP;  
	CGRect zoomRect = [self zoomRectForScale:newScale withCenter:[gestureRecognizer locationInView:gestureRecognizer.view]];  

	NSLog(@"zoomRect: %f %f  %f %f", zoomRect.origin.x, zoomRect.origin.y, zoomRect.size.width, zoomRect.size.height);

	[self setZoomScale:newScale];
	
	[self zoomToRect:zoomRect animated:YES];  
	
	NSLog(@"2.zoomScale: %f", [self zoomScale]);	
}  

- (void)handleTwoFingerTap:(UIGestureRecognizer *)gestureRecognizer 
{  
	NSLog(@"Pinch gesture: handleTwoFIngerTap");
	// two-finger tap zooms out 
	UIPinchGestureRecognizer *pinch = (UIPinchGestureRecognizer *)gestureRecognizer;
	float newScale = [self zoomScale] * ([pinch scale]*2);  
	CGRect zoomRect = [self zoomRectForScale:newScale withCenter:[gestureRecognizer locationInView:gestureRecognizer.view]];  
	[self zoomToRect:zoomRect animated:YES];  
}  


- (void)handleSlide:(UIGestureRecognizer *)gestureRecognizer
{
	UIPanGestureRecognizer *panM = (UIPanGestureRecognizer *)gestureRecognizer;
	CGPoint trnPoint = [panM translationInView:detailView];
	CGPoint velPoint = [panM velocityInView:detailView];

	BOOL sliding = NO;
//	changeImg = NO;

	switch (panM.state)
	{
		case UIGestureRecognizerStateBegan:
		{
			curRect = detailView.frame;
		}
			break;
		case UIGestureRecognizerStateChanged:
		{
			if(fabsf(trnPoint.x) > 2)
				sliding = YES;
			
			if(sliding)
			{
				CGRect newFrame = detailView.frame;
				newFrame.origin.x += (velPoint.x / 20);
				[detailView setFrame:newFrame];
				
				
				if(!changeImg)
				{
					float xPos = detailView.frame.origin.x;
					float detWidth = detailView.frame.size.width;
					float perc70 = detWidth * 0.7;
					float perc30 = detWidth * 0.3;
					
//					NSLog(@"xPos: %f | detWidth: %f | perc70: %f | perc30: %f", xPos, detWidth, perc70, perc30 );
					
					if(xPos < 0)
					{
						if(xPos < -perc70)
						{
							int nextInx = currentUrlIndex + 1;
							if(nextInx < [imagesSliderArray count])
							{
								changeImg = YES;
								[self changeImageDetail:nextInx];
								[(ImageScrollerThumbs *)test showAnimated:nil];
							}
						}
					}
					else
					{
						if (xPos > (320 - perc30))
						{
							int prevInx = currentUrlIndex - 1;
							if(prevInx >= 0)
							{
								changeImg = YES;
								[self changeImageDetail:prevInx];
								[(ImageScrollerThumbs *)test showAnimated:nil];
							}
						}
					}
				}
			}
		}
			break;
		case UIGestureRecognizerStateEnded:
		{
		}
			break;
		default:
			break;
	}

}



#pragma mark Utility methods  

- (CGRect)zoomRectForScale:(float)scale withCenter:(CGPoint)center 
{  
	
	CGRect zoomRect;  
	
	// the zoom rect is in the content view's coordinates.   
	//    At a zoom scale of 1.0, it would be the size of the imageScrollView's bounds.  
	//    As the zoom scale decreases, so more content is visible, the size of the rect grows.  
	zoomRect.size.height = [self frame].size.height / scale;  
	zoomRect.size.width  = [self frame].size.width  / scale;  
	
	// choose an origin so as to get the right center.  
	zoomRect.origin.x    = center.x - (zoomRect.size.width  / 2.0);  
	zoomRect.origin.y    = center.y - (zoomRect.size.height / 2.0);  
	
	return zoomRect;  
}  


-(void)slideImageToNew:(int)newIndex
{
	CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:nil context:context];
    [UIView setAnimationCurve:UIViewAnimationCurveLinear];
    [UIView setAnimationDidStopSelector:@selector(animationDidStop)]; 
    [UIView setAnimationDuration: .85];
    [UIView setAnimationDelegate: self];
	
	soonUrlIndex = newIndex;
	
	NSLog(@"soonUrlIndex: %d",soonUrlIndex);
	
	CGRect newDetFrm = detailView.frame;
	CGRect newPrevFrm = CGRectZero;
	CGRect newNextFrm = CGRectZero;
	
	if(newIndex > currentUrlIndex)
	{
		newDetFrm.origin.x -= newDetFrm.size.width*2;
		newPrevFrm.origin.x -= newDetFrm.size.width*2;
		newNextFrm.origin.x -= newDetFrm.size.width*2;
	}
	else
	{
		newDetFrm.origin.x += newDetFrm.size.width*2;
		newPrevFrm.origin.x += newDetFrm.size.width*2;
		newNextFrm.origin.x += newDetFrm.size.width*2;
	}
	
	[detailView setFrame:newDetFrm];

    [UIView commitAnimations];
	
	[self changeImageDetail:soonUrlIndex];

}


-(void)animateImageToInitial
{
	CGContextRef context = UIGraphicsGetCurrentContext();
    [UIView beginAnimations:nil context:context];
    [UIView setAnimationCurve:UIViewAnimationCurveLinear];
    [UIView setAnimationDuration: .5];
    [UIView setAnimationDelegate: self];
	
	[detailView setFrame:curRect];
	
    [UIView commitAnimations];
}


- (void)animationDidStop:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
	[loadingView stopAnimating];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code.
}
*/



- (void)dealloc 
{
    [super dealloc];
}

- (void) changeActualId:(NSString *)viewId {
	actualId = viewId;
}

- (void) changeNumItems:(int)items {
	page_items = items;
}

- (void) goDetail {
	
	NSLog(@"curr %i, pp %i, aID %@", currentUrlIndex, page_items, actualId);
	// return;
	
	int actImg = currentUrlIndex;//+1;
	int pageNo = actImg / page_items;
	//if ((actImg % page_items) != 0) 
		pageNo++;
	actImg = actImg - ((pageNo-1 < 0 ? 0 : pageNo-1)*page_items);
	NSLog(@"actImg %i, pN %i, aID %@", actImg, pageNo, actualId);

	NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, pageNo];
	Config *cnf = [[Config alloc] init];
	NSString *feedSourceValue = [cnf loadValue:@"feedSource"];
	if ([feedSourceValue isEqualToString:@""] || 
		feedSourceValue == nil)
		[cnf insertValue:@"feedSource" value:databaseName];
	else
		[cnf updateValue:@"feedSource" value:databaseName];
	
	/*
	// [self showAnimated:nil];
	// maxPages = 0;
	// Config * cnf;
	// cnf = [[Config alloc] initWithName:@"actualId"];
	// NSString * 
	// NSString * actualId = cnf.value;
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	*/

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * feedsXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * detailId = @"0";
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"slide_detail"]) {
									detailId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
		}		
	}
	
	NSLog(@"detail %@", detailId);
	
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[cnf updateValue:@"selectedListItem" value:[NSString stringWithFormat:@"%i", actImg]];
	[cnf updateValue:@"goUrl" value:@"---"];
	[cnf updateValue:@"displayId" value:detailId];
	
	[cnf release];
	// [Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_4_%i.xml", actualId, currentFeedPage]];
	// [Functions updateConfig:@"currentFeedPage" withValue:[NSString stringWithFormat:@"%i", currentFeedPage]];
	[appDelegate displayView:@"7"];
}

@end
