//
//  ImageViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 10/18/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "imageInfo.h"

@interface ImageViewController : UIViewController <UIScrollViewDelegate>
{
	CGRect				_frame;
	int					pageIndex;
	Boolean				zoomMode;
	Boolean				maximized;
	imageInfo			*	thumb;
	
	CGPoint				startPoint;
	CGPoint				lastPoint;
	Boolean				touched;
	
	CGFloat				initialDistance;
	CGFloat				currentDistance;
	CGAffineTransform	scaleTransform;
	CGAffineTransform	rotateTransform;	
}

- (id)				initWithThumb:(imageInfo*)t withTitle:(NSString *)title withFrame:(CGRect)frame;
- (void)			setPageIndex:(int)value;
- (void)			clearTouches;
- (void)			resetThumb;
- (Boolean)			getZoomMode;
- (void)			handleSingleTap:(NSDictionary *)touches;
- (void)			handleDoubleTap:(NSDictionary *)touches;

- (CGFloat)			distanceBetweenTwoPoints:(CGPoint)fromPoint toPoint:(CGPoint)toPoint;
CGFloat				distanceBetweenPoints(CGPoint firstPoint, CGPoint secondPoint);
CGPoint				vectorBetweenPoints(CGPoint firstPoint, CGPoint secondPoint);
CGAffineTransform	CGAffineScaleTransformWithTouches(CGAffineTransform _scaleTransform, UITouch *firstTouch, UITouch *secondTouch);
CGAffineTransform	CGAffineRotateTransformWithTouches(CGAffineTransform _rotateTransform, UITouch *firstTouch, UITouch *secondTouch);
//- (void)willAnimateRotationToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation   
//										 duration:(NSTimeInterval)duration;
- (void) setFrame: (CGRect) frame parentFrame:(CGRect) frameS;

@end
