//
//  ListViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 10/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "Element.h"
#import "ListSelectionDelegate.h"

@interface ListViewController : UIViewController <UITableViewDataSource, UITableViewDelegate, UISearchBarDelegate> {

	NSMutableArray * feeds;
	NSMutableArray * elements;
	NSMutableArray * searchResults;
	UITableView * tableView;
	UIViewController *popupView;
	UISearchBar *searchBar;
	BOOL searching;
	BOOL letUserSelectRow;
	NSString *feedSource;
	UIToolbar *toolbar;
	UILabel * label;
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;
    NSDictionary * infoData;
	int feedId;
	BOOL useIndexes;
    id<ListSelectionDelegate> _delegate;
	NSString *auth;
	NSString *authUrl;
	NSString * reqName;
	NSString * reqType;
	NSString * reqService;
	NSMutableArray * reqFields;
	NSMutableArray *thumbsArray;
	UIViewController * parentView;
}

@property (nonatomic, retain) NSMutableArray * feeds;
@property (nonatomic, retain) NSMutableArray * elements;
@property (nonatomic, retain) NSMutableArray * searchResults;
@property (nonatomic,retain) IBOutlet UITableView * tableView;
@property (nonatomic,retain) NSString *feedSource;
@property (nonatomic, retain) UILabel *waitLabel;
@property (nonatomic, assign) IBOutlet id<ListSelectionDelegate> delegate;
@property (nonatomic,retain) NSString *auth;
@property (nonatomic,retain) NSString *authUrl;
@property (nonatomic,retain) NSString * reqName;
@property (nonatomic,retain) NSString * reqType;
@property (nonatomic,retain) NSString * reqService;
@property (nonatomic,retain) NSMutableArray * reqFields;
@property (nonatomic,retain) UIViewController *parentView;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
-(void) searchTableView;
- (void) processXml:(NSMutableData *)myXMLData;
- (void)showXML;
-(void)loadView:(Element *) element;
-(NSString *) reviewLinkType: (NSString *)linkName: (NSString *)linkType;
- (void) initStatusBar:(UIView *)actualView;
// + (id)sharedManager;
- (void) goDownload;
- (void) createMutiListView:(NSArray *)lists;
- (void) useFeed;
- (NSArray *)loadListInfo:(NSString *)moduleId;
- (void) callAuth:(NSString *)text withPassword: (NSString *)password;
- (void) loadAuth:(BOOL)showErr errMsg:(NSString *)txtErr;
- (void)preloadThumbs;

@end
