//
//  ListViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ListViewController.h"
#import "Config.h"
#import "Functions.h"
#import "Element.h"
#import "app_builderAppDelegate.h"
#import "WebServiceHelper.h"
#import "NSString+HTML.h"
#import "TBXML.h"
#import "MenuViewController.h"
#import "URLConnection.h"

@implementation ListViewController

static ListViewController *sharedMyManager = nil;

@synthesize feeds, elements, searchResults;
@synthesize tableView, feedSource;
@synthesize waitLabel;

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        infoData = data;
    }
    return self;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
 -(void) loadView {
	tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.delegate = self;
	tableView.dataSource = self;
	// [tableView setDataSource:self];
	// [tableView setDelegate:self];
	[self.view addSubview:tableView];
}

-(void) loadData {
}
 */

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[super viewDidLoad];
	Config * cnf;
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * actualId = cnf.value;
	// cnf = [[Config alloc] initWithName:@"displayView"];
	// NSString * displayView = cnf.value;
	//tabbar
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	// cnf = [[Config alloc] initWithName:@"selectedTabBarItem"];
	// NSString * selectedTabBarItem = cnf.value;

	NSLog(@"tb: %@", tabbar);
	// NSLog(@"sel tb: %@", selectedTabBarItem);
	// NSLog(@"title: %@", self.tabBarItem.title);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
//	if ([actualId isEqualToString:@"0"])
//		actualId = 
	//	actualId = [Functions loadFromTabBar:self.tabBarItem.title];
	// NSLog(@"tbi: %@", [Functions loadFromTabBar:self.tabBarItem.title]);
	// NSLog(@"selected i: %i", self.tabBarController.selectedIndex);
	// NSLog(@"idTab (1): %@", self.idTab);
	// NSLog(@"idTab (2): %@", [infoData valueForKey:@"idTab"]);
	NSLog(@"actualId: %@", actualId);
	//tabbar

	tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.delegate = self;
	tableView.dataSource = self;
	// [tableView setDataSource:self];
	// [tableView setDelegate:self];
	[self.view addSubview:tableView];
	searching = NO;
	letUserSelectRow = YES;
	self.tableView.rowHeight = 70;
	[self initWaitView];
	[self showAnimated:nil];

	NSString * title = @"List";
	// [self initWaitView];

	NSString * url = @"";
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;

	NSString * pattern = @"";
	NSString * titleName = @"";
	NSString * titleFont = @"Courier";
	NSString * titleSize = @"12";
	NSString * titleColor = @"#cccccc";
	NSString * titleStyle = @"regular";
	NSString * titleLink = @"";
	NSString * subtitleName = @"";
	NSString * descriptionFont = @"Courier";
	NSString * descriptionSize = @"12";
	NSString * descriptionColor = @"#cccccc";
	NSString * descriptionStyle = @"regular";
	NSString * descriptionLink = @"";
	NSString * imageName = @"";
	NSString * imageLink = @"";
	NSString * linkName = @"";
	NSString * linkType = @"";
	NSString * search = @"";

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;

		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		pattern = [TBXML valueOfAttributeNamed:@"template_id" forElement:feedsXMLElement];
		
		/*
		do {
			if ([[TBXML elementName:child] isEqualToString:@"view"]) {
				NSLog(@" %@ - %@",
					  [TBXML elementName:child],
					  [TBXML valueOfAttributeNamed:@"type" forElement:child]);
				if ([[TBXML valueOfAttributeNamed:@"type" forElement:child] isEqualToString:@"2"]) {
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:child] isEqualToString:value]) {
						f = TRUE;
						feedsXMLElement = child;
					}
				}
			}
		} while ((child = child->nextSibling) && (f == FALSE));
		*/
		
		if (f) {
			feeds = [[NSMutableArray alloc] init];
			// appXMLElement =  feedsXMLElement; // ->firstChild;
			// do {
			// NSLog(@"feeds...");
			
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"button_search"]) {
									search = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"detail_title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									titleLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									titleFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									if (titleName == nil) titleName = @"";
									if (titleLink == nil) titleLink = @"";
									if (titleFont == nil) titleFont = @"";
								}
								if ([attribItem isEqualToString:@"detail_date"]) {
									subtitleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									descriptionLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									descriptionFont = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
									subtitleName = [subtitleName stringByReplacingOccurrencesOfString:@"_" withString:@":"];
									if (subtitleName == nil) subtitleName = @"";
									if (descriptionLink == nil) descriptionLink = @"";
									if (descriptionFont == nil) descriptionFont = @"";
								}
								if ([attribItem isEqualToString:@"detail_image"]) { // list_item_icon
									imageName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									imageLink = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									imageName = [imageName stringByReplacingOccurrencesOfString:@"_" withString:@":"];
									if (imageName == nil) imageName = @"";
									if (imageLink == nil) imageLink = @"";
								}
								if ([attribItem isEqualToString:@"detail_link"]) { // list_item_icon
									// titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									linkName = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									linkType = [TBXML valueOfAttributeNamed:@"link_to_type" forElement:childXMLElement];
									linkType = [self reviewLinkType:linkName:linkType];
									if (linkName == nil) linkName = @"";
									if (linkType == nil) linkType = @"";
									NSLog(@"l: %@:%@:%@", title, linkName, linkType);
								}
								
							}
						} while (childXMLElement = childXMLElement->nextSibling);
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								
							}
						} while (childXMLElement = childXMLElement->nextSibling);
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
				
			// linkName = @"";
			// linkType = @"";

			
			[Functions initToolBar:self.view withTitle:title]; // withTitle:@"" withView:NO];
			[self initStatusBar:self.view];

			NSLog(@"u: %@", url);
				feedSource = url;
				NSString * popup = @""; // [TBXML valueOfAttributeNamed:@"show_pop_up" forElement:appXMLElement];
				// NSLog(@"p: %@", popup);
				/*
				 if ([popup isEqualToString:@"1"]) {
				 // NSLog(@"go ad...");
				 [self performSelector:@selector(showAd) withObject:nil afterDelay:5.0];
				 }
				 */
				// NSString * search = @""; // [TBXML valueOfAttributeNamed:@"search_bar" forElement:appXMLElement];
				// NSLog(@"s: %@", search);
				
				FontItem * font;
				font = [Functions loadFont:titleFont]; 
				titleFont = font.nameFont;
				titleSize = font.sizeFont;  
				titleColor = font.colorFont;
				titleStyle = font.styleFont;
				font = [Functions loadFont:descriptionFont]; 
				descriptionFont = font.nameFont;
				descriptionSize = font.sizeFont;  
				descriptionColor = font.colorFont;
				descriptionStyle = font.styleFont;
				NSArray *feed = [NSArray arrayWithObjects: title, url, popup, search, pattern,
								 titleFont, titleSize, titleColor, titleStyle,
								 descriptionFont, descriptionSize, descriptionColor, descriptionStyle,
								 linkName, linkType,
								 titleName, subtitleName, imageName, 
								 titleLink, descriptionLink, imageLink, 
								 nil];
				[font release];
				[feeds addObject:feed];
			// } while (appXMLElement = appXMLElement->nextSibling);
			
			feed = [feeds objectAtIndex:0];
			/*
			NSLog(@"Array Count: %d",[feeds count]);
			// NSArray * 
			NSLog(@"Array Count: %d",[feed count]);
			for(NSString * test in feed) {
				NSLog(@"feed: %@", test);
			}
			 */

			title = [feed objectAtIndex:0];
			url = [feed objectAtIndex:1];
			url = [url urlUnescapedString];
			// NSString * 
			popup = [feed objectAtIndex:2];
			// NSString * 
			search = [feed objectAtIndex:3];
			pattern = [feed objectAtIndex:4];
			titleFont = [feed objectAtIndex:5];
			titleSize = [feed objectAtIndex:6];
			titleColor = [feed objectAtIndex:7];
			titleStyle = [feed objectAtIndex:8];
			descriptionFont = [feed objectAtIndex:9];
			descriptionSize = [feed objectAtIndex:10];
			descriptionColor = [feed objectAtIndex:11];
			descriptionStyle = [feed objectAtIndex:12];
			linkName = [feed objectAtIndex:13];
			linkType = [feed objectAtIndex:14];
			titleLink = [feed objectAtIndex:18];
			descriptionLink = [feed objectAtIndex:19];
			imageLink = [feed objectAtIndex:20];
			NSLog(@"l: %@:%@:%@", title, linkName, linkType);
			
			[Functions sendWebtrends: title 
						  eventDescr: title
						   eventType: @"view"
						contentGroup: title
						   mediaName: nil
						   mediaType: nil
						  mediaEvent: nil];
			
			int yT = 0;
			if ([tabbar isEqualToString:@"1"]) yT = 48;
				self.tableView.frame = CGRectMake(0,48,320,380-yT);

			if ([popup isEqualToString:@"1"]) {
				// NSLog(@"go ad...");
				[self performSelector:@selector(showAd) withObject:nil afterDelay:5.0];
			}
			// 44 search
			if ([search isEqualToString:@"true"]) {
				int yS = 0;
				int yT = 0;
				if ([feeds count] > 1) yS = 39;
				if ([tabbar isEqualToString:@"1"]) yT = 48+25;
				self.tableView.frame = CGRectMake(0,yS+94,320,366-yS-yT);
				searchResults = [[NSMutableArray alloc]init];
				searchBar = [[UISearchBar alloc]initWithFrame:CGRectMake(0,yS+44,320,44)]; // 50
				searchBar.delegate = self;
				[self.view addSubview:searchBar];
			}
			
			// download info
			NSLog(@"download...");
			// int itemCounter = 0;
			// NSURL *u = [NSURL URLWithString:url];
			// NSData *myXMLData;
			NSDate *date = [NSDate date];
			NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
			// NSDateFormatter *dateFormat = [[[NSDateFormatter alloc] init] autorelease];

			WebServiceHelper * loadWebService = [[WebServiceHelper alloc] init];
			// NSString * tmpUrl = @"http://mediasuite.multicastmedia.com/rss/vod.php?p=f30jt6g5&thumbs=true";
			// [loadWebService callWebService:tmpUrl delegate:self requestSelector:@selector(test:)];
			NSString * webService = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/mh_mobile_convert_rss.asmx";
			NSString * callMethod = @"ConvertRSS";
			NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug", nil];
			NSArray *keyvalues = [NSArray arrayWithObjects:url ,@"true", nil];	
			// [loadWebService callWebService:webService methodName:callMethod keys: keys values:keyvalues delegate:self requestSelector:nil];
			
			// cnf = [[Config alloc] initWithName:@"actualId"];
			NSString * displayId = actualId; // cnf.value;
			//tabbar
			cnf = [[Config alloc] initWithName:@"useTabBar"];
			NSString * tabbar = cnf.value;
			NSLog(@"tb: %@", tabbar);
			NSLog(@"title: %@", self.tabBarItem.title);
			// NSLog(@"title: %i", self.tabBarController.selectedIndex);
			if ([tabbar isEqualToString:@"1"]) {
				// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
				displayId = [infoData valueForKey:@"idTab"];
			}

			/*
			NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
			NSString *tmpFileName = [NSString stringWithString:dbName];
			// NSLog(@"name 1: %@", tmpFileName);
			 */
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];

			cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];
			
			if([cnf.value isEqualToString:@""] || cnf.value == nil
			   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
				NSLog(@"down ... ");
				// myXMLData = [NSData dataWithContentsOfURL:u];
				// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
				[dateFormat setDateFormat:@"YYYYMMddHHmm"];
				NSString *dateString = [dateFormat stringFromDate:date];  
				// [dateFormat release];
				[Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
				[loadWebService callWebService:webService methodName:callMethod 
										  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
			} else {
				
				NSTimeInterval dateTime;		
				// NSDateFormatter *
				// dateFormat = [[[NSDateFormatter alloc] init] autorelease];
				[dateFormat setDateFormat:@"yyyyMMddHHmm"];
				NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
				date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
				
				dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
				/*
				 NSLog(@"t: %@ - %@", 
				 [dateFormat stringFromDate:date],
				 [dateFormat stringFromDate:[dateFormat dateFromString:@"201010150300"]]
				 );
				 NSLog(@" date = %@", date);
				 NSLog(@" date = %@", lastCheck);
				 */
				
				if(dateTime > 1) {
					// if ([date timeIntervalSinceDate:lastCheck] >= 1 ) // today is before launch
					NSLog(@"down (2)... ");
					// myXMLData = [NSData dataWithContentsOfURL:u];
					// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
					[dateFormat setDateFormat:@"YYYYMMddHHmm"];
					NSString *dateString = [dateFormat stringFromDate:date];  
					// [dateFormat release];
					NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_2.xml", displayId],dateString);
					[Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
					[loadWebService callWebService:webService methodName:callMethod 
											  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
				} else {
					// myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
					// [self processXml:[[NSData alloc] initWithContentsOfFile:fileName]];
					[self showXML];
				}
			}
			
			// NSLog(@"--> %@ <--", elements);
		} else {
			NSLog(@"err");
			
			// Also issue visual alert
			UIAlertView *alert = [[UIAlertView alloc]
								  initWithTitle:@"Information file doesn't exists."
								  message:nil
								  delegate:nil
								  cancelButtonTitle:nil
								  otherButtonTitles:@"OK", nil];
			[alert show];
		}
	}
	[self stopAnimated:nil];
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
	[[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleDefault animated:NO];
	[[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationNone];

}


- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
	
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
	[[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleDefault animated:NO];
	[[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationNone];
}
-(void) dataLoaded :(NSMutableData*)content {
	NSLog(@"loaded...");
	
	Config * cnf;
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * actualId = cnf.value;
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSString * displayId = actualId;

	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	// [dateFormat release];
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] withValue:dateString];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_2.xml", displayId],dateString);
	[Config updateValue:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId] value:dateString];

	// NSLog(@"%@", [[NSString alloc] initWithData:content encoding:NSASCIIStringEncoding]);
	[self processXml:content];
}

- (void) processXml:(NSMutableData *)myXMLData {
	NSLog(@"process");

	// NSLog(@"%@", [[NSString alloc] initWithData:myXMLData encoding:NSASCIIStringEncoding]);

	Config * cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * displayId = cnf.value;
	//tabbar
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		displayId = [infoData valueForKey:@"idTab"];
	}

	// NSLog(@"%@", [NSString stringWithFormat:@"tmp_%@_2.xml", displayId]);
	// NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];
	cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];

	elements = [[NSMutableArray alloc] init];
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	TBXMLElement * childXMLElement;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		TBXMLElement * rssXMLElement = [TBXML childElementNamed:@"ConvertRSSResponse" parentElement:childXMLElement];
		rssXMLElement = [TBXML childElementNamed:@"ConvertRSSResult" parentElement:rssXMLElement];
		
		NSString * rssData = [TBXML textForElement:rssXMLElement];
		NSData * XMLData = [rssData dataUsingEncoding:NSUTF8StringEncoding];
		// NSLog(@"--> *** %@", XMLData);
		[XMLData writeToFile:fileName atomically:YES];
		NSLog(@"saved %@...", fileName);
		// NSString *unescaped = [[TBXML textForElement:rssXMLElement] htmlUnescapedString];
		//  escaped = [escaped htmlUnescapedString];

		// [myXMLData writeToFile:fileName atomically:YES];
		/*
		 NSError *error;
		if (![unescaped writeToFile:fileName atomically:YES encoding:NSASCIIStringEncoding error:&error]) {
			NSLog(@"Error while saving\n%@",
				  ([error localizedDescription] != nil) ? [error localizedDescription] : @"Unknown Error");
		}
		 */
		[self showXML];

	}
}

- (void)showXML {
	NSLog(@"show");

	int itemCounter = 0;
	NSArray * feed = [feeds objectAtIndex:0];
	// NSString * title = [feed objectAtIndex:0];
	// NSString * url = [feed objectAtIndex:1];
	// NSString * popup = [feed objectAtIndex:2];
	// NSString * search = [feed objectAtIndex:3];
	NSString * pattern = [feed objectAtIndex:4];
	NSString * titleFont = [feed objectAtIndex:5];
	NSString * titleSize = [feed objectAtIndex:6];
	NSString * titleColor = [feed objectAtIndex:7];
	NSString * titleStyle = [feed objectAtIndex:8];
	NSString * descriptionFont = [feed objectAtIndex:9];
	NSString * descriptionSize = [feed objectAtIndex:10];
	NSString * descriptionColor = [feed objectAtIndex:11];
	NSString * descriptionStyle = [feed objectAtIndex:12];
	NSString * linkName = [feed objectAtIndex:13];
	NSString * linkType = [feed objectAtIndex:14];
	NSString * titleName = [feed objectAtIndex:15];
	NSString * subtitleName = [feed objectAtIndex:16];
	NSString * imageName = [feed objectAtIndex:17];
	NSString * titleLink = [feed objectAtIndex:18];
	NSString * descriptionLink = [feed objectAtIndex:19];
	// NSString * imageLink = [feed objectAtIndex:20];

	/*
	 if ([search isEqualToString:@"true"]) {
		int yS = 0;
		if ([feeds count] > 1) yS = 39;
		self.tableView.frame = CGRectMake(0,yS+94,320,366-yS);
		searchResults = [[NSMutableArray alloc]init];
		searchBar = [[UISearchBar alloc]initWithFrame:CGRectMake(0,yS+44,320,44)]; // 50
		searchBar.delegate = self;
		[self.view addSubview:searchBar];
	}
	*/

	Config * cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * displayId = cnf.value;
	//tabbar
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		displayId = [infoData valueForKey:@"idTab"];
		[Functions updateConfig:@"displayId" withValue:displayId];	
	}

	// NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];

	NSData *XMLData = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[NSString alloc] initWithData:XMLData encoding:NSASCIIStringEncoding];
	unescaped = [unescaped htmlUnescapedString];
	// NSLog(@"--> %@", unescaped);
	
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	elements = [[NSMutableArray alloc] init];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	TBXMLElement * childXMLElement;
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	elements = [[NSMutableArray alloc] init];
	rootXMLElement = tbxml.rootXMLElement;
	// TBXMLElement * childXMLElement;
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				if (!(childXMLElement->firstChild == nil)) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				// NSInteger total = 1;
				do {
					Element * element = [[Element alloc] init];
					TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
					// NSLog(@"ch %@ ", [TBXML elementName:itemXMLElement]);
					// NSLog(@"id %@ ", [TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement]);
					element.idList = [NSString stringWithFormat:@"%i", itemCounter]; // [TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement];
					itemCounter++;
					element.pattern = pattern;
					element.titleFont = titleFont;
					element.titleSize = titleSize;
					element.titleStyle = titleStyle;
					element.titleColor = titleColor;
					element.descriptionFont = descriptionFont;
					element.descriptionColor = descriptionColor;
					element.descriptionSize = descriptionSize;
					element.descriptionStyle = descriptionStyle;
					element.linkType = linkType;
					element.link = linkName;
					do {
						// NSLog(@"sub %@ ? %@", [TBXML elementName:itemXMLElement], imageName);
						if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
							// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
							element.title = [TBXML textForElement:itemXMLElement];
							element.titleLink = titleLink;
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:subtitleName]) {
							// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
							element.description = [TBXML textForElement:itemXMLElement];
							element.descriptionLink = descriptionLink;
						}
						if ([[TBXML elementName:itemXMLElement] isEqualToString:imageName]) {
							// NSLog(@"img -> %@", imageName);
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							//if ([element.linkType isEqualToString:@"video"])
								element.thumb = [TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement];
							//else
							//	element.thumb = [TBXML textForElement:itemXMLElement];
							//NSLog(@"thumb %@ %@", element.linkType, element.thumb);
							//element.thumbLink = imageLink;
						}
						/*
						 if ([[TBXML elementName:itemXMLElement] isEqualToString:linkName]) {
							// NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
							if ([element.linkType isEqualToString:@"video"])
								element.link = [TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement];
							else
								element.link = linkName; // [TBXML textForElement:itemXMLElement];
						}*/
					} while ((itemXMLElement = itemXMLElement->nextSibling));
					// total++;
					[elements addObject:element];
				} while ((dataXMLElement = dataXMLElement->nextSibling));
				} else {
					NSLog(@"data null...");
					UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Empty list." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
					[alert show];
					[alert release];	
					[waitView stopAnimating];
					waitView.hidden=YES;
					waitLabel.hidden=YES;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling));

		cnf = [[Config alloc] initWithName:@"actualId"];
		NSString * displayId = cnf.value;
		if ([tabbar isEqualToString:@"1"]) {
			displayId = [infoData valueForKey:@"idTab"];
		}
		NSString *newName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
		cnf = [[Config alloc] initWithName:newName];
		
		NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
		
		[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
		
	}
	[self.tableView reloadData];
	[self stopAnimated:nil];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[waitLabel release];
	[feeds release];
	[elements release];
	[searchResults release];
	[feedSource release];
	[toolbar release];
	[label release];
	[tableView release];
	[elements release];
    [super dealloc];
}

- (void) initStatusBar:(UIView *)actualView {
	//tabbar
	Config *cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 48;
	
	toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 25; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 435-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	// toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];
	
	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goRefresh) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	UIImage * btnImage = [UIImage alloc];
	button.frame = CGRectMake(288, 2, 20, 20);
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	
	[toolbar addSubview:button];
	
	// [button release];
	
	// info
	UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[infoButton addTarget:self action:@selector(goInfo) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	infoButton.frame = CGRectMake(14, 2, 20, 20);
	btnImage = [UIImage imageNamed:@"info_icon.png"];
	// infoButton.tag = IMAGE_TAG;
	infoButton.backgroundColor = [UIColor clearColor];
	[infoButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:infoButton];
	// [infoButton release];
	// info
	
	// UILabel *
	label = [[UILabel alloc] initWithFrame:
			 CGRectMake(100,3,185,20)];
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    /*
	 NSDateFormatter *formatter = [[[NSDateFormatter alloc] init] autorelease];
	 NSDate *date = [NSDate date];
	 [formatter setDateFormat:@"MM/dd/YY HH:mm"];
	 // [label setText:[formatter stringFromDate:date]];
	 [label setText:[NSString stringWithFormat:@"Updated: %@", [formatter stringFromDate:date]]];
	 */
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * displayId = cnf.value;
	// NSLog(@"tb: %@", tabbar);
	// NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	NSString *newName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	// NSLog(@"name 2: %@", newName);
	cnf = [[Config alloc] initWithName:newName];
	
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"yyyyMMddHHmm"];
	NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
	// NSLog(@"date: %@", cnf.value);
	// NSLog(@"date 2: %@", [dateFormat stringFromDate:lastCheck]);
	
	[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
	[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
	
    label.backgroundColor = [UIColor clearColor];
    // label.backgroundColor = [UIColor blueColor];
    label.textColor = [UIColor whiteColor];
    label.font = [UIFont boldSystemFontOfSize:11];
    label.textAlignment = UITextAlignmentRight;
	
	[toolbar addSubview:label];
    // [label release];
}
	
#pragma mark UISearchBarDelegate

- (void) searchBarTextDidBeginEditing:(UISearchBar *)theSearchBar {
	
	searchBar.showsCancelButton = YES;
	
	NSString *searchText = searchBar.text;
	if([searchText isEqualToString:@""] || searchText==nil)
		return;
	
	searching = YES;
	letUserSelectRow = NO;
	searchBar.showsCancelButton = YES;
	searchBar.autocorrectionType = UITextAutocorrectionTypeNo;
	self.tableView.scrollEnabled = NO;
}

- (void)searchBarTextDidEndEditing:(UISearchBar *)theSearchBar
{
	searchBar.showsCancelButton = NO;
}


- (void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{
	[searchResults removeAllObjects];
	
	if([searchText length] > 0) {
		searching = YES;
		letUserSelectRow = YES;
		self.tableView.scrollEnabled = YES;
		[self searchTableView];
	}
	else {
		searching = NO;
		letUserSelectRow = NO;
		self.tableView.scrollEnabled = NO;
	}
	[self.tableView reloadData];
}

- (void) searchTableView {
	NSString *searchText = searchBar.text;
	if([searchText isEqualToString:@""] || searchText==nil)
	{
		[self.tableView reloadData];
		return;
	}
	
	/*
	 NSMutableArray *searchArray = [[NSMutableArray alloc] init];
	 for (NSDictionary *dictionary in elements)
	 {
	 NSArray *array = [dictionary objectForKey:elements];
	 [searchArray addObjectsFromArray:array];
	 }
	 
	 for (NSString *sTemp in searchArray)
	 {
	 NSRange titleResultsRange = [sTemp rangeOfString:searchText options:NSCaseInsensitiveSearch];
	 
	 if (titleResultsRange.length > 0)
	 [searchResults addObject:sTemp];
	 }
	 
	 [searchArray release];
	 searchArray = nil;
	 */
	NSInteger counter = 0;
	// for(NSString *name in elements)
	for(Element *element in elements)
	{
		// NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
		// NSRange r = [element.title rangeOfString:searchText];
		NSRange r = [element.title rangeOfString:searchText options:NSCaseInsensitiveSearch];
		if(r.location != NSNotFound)
		{
			// if(r.location== 0)//that is we are checking only the start of the names.
			// {
			[searchResults addObject:element];
			// }
		} else {
			if (element.description != nil && ![element.description isEqualToString:@""]) {
				NSRange r = [element.description rangeOfString:searchText options:NSCaseInsensitiveSearch];
				if(r.location != NSNotFound)
				{
					[searchResults addObject:element];
				}
			}
		}
		counter++;
		// [pool release];
	}
	
}

- (void)searchBarCancelButtonClicked:(UISearchBar *)theSearchBar
{
	// if a valid search was entered but the user wanted to cancel, bring back the main list content
	// [self.tableView removeAllObjects];
	// [elements addObjectsFromArray:elements];
	NSLog(@"Cancel");
	searching = NO;
	letUserSelectRow = NO;
	self.tableView.scrollEnabled = YES;
	@try{
		[self.tableView reloadData];
	}
	@catch(NSException *e){
	}
	[searchBar resignFirstResponder];
	searchBar.text = @"";
}

- (void)searchBarSearchButtonClicked:(UISearchBar *)theSearchBar
{
	NSLog(@"Search");
	[searchBar resignFirstResponder];
	[self searchTableView];
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
	if (searching)
		return 1;
	else
		return [elements count];
}

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    // return 0;
	if (searching)
		return [searchResults count];
	else
		return elements.count;
}

- (NSIndexPath *)tableView :(UITableView *)theTableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	if(letUserSelectRow)
		return indexPath;
	else
		return nil;
}

// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)aTableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
	// NSLog(@"BOOL = %d", (int)searching);
	static NSString *CellIdentifier = @"Cell";
    
	const NSInteger TOP_LABEL_TAG = 1001;
	const NSInteger BOTTOM_LABEL_TAG = 1002;
	const NSInteger IMAGE_TAG = 1003;
	// const NSInteger TEST_LABEL_TAG = 1010;
	UIButton *topLabel;
	
	UIButton *bottomLabel;
	UIButton *imageCell;
	// UILabel *testLabel;
	Element *element;
	
	if (searching)
		element = (Element *)[searchResults objectAtIndex:indexPath.row];
	else
		element = (Element *)[elements objectAtIndex:indexPath.row];
	
	// NSLog(@"id: %@", element.idList);
	// NSLog(@"ct: %@", element.description);
	
    /*
	 UITableV// iewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	 if (cell == nil) {
	 cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
	 }
	 */
    UITableViewCell *cell = [aTableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
		/*
		 UIImage *indicatorImage = [UIImage imageNamed:@"button_right.png"];
		 cell.accessoryView =
		 [[[UIImageView alloc]
		 initWithImage:indicatorImage]
		 autorelease];
		 */
		
		const CGFloat LABEL_HEIGHT = 20;
		// NSLog(@"pattern %@", element.pattern);
		
		
		// cell image
		imageCell = [UIButton buttonWithType:UIButtonTypeCustom];
		UIImage * btnImage = [UIImage alloc];
		if (![element.pattern isEqualToString:@"1"]) {
			imageCell.frame = CGRectMake(5, 5, 60, 60);
			// imageCell.frame = CGRectMake(250, 4, 42, 35);
			[cell.contentView addSubview:imageCell];
			btnImage = [UIImage imageNamed:@"unknown.jpg"];
			imageCell.tag = IMAGE_TAG;
			imageCell.backgroundColor = [UIColor clearColor];
			// btnImage = [Functions resizeImage:btnImage width:40 height:40];
			[imageCell setImage:btnImage forState:UIControlStateNormal];
			// [btnImage release];
			[imageCell addTarget:self
						  action:@selector(loadView:)
				forControlEvents:UIControlEventTouchUpInside];
		}
		
		//cell accesory
		NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
		NSString *documentsDir = [documentPaths objectAtIndex:0];
		NSString *fileName = @"/indicator.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		NSData *imgData = [[NSData alloc] initWithContentsOfFile:filePath];
		UIImage *indicatorImage = [[UIImage alloc] initWithData:imgData];
		cell.accessoryView =
		[[[UIImageView alloc]
		  initWithImage:indicatorImage]
		 autorelease];
		
		//
		// Create the label for the top row of text
		//
		topLabel = [UIButton buttonWithType:UIButtonTypeCustom];
		topLabel.frame = CGRectMake(
									/*btnImage.size.width*/70/2 + 3.3 * cell.indentationWidth,
									0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT),
									aTableView.bounds.size.width -
									/*btnImage.size.width*/70/2 - 4.0 * cell.indentationWidth
									- 30,
									LABEL_HEIGHT);
		[cell.contentView addSubview:topLabel];
		topLabel.tag = TOP_LABEL_TAG;
		topLabel.backgroundColor = [UIColor clearColor];
		// topLabel.backgroundColor = [UIColor redColor];
		// topLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize]];
		[topLabel addTarget:self
					 action:@selector(goView:)
		   forControlEvents:UIControlEventTouchUpInside];
		
		// [topLabel setTitleColor:[UIColor whiteColor] forState:UIControlStateSelected];
		// [topLabel setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
		// [topLabel setTitleShadowColor:[UIColor colorWithRed:0.25 green:1.0 blue:1.0 alpha:1.0] forState:UIControlStateSelected];
		// [topLabel setContentHorizontalAlignment:UIControlContentHorizontalAlignmentLeft];
		// topLabel.backgroundColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		// UIFont* font = [UIFont fontWithFamilyName:@"Verdana" traits:GSBoldFontMask size:24];
		// theBtn.titleLabel.font = font;
		// [[topLabel titleLabel] setFont:font];
		// [topLabel.titleLabel setFont:[UIFont systemFontOfSize:24]];
		// [topLabel.titleLabel setFont:[UIFont fontWithName:@"American Typewriter" size:24]];
		// [UIFont systemFontOfSize:20]
		
		// element.titleStyle = titleStyle;
		
#ifdef OS_VER_3
#elseif defined OS_VER_2
#endif
		
		//
		// Create the label for the top row of text
		//
		bottomLabel = [UIButton buttonWithType:UIButtonTypeCustom];
		bottomLabel.frame = CGRectMake(
									   /*btnImage.size.width*/70/2 + 3.3 * cell.indentationWidth,
									   0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
									   aTableView.bounds.size.width -
									   /*btnImage.size.width*/70/2 - 4.0 * cell.indentationWidth
									   - 30,
									   LABEL_HEIGHT);
		[cell.contentView addSubview:bottomLabel];
		bottomLabel.tag = BOTTOM_LABEL_TAG;
		bottomLabel.backgroundColor = [UIColor clearColor];
		[bottomLabel addTarget:self
						action:@selector(loadView:)
			  forControlEvents:UIControlEventTouchUpInside];
		// [bottomLabel setTag:indexPath.row];
		[bottomLabel setContentHorizontalAlignment:UIControlContentHorizontalAlignmentLeft];
		// [bottomLabel setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
		
		// testLabel = [[UILabel alloc] initWithFrame:CGRectMake(80, 0, 240, 40)];
		// testLabel.tag = TEST_LABEL_TAG;
		// [cell.contentView addSubview:testLabel];
		
	}
	else
	{
		topLabel = (UIButton *)[cell viewWithTag:TOP_LABEL_TAG];
		bottomLabel = (UIButton *)[cell viewWithTag:BOTTOM_LABEL_TAG];
		imageCell = (UIButton *)[cell viewWithTag:IMAGE_TAG];
		// testLabel = (UILabel *)[cell viewWithTag:TEST_LABEL_TAG];
	}
	
	// Set up the cell...
	// [cell setText: menuItem.name];
	// cell.textLabel.text = element.title;
	cell.selectionStyle = UITableViewCellSelectionStyleGray;
	
	NSData * imgData = [[NSData alloc] init];
	if (nil != element.thumb) {
		// NSLog(@"image...  %@", element.thumb);
		NSURL *url = [NSURL URLWithString:element.thumb];
		imgData = [[NSData alloc] initWithContentsOfURL:url];
		UIImage *btnImage = [[UIImage alloc] initWithData:imgData];
		btnImage = [Functions resizeImage:btnImage width:60 height:60];
		[imageCell setImage:btnImage forState:UIControlStateNormal];
		// [btnImage release];
		[imageCell addTarget:self
					  action:@selector(loadView:)
			forControlEvents:UIControlEventTouchUpInside];
		[imageCell setTitle:element.description forState:UIControlStateNormal];
	} else {
	}
	
	// NSString *subtitle = [NSString stringWithString: @"All about the color "];
	// subtitle = [subtitle stringByAppendingFormat:colorString];
	
	// cell.detailTextLabel.text = element.description; // subtitle;
	
	// NSString *tmpTitle = element.description;
	// testLabel.text = tmpTitle;
	[topLabel setTitle:element.title forState:UIControlStateNormal];
	// NSLog(@"set title %@", element.title);
	[topLabel setTitle:element.title forState:UIControlStateHighlighted];
	[topLabel setTitle:element.title forState:UIControlStateDisabled];
	[topLabel setTitle:element.title forState:UIControlStateSelected];
	// topLabel.titleLabel.font = [UIFont fontWithName:element.titleFont size:[element.titleSize intValue]];
	NSString * titleFont;
	// NSLog(@"TF: %@ %@", element.titleFont, element.titleSize);
	if (element.titleFont != nil) {
		if ([element.titleStyle isEqualToString:@"bold"]) {
			// element.titleFont = [[element.titleFont autorelease] stringByAppendingString:@"-Bold"];
			titleFont = [element.titleFont stringByAppendingString:@"-Bold"];
		} else if ([element.titleStyle isEqualToString:@"italic"]) {
			titleFont = [element.titleFont stringByAppendingString:@"-Oblique"];
		} else if ([element.titleStyle isEqualToString:@"bold-italic"]) {
			titleFont = [element.titleFont stringByAppendingString:@"-BoldOblique"];
		} else {
			titleFont = element.titleFont;
		}
		titleFont = [Functions fontName:element.titleFont fontStyle:element.titleStyle];
		[topLabel.titleLabel setFont:[UIFont fontWithName:titleFont size:[element.titleSize intValue]]];
		[topLabel setTitleColor:[Functions colorForHex: element.titleColor] forState:UIControlStateNormal];
	}
	topLabel.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
	
	if (nil == element.thumb) {
		// NSLog(@"image?");
		const CGFloat LABEL_HEIGHT = 20;
		topLabel.frame = CGRectMake(
									2 * cell.indentationWidth,
									0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT),
									aTableView.bounds.size.width -
									4.0 * cell.indentationWidth
									- 25,
									LABEL_HEIGHT);
		bottomLabel.frame = CGRectMake(
									   2 * cell.indentationWidth,
									   0.5 * (aTableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
									   aTableView.bounds.size.width -
									   4.0 * cell.indentationWidth
									   - 20,
									   LABEL_HEIGHT);
	}
	
	if (element.description == nil) {
		topLabel.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
		topLabel.titleLabel.numberOfLines = 2;
		int imageSize = 0;
		// if (![element.pattern isEqualToString:@"1"]) 
		if (nil != element.thumb)
			imageSize = 60;
		topLabel.frame = CGRectMake(
									imageSize/2 + 2.5 * cell.indentationWidth,
									0.5 * (aTableView.rowHeight - 2 * 20),
									aTableView.bounds.size.width -
									imageSize/2 - 4.0 * cell.indentationWidth
									- 25,
									20*2);
	}
	
	// NSLog(@"tt: %@", element.title);
	[bottomLabel setTitle:element.description forState:UIControlStateNormal];
	// NSLog(@"DF: %@ %@", element.descriptionFont, element.descriptionSize);
	if (element.descriptionFont != nil) {
		if ([element.descriptionStyle isEqualToString:@"bold"]) {
			// element.titleFont = [[element.titleFont autorelease] stringByAppendingString:@"-Bold"];
			titleFont = [element.descriptionFont stringByAppendingString:@"-Bold"];
		} else if ([element.descriptionStyle isEqualToString:@"italic"]) {
			titleFont = [element.descriptionFont stringByAppendingString:@"-Oblique"];
		} else if ([element.descriptionStyle isEqualToString:@"bold-italic"]) {
			titleFont = [element.descriptionFont stringByAppendingString:@"-BoldOblique"];
		} else {
			titleFont = element.descriptionFont;
		}
		titleFont = [Functions fontName:element.descriptionFont fontStyle:element.descriptionStyle];
		[bottomLabel.titleLabel setFont:[UIFont fontWithName:titleFont size:[element.descriptionSize intValue]]];
		[bottomLabel setTitleColor:[Functions colorForHex: element.descriptionColor] forState:UIControlStateNormal];
	}
	
	/*
	 imagen pendiente...
	 testXmlListDetailAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	 NSString * offline = [appDelegate loadOffline];
	 NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	 NSString *documentsDir = [documentPaths objectAtIndex:0];
	 NSData *imgData;
	 UIImage *img;
	 NSString *data = project.thumb;
	 NSLog(@"thumb: %@", data);
	 NSArray *parts = [data componentsSeparatedByString:@"/"];
	 NSString *filename;
	 NSString *imgPath = [documentsDir stringByAppendingPathComponent:@"/thumbs/"];
	 [[NSFileManager defaultManager] createDirectoryAtPath:imgPath attributes:nil];
	 filename = [parts objectAtIndex:[parts count]-2];
	 imgPath = [imgPath stringByAppendingPathComponent:filename];
	 [[NSFileManager defaultManager] createDirectoryAtPath:imgPath attributes:nil];
	 filename = [parts lastObject]; 
	 imgPath = [imgPath stringByAppendingPathComponent:filename];
	 if (offline == @"onl") {
	 NSURL *imgURL = [NSURL URLWithString:data];
	 imgData = [NSData dataWithContentsOfURL:imgURL];
	 [imgData writeToFile:imgPath atomically:YES];
	 } else {
	 // imgData = [[NSData alloc] initWithContentsOfFile:imgPath];
	 // img = [[UIImage alloc] initWithData:imgData];
	 }
	 imgData = [[NSData alloc] initWithContentsOfFile:imgPath];
	 img = [[UIImage alloc] initWithData:imgData];
	 cell.imageView.image = img;
	 */
	
	// cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	// cell.accessoryType = UITableViewCellAccessoryNone;
	
	[topLabel setEnabled: NO];
	[bottomLabel setEnabled: NO];
	[imageCell setEnabled: NO];

	if (
		![element.pattern isEqualToString:@"7"] && 
		![element.pattern isEqualToString:@"8"] && 
		![element.pattern isEqualToString:@"9"]
		) {
	// if (![element.titleLink isEqualToString:@"none"])
		[topLabel setEnabled: YES];
	// if (![element.descriptionLink isEqualToString:@"none"])
		[bottomLabel setEnabled: YES];
	// if (![element.thumbLink isEqualToString:@"none"])
		[imageCell setEnabled: YES];
	}

	return cell;
}



- (void)tableView:(UITableView *)aTableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
    // Navigation logic may go here. Create and push another view controller.
	// AnotherViewController *anotherViewController = [[AnotherViewController alloc] initWithNibName:@"AnotherView" bundle:nil];
	// [self.navigationController pushViewController:anotherViewController];
	// [anotherViewController release];
	NSLog(@"???");	
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];*/
	[NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(showAd) object:nil];
	[NSObject cancelPreviousPerformRequestsWithTarget:self selector:@selector(hideAd) object:nil];
	
	[aTableView deselectRowAtIndexPath:indexPath animated:NO];
	// NSLog(@"p: %d", indexPath);

	Element *element;
	
	if (searching)
		element = (Element *)[searchResults objectAtIndex:indexPath.row];
	else
		element = (Element *)[elements objectAtIndex:indexPath.row];
	
	NSLog(@"e: %@", element.link);
	
	if ([element.link isEqualToString:@""] ||
		element.link == nil)
		return;
	
	[self loadView:element];
}

- (IBAction)goView:(id)sender {
	
	// titleLink
    NSString *buttonTitle = [(UIButton *)sender currentTitle];
    NSInteger buttonTag = [(UIButton *)sender tag];
	NSLog(@"b: %@ , %i", buttonTitle, buttonTag);
	
	UITableViewCell *cell = (UITableViewCell*)[[sender superview] superview];
    NSIndexPath* indexPath = [[self tableView] indexPathForCell:(UITableViewCell*)cell];
	// NSLog(@"i: %d", index);
	Element *element;
	
	if (searching)
		element = (Element *)[searchResults objectAtIndex:indexPath.row];
	else
		element = (Element *)[elements objectAtIndex:indexPath.row];

	if (buttonTag == 1001)
		element.link = element.titleLink;
	else if (buttonTag == 1002)
		element.link = element.descriptionLink;
	else if (buttonTag == 1003)
		element.link = element.thumbLink;

	// element.link = element.titleLink;
	
	[self loadView:element];

}

-(void)loadView:(Element *) element {
	/*
	 Config * cnf;
	 cnf = [[Config alloc] initWithName:@"selectedListItem"];
	 NSString * value = cnf.value;
	 if (value == @"") {
	 int primaryKey = [Config insertValue:@"selectedListItem" value: element.idList];
	 // NSLog("pk %d", primaryKey);
	 } else {
	 [Config updateValue:@"selectedListItem" value: element.idList];
	 }
	 */
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];

	Config * cnf;
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * actualId = cnf.value;
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	
	if ([element.linkType isEqualToString:@"url"]) {
		NSLog(@"??? %@", element.link);
		[Functions updateConfig:@"selectedListItem" withValue:@"0"];
		[Functions updateConfig:@"goUrl" withValue:element.link];
		[Functions updateConfig:@"displayId" withValue:@"0"];
		[Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
		[appDelegate displayView:@"5"]; // :[appDelegate detailType]];
	} else if ([element.linkType isEqualToString:@"video"]) {
		// detail
		[Functions updateConfig:@"selectedListItem" withValue: element.idList];
		[Functions updateConfig:@"displayId" withValue:element.link];
		[Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
		// detail
		
		[Functions updateConfig:@"goUrl" withValue:element.link];
		// [Functions updateConfig:@"displayId" withValue:@"0"];
		[appDelegate displayView:@"6"]; // :[appDelegate detailType]];
	} else {
		NSLog(@"aaa %@", element.link);
		[Functions updateConfig:@"selectedListItem" withValue: element.idList];
		[Functions updateConfig:@"goUrl" withValue:@"---"];
		[Functions updateConfig:@"displayId" withValue:element.link];
		[Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_2.xml", actualId]];
		[appDelegate displayView:@"7"];
	}

	/*
	 xmlDetailViewController * aXmlDetailViewController = [[xmlDetailViewController alloc] initWithNibName:@"DescriptionView" bundle:nil];
	 
	 aXmlDetailViewController.aProject = [projects objectAtIndex:indexPath.row];
	 NSLog(@"go... %@", aXmlDetailViewController.aProject.title);
	 [self.navigationController pushViewController:aXmlDetailViewController animated:YES];
	 
	 [aXmlDetailViewController release];
	 */
}

-(NSString *) reviewLinkType: (NSString *)linkName: (NSString *)linkType {
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"linkName : %@ - idItem: %@ ", linkName, idItem);
				if ([linkName isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			/*
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				// NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"detail_link"]) {
									
									if ([[TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement] isEqualToString:@"media_content"])
										linkType = @"video";
									
								}
							}
						} while (childXMLElement = childXMLElement->nextSibling);
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			 */
			NSString *attribItem = [TBXML valueOfAttributeNamed:@"type" forElement:feedsXMLElement];
			if ([attribItem isEqualToString:@"6"])
				linkType = @"video";
		}
	}
	return linkType;
}

- (void) goRefresh {
	//NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	//										 selector:@selector(showAnimated:) object:self];
	//[thrAni start];
	[self showAnimated:nil];
	searching = NO;
	letUserSelectRow = NO;
	self.tableView.scrollEnabled = NO;
	NSArray * feed = [feeds objectAtIndex:0];
	NSString * url = [feed objectAtIndex:1];
	
	// download info
	NSLog(@"download...");
	// NSURL *u = [NSURL URLWithString:url];
	// NSData *myXMLData   = [NSData dataWithContentsOfURL:u];

	WebServiceHelper * loadWebService = [[WebServiceHelper alloc] init];
	// NSString * tmpUrl = @"http://mediasuite.multicastmedia.com/rss/vod.php?p=f30jt6g5&thumbs=true";
	// [loadWebService callWebService:tmpUrl delegate:self requestSelector:@selector(test:)];
	NSString * webService = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/mh_mobile_convert_rss.asmx";
	NSString * callMethod = @"ConvertRSS";
	NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug", nil];
	NSArray *keyvalues = [NSArray arrayWithObjects:url,@"true", nil];	
	[loadWebService callWebService:webService methodName:callMethod 
							  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
	
	// old
	// URLConnection * urlConnection = [[URLConnection alloc] initWithUrl:url];
	// [urlConnection downloadData:self];
	// old
	
}

-(void)internetUrlError:(URLConnection *)urlConnection {
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Error downloading update." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];	
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.hidden=YES;
}

-(void)internetUrlReady:(URLConnection *)urlConnection {
	NSMutableData *myXMLData   = urlConnection.xmlDownload;

	Config * cnf;
	cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * displayId = cnf.value;
	//tabbar
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [Functions loadFromTabBar:self.tabBarItem.title];
	}

	NSLog(@"%@", [NSString stringWithFormat:@"tmp_%@_2.xml", displayId]);
	// NSString *dbName = [NSString stringWithFormat:@"tmp_%@_2.xml", displayId];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];
	cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"tmp_%@_2.xml", displayId]];
	
		[myXMLData writeToFile:fileName atomically:YES];
		NSLog(@"saved %@...", fileName);
		[self showXML];
		
}

- (void) goInfo {
	//NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	//										 selector:@selector(showAnimated:) object:self];
	//[thrAni start];
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"9"];
}


#pragma mark Singleton Methods
+ (id)sharedManager {
	@synchronized(self) {
		if(sharedMyManager == nil)
			sharedMyManager = [[super allocWithZone:NULL] init];
	}
	return sharedMyManager;
}
+ (id)allocWithZone:(NSZone *)zone {
	return [[self sharedManager] retain];
}
- (id)copyWithZone:(NSZone *)zone {
	return self;
}
- (id)retain {
	return self;
}
- (unsigned)retainCount {
	return UINT_MAX; //denotes an object that cannot be released
}
- (void)release {
	// never release
}
- (id)autorelease {
	return self;
}
- (id)init {
	return self;
}

@end
