//
//  LoginViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 4/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "LoginViewController.h"
#import "Functions.h"
#import "app_builderAppDelegate.h"
#import "ASIFormDataRequest.h"

@implementation LoginViewController

@synthesize waitLabel;
@synthesize txtUsername, txtPassword;
@synthesize txtError;

@synthesize reqName;
@synthesize reqType;
@synthesize reqService;
@synthesize reqFields;

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	UIImage *tempImg = [[UIImage alloc] initWithData:imgData];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	[tempImg release];
	imageView.frame = CGRectMake(0, 0, 320, 460);
	[self.view addSubview:imageView];
	[imageView release];
	
	[Functions addToolBar:self.view withTitle:@"Login" actualId:nil];

	// UITextView *
	txtUsername = [[SSTextView alloc] initWithFrame:CGRectMake(40, 70, 240, 40)];
	txtUsername.delegate = self;
	txtUsername.placeholder = @"Username";
	txtUsername.textColor = [UIColor blackColor]; //text color
	txtUsername.font = [UIFont systemFontOfSize:20.0];  //font size
	txtUsername.textAlignment = UITextAlignmentCenter;
	[txtUsername addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtUsername.scrollEnabled = NO;
	txtUsername.returnKeyType = UIReturnKeyDone;  // type of the return key
	[self.view addSubview:txtUsername];
	
	txtError = [[UILabel alloc] initWithFrame:CGRectMake(40, 250, 240, 60)];
	txtError.textColor = [UIColor redColor]; //text color
	txtError.font = [UIFont systemFontOfSize:16.0];  //font size
	txtError.textAlignment = UITextAlignmentCenter;
	[self.view addSubview:txtError];
	// txtError.backgroundColor = [UIColor blueColor];

	txtPassword = [[SSTextView alloc] initWithFrame:CGRectMake(40, 140, 240, 40)];
	txtPassword.delegate = self;
	txtPassword.textColor = [UIColor blackColor]; //text color
	txtPassword.font = [UIFont systemFontOfSize:20.0];  //font size
	txtPassword.textAlignment = UITextAlignmentCenter;
	txtPassword.scrollEnabled = NO;
	[txtPassword addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtPassword.returnKeyType = UIReturnKeyDone;  // type of the return key
	[self.view addSubview:txtPassword];
	
	UIButton *sendButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[sendButton setFrame:CGRectMake(124,210,73,32)]; // 600
	[sendButton setTitle:@"Send" forState:UIControlStateNormal];
	[sendButton setTitle:@" " forState:UIControlStateNormal];
	[sendButton addTarget:self action:@selector(goLogin:) forControlEvents:UIControlEventTouchUpInside];
	sendButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[self.view addSubview:sendButton];
	// [sendButton release];
	
	UIImage *btnImage = [UIImage imageNamed:@"button_send.png"];
	sendButton.backgroundColor = [UIColor clearColor];
	[sendButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];

	
	[self initWaitView];
	// [self showAnimated:nil];
	// [self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
	[self loadAuth:NO errMsg:@""];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[txtUsername release];
	[txtPassword release];
    [super dealloc];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	[textField resignFirstResponder];
	return YES;
}

-(void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change   context:(void *)context {
	UITextView *tv = object;
	CGFloat topCorrect = ([tv bounds].size.height - [tv contentSize].height * [tv zoomScale])  / 2.0;
	topCorrect = ( topCorrect < 0.0 ? 0.0 : topCorrect );
	tv.contentOffset = (CGPoint){.x = 0, .y = -topCorrect};
}

/*- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
    [theTextField resignFirstResponder];
	// NSLog(@"tx: %@ %@", theTextField.fieldName, theTextField.text);
	return YES;
}*/

-(IBAction) goLogin:(id) sender
{
	[txtUsername resignFirstResponder];
	[txtPassword resignFirstResponder];
	[self showAnimated:nil];
	[self performSelector:@selector(doLogin) withObject:nil afterDelay:0.5];
}

- (void) doLogin
{
	Config * cnf = [[Config alloc] init];
	//app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	//[appDelegate displayView:@"1"];
	NSString * userName = txtUsername.text; 
	NSString * userPassword = txtPassword.text;
	NSLog(@"Entered information: %@ - %@", userName, userPassword);
	NSString *autName = [NSString stringWithFormat:@"tmp_16.aut"];
	NSLog(@"aut 2: %@", autName);
	NSString * value = [cnf loadValue:autName];
	if ([value isEqualToString:@""] || value == nil) {
		[cnf insertValue:autName value:userName];
	} else {
		[cnf updateValue:autName value:userName];
	}
    [cnf release];
	[self callAuth:userName withPassword:userPassword];
	
}

- (void) loadAuth:(BOOL)showErr errMsg:(NSString *)txtErr 
{
	
	Config *cnf = [[Config alloc] init];
	NSString * authenticationId = [cnf loadValue:@"authentication_id"];
	NSString * authentication = [cnf loadValue:@"authentication"];
	[cnf release];
	txtError.text = txtErr;
	[self stopAnimated:nil];

	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:authentication ] ];
 	NSLog(@"sent: %@", authentication);	
	[request startSynchronous];
	
	NSError *error = [request error];
	self.reqName = @"";
	self.reqType = @"";
	self.reqService = @"";
	// [reqFields release];
	reqFields = [[NSMutableArray alloc] init];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		[self stopAnimated:nil];
		
		// TBXML * dataXml = [[TBXML tbxmlWithXMLString:response] retain];
		TBXML * dataXml = [[TBXML tbxmlWithXMLString:response] retain];
		if (dataXml.rootXMLElement)
		{
			TBXMLElement * childXMLElement = dataXml.rootXMLElement;
			childXMLElement = childXMLElement->firstChild;
			BOOL f = NO;
			do {

				NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"authentication_module"]
					&& [[TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement] isEqualToString:authenticationId]
					) {
					f = YES;
					self.reqName = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
					self.reqType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					TBXMLElement * serviceXml = [TBXML childElementNamed:@"service" parentElement:childXMLElement];
					if (serviceXml)
						self.reqService = [TBXML textForElement:serviceXml];
					TBXMLElement * fieldsXml = [TBXML childElementNamed:@"fields" parentElement:childXMLElement];
					if (fieldsXml) 
					{
						TBXMLElement * fieldXml = fieldsXml->firstChild;
						
						do
						{
							NSString * formName = [TBXML valueOfAttributeNamed:@"display_name" forElement:fieldXml];
							NSString * formField = [TBXML valueOfAttributeNamed:@"form_name" forElement:fieldXml];
							NSArray *field = [NSArray arrayWithObjects: formName, formField, nil];
							[self.reqFields addObject:field];
							// [field release];
						} while ((fieldXml = fieldXml->nextSibling));
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && !f);
			
		}
        [dataXml release];
	}
	else
	{
		// error
	}
	NSLog(@"f:::: %@ +++ %@ --- %@ *** %@", reqFields, reqName, reqType, reqService);
	
	// Config * cnf = [[Config alloc] init];
	// NSString * displayId = [cnf loadValue:@"actualId"];
	// NSString * tabbar = [cnf loadValue:@"useTabBar"];
	// if ([tabbar isEqualToString:@"1"]) {
	//	displayId = [infoData valueForKey:@"idTab"];
	// }
	//NSString *autName = [NSString stringWithFormat:@"tmp.aut"];
	//NSString * value = [NSString stringWithFormat:@"%@", [cnf loadValue:autName] ];
	//NSLog(@"aut 1: %@ --", autName);
	
	NSString *errMsg = @"";
	if (showErr) 
		if ([txtErr isEqualToString:@""])
			errMsg = @"Error on data.";
		else
			errMsg = [NSString stringWithFormat:@"%@", txtErr];
	
	NSLog(@"err? %@ ? %d", errMsg, showErr);
	if ([[reqFields objectAtIndex:0] objectAtIndex:0]) {
		txtUsername.placeholder = [[reqFields objectAtIndex:0] objectAtIndex:0];
	}
	if ([reqFields count] == 2)
	{
		if ([[reqFields objectAtIndex:1] objectAtIndex:0]) {
			txtPassword.placeholder = [[reqFields objectAtIndex:1] objectAtIndex:0];
		}
	} else {
		txtPassword.hidden = YES;
	}
	
}

- (void) callAuth:(NSString *)text withPassword: (NSString *)password
{
	Config * cnf =[[Config alloc] init];
	
	NSString *requestString = [NSString 
							   stringWithFormat:@"%@?", reqService];
	
	int $i = 0;
	NSLog(@"req: %@", reqFields);
	txtError.text = @"";
	
	for (NSArray *field in reqFields) {
		NSLog(@"req: %@", [field objectAtIndex:1]);
		requestString = [NSString stringWithFormat:@"%@%@=%@&", requestString, [field objectAtIndex:1], ($i == 0) ? text: password];
		$i++;
	}
	
	
	
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
	NSLog(@"++++++++++++++ req: %@", requestString);
	[request startSynchronous];
	NSError *error = [request error];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		[self stopAnimated:nil];
		if ([response isEqualToString:@"true"]) 
		{
			// NSString * displayId = [cnf loadValue:@"actualId"];
			//tabbar
			NSString * tabbar = [cnf loadValue:@"useTabBar"];
			NSLog(@"tb: %@", tabbar);
			NSLog(@"title: %@", self.tabBarItem.title);
			// NSLog(@"title: %i", self.tabBarController.selectedIndex);
			// if ([tabbar isEqualToString:@"1"]) {
			//	displayId = [infoData valueForKey:@"idTab"];
			// }
			NSString *autName = [NSString stringWithFormat:@"tmp_16.log"];
			// NSString * value = [cnf loadValue:autName];
			// if ([value isEqualToString:@""] || value == nil) {
			//	[cnf insertValue:autName value:@"true"];
			// } else {
				[cnf updateValue:autName value:@"true"];
			// }
		} else {
			[self loadAuth:TRUE errMsg:@"Error on Username or Password"];
            [cnf release];
			return;
		}
	}
	else
	{
		[self loadAuth:TRUE errMsg:[error localizedDescription]];
        [cnf release];
		return;
	}
	
	[cnf release];
	[Functions goMenu:@"1"];
	
	/*************	
	// NSString *
	requestString = [NSString 
					 stringWithFormat:@"http://widgets.isg-marketing.com/mcgrawhill_mobile/app_builder/services/add_survey_response.aspx"];
	// stringWithFormat:@"http://widgets.isg-marketing.com/mcgrawhill_mobile/app_builder/services/add_survey_response.aspx?user_name=%@&survey_id=%@&", text, idSurvey];
	//							   184.73.161.149:8040/services/events_is_valid_attendee.aspx?user_name=%@", text];
	request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
	
	// ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:url];
	[request setPostValue:text forKey:@"user"];
	NSLog(@"sent: %@", requestString);	
	NSLog(@"user_name: %@", text);	
	[request startSynchronous];
	NSError *error = [request error];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		[self stopAnimated:nil];
		
		NSString * error = @"";
		TBXML * dataXml = [[TBXML tbxmlWithXMLString:response] retain];
		if (dataXml.rootXMLElement)
		{
			TBXMLElement * infoXml = dataXml.rootXMLElement;
			// dataXml = dataXml->firstChild;
			TBXMLElement * errorXml = [TBXML childElementNamed:@"error" parentElement:infoXml];
			if (errorXml)
				error = [TBXML textForElement:errorXml];
			TBXMLElement * responseIdXml = [TBXML childElementNamed:@"response_id" parentElement:infoXml];
			if (responseIdXml)
				self.idResponse = [TBXML textForElement:responseIdXml];
			else 
				idResponse = @"";
			NSLog(@"error: %@", error);
			NSLog(@"response: %@", idResponse);
		}
		[cnf release];
		
		if (idResponse) {
			Config * cnf = [[Config alloc] init];
			NSString *autName = [NSString stringWithFormat:@"survey_%@_%@.log", idSurvey, idModule];
			NSString * value = [cnf loadValue:autName];
			if ([value isEqualToString:@""] || value == nil) {
				[cnf insertValue:autName value:idResponse];
			} else {
				[cnf updateValue:autName value:idResponse];
			}
			[cnf release];
		}
		else 
		{
			// [cnf release];
			//[self loadAuth:TRUE errMsg:error];
		}
	}
***********/
}

@end
