//
//  MapViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 8/20/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MapViewController.h"
#import "DisplayMap.h"
#import "Functions.h"
#import "Config.h"
#import "NSString+HTML.h"
#import "Project.h"
#import "app_builderAppDelegate.h"

@implementation MapViewController

@synthesize mapView;
@synthesize useGps, radiusField;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
 // Custom initialization
 }
 return self;
 }
 */

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	/*
	cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = cnf.value;
	cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"useGps_%@", actualId]];
	 useGps = cnf.value;
	 */
	
	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	self.useGps = [cnf loadValue:[NSString stringWithFormat:@"useGps_%@", actualId]];

	if ([useGps isEqualToString:@""] || (useGps == nil))
		useGps = @"2";
	
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	NSLog(@"actualId: %@", actualId);
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * mapXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * url = @"";
	NSString * map = @"";
	NSString * mapType = @"";
	NSString * mapLocation = @"";
	NSString * mapScrolling = @"";
	NSString * mapZooming = @"";
	NSString * mapLongitude = @"";
	NSString * mapLatitude = @"";
	NSString * mapAddress = @"";
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					mapXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			appXMLElement = mapXMLElement->firstChild;
			do {
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"map_option"]) {
									map = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
							
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:map]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"map_type"]) {
									mapType = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapType = [mapType urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_location"]) {
									mapLocation = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapLocation = [mapLocation urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_scrolling"]) {
									mapScrolling = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapScrolling = [mapScrolling urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_zooming"]) {
									mapZooming = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapZooming = [mapZooming urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_longitude"]) {
									mapLongitude = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapLongitude = [mapLongitude urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_latitude"]) {
									mapLatitude = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapLatitude = [mapLatitude urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_address"]) {
									mapAddress = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapAddress = [mapAddress urlUnescapedString];
								}
								
								
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					
					
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}
    
    NSLog(@"long %@ lat %@ add %@", mapLongitude, mapLatitude, mapAddress);

    [Functions addToolBar:self.view withTitle:@"Map" actualId:actualId];
	[self initStatusBar:self.view];

	[mapView setDelegate:self];
	mapView.frame = CGRectMake(0,48,320,420-34);
	if ([mapLocation isEqualToString:@"true"])
        useGps = @"1";
    else
        useGps = @"2";
    if ([mapZooming isEqualToString:@"false"])
		[mapView setZoomEnabled:NO];
	else
		[mapView setZoomEnabled:YES];
	if ([mapScrolling isEqualToString:@"false"])
		[mapView setScrollEnabled:NO];
	else
		[mapView setScrollEnabled:YES];
	
	if ([mapType isEqualToString:@"Hybrid"])
		[mapView setMapType:MKMapTypeHybrid];
	else if ([mapType isEqualToString:@"Satellite"])
		[mapView setMapType:MKMapTypeSatellite];
	else
		[mapView setMapType:MKMapTypeStandard];
	
    [self createMap];

	/***********
	 MKCoordinateRegion region = { {0.0, 0.0 }, { 0.0, 0.0 } }; 
	 region.center.latitude = 22.569722 ;
	 region.center.longitude = 88.369722;
	 region.span.longitudeDelta = 0.01f;
	 region.span.latitudeDelta = 0.01f;
	 [mapView setRegion:region animated:YES]; 
	 
	 [mapView setDelegate:self];
	 
	 DisplayMap *ann = [[DisplayMap alloc] init]; 
	 ann.title = @" Kolkata";
	 ann.subtitle = @"Mahatma Gandhi Road"; 
	 ann.coordinate = region.center;
	 ann.annTag = @"1001";
	 [mapView addAnnotation:ann];
	 **********/
	
	CLLocationManager *locationManager=[[CLLocationManager alloc] init];
	locationManager.delegate=self;
	locationManager.desiredAccuracy=kCLLocationAccuracyNearestTenMeters;
	[locationManager startUpdatingLocation];
	
	
	/*
	 if ([popup isEqualToString:@"1"])
	 [mapView setMapType:MKMapTypeHybrid];
	 else if ([popup isEqualToString:@"2"])
	 [mapView setMapType:MKMapTypeSatellite];
	 else
	 [mapView setMapType:MKMapTypeStandard];
	 / *
	 mapView.mapType=;
	 [mapView setMapType:MKMapTypeStandard];
	 [mapView setZoomEnabled:YES];
	 [mapView setScrollEnabled:YES];
	 MKCoordinateRegion region = { {0.0, 0.0 }, { 0.0, 0.0 } }; 
	 region.center.latitude = 22.569722 ;
	 region.center.longitude = 88.369722;
	 region.span.longitudeDelta = 0.01f;
	 region.span.latitudeDelta = 0.01f;
	 [mapView setRegion:region animated:YES]; 
	 
	 [mapView setDelegate:self];
	 
	 DisplayMap *ann = [[DisplayMap alloc] init]; 
	 ann.title = @" Kolkata";
	 ann.subtitle = @"Mahatma Gandhi Road"; 
	 ann.coordinate = region.center;
	 [mapView addAnnotation:ann];
	 */
	
	[cnf release];
}

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[mapView release];
    [super dealloc];
}

- (void) initStatusBar:(UIView *)actualView {
	//tabbar
	Config *cnf = [[Config alloc] init];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
    [cnf release];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 48;
	
	UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 34; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 425-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	

	toolbar.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);
	[toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 102.0, 320, toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, CGRectGetHeight(mainViewBounds)-toolbarHeight, CGRectGetWidth(mainViewBounds), toolbarHeight)];

	
    // toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	// toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];
    [toolbar release];
	return;
    
	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goRefresh) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	button.frame = CGRectMake(288, 2, 30, 30);
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage * btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	
	[toolbar addSubview:button];
	
	// [button release];
	
	// info
	UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[infoButton addTarget:self action:@selector(goInfo) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	infoButton.frame = CGRectMake(14, 2, 30, 30);
	btnImage = [UIImage imageNamed:@"info_icon.png"];
	// infoButton.tag = IMAGE_TAG;
	infoButton.backgroundColor = [UIColor clearColor];
	[infoButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:infoButton];
	// [infoButton release];
	// info
	
	// config
	UIButton *configButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[configButton addTarget:self action:@selector(goGps) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	configButton.frame = CGRectMake(56, 2, 30, 30);
	// configButton.frame = CGRectMake(46, 2, 30, 30);
	btnImage = [UIImage imageNamed:@"icon_user_settings.png"];
	// infoButton.tag = IMAGE_TAG;
	configButton.backgroundColor = [UIColor clearColor];
	[configButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:configButton];
	// [infoButton release];
	// config
	
	// address
	UIButton *addressButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[addressButton addTarget:self action:@selector(goAddress) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	addressButton.frame = CGRectMake(90, 2, 30, 30);
	// addressButton.frame = CGRectMake(78, 2, 30, 30);
	btnImage = [UIImage imageNamed:@"info_icon.png"];
	// addressButton.tag = IMAGE_TAG;
	addressButton.backgroundColor = [UIColor clearColor];
	[addressButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:addressButton];
	// [addressButton release];
	// address

	// radiusLabel
	UILabel *
	radiusLabel = [[UILabel alloc] initWithFrame:
				   CGRectMake(110,2,50,30)];
    radiusLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    radiusLabel.backgroundColor = [UIColor clearColor];
    // radiusLabel.textColor = [UIColor whiteColor];
    radiusLabel.font = [UIFont boldSystemFontOfSize:13];
    radiusLabel.textAlignment = UITextAlignmentRight;
	[radiusLabel setText:@"Rad:"];
	[toolbar addSubview:radiusLabel];
    // [radiusLabel release];
	// radiusLabel

	NSString * actualId = [cnf loadValue:@"actualId"];
	if ([tabbar isEqualToString:@"1"])
		actualId = [infoData valueForKey:@"idTab"];
	NSLog(@"actualId: %@", actualId);
	NSString * radius = [cnf loadValue:[NSString stringWithFormat:@"radius_%@", actualId]];
	if ([radius isEqualToString:@""] || (radius == nil))
		radius = @"16";

	// radiusField
	radiusField = [[UITextField alloc] 
				   initWithFrame: CGRectMake(160, 2, 25, 30)];
	radiusField.adjustsFontSizeToFitWidth = YES;
	radiusField.textColor = [UIColor blackColor];
	radiusField.font = [UIFont systemFontOfSize:17.0];
	radiusField.placeholder = @"";
	radiusField.backgroundColor = [UIColor clearColor];
	radiusField.autocorrectionType = UITextAutocorrectionTypeNo;        // no auto correction support
	radiusField.autocapitalizationType = UITextAutocapitalizationTypeNone; // no auto capitalization support
	radiusField.textAlignment = UITextAlignmentLeft;
	radiusField.textAlignment = UITextAlignmentCenter;
	radiusField.keyboardType = UIKeyboardTypeDefault; // use the default type input method (entire keyboard)
	radiusField.returnKeyType = UIReturnKeyDone;
	radiusField.tag = 0;
	radiusField.delegate = self;
	radiusField.clearButtonMode = UITextFieldViewModeNever; // no clear 'x' button to the right
	radiusField.text = radius; // @"16";
	[radiusField setEnabled:NO];
	radiusField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
	// [radiusField release];
	[toolbar addSubview:radiusField];
	// radiusField
	
	// radius
	UISlider *radiusControl = [[UISlider alloc] 
							   initWithFrame:CGRectMake(187, 2, 100, 30)];
	radiusControl.minimumValue = 0.0;
	radiusControl.maximumValue = 32.0;
	radiusControl.tag = 1005;
	radiusControl.value = [radius intValue]; // 16;
	radiusControl.continuous = YES;
	[radiusControl addTarget:self action:@selector(changeSlide:) forControlEvents:UIControlEventValueChanged];
	[toolbar addSubview:radiusControl];
	// [radiusControl release ];
	// radius

	UILabel *
	label = [[UILabel alloc] initWithFrame:
			 CGRectMake(100,3,185,30)];
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    /*
	 NSDateFormatter *formatter = [[[NSDateFormatter alloc] init] autorelease];
	 NSDate *date = [NSDate date];
	 [formatter setDateFormat:@"MM/dd/YY HH:mm"];
	 // [label setText:[formatter stringFromDate:date]];
	 [label setText:[NSString stringWithFormat:@"Updated: %@", [formatter stringFromDate:date]]];
	 */
	/*// cnf = [[Config alloc] initWithName:@"actualId"];
	NSString * displayId = [Config loadValue:@"actualId"]; // cnf.value;
	// NSLog(@"tb: %@", tabbar);
	// NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	NSString *newName = [NSString stringWithFormat:@"tmp_%@_3.xml", displayId];
	// NSLog(@"name 2: %@", newName);
	cnf = [[Config alloc] initWithName:newName];
	*/

	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"yyyyMMddHHmm"];
	// NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
	// NSLog(@"date: %@", cnf.value);
	// NSLog(@"date 2: %@", [dateFormat stringFromDate:lastCheck]);
	
	[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
	// [label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
	
    label.backgroundColor = [UIColor clearColor];
    // label.backgroundColor = [UIColor blueColor];
    label.textColor = [UIColor whiteColor];
    label.font = [UIFont boldSystemFontOfSize:11];
    label.textAlignment = UITextAlignmentRight;
	
	[toolbar addSubview:label];
    // [label release];
	
	[cnf release];
}

-(IBAction)changeSlide:(id)sender {
	UISlider *slider = (UISlider *)sender;
    radiusField.text = [NSString stringWithFormat:@"%d", (int)slider.value];
}

/*
 -(MKAnnotationView *)mapView:(MKMapView *)mV viewForAnnotation:
 (id <MKAnnotation>)annotation {
 MKPinAnnotationView *pinView = nil; 
 if(annotation != mapView.userLocation) 
 {
 static NSString *defaultPinID = @"com.invasivecode.pin";
 pinView = (MKPinAnnotationView *)[mapView dequeueReusableAnnotationViewWithIdentifier:defaultPinID];
 if ( pinView == nil ) pinView = [[[MKPinAnnotationView alloc]
 initWithAnnotation:annotation reuseIdentifier:defaultPinID] autorelease];
 pinView.pinColor = MKPinAnnotationColorRed; 
 pinView.canShowCallout = YES;
 pinView.animatesDrop = YES;
 } 
 else {
 [mapView.userLocation setTitle:@"I am here"];
 }
 return pinView;
 }
 */

-(void) goRefresh {
	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[mapView removeAnnotations:mapView.annotations];
	/*
	 NSMutableArray *toRemove = [NSMutableArray arrayWithCapacity:10];
	 for (id annotation in myMap.annotations)
	 if (annotation != myMap.userLocation)
	 [toRemove addObject:annotation];
	 [myMap removeAnnotations:toRemove];
	*/
	NSLog(@"refreshing... %@", radiusField.text);
	[cnf updateValue:[NSString stringWithFormat:@"radius_%@", actualId] value:radiusField.text];
	CLLocationManager *locationManager=[[CLLocationManager alloc] init];
	locationManager.delegate=self;
	locationManager.desiredAccuracy=kCLLocationAccuracyNearestTenMeters;
	
	[cnf release];
	
	[locationManager startUpdatingLocation];
}

- (void) goGps {
	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[cnf updateValue:[NSString stringWithFormat:@"useGps_%@", actualId] value:@"1"];
	[cnf updateValue:[NSString stringWithFormat:@"radius_%@", actualId] value:radiusField.text];
	useGps = @"1";
	
	[cnf release];
	
	[self goRefresh];
}

- (void) goAddress {
	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	[cnf updateValue:@"displayId" value:actualId];
	[cnf updateValue:[NSString stringWithFormat:@"radius_%@", actualId] value:radiusField.text];

	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	
	[cnf release];
	
	[appDelegate displayView:@"13"];
}

- (void) goInfo {
	//NSThread *thrAni=[[NSThread alloc] initWithTarget:self
	//										 selector:@selector(showAnimated:) object:self];
	//[thrAni start];
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"9"];
}

- (void) createMap 
{
	[self loadData];

    MKCoordinateRegion region;
	region.center = location;
	//Set Zoom level using Span
	MKCoordinateSpan span;
	span.latitudeDelta=.01; // .01; // 1; //.005;
	span.longitudeDelta=.01; // .01; //1; // .005;
	region.span=span;
	
	[mapView setRegion:region animated:TRUE];

    int count = 1;
	// DisplayMap * addAnnotation = [[DisplayMap alloc] init];
	for (Project *project in projects) {
		CLLocationCoordinate2D newLocation;
		NSString* longitude = [project.longitude stringByReplacingOccurrencesOfString:@"\n" withString:@""];
		NSString* latitude = [project.latitude stringByReplacingOccurrencesOfString:@"\n" withString:@""];
		newLocation.latitude = [latitude floatValue];
		newLocation.longitude = [longitude floatValue];
		NSLog(@"%@", [NSString stringWithFormat:@"latitude %f", location.latitude]);
		// if(addAnnotation) {
			// [mapView removeAnnotation:addAnnotation];
			// [addAnnotation release];
		//	addAnnotation = nil;
		//}
		DisplayMap * addAnnotation = [[DisplayMap alloc] initWithCoordinate:newLocation];
		addAnnotation.title = project.title;
		addAnnotation.subtitle = project.desc;
		// addAnnotation.currentPoint = [NSNumber numberWithInt:count];
        
		addAnnotation.annTag = [NSString stringWithFormat:@"%i", count];
		
		[mapView addAnnotation:addAnnotation];
        [addAnnotation release];
		count++;
	}
	// [addAnnotation release];

}


#pragma mark -
#pragma mark Reverse Geocoder Delegate Methods
- (void)reverseGeocoder:(MKReverseGeocoder *)geocoder didFailWithError:(NSError *)error{
	NSLog(@"Geocoder error");
}

- (void)reverseGeocoder:(MKReverseGeocoder *)geocoder didFindPlacemark:(MKPlacemark *)placemark{
	NSLog(@"Geocoder completed");
	// mPlacemark=placemark;
	// [mapView addAnnotation:placemark];
	// NSLog(@"pl: %@", placemark);
	DisplayMap *annotation = [[DisplayMap alloc] initWithCoordinate:location];
	annotation.title = @"You are here";
	annotation.subtitle = placemark.postalCode;
	annotation.annTag = @"1001";
	[mapView addAnnotation:annotation];
    [mapView selectAnnotation:annotation animated:YES];
	[annotation release];

	/*
	location.latitude = location.latitude+1;
	location.longitude = location.longitude+1;
	if(annotation != nil) {
		// [mapView removeAnnotation:addAnnotation];
		[annotation release];
		annotation = nil;
	}
	annotation = [[DisplayMap alloc] initWithCoordinate:location];
	annotation.title = @"Other";
	annotation.annTag = @"1002";
	[mapView addAnnotation:annotation];

	
	/ *
	 annotation.streetAddress = placemark.thoroughfare;
	 annotation.city = placemark.locality;
	 annotation.state = placemark.administrativeArea;
	 annotation.zip = placemark.postalCode;
	 */

	/*
	 // add annotations
	 for (Project *aProject in appDelegate.projects) {
	 CLLocationCoordinate2D location;
	 NSString* longitude = [aProject.longitude stringByReplacingOccurrencesOfString:@"\n" withString:@""];
	 NSString* latitude = [aProject.latitude stringByReplacingOccurrencesOfString:@"\n" withString:@""];
	 location.latitude = [latitude floatValue];
	 location.longitude = [longitude floatValue];
	 //NSLog([NSString stringWithFormat:@"%f", location.latitude]);
	 if(addAnnotation != nil) {
	 // [mapView removeAnnotation:addAnnotation];
	 [addAnnotation release];
	 addAnnotation = nil;
	 }
	 addAnnotation = [[AddressAnnotation alloc] initWithCoordinate:location];
	 addAnnotation.mTitle = aProject.report_num;
	 addAnnotation.mSubTitle = aProject.title;
	 addAnnotation.currentPoint = [NSNumber numberWithInt:count];
	 addAnnotation.mTest = @"12qwas";
	 
	 [mapView addAnnotation:addAnnotation];
	 count++;
	 }
	 */
	
	// geocoder.delegate = nil;
	// [geocoder autorelease];
}

#pragma mark -
#pragma mark Map View Delegate Methods
// - (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation{
- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(DisplayMap *)annotation{
	// NSLog(@"View for Annotation is called %@ ", [annotation title]);
	// int postag = 0;
	NSLog(@"tag: %@", annotation.annTag);
	UIButton *myDetailButton = [UIButton buttonWithType:UIButtonTypeCustom];
	myDetailButton.frame = CGRectMake(0, 0, 23, 23);
	myDetailButton.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
	myDetailButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentCenter;
	
	// Set the image for the button
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = @"/indicator.png";
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	UIImage *indicatorImage = [UIImage imageWithData:imgData];
	[myDetailButton setImage:indicatorImage forState:UIControlStateNormal];
	// [myDetailButton setImage:[UIImage imageNamed:@"button_right.png"] forState:UIControlStateNormal];
	[myDetailButton addTarget:self action:@selector(showLinks:) forControlEvents:UIControlEventTouchUpInside]; 
	
	MKPinAnnotationView *test=[[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"parkingloc"];
	test.userInteractionEnabled=TRUE;
	test.animatesDrop=TRUE;
	test.canShowCallout = YES;
	test.calloutOffset = CGPointMake(-5, 5);
	if([[annotation title] isEqualToString:@"You are here"])
	{
		NSLog(@"Here");
		[self performSelector:@selector(openCallout:) withObject:annotation afterDelay:0.5];
		[test setPinColor:MKPinAnnotationColorPurple];
	}
	else
	{
		NSLog(@"Other");
		myDetailButton.tag  = [annotation.annTag intValue]; // 1001; // postag;
		// postag = [annotation.currentPoint intValue];
		test.rightCalloutAccessoryView = myDetailButton;
		[test setPinColor:MKPinAnnotationColorGreen];
	}
	return test;
}

- (void)openCallout:(id<MKAnnotation>)annotation {
	NSLog(@"Callout...");
    [mapView selectAnnotation:annotation animated:YES];
}

#pragma mark -
#pragma mark CLLocationManagerDelegate Methods
- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation{

// cut

	Config *cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	
    Project * project = [projects objectAtIndex:0];
    
	NSLog(@"useGps %@", useGps);
	if ([useGps isEqualToString:@"1"]) {
		location = newLocation.coordinate;
		[cnf updateValue:[NSString stringWithFormat:@"useGps_%@", actualId] value:@"0"];
		[cnf updateValue:[NSString stringWithFormat:@"latitude_%@", actualId] 
                   value:[NSString stringWithFormat:@"%f", location.latitude]];
		[cnf updateValue:[NSString stringWithFormat:@"longitude_%@", actualId]
                   value:[NSString stringWithFormat:@"%f", location.longitude]];
		//One location is obtained.. just zoom to that location
		useGps = @"0";
	} else if ([useGps isEqualToString:@"2"]) {
		location.latitude =  [project.latitude doubleValue]; // [@"41.026508" floatValue];
		location.longitude =  [project.longitude doubleValue]; // [@"-73.578701" floatValue]; 
	} else {
		location.latitude = [[cnf loadValue:[NSString stringWithFormat:@"latitude_%@", actualId]] floatValue];
		location.longitude = [[cnf loadValue:[NSString stringWithFormat:@"longitude_%@", actualId]] floatValue];
	}
	
	// location.latitude = [@"41.026508" floatValue];
	// location.longitude = [@"-73.578701" floatValue]; 
	
	[cnf release];

    NSLog(@"geocoder starting...");
	MKReverseGeocoder *geocoder=[[MKReverseGeocoder alloc] initWithCoordinate:location];
	geocoder.delegate=self;
	[geocoder start];
}

- (void)locationManager:(CLLocationManager *)manager didFailWithError:(NSError *)error{
}


- (IBAction)storeLocationInfo:(id) sender{
	//Either we can use geocoder to get a placemark or just create our own.
	NSLog(@"l: %@", location);
	MKReverseGeocoder *geocoder=[[MKReverseGeocoder alloc] initWithCoordinate:location];
	geocoder.delegate=self;
	[geocoder start];
	//Our own
	
	/*
	 DisplayMap *placemark=[[DisplayMap alloc] initWithCoordinate:location];
	 [mapView addAnnotation:placemark];
	 */
}

- (IBAction)showLinks:(id)sender
{
	int nrButtonPressed = ((UIButton *)sender).tag;
	nrButtonPressed--;
	
	if (nrButtonPressed < 99999) {

		NSLog(@"b: %i", nrButtonPressed);
		/*
		if ([element.link isEqualToString:@""] ||
			element.link == nil) {
			[self stopAnimated:nil];
			return;
		}
		*/
		
		app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
		Config *cnf = [[Config alloc] init];
		[cnf updateValue:@"selectedListItem" value: [NSString stringWithFormat:@"%i", nrButtonPressed]];
		[cnf release];
		// [Functions updateConfig:@"goUrl" withValue:@"---"];
		// [Functions updateConfig:@"displayId" withValue:element.link];
		// [Functions updateConfig:@"feedSource" withValue:[NSString stringWithFormat:@"tmp_%@_3.xml", actualId]];
		[appDelegate displayView:@"7"];
	}
}

- (void) loadData {
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];

	// cnf = [[Config alloc] initWithName:@"useTabBar"];
	// NSString * tabbar = cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	
	NSString * url = @"";
	NSString * map = @"";
	NSString * titleName = @"";
	NSString * subtitleName = @"";
	NSString * mapLongitude = @"";
	NSString * mapLatitude = @"";
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * mapXMLElement;
	TBXMLElement * childXMLElement;
	TBXMLElement * appXMLElement;
	
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"l actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					mapXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			appXMLElement = mapXMLElement->firstChild;
			do {
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								
								if ([attribItem isEqualToString:@"tab_bar"]) {
								}
								if ([attribItem isEqualToString:@"data_source"]) {
									url = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"map_option"]) {
									map = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"title"]) {
									titleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"desc"]) {
									subtitleName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"link"]) {
									NSString * linkId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
									[cnf updateValue:@"displayId" value:linkId];
								}
								
							
							}
							
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:url]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									url = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									url = [url urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:map]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"map_longitude"]) {
									mapLongitude = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapLongitude = [mapLongitude urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"map_latitude"]) {
									mapLatitude = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									mapLatitude = [mapLatitude urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}
	
	NSString * radius = [cnf loadValue:[NSString stringWithFormat:@"radius_%@", actualId]];
	if ([radius isEqualToString:@""] || (radius == nil))
		radius = @"16";

	url = [url stringByAppendingString:[NSString stringWithFormat:@"?lon=%f&lat=%f&rad=%@&", location.longitude, location.latitude, radius]];
	NSLog(@"url: %@", url);
	NSURL *u = [NSURL URLWithString:url];
	NSData *myXMLData;
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	NSString *databaseName = [NSString stringWithFormat:@"tmp_%@_3.xml", actualId];
	[cnf updateValue:@"feedSource" value:databaseName];
	NSString *databaseNameValue = [cnf loadValue:databaseName];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_3.xml", actualId]];
	
	if([databaseNameValue isEqualToString:@""] || databaseNameValue == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		myXMLData = [NSData dataWithContentsOfURL:u];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  

		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_3.xml", actualId] value:dateString];
	} else {
		
		NSLog(@"use ... ");
		NSTimeInterval dateTime;		
		// NSDateFormatter *
		// dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:databaseNameValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);  
		if(dateTime > 1) {
			NSLog(@"down (2)... ");
			myXMLData = [NSData dataWithContentsOfURL:u];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_3.xml", actualId] value:dateString];
			
			NSFileManager* fileManager = [NSFileManager defaultManager];
			fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_3", actualId]];
			[fileManager createDirectoryAtPath:fileName withIntermediateDirectories:YES attributes:nil error:nil];
			
			NSError *error = nil;
			for (NSString *file in [fileManager contentsOfDirectoryAtPath:fileName error:&error]) {
				BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@", fileName, file] error:&error];
				if (!success || error) {
					// it failed.
					// NSLog(@"err: %@%@", fileName, file);
				} else {
					// NSLog(@"del: %@%@", fileName, file);
				}
			}
		} else {
			myXMLData = [NSData dataWithContentsOfFile:fileName];
		}
	}
    [dateFormat release];
	// NSLog(@"bk: %@", fileName);
	[myXMLData writeToFile:fileName atomically:YES];
	
	projects = [[NSMutableArray alloc] init];
	
	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	root = tbxml.rootXMLElement;
    [tbxml release];
	if (root) {
		childXMLElement = root->firstChild;
		do {
			if (
				!([[TBXML elementName:childXMLElement] isEqualToString:@"error"]) &&
				!([[TBXML elementName:childXMLElement] isEqualToString:@"debug"])
				) {
				// NSLog(@"child name: %@", [TBXML elementName:childXMLElement]);
                
				if (!(childXMLElement->firstChild == nil)) {
					// NSLog(@"child not: %@", [TBXML elementName:childXMLElement]);
                    
                    TBXMLElement * dataXMLElement = childXMLElement->firstChild;
                    // NSLog(@"data name: %@", [TBXML elementName:dataXMLElement]);
                    do {
                        TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
                        // NSLog(@"item name: %@", [TBXML elementName:itemXMLElement]);
                        NSString * latitude = @"";
                        NSString * longitude = @"";
                        NSString * title = @"";
                        NSString * subtitle = @"";
                        do {
                            if ([[TBXML elementName:itemXMLElement] isEqualToString:titleName]) {
                                title = [TBXML textForElement:itemXMLElement];
                            }
                            if ([[TBXML elementName:itemXMLElement] isEqualToString:subtitleName]) {
                                subtitle = [TBXML textForElement:itemXMLElement];
                            }
                            if ([[TBXML elementName:itemXMLElement] isEqualToString:mapLatitude]) {
                                latitude = [TBXML textForElement:itemXMLElement];
                            }
                            if ([[TBXML elementName:itemXMLElement] isEqualToString:mapLongitude]) {
                                // NSLog(@"ii: %@", [TBXML textForElement:itemXMLElement]);
                                // element.image = [TBXML textForElement:itemXMLElement];
                                longitude = [TBXML textForElement:itemXMLElement];
                                // NSLog(@"t: %@", title);
                            }
                        } while ((itemXMLElement = itemXMLElement->nextSibling));
                        
                        Project * project = [[Project alloc] init];
                        project.title = title;
                        project.desc = subtitle;
                        project.latitude = latitude;
                        project.longitude = longitude;
                        [projects addObject:project];
                        [project release];
                        
                    } while ((dataXMLElement = dataXMLElement->nextSibling));
					
				}
				
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
		
	}

	// NSLog(@"proj: %@", projects);
	

    NSLog(@"useGps %@", useGps);
	if ([useGps isEqualToString:@"1"]) {
		//location = newLocation.coordinate;
		[cnf updateValue:[NSString stringWithFormat:@"useGps_%@", actualId] value:@"0"];
		[cnf updateValue:[NSString stringWithFormat:@"latitude_%@", actualId] 
                   value:[NSString stringWithFormat:@"%f", location.latitude]];
		[cnf updateValue:[NSString stringWithFormat:@"longitude_%@", actualId]
                   value:[NSString stringWithFormat:@"%f", location.longitude]];
		//One location is obtained.. just zoom to that location
		useGps = @"0";
	} else if ([useGps isEqualToString:@"2"]) {
        Project * project = [projects objectAtIndex:0];
		location.latitude =  [project.latitude doubleValue]; // [@"41.026508" floatValue];
		location.longitude =  [project.longitude doubleValue]; // [@"-73.578701" floatValue]; 
	} else {
		location.latitude = [[cnf loadValue:[NSString stringWithFormat:@"latitude_%@", actualId]] floatValue];
		location.longitude = [[cnf loadValue:[NSString stringWithFormat:@"longitude_%@", actualId]] floatValue];
	}
    
    [cnf release];
}

@end
