//
//  PopupViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 12/22/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "PopupViewController.h"
#import "Config.h"
#import "Functions.h"

@implementation PopupViewController

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	BOOL isInternetConnected=[Functions connectedToNetwork];
	
    if (!isInternetConnected){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"You do not have an internet connection. Please check your settings and try again later." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		// [alert show];
		[alert release];
	}

	self.view.backgroundColor = [UIColor clearColor];
	Config * cnf = [[Config alloc] init];
	NSString * urlOas = [cnf loadValue:@"OASUrl"];
	NSString * siteOas = [cnf loadValue:@"OASSite"];
	NSString * posOas = [cnf loadValue:@"OASPos"];
	NSString * queryOas = [cnf loadValue:@"OASQuery"];
	[cnf release];
	
	
	// NSString * format = @"%@/RealMedia/ads/adstream_jx.ads/%@/1%@@?%@";
	NSString * format = @"%@/RealMedia/ads/adstream_sx.ads/%@/@%@?%@";
	NSString * loadUrl = [NSString stringWithFormat:format,
						 urlOas, siteOas, posOas, queryOas];
	NSLog(@"weburl: %@", loadUrl);
	NSURL *u = [NSURL URLWithString:loadUrl];
	NSMutableData *myXMLData = [NSData dataWithContentsOfURL:u];

	TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
    // NSLog(@"tbxml: %@", [[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding]);
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	NSString * imgData = @"";
	NSString * linkData = @"";
	if (rootXMLElement) {
		TBXMLElement * imgXMLElement = [TBXML childElementNamed:@"image" parentElement:rootXMLElement];
        if (imgXMLElement)
        {
		imgData = [TBXML textForElement:imgXMLElement];
		imgXMLElement = [TBXML childElementNamed:@"link" parentElement:rootXMLElement];
		linkData = [TBXML textForElement:imgXMLElement];
        }
	}
	[tbxml release];
	
	UIWebView *aWebView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 0, 320, 100)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	aWebView.autoresizesSubviews = YES;
	aWebView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	aWebView.delegate = self;
	aWebView.backgroundColor = [UIColor clearColor];
	[aWebView setOpaque:NO];
	NSString *myHtml = [NSString stringWithFormat:@"<html> \n"
						"<head> \n"
						"<meta name=\"viewport\" content=\"width=device-width;\" />\n"
						"<style type=\"text/css\"> \n"
						"* {\n"
						"margin: 0em;\n"
						"padding: 0em;\n"
						"}\n"
						"body{background-color:transparent; text-align: center;}\n"
						"</style> \n"
						"</head> \n"
						"<body>\n"
						// "<!-- OAS JX Tag Begins -->\n"
						// "<script language=\"JavaScript\" type=\"text/javascript\">\n"
						// "<!--\n"
						//"var OAS_url = '%@'; // // Your OAS cname - Required\n"
						//"var OAS_sitepage = '%@'; // Target site/page - Required\n"
						//"var OAS_pos = '%@'; // Target Position - Required\n"
						//"var OAS_query = '%@'; // Search Terms/Keywords - Optional\n"
						//"\n"
						//"var OAS_RN = new String (Math.random());\n"
						//"var OAS_RNS = OAS_RN.substring (2,11);\n"
						//"\n"
						//"document.write('<scr' + 'ipt language=\"javascript\" type=\"text/javascript\" src=\"'\n"
						//"+ OAS_url + '/RealMedia/ads/adstream_jx.ads/' + OAS_sitepage + '/1' + OAS_RNS\n"
						//"+ '@' + OAS_pos + '?' + OAS_query + '\"></scr' + 'ipt>');\n"
						//"// -->\n"
						"<a href=\"%@\"><img src=\"%@\" /></a>\n"
						"</script>\n"
						// "<!-- OAS JX Tag Ends -->"
						"</body> \n"
						"</html>", linkData, imgData];
	
	// myHtml = @"<html><body>123M</body></html>";
	NSLog(@"html: %@", myHtml);
	// [aWebView setDelegate:self];
	[aWebView loadHTMLString:myHtml baseURL:nil];
	[self.view addSubview:aWebView];
	[aWebView release];

}

-(BOOL) webView:(UIWebView *)inWeb shouldStartLoadWithRequest:(NSURLRequest *)inRequest navigationType:(UIWebViewNavigationType)inType {
	if (inType == UIWebViewNavigationTypeLinkClicked) {
		[[UIApplication sharedApplication] openURL:[inRequest URL]];
		return NO;
	}
    return YES;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
