//
//  SendImageViewController.h
//  app_builder
//
//  Created by IVAN BEJARANO on 2/3/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <MediaPlayer/MediaPlayer.h>
#import "CustomTextField.h"
#import "SSTextView.h"

#import "ImageScrollerThumbs.h"


@interface SendImageViewController : UIViewController 
<UINavigationControllerDelegate, UIImagePickerControllerDelegate,
UIActionSheetDelegate, UITextFieldDelegate, UIScrollViewDelegate, UITextViewDelegate> {
    UIImagePickerController* imagePickerController;
	UIImageView* imageView;
	BOOL isTakingPicture;
	UIViewController * parentView;
	IBOutlet SSTextView * txtTitle;
	IBOutlet SSTextView * txtDescription;
	IBOutlet SSTextView * txtTeam;
	IBOutlet SSTextView * txtLocation;
	IBOutlet SSTextView * txtKeywords;
	UIActivityIndicatorView *waitView;
	UILabel *waitLabel;

    NSDictionary * infoData;
	UIPopoverController * popoverController;
}

@property(nonatomic, retain) UIImageView *imageView;
@property (nonatomic, retain) UIImagePickerController *imagePickerController;
@property (nonatomic,retain) IBOutlet SSTextView * txtTitle;
@property (nonatomic,retain) IBOutlet SSTextView * txtDescription;
@property (nonatomic,retain) IBOutlet SSTextView * txtTeam;
@property (nonatomic,retain) IBOutlet SSTextView * txtLocation;
@property (nonatomic,retain) IBOutlet SSTextView * txtKeywords;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil;
- (IBAction)openPhotolibrary: (id)sender;
- (void)pickPicture;
- (BOOL)startCameraPickerFromViewController:(UIViewController*)controller usingDelegate:(id<UIImagePickerControllerDelegate>)delegateObject;
// - (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response;
// - (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data;
// - (void)connectionDidFinishLoading:(NSURLConnection *)connection;
- (IBAction)takePictureButtonTapped;
-(IBAction) goBack:(id) sender;
-(IBAction) goPick:(id) sender;
-(IBAction) goSend:(id) sender;
- (void)setParent: (UIViewController *)viewController;

- (NSString *) base64StringFromData: (NSData *)data length: (int)length;
-(void) onSendData:(NSData *)theData;

@end
