//
//  SendImageViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 2/3/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SendImageViewController.h"
#import "TabBarViewController.h"
#import "ThumbnailViewController.h"
#import "app_builderAppDelegate.h"
#import "ASIFormDataRequest.h"
#import <QuartzCore/QuartzCore.h>
#import "SSTextView.h"
#import "Functions.h"

@implementation SendImageViewController

@synthesize imagePickerController;
@synthesize imageView;
@synthesize txtTitle, txtDescription, txtTeam, txtLocation, txtKeywords;

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        infoData = data;
    }
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	[Functions initWaitView:self.view];
	[Functions showAnimated:self.view];
	[Functions stopAnimated:self.view];
	
	UIScrollView * scrollView =[[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, 320, 410)];
	scrollView.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
	scrollView.scrollEnabled= YES;
	// scrollView.pagingEnabled = YES;
	scrollView.contentSize = CGSizeMake(320, 640);
	scrollView.contentSize = CGSizeMake(scrollView.frame.size.width, scrollView.frame.size.height+200);
	scrollView.clipsToBounds = YES;
	scrollView.delegate = self;
	[self.view addSubview:scrollView];
	scrollView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	scrollView.backgroundColor = [UIColor darkGrayColor];

	// UIView *mainView = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 640)]; // 580
	UIView *mainView = [[UIView alloc] initWithFrame:scrollView.frame]; // 580
	mainView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	[scrollView addSubview:mainView];
	// mainView.backgroundColor = [UIColor redColor];

	imageView = [[UIImageView alloc] initWithFrame:CGRectMake(10, 332, 300, 300)];
	imageView.hidden = YES;
	imageView.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleRightMargin;
	// [self.view addSubview:imageView];
	[mainView addSubview:imageView];

	/*
	UITextView *txtTitle = [[UITextView alloc] initWithFrame:CGRectMake(10, 330, 300, 60)];
	txtTitle.fieldName = @"title";
	txtTitle.borderStyle = UITextBorderStyleNone;
	txtTitle.text = @""; // tmpValue;
	txtTitle.tag = 1001;
	txtTitle.borderStyle = UITextBorderStyleRoundedRect;
	txtTitle.textColor = [UIColor blackColor]; //text color
	txtTitle.font = [UIFont systemFontOfSize:20.0];  //font size
	txtTitle.textAlignment = UITextAlignmentCenter;
	txtTitle.placeholder = @"Title";  //place holder
	txtTitle.backgroundColor = [UIColor clearColor]; //background color
	txtTitle.autocorrectionType = UITextAutocorrectionTypeNo;	// no auto correction support
	txtTitle.keyboardType = UIKeyboardTypeDefault;  // type of the keyboard
	txtTitle.returnKeyType = UIReturnKeyDone;  // type of the return key
	txtTitle.clearButtonMode = UITextFieldViewModeWhileEditing;	// has a clear 'x' button to the right
	txtTitle.delegate = self;	// let us be the delegate so we know when the keyboard's "Done" button is pressed
	// [self.view addSubview:txtTitle];
	[mainView addSubview:txtTitle];*/
	
	/*UITextView * txtTitle2 = [[UITextView alloc] initWithFrame:CGRectMake(10, 330, 300, 40)];
	// txtTitle2.delegate = self;
	// txtTitle.placeholder = @"Title";
	//txtTitle2.textColor = [UIColor blackColor]; //text color
	//txtTitle2.font = [UIFont systemFontOfSize:10.0];  //font size
	// txtTitle2.textAlignment = UITextAlignmentCenter;
	[mainView addSubview:txtTitle2];
	[txtTitle2 addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];*/

	txtTitle = [[SSTextView alloc] initWithFrame:CGRectMake(10, 20, 300, 50)];
	txtTitle.frame = CGRectMake(10, 20, scrollView.frame.size.width - 20, 50);
	txtTitle.delegate = self;
	txtTitle.placeholder = @"Title (*)";
	txtTitle.textColor = [UIColor blackColor]; //text color
	txtTitle.font = [UIFont systemFontOfSize:14.0];  //font size
	txtTitle.textAlignment = UITextAlignmentCenter;
	[txtTitle addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtTitle.scrollEnabled = NO;
	txtTitle.returnKeyType = UIReturnKeyDone;  // type of the return key
	txtTitle.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[mainView addSubview:txtTitle];

	txtDescription = [[SSTextView alloc] initWithFrame:CGRectMake(10, 80, 300, 50)];
	txtDescription.delegate = self;
	txtDescription.placeholder = @"Description";
	txtDescription.textColor = [UIColor blackColor]; //text color
	txtDescription.font = [UIFont systemFontOfSize:14.0];  //font size
	txtDescription.textAlignment = UITextAlignmentCenter;
	txtDescription.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[mainView addSubview:txtDescription];
	[txtDescription addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtDescription.scrollEnabled = NO;
	txtDescription.returnKeyType = UIReturnKeyDone;  // type of the return key

	txtTeam = [[SSTextView alloc] initWithFrame:CGRectMake(10, 140, 300, 30)];
	txtTeam.delegate = self;
	txtTeam.placeholder = @"Building Team / Key Players (*)";
	txtTeam.textColor = [UIColor blackColor]; //text color
	txtTeam.font = [UIFont systemFontOfSize:14.0];  //font size
	txtTeam.textAlignment = UITextAlignmentCenter;
	txtTeam.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[mainView addSubview:txtTeam];
	txtTeam.scrollEnabled = NO;
	[txtTeam addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtTeam.returnKeyType = UIReturnKeyDone;  // type of the return key
	
	txtLocation = [[SSTextView alloc] initWithFrame:CGRectMake(10, 180, 300, 30)];
	txtLocation.delegate = self;
	txtLocation.placeholder = @"Location (*)";
	txtLocation.textColor = [UIColor blackColor]; //text color
	txtLocation.font = [UIFont systemFontOfSize:14.0];  //font size
	txtLocation.textAlignment = UITextAlignmentCenter;
	txtLocation.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[mainView addSubview:txtLocation];
	txtLocation.scrollEnabled = NO;
	[txtLocation addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtLocation.returnKeyType = UIReturnKeyDone;  // type of the return key

	txtKeywords = [[SSTextView alloc] initWithFrame:CGRectMake(10, 220, 300, 30)];
	txtKeywords.delegate = self;
	txtKeywords.placeholder = @"Keywords (separate keywords with commas)";
	txtKeywords.textColor = [UIColor blackColor]; //text color
	txtKeywords.font = [UIFont systemFontOfSize:14.0];  //font size
	txtKeywords.textAlignment = UITextAlignmentCenter;
	txtKeywords.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	[mainView addSubview:txtKeywords];
	txtKeywords.scrollEnabled = NO;
	[txtKeywords addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	txtKeywords.returnKeyType = UIReturnKeyDone;  // type of the return key

	// UIImage * btnImage = [UIImage alloc];

	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeCustom
							];
	[backButton setFrame:CGRectMake(240,290,73,32)];
	[backButton setTitle:@"Cancel" forState:UIControlStateNormal];
	[backButton setTitle:@" " forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack:) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[mainView addSubview:backButton];
	// [backButton release];

	UIImage * btnImage = [UIImage imageNamed:@"button_cancel.png"];
	backButton.backgroundColor = [UIColor clearColor];
	[backButton setImage:btnImage forState:UIControlStateNormal];
	
	UIButton *pickButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[pickButton setFrame:CGRectMake(10,290,73,32)];
	[pickButton setTitle:@"Select" forState:UIControlStateNormal];
	[pickButton setTitle:@" " forState:UIControlStateNormal];
	[pickButton addTarget:self action:@selector(goPick:) forControlEvents:UIControlEventTouchUpInside];
	pickButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[mainView addSubview:pickButton];
	// [pickButton release];

	btnImage = [UIImage imageNamed:@"button_select.png"];
	pickButton.backgroundColor = [UIColor clearColor];
	[pickButton setImage:btnImage forState:UIControlStateNormal];
	
	UIButton *sendButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[sendButton setFrame:CGRectMake(124,290,73,32)];
	[sendButton setTitle:@"Send" forState:UIControlStateNormal];
	[sendButton setTitle:@" " forState:UIControlStateNormal];
	[sendButton addTarget:self action:@selector(goSend:) forControlEvents:UIControlEventTouchUpInside];
	sendButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[mainView addSubview:sendButton];
	// [sendButton release];

	btnImage = [UIImage imageNamed:@"button_send.png"];
	sendButton.backgroundColor = [UIColor clearColor];
	[sendButton setImage:btnImage forState:UIControlStateNormal];
	
	UILabel *label = [[UILabel alloc] initWithFrame:
                      CGRectMake(10,260,300,20)];
    // label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
    label.text = @"(*) Required";
    label.backgroundColor = [UIColor clearColor];
    // label.backgroundColor = [UIColor blueColor];
    label.textColor = [Functions colorForHex:@"#666666"]; // [UIColor blackColor];
    label.font = [UIFont boldSystemFontOfSize:11];
    label.textAlignment = UITextAlignmentLeft;
	
	[mainView addSubview:label];
    [label release];
    [mainView release];
	[scrollView release];

	// [self openPhotolibrary:nil];
	NSLog(@"1");
	// [self takePictureButtonTapped];
	[self performSelectorOnMainThread:@selector(takePictureButtonTapped) withObject:nil waitUntilDone:NO];
}

-(void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary *)change   context:(void *)context {
	UITextView *tv = object;
	CGFloat topCorrect = ([tv bounds].size.height - [tv contentSize].height * [tv zoomScale])  / 2.0;
	topCorrect = ( topCorrect < 0.0 ? 0.0 : topCorrect );
	tv.contentOffset = (CGPoint){.x = 0, .y = -topCorrect};
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[imagePickerController release];
	[imageView release];
	// parentView;
	[txtTitle release];
	[txtDescription release];
	[txtTeam release];
	[txtLocation release];
	[txtKeywords release];
	[waitView release];
	[waitLabel release];
    [super dealloc];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingImage:(UIImage *)image editingInfo:(NSDictionary *)editingInfo
{
	if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad)
	[[picker parentViewController] dismissModalViewControllerAnimated:YES];
	else
	[popoverController dismissPopoverAnimated:YES];
	isTakingPicture = NO;
	// NSLog(@"didFinishPickingImage self.view=%@",self.view);
	// NSLog(@"Image=%@",image);
	// NSLog(@"PhotoImageView=%@",imageView);
	// NSLog(@"PhotoImageView.image=%@",imageView.image);
	imageView.image = image;
	imageView.hidden = NO;
	NSLog(@"PhotoImageView.image=%@",imageView.image);
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker
{
	[[picker parentViewController] dismissModalViewControllerAnimated:YES];	
	isTakingPicture = NO;
}

- (BOOL)startCameraPickerFromViewController:(UIViewController*)controller usingDelegate:(id<UIImagePickerControllerDelegate>)delegateObject
{
	if ((![UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) || (delegateObject == nil) || (controller == nil)) {
		return NO;
	}
	
	UIImagePickerController *picker = [[UIImagePickerController alloc] init];
	picker.sourceType = UIImagePickerControllerSourceTypeCamera;
	picker.delegate = self; // delegateObject;
	picker.allowsEditing = YES;
	[controller presentModalViewController:picker animated:YES];
	
	return YES;
}

- (void)pickPicture
{
	if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary] && !isTakingPicture)
	{
		UIImagePickerController *picker;
		picker = [[[UIImagePickerController alloc] init] autorelease];
		picker.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
		picker.delegate = self;
		
		NSLog(@"Before presenting self.view=%@",self.view);	
		[self presentModalViewController:picker animated:YES];
		NSLog(@"Before presenting self.view=%@",self.view);	
		isTakingPicture = YES;
	}
	
}

- (IBAction)openPhotolibrary: (id)sender {
	
	NSLog(@"open...");
	if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary]) {
		NSLog(@"open...");
		
		//Now this seems to do the trick. The picker only gets allocated once. Therefore no memory issues any longer!
		//Before I did it this way, my app crashed after picking 25 images. This one still was OK after picking about 50 images.
		if (imagePickerController == nil) {
			NSLog(@"open...");
			imagePickerController = [[UIImagePickerController alloc] init];
			imagePickerController.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
			// imagePickerController.allowsImageEditing = YES;
			imagePickerController.delegate = self;
		}
		[self presentModalViewController:imagePickerController animated:YES];
		NSLog(@"open...");
	}
}

- (void)actionSheet:(UIActionSheet *)actionSheet
clickedButtonAtIndex:(NSInteger)buttonIndex
{
    NSLog(@"actionSheet:clickedButtonAtIndex:%d", buttonIndex);
	[actionSheet dismissWithClickedButtonIndex:buttonIndex animated:YES];
    if(buttonIndex == 2)
    {
        // cancel
		if (imagePickerController != nil)
        [imagePickerController release];
    }
    else
    {

		// imagePickerController = [[[UIImagePickerController alloc] init] autorelease];
		imagePickerController = [[UIImagePickerController alloc] init];
		// imagePickerController.view.frame = CGRectMake(0, 0, 200, 200);
        imagePickerController.delegate = self;
        imagePickerController.allowsEditing = YES;
		
        if (buttonIndex == 0)
        {
            // Take a photo
            // Set up the image picker controller and add it to the view
            imagePickerController.sourceType = UIImagePickerControllerSourceTypeCamera;
			imagePickerController.cameraCaptureMode = UIImagePickerControllerCameraCaptureModePhoto;
        }
        else if (buttonIndex == 1)
        {
            // Upload from Library
            imagePickerController.sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
			
            if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary] == NO)
                imagePickerController.sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
        }
		
		
        // [(ThumbnailViewController *)self.parentViewController presentModalViewController:imagePickerController animated:YES];
		 if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad)
			 [self presentModalViewController:imagePickerController animated:YES];
		else
		{
			// UIPopoverController * 
			popoverController = [[UIPopoverController alloc]
													   initWithContentViewController:imagePickerController];
			// popoverController.delegate = self;
			[popoverController setPopoverContentSize:CGSizeMake(160,160) animated:YES];
			CGRect selectedRect = CGRectMake(0,0,1,1);
			[popoverController presentPopoverFromRect:selectedRect inView:self.view 
							 permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];
			
			// [popoverController release];
			
		}
		
		// app_builderAppDelegate * appDelegate = [[app_builderAppDelegate alloc] init];
		// [appDelegate showParent:imagePickerController];
    }
}

- (IBAction)takePictureButtonTapped
{

    UIActionSheet *popupQuery = [[UIActionSheet alloc]
                                 initWithTitle:nil
                                 delegate:self
                                 cancelButtonTitle:@"Cancel"
                                 destructiveButtonTitle:nil
                                 otherButtonTitles:@"Take a Photo", @"Upload from Library", nil];

	// UIActionSheet *popupQuery = [[UIActionSheet alloc] initWithFrame:CGRectMake(200.0, 200.0, 100.0f, 100.0f)];

	//popupQuery.delegate = self;
	//popupQuery.title = nil;
	//[popupQuery addButtonWithTitle:@"Take a Photo"];
	//[popupQuery addButtonWithTitle:@"Upload from Library"];
	// NSLog(@"View: %@; Window: %@",[self.view description], [self.view.window description]);

    popupQuery.actionSheetStyle = UIActionSheetStyleBlackOpaque;
    // [popupQuery showInView:self.parentViewController.view];
	//[popupQuery showInView:parentView.view];
    [popupQuery showInView:self.view];
	
    [popupQuery release];

}

- (IBAction)postForm:(id)sender {
	// MultipartUploadAppDelegate *appDelegate = (MultipartUploadAppDelegate *)[[UIApplication sharedApplication] delegate];
	NSString *urlString = @"http://www.example.com/services";
	NSURL *url = [NSURL URLWithString:urlString];
	NSString *boundary = @"----1010101010";
	NSString *contentType = [NSString stringWithFormat:@"multipart/form-data; boundary=%@",boundary];
	
	NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
	[request setHTTPMethod:@"POST"];
	[request addValue:contentType forHTTPHeaderField: @"Content-Type"];
	
	NSString *photoPath = [[NSBundle mainBundle] pathForResource:@" my-photo " ofType:@"jpg"];
	NSData *photoData = [NSData dataWithContentsOfFile:photoPath];
	
	NSMutableData *body = [NSMutableData data];
	[body appendData:[[NSString stringWithFormat:@"--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[@"Content-Disposition: form-data; name=\"photo-description\"\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[@"testing 123" dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithFormat:@"Content-Disposition: form-data; name=\"photo-file\"; filename=\"%@\"\r\n", " my-photo.jpg"] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[@"Content-Type: image/jpeg\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:photoData];
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@\r\n", boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[@"Content-Disposition: form-data; name=\"tags\"\r\n\r\n" dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[@"random,test,example" dataUsingEncoding:NSUTF8StringEncoding]];
	[body appendData:[[NSString stringWithFormat:@"\r\n--%@--\r\n",boundary] dataUsingEncoding:NSUTF8StringEncoding]];
	[request setHTTPBody:body];
	
	[request addValue:[NSString stringWithFormat:@"%d", body.length] forHTTPHeaderField: @"Content-Length"];
	
	// [[NSURLConnection alloc] initWithRequest:request delegate:appDelegate];
	// [[NSURLConnection alloc] initWithRequest:request delegate:self];
    [NSURLConnection connectionWithRequest:request delegate:self];	
	// [photoData release];
	// [body release];
	// [request release];
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
 	NSLog(@"Response Recieved");
	// NSLog(@"Response Code: %d",[response statusCode]);
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	NSLog(@"Data Recieved");
	NSString *content = [NSString stringWithUTF8String:[data bytes]];
	NSLog(@"DATA: %@",content);
}

- (void)setParent: (UIViewController *)viewController {
    parentView = viewController;
}

-(IBAction) goBack:(id) sender
{
	NSLog(@"Cancel");
	// NSLog(@"?? %@", [self superview].name);
	// [(ThumbnailViewController *)[self parentViewController] hidetabbar];
//	[(ThumbnailViewController *)parentView hidetabbar];
	NSLog(@"?? %@", infoData);
	if (infoData != nil) {
		app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
			[appDelegate displayView:@"1"];
			return;
	}

	
	[(ImageScrollerThumbs *)parentView hidetabbar];
	[self.view removeFromSuperview];
}

-(IBAction) goPick:(id) sender
{
	
	[self takePictureButtonTapped];
}

/*Ihonahan. 20110329. Recognize Upload Button to disable it when trying to upload image */
-(IBAction) goSend:(id) sender 
{

	[Functions showAnimated:self.view];
	UIButton *uploadBtn = (UIButton *)sender;
	uploadBtn.enabled = NO;
	[self performSelector:@selector(sendImageF:) withObject:uploadBtn afterDelay:0.5];
}

-(void) sendImageF:(id)sender
{	
	NSData *imageData = UIImagePNGRepresentation(imageView.image);

	if (imageData == nil) {
		[Functions stopAnimated:self.view];
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Image is empty." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		// [self stopAnimated:nil];
		//Ihonahan. 20110329. Because the button for uploading is disabled, we need to re-enable it for fixing missed data and upload again
		UIButton *uploadBtn = (UIButton *)sender;
		uploadBtn.enabled = YES;
		return;
	}
	if ([txtTitle.text isEqualToString:@""] ||
		txtTitle.text == nil) {
		[Functions stopAnimated:self.view];
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Title is required." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		// [self stopAnimated:nil];
		//Ihonahan. 20110329. Because the button for uploading is disabled, we need to re-enable it for fixing missed data and upload again
		UIButton *uploadBtn = (UIButton *)sender;
		uploadBtn.enabled = YES;
		return;
	}	
	if ([txtTeam.text isEqualToString:@""] ||
		txtTeam.text == nil) {
		[Functions stopAnimated:self.view];
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Building Team / Key Players is required." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		// [self stopAnimated:nil];
		//Ihonahan. 20110329. Because the button for uploading is disabled, we need to re-enable it for fixing missed data and upload again
		UIButton *uploadBtn = (UIButton *)sender;
		uploadBtn.enabled = YES;
		
		return;
	}	
	if ([txtLocation.text isEqualToString:@""] ||
		txtLocation.text == nil) {
		[Functions stopAnimated:self.view];
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Location is required." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];
		// [self stopAnimated:nil];
		//Ihonahan. 20110329. Because the button for uploading is disabled, we need to re-enable it for fixing missed data and upload again
		UIButton *uploadBtn = (UIButton *)sender;
		uploadBtn.enabled = YES;
		
		return;
	}	
	
	[self onSendData:imageData];

}
/*Ihonahan. 20110329. End */


- (BOOL)textFieldShouldReturn:(CustomTextField *)theTextField {
    [theTextField resignFirstResponder];
	NSLog(@"tx: %@ %@", theTextField.fieldName, theTextField.text);
	return YES;
}

-(void) onSendData:(NSData *)theData
{
	NSString *base64String=[self base64StringFromData:theData length:[theData length]];
	
	// Singleton *singleton = [Singleton retrieveSingleton];
	// NSString *soapMessage = [NSString stringWithFormat:
	//						 @"<string xmlns=\"http://schemas.microsoft.com/2003/10/Serialization/\">%@</string>\n",base64String];
	
	// get current date/time
	// NSDate *today = [NSDate date];
	// NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
	// display in 12HR/24HR (i.e. 11:25PM or 23:25) format according to User Settings
	
	// [dateFormatter setDateFormat:@"yyyy-MM-dd-HH-mm-ss"];
	// NSString *currentTime = [dateFormatter stringFromDate:today];
	// [dateFormatter release];
	
	//NSString *fileName=[NSString 
	//					stringWithFormat:@"%i_%@",@"1",currentTime,fileName];
	// stringWithFormat:@"%i_%@_%@",singleton.userId,currentTime,self.mediaEx];
	
	
	Config * cnf = [[Config alloc] init];
	NSString *requestString = [cnf loadValue:@"servicesUrl"];
	// NSString *requestString = @"http://184.73.161.149:8040/services/upload_pluck_photo.aspx";
	requestString = [NSString stringWithFormat:@"%@/upload_pluck_photo.aspx", requestString];
    [cnf release];

	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
	[request addRequestHeader:@"Content-Type" value:@"text/xml"];
	
	// [request appendPostData: [soapMessage dataUsingEncoding:NSUTF8StringEncoding]];

	[request setPostValue:base64String forKey:@"resource"];
	[request setPostValue:txtTitle.text forKey:@"title"];
	[request setPostValue:txtDescription.text forKey:@"description"];
	[request setPostValue:txtTeam.text forKey:@"team"];
	[request setPostValue:txtLocation.text forKey:@"location"];
	[request setPostValue:txtKeywords.text forKey:@"keywords"];
	// [request setPostValue:@"960fffc0-68b0-4791-b3b4-fdc58adcd2dd" forKey:@"gallery_id"];
	[request setPostValue:@"a6bbdadb-33e1-40d1-8a2c-0465e8fc5edb" forKey:@"gallery_id"];

	// [request setUsername:@"uploadPhotos"];
	[request setDelegate:self];
	[request startAsynchronous];
	/*
	 [request startSynchronous];
	NSError *error = [request error];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		[self stopAnimated:nil];
		[self goBack:nil];
	}
	 */
}

- (void)requestFinished:(ASIHTTPRequest *)request
{
	// Use when fetching text data
	NSString *responseString = [request responseString];
	
	// Use when fetching binary data
	// NSData *responseData = [request responseData];

	NSLog(@"response: %@", responseString);
	// [self stopAnimated:nil];
	[Functions stopAnimated:self.view];
	[self goBack:nil];

	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Thank you" message:@"Your photo has been submitted and if it's approved will be displayed in the Mobile Photos Gallery" delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
	// UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Thank you" message:@"Thanks for adding your photo to the CFT Event. It’s in the approval queue." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];

}

- (void)requestFailed:(ASIHTTPRequest *)request
{
	NSError *error = [request error];
	NSLog(@"error: %@", [error localizedDescription]);
	UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:[error localizedDescription] delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
	[alert show];
	[alert release];
}

static char base64EncodingTable[64] = {
'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/'
};


- (NSString *) base64StringFromData: (NSData *)data length: (int)length
{
       unsigned long ixtext, lentext;
       long ctremaining;
       unsigned char input[3], output[4];
       short i, charsonline = 0, ctcopy;
       const unsigned char *raw;
       NSMutableString *result;

       lentext = [data length];
       if (lentext < 1)
               return @"";
       result = [NSMutableString stringWithCapacity: lentext];
       raw = [data bytes];
       ixtext = 0;

       while (true) {
               ctremaining = lentext - ixtext;
               if (ctremaining <= 0)
                       break;
               for (i = 0; i < 3; i++) {
                       unsigned long ix = ixtext + i;
                       if (ix < lentext)
                               input[i] = raw[ix];
                       else
                               input[i] = 0;
               }
               output[0] = (input[0] & 0xFC) >> 2;
               output[1] = ((input[0] & 0x03) << 4) | ((input[1] & 0xF0) >> 4);
               output[2] = ((input[1] & 0x0F) << 2) | ((input[2] & 0xC0) >> 6);
               output[3] = input[2] & 0x3F;
               ctcopy = 4;
               switch (ctremaining) {
                       case 1:
                               ctcopy = 2;
                               break;
                       case 2:
                               ctcopy = 3;
                               break;
               }

               for (i = 0; i < ctcopy; i++)
                       [result appendString: [NSString stringWithFormat: @"%c", base64EncodingTable[output[i]]]];

               for (i = ctcopy; i < 4; i++)
                       [result appendString: @"="];

               ixtext += 3;
               charsonline += 4;

               if ((length > 0) && (charsonline >= length))
                       charsonline = 0;


       }
       return result;
}

@end

