//
//  SubmenuViewController.m
//  app_builder
//
//  Created by ivan bejarano on 12/2/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "SubmenuViewController.h"
#import "Functions.h"
#import "Config.h"
#import "ListViewController.h"
#import "VerticallyAlignedLabel.h"

#define USE_CUSTOM_DRAWING 1

@implementation SubmenuViewController

@synthesize lists;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	[Functions initWaitView:self.view];
	[Functions showAnimated:self.view];

    [self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

- (void) showView
{
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSLog(@"actualId: %@", actualId);

    hiddenTabBar = NO;

	UITableView * tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-45-103);
	tableView.delegate = self;
	tableView.dataSource = self;
	tableView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	
#if USE_CUSTOM_DRAWING
	//self.
	tableView.rowHeight = 80;
	//self.
	tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
	//self.
	tableView.backgroundColor = [UIColor clearColor];
#endif
	[self.view addSubview:tableView];
	[tableView release];


	NSString * titleView = @"";
	lists = [[NSMutableArray alloc] init];
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * menuXMLElement;

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					menuXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));


		if (f)
		{
			NSString * pattern = [TBXML valueOfAttributeNamed:@"template_id" forElement:menuXMLElement];
			childXMLElement = menuXMLElement->firstChild;
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"field_set"]) {
				if ([[TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement] isEqualToString:@"0"]) {
					// f = TRUE;
					TBXMLElement * dataXMLElement = childXMLElement->firstChild;
					do {
						
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:dataXMLElement] isEqualToString:@"text_title"]) {
							titleView = [TBXML valueOfAttributeNamed:@"value" forElement:dataXMLElement];
						}
						if ([[TBXML valueOfAttributeNamed:@"type" forElement:dataXMLElement] isEqualToString:@"submenu_item"]) {
							NSMutableDictionary * listMenuItem = [[[NSMutableDictionary alloc] init] autorelease];
							[listMenuItem setObject:[TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement] forKey:@"id"];
							[listMenuItem setObject:[TBXML valueOfAttributeNamed:@"link_to_ref" forElement:dataXMLElement] forKey:@"link"];
							[listMenuItem setObject:pattern forKey:@"pattern"];
							[self.lists addObject:listMenuItem];
						}
					} while ((dataXMLElement = dataXMLElement->nextSibling));
				}
			}
			// NSLog(@"lists %@", lists);
			for(NSMutableDictionary * listMenuItem in lists) {
                // NSLog(@"lists %@", listMenuItem);
				f = FALSE;
				int total = 0;
                TBXMLElement * infoXMLElement = childXMLElement;
				if (infoXMLElement)
				do {
					[listMenuItem setObject:[NSString stringWithFormat:@"%i", total] forKey:@"idItem"];
					if ([[TBXML elementName:childXMLElement] isEqualToString:@"field_set"]) {
                        // NSLog(@"id id %@ %@", [TBXML valueOfAttributeNamed:@"id" forElement:infoXMLElement], [listMenuItem objectForKey:@"id"]);
						if ([[TBXML valueOfAttributeNamed:@"id" forElement:infoXMLElement] isEqualToString:[listMenuItem objectForKey:@"id"]]) {
							f = TRUE;
							TBXMLElement * dataXMLElement = infoXMLElement->firstChild;
							do {
								NSString * attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:dataXMLElement];
								if ([attribItem isEqualToString:@"menu_title"]) {
									NSString * titleText = [TBXML valueOfAttributeNamed:@"value" forElement:dataXMLElement];
									NSString * titleStyle = [TBXML valueOfAttributeNamed:@"style_id" forElement:dataXMLElement];
									[listMenuItem setObject:titleText forKey:@"titleText"];
									[listMenuItem setObject:titleStyle forKey:@"titleStyle"];
								}
								if ([attribItem isEqualToString:@"menu_desc"]) {
									NSString * descriptionText = @"";
									NSString * descriptionStyle = @"";
									if ([[TBXML valueOfAttributeNamed:@"visible" forElement:dataXMLElement] isEqualToString:@"0"]) {
										descriptionText = [TBXML valueOfAttributeNamed:@"value" forElement:dataXMLElement];
										descriptionStyle = [TBXML valueOfAttributeNamed:@"style_id" forElement:dataXMLElement];
									}
									[listMenuItem setObject:descriptionText forKey:@"descriptionText"];
									[listMenuItem setObject:descriptionStyle forKey:@"descriptionStyle"];
								}
								if ([attribItem isEqualToString:@"menu_image"]) {
									NSString * icon = @"";
									if ([[TBXML valueOfAttributeNamed:@"visible" forElement:dataXMLElement] isEqualToString:@"0"]) {
										icon = [TBXML valueOfAttributeNamed:@"resource_url" forElement:dataXMLElement];
									}
									[listMenuItem setObject:icon forKey:@"menuIcon"];
								}

							} while ((dataXMLElement = dataXMLElement->nextSibling));
							
						}
					}
					total++;
				} while ((infoXMLElement = infoXMLElement->nextSibling) && !f);
			}
			
		}
	}
	NSLog(@"lists %@", lists);
	[Functions initToolBar:self.view withTitle:titleView];

	int loadListItem = -1;
    NSString * selSubDb = [NSString stringWithFormat:@"selSubMenu_%@", actualId];
	NSString * selSubMenu = [cnf loadValue:selSubDb];
	if (![selSubMenu isEqualToString:@"-1"]
		&& selSubMenu != nil 
		&& ![selSubMenu isEqualToString:@""])
	{
		loadListItem = [selSubMenu intValue];
		// [cnf updateValue:selSubDb value:@"-1"];
	}
	[cnf release];
	
	if (loadListItem != -1)
		[self showList:loadListItem];
        // [self loadList:loadListItem];
	
	[Functions stopAnimated:self.view];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

#pragma mark tableView

// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return lists.count;
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSLog(@"actualId: %@", actualId);
    [cnf release];
    
#if USE_CUSTOM_DRAWING

	const NSInteger TOP_LABEL_TAG = 1001;
	const NSInteger BOTTOM_LABEL_TAG = 1002;
	const NSInteger IMAGE_TAG = 1003;
	VerticallyAlignedLabel *topLabel;
	UILabel *bottomLabel;
	UIImageView *image;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSMutableDictionary * listMenuItem = (NSMutableDictionary *)[lists objectAtIndex:indexPath.row];

#endif
    
    static NSString *CellIdentifier = @"Cell";
 	BOOL isThumbNull = YES;
	
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        // cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
		
#if USE_CUSTOM_DRAWING
		FontItem * font;
		NSString *fileName = @"/indicator.png"; // button_right.png";
		NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
		NSData *imgData = [NSData dataWithContentsOfFile:filePath];
		UIImage *indicatorImage = [UIImage imageWithData:imgData];
		
		// UIImage *indicatorImage = [UIImage imageNamed:@"button_right.png"];
		cell.accessoryView =
		[[[UIImageView alloc]
		  initWithImage:indicatorImage]
		 autorelease];
		
		const CGFloat LABEL_HEIGHT = 20;
		NSInteger leftMargin = 0;
		if ([[listMenuItem objectForKey:@"pattern"] isEqualToString:@"1"])
			leftMargin = 50;
		
		// image
		image = [[[UIImageView alloc] initWithFrame:CGRectMake(15, 15, 50, 50)] autorelease];
        image.tag = IMAGE_TAG;
		// NSLog(@"pattern %@", menuItem.pattern);
		if ([[listMenuItem objectForKey:@"pattern"] isEqualToString:@"2"]) {
			image.frame = CGRectMake(230, 15, 50, 50);
			image.frame = CGRectMake(self.view.frame.size.width-90, 15, 50, 50);
			// NSLog(@"template");
		}
        // image.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin | UIViewAutoresizingFlexibleHeight;
        [cell.contentView addSubview:image];
		
		//
		// Create the label for the top row of text
		//
		topLabel =
		[[[VerticallyAlignedLabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*64 + 50*/leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (tableView.rowHeight - 2 * LABEL_HEIGHT),
					 tableView.bounds.size.width -
					 /*image.size.width 64 -  50*/leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:topLabel];
		
		//
		// Configure the properties for the text that are the same on every row
		//
		topLabel.tag = TOP_LABEL_TAG;
		topLabel.backgroundColor = [UIColor clearColor];
		topLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		topLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		topLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize]];
		font = [Functions loadFont:[listMenuItem objectForKey:@"titleStyle"]]; 
		
		[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		topLabel.textColor = [Functions colorForHex:font.colorFont];
		topLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];
		
		//
		// Create the label for the top row of text
		//
		bottomLabel =
		[[[UILabel alloc]
		  initWithFrame:
		  CGRectMake(
					 /*image.size.width + */ leftMargin + 2.0 * cell.indentationWidth,
					 0.5 * (tableView.rowHeight - 2 * LABEL_HEIGHT) + LABEL_HEIGHT,
					 tableView.bounds.size.width -
					 /*image.size.width - */ leftMargin - 4.0 * cell.indentationWidth
					 - 20,
					 LABEL_HEIGHT)]
		 autorelease];
		[cell.contentView addSubview:bottomLabel];
		
		//
		// Configure the properties for the text that are the same on every row
		//
		bottomLabel.tag = BOTTOM_LABEL_TAG;
		bottomLabel.backgroundColor = [UIColor clearColor];
		bottomLabel.textColor = [UIColor colorWithRed:0.25 green:0.0 blue:0.0 alpha:1.0];
		bottomLabel.highlightedTextColor = [UIColor colorWithRed:1.0 green:1.0 blue:0.9 alpha:1.0];
		bottomLabel.font = [UIFont systemFontOfSize:[UIFont labelFontSize] - 2];
		
		font = [Functions loadFont:[listMenuItem objectForKey:@"descriptionStyle"]];
		
		[bottomLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
		bottomLabel.textColor = [Functions colorForHex:font.colorFont];
		bottomLabel.highlightedTextColor = [Functions colorForHex:font.colorFont];
		
		//
		// Create a background image view.
		//
		cell.backgroundView =
		[[[UIImageView alloc] init] autorelease];
		cell.selectedBackgroundView =
		[[[UIImageView alloc] init] autorelease];
#endif
    }
#if USE_CUSTOM_DRAWING
	else
	{
		topLabel = (VerticallyAlignedLabel *)[cell viewWithTag:TOP_LABEL_TAG];
		bottomLabel = (UILabel *)[cell viewWithTag:BOTTOM_LABEL_TAG];
        image = (UIImageView *)[cell.contentView viewWithTag:IMAGE_TAG];
	}
	
	// NSLog(@"m: %@", menuItem.name);
	FontItem *font;
	
	topLabel.text = [listMenuItem objectForKey:@"titleText"];

	font = [Functions loadFont:[listMenuItem objectForKey:@"nameStyle"]]; 
	
	[topLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	topLabel.textColor = [Functions colorForHex:font.colorFont];
	
	bottomLabel.text = [listMenuItem objectForKey:@"descriptionText"];

	font = [Functions loadFont:[listMenuItem objectForKey:@"descriptionStyle"]]; 
	[bottomLabel setFont:[UIFont fontWithName:font.nameFont size:[font.sizeFont intValue]]];
	bottomLabel.textColor = [Functions colorForHex:font.colorFont];
	
	if ([listMenuItem objectForKey:@"descriptionText"] == nil ||
		[[listMenuItem objectForKey:@"descriptionText"] isEqualToString:@""]) {
		// topLabel.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
		// topLabel.titleLabel.numberOfLines = 2;
		int imageSize = 0;
		// if (![element.pattern isEqualToString:@"1"]) 
		if ([[listMenuItem objectForKey:@"pattern"] isEqualToString:@"1"])
			imageSize = 50;
		topLabel.frame = CGRectMake(
									/*64 + 50*/imageSize + 2.0 * cell.indentationWidth,
									0.5 * (tableView.rowHeight - 2 * 20),
									tableView.bounds.size.width -
									/*image.size.width 64 -  50*/imageSize - 4.0 * cell.indentationWidth
									- 20,
									20*2);
		// topLabel.backgroundColor = [UIColor blackColor];
	}
	
	//
	// Set the background and selected background images for the text.
	// Since we will round the corners at the top and bottom of sections, we
	// need to conditionally choose the images based on the row index and the
	// number of rows in the section.
	//
	UIImage *rowBackground;
	NSString * fileName;
	// UIImage *selectionBackground;
	NSInteger sectionRows = [tableView numberOfRowsInSection:[indexPath section]];
	NSInteger row = [indexPath row];
	if (row == 0 && row == sectionRows - 1)
	{
		fileName = @"/topAndBottomRow.png";
		// rowBackground = [UIImage imageNamed:@"topAndBottomRow.png"];
		// selectionBackground = [UIImage imageNamed:@"topAndBottomRowSelected.png"];
	}
	else if (row == 0)
	{
		fileName = @"/topRow.png";
		// rowBackground = [UIImage imageNamed:@"topRow.png"];
		// selectionBackground = [UIImage imageNamed:@"topRowSelected.png"];
	}
	else if (row == sectionRows - 1)
	{
		fileName = @"/bottomRow.png";
		// rowBackground = [UIImage imageNamed:@"bottomRow.png"];
		// selectionBackground = [UIImage imageNamed:@"bottomRowSelected.png"];
	}
	else
	{
		fileName = @"/middleRow.png";
		// rowBackground = [UIImage imageNamed:@"middleRow.png"];
		// selectionBackground = [UIImage imageNamed:@"middleRowSelected.png"];
	}
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	// NSLog(@"show %@", filePath);
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	rowBackground = [UIImage imageWithData:imgData];
	((UIImageView *)cell.backgroundView).image = rowBackground;
	((UIImageView *)cell.selectedBackgroundView).image = rowBackground;
	// ((UIImageView *)cell.selectedBackgroundView).image = selectionBackground;
	
	//
	// Here I set an image based on the row. This is just to have something
	// colorful to show on each row.
	//
	// NSLog(@"icon: %@", menuItem.icon);
	// NSLog(@"pattern: %@", menuItem.pattern);
	
	NSString *fileNameNoDir = [NSString stringWithFormat:@"submenu"];
	NSString * fileMenu = [documentsDir stringByAppendingPathComponent:fileNameNoDir];
	fileMenu = [NSString stringWithFormat:@"%@/submenu_%@_%@.png", fileMenu, actualId, [listMenuItem objectForKey:@"link"]];
    NSLog(@"??? %@", listMenuItem);	
	NSLog(@"icon: %@", [listMenuItem objectForKey:@"menuIcon"]);
	NSLog(@"fileMenu: %@", fileMenu);
	if(isThumbNull)
	{
		
		if ([[listMenuItem objectForKey:@"pattern"] isEqualToString:@"1"] ||
			[[listMenuItem objectForKey:@"pattern"] isEqualToString:@"2"]) {
			fileName = [listMenuItem objectForKey:@"icon"];
			if([fileName isEqualToString:@""] == FALSE) {
				BOOL fileExists = [[NSFileManager defaultManager] fileExistsAtPath:fileMenu];
				if (fileExists) {
					NSLog(@"exists");
					imgData = [NSData dataWithContentsOfFile:fileMenu];
				} else {
					NSLog(@"download");
					// change of plans...
                    // NSURL *imgURL     = [NSURL URLWithString:fileName];
					// imgData   = [NSData dataWithContentsOfURL:imgURL];
					// [imgData writeToFile:fileMenu atomically:YES];
					// cell.image = [[UIImage alloc] initWithData:imgData];
					// cell.imageView.image = [[UIImage alloc] initWithData:imgData];
				}				
				
				/*			filePath = [documentsDir stringByAppendingPathComponent:fileName];
				 
				 // imgData = [[NSData alloc] initWithContentsOfFile:filePath];
				 NSURL *imgURL     = [NSURL URLWithString:fileName];
				 imgData   = [NSData dataWithContentsOfURL:imgURL];
				 // cell.image = [[UIImage alloc] initWithData:imgData];
				 // cell.imageView.image = [[UIImage alloc] initWithData:imgData];*/
				UIImage *img    = [UIImage imageWithData:imgData];
				image.image = img;
			}
		}
	}//End if(isThumbNull)
    
#else
    // Set up the cell...
	NSMutableDictionary * listMenuItem = (NSMutableDictionary *)[lists objectAtIndex:indexPath.row];
	NSLog(@"m: %@", [listMenuItem objectForKey:@"titleText"]);
	cell.textLabel.text = [listMenuItem objectForKey:@"titleText"];
	// cell.detailTextLabel.text = [listMenuItem objectForKey:@"descriptionText"];
#endif
    
    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
	[Functions showAnimated:self.view];
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
    NSString * selSubDb = [NSString stringWithFormat:@"selSubMenu_%@", actualId];
	[cnf updateValue:selSubDb value:[NSString stringWithFormat:@"%i", indexPath.row]];
	[cnf release];
	[self loadList:indexPath.row];
}

- (void) loadList:(int) selectedItem
{
	NSMutableDictionary * listMenuItem = (NSMutableDictionary *)[lists objectAtIndex:selectedItem];
	NSLog(@"s: %@", listMenuItem);
	NSLog(@"m: %@", [listMenuItem objectForKey:@"titleText"]);

	// NSMutableDictionary *myData = [[ NSMutableDictionary alloc] init];
	NSMutableDictionary *myData = [[NSMutableDictionary dictionaryWithCapacity:2] retain];
	[myData setObject:[listMenuItem objectForKey:@"link"] forKey:@"idTab"];
	ListViewController * listViewController = [[ListViewController alloc] 
											   initWithData:myData
											   nibName:@"ListViewController" bundle:[NSBundle mainBundle]];
	listViewController.view.tag = 20003;
	listViewController.parentView = self;
	listViewController.view.frame = CGRectMake(self.view.frame.size.width, self.view.frame.origin.y, 
									   self.view.frame.size.width,  self.view.frame.size.height);
	// [listViewController setParent:self];
	// [myData release];
	if (self.tabBarController) 
		hiddenTabBar = [Functions hidetabbar:hiddenTabBar withViewController:self];
	[self.view addSubview:listViewController.view];
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	[listViewController.view setFrame: self.view.frame];
	[UIView commitAnimations];
	[Functions stopAnimated:self.view];
	[self prepareStatusBar:listViewController];
	
}

- (void) showList:(int) selectedItem
{
    // hiddenTabBar = YES;
	NSMutableDictionary * listMenuItem = (NSMutableDictionary *)[lists objectAtIndex:selectedItem];
	NSLog(@"s: %@", listMenuItem);
	NSLog(@"m: %@", [listMenuItem objectForKey:@"titleText"]);
    
	// NSMutableDictionary *myData = [[ NSMutableDictionary alloc] init];
	NSMutableDictionary *myData = [[NSMutableDictionary dictionaryWithCapacity:2] retain];
	[myData setObject:[listMenuItem objectForKey:@"link"] forKey:@"idTab"];
	ListViewController * listViewController = [[ListViewController alloc] 
											   initWithData:myData
											   nibName:@"ListViewController" bundle:[NSBundle mainBundle]];
	listViewController.view.tag = 20003;
	// [myData release];
	listViewController.parentView = self;
    listViewController.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
	// [listViewController setParent:self];
	[self.view addSubview:listViewController.view];
	[Functions stopAnimated:self.view];
	[self prepareStatusBar:listViewController];
	if (self.tabBarController) 
		hiddenTabBar = [Functions hidetabbar:hiddenTabBar withViewController:self];
}

- (void)prepareStatusBar:(UIViewController *)actualView
{
	/*if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad ||
		parentView == nil)
	{*/
	// UIToolbar * toolbar = (UIToolbar *)[actualView.view viewWithTag:10001];
	UIToolbar * toolbar = (UIToolbar *)[actualView.view viewWithTag:11003];

	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(5,4,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(hideDetail) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[toolbar addSubview:backButton];
	// }
	
	UIButton *infoButton = (UIButton *)[actualView.view viewWithTag:20004];
	CGRect frame = infoButton.frame;
	frame.origin.x += 50;
	infoButton.frame = frame;

}

- (void) hideDetail
{
	NSLog(@"back...");
	for(UIView *view in self.view.subviews)
	{
		NSLog(@"%@", view);
	}

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
    NSString * selSubDb = [NSString stringWithFormat:@"selSubMenu_%@", actualId];
	[cnf updateValue:selSubDb value:@"-1"];
	[cnf release];
	
	UIView * detailView = (UIView *)[self.view viewWithTag:20003];
	NSLog(@"* %@", detailView);
	hiddenTabBar = [Functions hidetabbar:hiddenTabBar withViewController:self];
	[detailView removeFromSuperview];
	detailView = nil;
	// [detailView release];
}


@end
