//
//  SurveyViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 6/7/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "SurveyViewController.h"
#import "Functions.h"
#import "MIRadioButtonGroup.h"
#import "TBXML.h"
#import "Config.h"
#import "NSString+HTML.h"
#import "ASIFormDataRequest.h"
#import "SilLoginPrompt.h"
#import "SSTextView.h"

@implementation SurveyViewController

@synthesize idResponse;
@synthesize idQuestion;
@synthesize idSurvey;
@synthesize idModule;
@synthesize auth;
@synthesize authUrl;

@synthesize reqName;
@synthesize reqType;
@synthesize reqService;
@synthesize reqFields;


@synthesize XMLData;

static const CGFloat KEYBOARD_ANIMATION_DURATION = 0.3;
static const CGFloat MINIMUM_SCROLL_FRACTION = 0.2;
static const CGFloat MAXIMUM_SCROLL_FRACTION = 0.8;
static const CGFloat PORTRAIT_KEYBOARD_HEIGHT = 216;
static const CGFloat LANDSCAPE_KEYBOARD_HEIGHT = 162;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
 if (self) {
 // Custom initialization.
 }
 return self;
 }
 */

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	self.idResponse = @"";
	self.idQuestion = @"";
	self.idSurvey = @"";
	self.idModule = @"";
	self.reqName = @"";
	self.reqType = @"";
	self.reqService = @"";
	reqFields = [[NSMutableArray alloc] init];
	
	NSString * title = @"Survey";
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}

	idModule = actualId;

	/*NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	UIImage *tempImg = [[UIImage alloc] initWithData:imgData];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	[tempImg release];
	imageView.frame = CGRectMake(0, 0, 320, 416);
	[self.view addSubview:imageView];
	[imageView release];*/

	[Functions addToolBar:self.view withTitle:title actualId:actualId];

	UIButton * prevButt = [UIButton buttonWithType:UIButtonTypeCustom];
	prevButt.tag = 2001;
	// UIImage * btnImage = [[UIImage alloc] init];
	prevButt.frame = CGRectMake(220, 400, 30, 30);
	UIImage * btnImage = [UIImage imageNamed:@"prev.png"];
	prevButt.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:30 height:30];
	[prevButt setImage:btnImage forState:UIControlStateNormal];
	[prevButt addTarget:self
				 action:@selector(prevSurvey)
	   forControlEvents:UIControlEventTouchUpInside];
	// if (current > 0) prevButt.hidden = FALSE;
	// else 
	prevButt.hidden = TRUE;
	prevButt.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin  | UIViewAutoresizingFlexibleTopMargin;
	[self.view addSubview:prevButt];
	
	UIButton * nextButt = [UIButton buttonWithType:UIButtonTypeCustom];
	nextButt.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin  | UIViewAutoresizingFlexibleTopMargin;
	nextButt.tag = 2002;
	nextButt.frame = CGRectMake(260, 400, 30, 30);
	btnImage = [UIImage imageNamed:@"next.png"];
	btnImage = [Functions resizeImage:btnImage width:30 height:30];
	nextButt.backgroundColor = [UIColor clearColor];
	[nextButt setImage:btnImage forState:UIControlStateNormal];
	[nextButt addTarget:self
				 action:@selector(nextSurvey)
	   forControlEvents:UIControlEventTouchUpInside];
	// if (current < [pollList count]-1) nextButt.hidden = FALSE;
	// else 
	nextButt.hidden = TRUE;
	[self.view addSubview:nextButt];
	
	UILabel * questLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 50, 260, 50)];
	questLabel.tag = 2003;
	questLabel.text = @"";
	questLabel.backgroundColor = [UIColor clearColor];
	[questLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:16]];
	questLabel.textColor = [Functions colorForHex:@"#000000"];
	// questLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	questLabel.lineBreakMode = UILineBreakModeWordWrap;
	questLabel.numberOfLines = 0;
	// questLabel.shadowColor = [UIColor grayColor];
	// questLabel.shadowOffset = CGSizeMake(1,1);
	questLabel.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	// questLabel.textColor = [UIColor blueColor];
	[self.view addSubview:questLabel];
	[questLabel release];
	
	UILabel * questThanks = [[UILabel alloc] initWithFrame:CGRectMake(30, 80, 260, 200)];
	questThanks.tag = 2004;
	questThanks.text = @"";
	questThanks.backgroundColor = [UIColor clearColor];
	[questThanks setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:13]];
	questThanks.textColor = [Functions colorForHex:@"#000000"];
	// questThanks.textAlignment = UITextAlignmentCenter; // UIControlContentHorizontalAlignmentLeft;
	questThanks.lineBreakMode = UILineBreakModeWordWrap;
	questThanks.numberOfLines = 0;
	// questThanks.shadowColor = [UIColor grayColor];
	// questThanks.shadowOffset = CGSizeMake(1,1);
	questThanks.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
	// questLabel.textColor = [UIColor blueColor];
	[self.view addSubview:questThanks];
	[questThanks release];
	
	UILabel * textLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, 250, 300, 50)];
	textLabel.tag = 2006;
	textLabel.text = @"123";
	textLabel.backgroundColor = [UIColor clearColor];
	[textLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:13]];
	textLabel.textColor = [Functions colorForHex:@"#000000"];
	// textLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	textLabel.lineBreakMode = UILineBreakModeWordWrap;
	textLabel.numberOfLines = 0;
	// textLabel.shadowColor = [UIColor grayColor];
	// textLabel.shadowOffset = CGSizeMake(1,1);
	textLabel.hidden = YES;
	// textLabel.textColor = [UIColor blueColor];
	[self.view addSubview:textLabel];
	[textLabel release];
		
	SSTextView * txtInfo = [[SSTextView alloc] initWithFrame:CGRectMake(30, 300, 260, 50)];
	// UITextField * txtInfo = [[UITextField alloc] initWithFrame:CGRectMake(30, 300, 260, 50)];
	txtInfo.delegate = self;
	txtInfo.tag = 2007;
	txtInfo.hidden = YES;
	txtInfo.placeholder = @"";
	txtInfo.textColor = [UIColor blackColor]; //text color
	// txtInfo.font = [UIFont systemFontOfSize:20.0];  //font size
	txtInfo.textAlignment = UITextAlignmentCenter;
	// [txtInfo addObserver:self forKeyPath:@"contentSize" options:(NSKeyValueObservingOptionNew) context:NULL];
	// txtInfo.scrollEnabled = NO;
	txtInfo.returnKeyType = UIReturnKeyDone;  // type of the return key
	// txtInfo.borderStyle = UITextBorderStyleLine;
	[self.view addSubview:txtInfo];
	[txtInfo release];
	
	
	group =[[MIRadioButtonGroup alloc] initWithFrame:CGRectMake(0, 100, 320, 270) andOptions:nil andColumns:1];
	/*group.autoresizingMask = ( UIViewAutoresizingFlexibleWidth
							  | UIViewAutoresizingFlexibleHeight);*/
	//[group setBackgroundColor:[UIColor redColor]];
	//[questLabel setBackgroundColor:[UIColor whiteColor]];

	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
	[group setFrame:CGRectMake(CGRectGetMinX(mainViewBounds)+100, questLabel.frame.origin.y + questLabel.frame.size.height + 50.0, CGRectGetWidth(mainViewBounds)-200, 270)];
	[self.view addSubview:group];

	UIButton *cancelButton = [UIButton buttonWithType:UIButtonTypeCustom];
	cancelButton.tag = 2005;
	[cancelButton setFrame:CGRectMake(100,350,120,44)];
	[cancelButton setTitle:@"Go" forState:UIControlStateNormal];
	[cancelButton addTarget:self action:@selector(showSurvey) forControlEvents:UIControlEventTouchUpInside];
	cancelButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin  | UIViewAutoresizingFlexibleTopMargin;
	cancelButton.backgroundColor = [UIColor clearColor]; // [Functions colorForHex:@"#cccccc"];
	[cancelButton setBackgroundImage:[[UIImage imageNamed:@"button-bg-blck.png"] stretchableImageWithLeftCapWidth:10.0 topCapHeight:0.0] forState:UIControlStateNormal];
	[self.view addSubview:cancelButton];
	// [cancelButton release];
	
	// [self showHome];
	// [self showXML];
	// return;
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	
    
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	self.auth = @"0";
	self.authUrl = @"0";
	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"authentication"]) {
									self.auth = [TBXML valueOfAttributeNamed:@"sequence" forElement:childXMLElement];
									self.authUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
                    /*
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:idAbout]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"about_title"]) {
									titleText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"about_desc"]) {
									aboutText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
							}
						} while (childXMLElement = childXMLElement->nextSibling);
					}
                     */
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}

    
    
    
    
    
	NSString * value = [cnf loadValue:@"useTabBar"];
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_18.xml", actualId]];
	XMLData =[[NSMutableData alloc] init];
	// if([cnf.value isEqualToString:@""] || cnf.value == nil
	if([value isEqualToString:@""] || value == nil
	   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		// [dateFormat release];
		[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_18.xml", actualId] value:dateString];
		// myXMLData = [NSData dataWithContentsOfURL:u];
		[self goDownload];
	} else {
		/*
		NSTimeInterval dateTime;		
		// NSDateFormatter *
		// dateFormat = [[[NSDateFormatter alloc] init] autorelease];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		// NSDate *lastCheck = [dateFormat dateFromString:cnf.value];
		NSDate *lastCheck = [dateFormat dateFromString:value];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
		*/
		NSString *displayIdValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_18.xml", actualId]];
		
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:displayIdValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		// dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
		/*
		 NSLog(@"t: %@ - %@", 
		 [dateFormat stringFromDate:date],
		 [dateFormat stringFromDate:[dateFormat dateFromString:@"201010150300"]]
		 );
		 NSLog(@" date = %@", date);
		 NSLog(@" date = %@", lastCheck);
		 */
		int day1 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:date];
		int day2 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:lastCheck];
		NSLog(@"%i - %i * %@ - %@", day1, day2, [dateFormat stringFromDate:date], [dateFormat stringFromDate:lastCheck]);

		// if(dateTime > 1) {
		if(day1 != day2) {
			NSLog(@"down (2)... ");
			// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			// [dateFormat release];
			NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_18.xml", actualId],dateString);
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_18.xml", actualId] value:dateString];
			// myXMLData = [NSData dataWithContentsOfURL:u];
			[self goDownload];
		} else {
			// myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
			// [self processXml:[[NSData alloc] initWithContentsOfFile:fileName]];
			[self showHome];
		}
	}
	[dateFormat release];
	
	[cnf release];
	
}

/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations.
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[XMLData release];
	[idModule release];
	[idSurvey release];
	[idQuestion release];
	[idResponse release];
	[infoData release];
	[group release];

	[reqName release];
	[reqType release];
	[reqService release];
	[reqFields release];
	[super dealloc];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSMutableData*)myXMLData
{
	// NSString *content = [NSString stringWithUTF8String:[data bytes]]; // NSASCIIStringEncoding
	// NSString *content = [[NSString alloc]  initWithBytes:[data bytes]
	//											  length:[data length] 
	//											encoding: NSUTF8StringEncoding];
	// NSLog(@"data: %@", content);
    NSLog(@"didReceiveData");
	
	[XMLData appendData:myXMLData];
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
    NSLog(@"didFinishLoading");
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
		// [cnf updateValue:@"displayId"  value:actualId];	
	}
	NSLog(@"?? %@", infoData);
	NSString * displayId = actualId;
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	// [dateFormat release];
	// NSString *name = [NSString stringWithFormat:@"tmp_%@_18.xml", displayId];
	// [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_18.xml", displayId] withValue:dateString];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_18.xml", displayId],dateString);
	[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_18.xml", displayId] value:dateString];
	[dateFormat release];
	
	// NSLog(@"%@", [[NSString alloc] initWithData:myXMLData encoding:NSASCIIStringEncoding]);
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_18.xml", actualId]];
	
	[XMLData writeToFile:fileName atomically:YES];
	NSLog(@"saved %@...", fileName);
	
	[cnf release];
	
	[self showHome];
	
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    NSLog(@"didFailWithError");
}

- (void) goDownload {
	// NSString *url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/xml/survey.xml";
	// NSString *url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/app_builder/services/get_application_surveys.aspx";
	Config * cnf = [[Config alloc] init];
	NSString *url = [cnf loadValue:@"servicesUrl"];
	url = [NSString stringWithFormat:@"%@/get_application_surveys.aspx", url];

	NSString * email = @"cberzolla@isg-marketing.com";
	NSString * pass = @"soccer";
	NSString * app = [cnf loadValue:@"app_id"]; //@"1";
	[cnf release];
	
	NSString * post = [NSString stringWithFormat:@"&email=%@&password=%@&application_id=%@", 
					   email,
					   pass,
					   app];
	NSData * postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:NO];
	NSString * postLength = [NSString stringWithFormat:@"%d",[postData length]];
	NSMutableURLRequest * request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:url]]; 
	[request setHTTPMethod:@"POST"];
	[request setValue:postLength forHTTPHeaderField:@"Content-Length"];
	[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
	[request setHTTPBody:postData];
	NSLog(@"url %@", url);
	NSLog(@"post %@", post);
	// NSMutableURLRequest *request = [ [ NSMutableURLRequest alloc ] initWithURL: [ NSURL URLWithString:url ] ];
	// [ request setHTTPMethod: @"POST" ];
	// [ request setHTTPBody: postData ];
	
	NSURLConnection * conn = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	if (conn) NSLog(@"Connection Successful");
	else NSLog(@"Failed to submit request");
    [conn release];

}

- (void) showXML:(int)isHome {
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		actualId = [infoData valueForKey:@"idTab"];
		[cnf updateValue:@"displayId" value:actualId];	
	}
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_18.xml", actualId]];
	// NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"survey.xml", actualId]];
	
	NSData *Data = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:Data encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	
	
	// TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	// BOOL surveyTmp = NO;
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	NSString * showSurveyId = @"";
	NSString * question = @"";
	NSString * bgImage = @"";
	NSMutableArray *optionsId = [[NSMutableArray alloc] init];
	NSMutableArray *optionsText = [[NSMutableArray alloc] init];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	TBXMLElement * childXMLElement;
    [tbxml release];
	BOOL f = FALSE;
	int currentQuestion = 0;
	UILabel * tmpTitle = (UILabel *)[self.view viewWithTag:2003];
	[tmpTitle setText:@""];
	UILabel * tmpThanks = (UILabel *)[self.view viewWithTag:2004];
	[tmpThanks setText:@""];
	NSString * surveyId = @""; // [[NSString alloc] init];
	NSString * surveyBack = @""; // [[NSString alloc] init];
	NSString * surveyWelcome = @""; // [[NSString alloc] init];
	NSString * surveyThanks = @""; // [[NSString alloc] init];
	NSString * surveyTitle = @""; // [[NSString alloc] init];
	textBox = NO;
	NSString * textTitle = @"";
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"survey"]) {
				surveyId = [TBXML valueOfAttributeNamed:@"survey_id" forElement:childXMLElement];
				surveyBack = [TBXML valueOfAttributeNamed:@"back_btn" forElement:childXMLElement];
				surveyTitle = [TBXML valueOfAttributeNamed:@"title" forElement:childXMLElement];
				surveyWelcome = [TBXML valueOfAttributeNamed:@"welcome" forElement:childXMLElement];
				NSLog(@"wl: %@", surveyWelcome);
				surveyThanks = [TBXML valueOfAttributeNamed:@"thanks" forElement:childXMLElement];
				// cnf = [[Config alloc] initWithName:[NSString stringWithFormat:@"survey_%@", surveyId]];
				NSString * value = [cnf loadValue:[NSString stringWithFormat:@"survey_%@_%@", surveyId, actualId]];
				int currentSurvey = [value intValue];
				currentSurvey += 1;
				value = [cnf loadValue:[NSString stringWithFormat:@"survey_question_%@_%@", surveyId, actualId]];
				currentQuestion = [value intValue];
				NSLog(@"val? %i <> %i --> %@", currentSurvey, currentQuestion, [NSString stringWithFormat:@"survey_%@_%@", surveyId, actualId]);
				
				//surveyTmp = YES;
				showSurveyId = surveyId;
				question = [TBXML valueOfAttributeNamed:@"question" forElement:childXMLElement];
				bgImage = [TBXML valueOfAttributeNamed:@"background_image" forElement:childXMLElement];
				NSLog(@"q: %@", question);
				f = TRUE;
				TBXMLElement * itemXMLElement = childXMLElement->firstChild;\
				int counter = 0;
				do {
					NSLog(@"opt? %@", [TBXML elementName:itemXMLElement]);
					TBXMLElement * optionXMLElement = itemXMLElement->firstChild;
					if (currentQuestion == counter) {
						NSString * surveyTitle = [TBXML valueOfAttributeNamed:@"title" forElement:itemXMLElement];
						NSString * questionId = [TBXML valueOfAttributeNamed:@"question_id" forElement:itemXMLElement];
						self.idQuestion = questionId; // [questionId retain];
						if (!isHome) [tmpTitle setText:surveyTitle];
						do {
							if ([[TBXML elementName:optionXMLElement] isEqualToString:@"option"]) {
								NSString * optionId = [TBXML valueOfAttributeNamed:@"option_id" forElement:optionXMLElement];
								NSString * optionText = [TBXML valueOfAttributeNamed:@"text" forElement:optionXMLElement];
								NSLog(@"opt-> %@ - %@", optionText, optionId);
								if (optionId) {
									[optionsId addObject:optionId];
									[optionsText addObject:optionText];
								}
								// NSArray * element = [NSArray arrayWithObjects:optionId, optionText, nil];
								// [elements addObject:element];
							}
							if ([[TBXML elementName:optionXMLElement] isEqualToString:@"textbox"]) {
								textBox = YES;
								textTitle = [TBXML valueOfAttributeNamed:@"text" forElement:optionXMLElement];
							}
						} while ((optionXMLElement = optionXMLElement->nextSibling));
					}
					if (currentQuestion == counter) break;
					counter++;
				} while ((itemXMLElement = itemXMLElement->nextSibling));
				
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && !f);
	}

	self.idSurvey = @""; // showSurveyId;
	self.idSurvey = showSurveyId;
	NSLog(@"survey: %@", idSurvey);

	if ([idSurvey isEqualToString:@""] ||
		(idSurvey == nil)) { 
		
		/*NSMutableDictionary * myData;
		 [myData setObject:@"0" forKey:@"showSurvey"];
		 SurveyResultsViewController *surveyResultsViewController = [[SurveyResultsViewController alloc] 
		 initWithData:myData
		 nibName:@"SurveyResultsViewController" bundle:[NSBundle mainBundle]];
		 [self.view addSubview:surveyResultsViewController.view];*/
		
		if ([tabbar isEqualToString:@"1"]) {
		} else {		
		}
		
        [optionsId release];
        [optionsText release];

		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Survey" message:@"There are no surveys at this moment." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];	

		[cnf updateValue:@"displayView" value:@"1"];
		[cnf release];
		[Functions goMenu:nil];
		
		return;

	}	
	
	if (isHome) {
        [optionsId release];
        [optionsText release];

		NSLog(@"wl: %@", surveyWelcome);
		[tmpThanks setText:surveyWelcome];
		[tmpTitle setText:surveyTitle];

		
		// BOOL auth = YES;
        NSLog(@"auth: %@", auth);

		// exists survey

		// Config * cnf = [[Config alloc] init];
		NSString *autName = [NSString stringWithFormat:@"survey_%@_%@.log", idSurvey, idModule];
		NSString * autVal = [cnf loadValue:autName];
		[cnf release];		

		if ([autVal isEqualToString:@""])
		if (![auth isEqualToString:@"0"])
		{
		//	[self loadAuth];
		[self loadAuth:FALSE errMsg:@""];
		// [self doAuth:FALSE errMsg:@""];
		}
		else
		{
			[self callAuth:@"Anonymous" withPassword:@""];
			/*
			 NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.log", displayId];
			 NSString * value = [cnf loadValue:autName];
			 if ([value isEqualToString:@"true"]) {
			 [self goDownload];
			 } else {
			 [dateFormat setDateFormat:@"YYYYMMddHHmm"];
			 NSString *dateString = [dateFormat stringFromDate:date];  
			 [Functions updateConfig:[NSString stringWithFormat:@"tmp_%@_18.xml", displayId] withValue:dateString];
			 [self doAuth:FALSE];
			 }*/
			
		}
		
		
		return;
	}
	
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2001];
	if (currentQuestion == 0 || [surveyBack isEqualToString:@"0"]) tmpBt.hidden = TRUE;
	else tmpBt.hidden = FALSE;
	tmpBt = (UIButton *)[self.view viewWithTag:2002];
	if ([optionsText count] > 0 || textBox ) tmpBt.hidden = FALSE;
	else {
		tmpBt.hidden = YES;
		tmpBt = (UIButton *)[self.view viewWithTag:2001];
		tmpBt.hidden = YES;
		// [tmpThanks setText:@"Thanks for taking the time to answer this survey"];
		[tmpThanks setText:surveyThanks];
		[tmpTitle setText:surveyTitle];

		UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2005];
		tmpBt.hidden = NO;
		[tmpBt setTitle:@"Take survey again" forState:UIControlStateNormal];
		// [tmpBt setFrame:CGRectMake(50,355,200,44)];
		CGRect frame = tmpBt.frame;
		frame.size.width += 80;
		tmpBt.frame = frame;
		[tmpBt addTarget:self action:@selector(restartSurvey) forControlEvents:UIControlEventTouchUpInside];
		[cnf updateValue:[NSString stringWithFormat:@"survey_question_%@_%@", idSurvey, idModule] value:@"0"];	
		[cnf updateValue:[NSString stringWithFormat:@"survey_%@_%@.log", idSurvey, idModule] value:@""];	
		for (int i = 0; i < currentQuestion; i++) {
			[cnf updateValue:[NSString stringWithFormat:@"survey_%i_%@_%@", i, idSurvey, idModule] value:@""];
			[cnf updateValue:[NSString stringWithFormat:@"survey_text_%i_%@_%@", i, idSurvey, idModule] value:@""];	
		}
	}
    NSLog(@"opt -> %@", optionsText);

	NSLog(@"count : -> %d :: %i", [optionsText count], currentQuestion);

//	if (!isHome) [tmpTitle setText:surveyTitle];
	
	/* bh autosze */
	// http://stackoverflow.com/questions/446405/a00000000000000000000000000000000000000000000djust-uilabel-height-depending-on-the-text
	//Calculate the expected size based on the font and linebreak mode of your label
	CGSize maximumLabelSize = CGSizeMake(296,9999);
	
	NSString * tmpString = tmpTitle.text;
	CGSize expectedLabelSize = [tmpString sizeWithFont:tmpTitle.font 
									  constrainedToSize:maximumLabelSize 
										  lineBreakMode:tmpTitle.lineBreakMode]; 
	
	//adjust the label the the new height.
	CGRect newFrame = tmpTitle.frame;
	newFrame.size.height = expectedLabelSize.height;
	tmpTitle.frame = newFrame;
	// tmpTitle.backgroundColor = [UIColor redColor];
	/* bh */

	if ([idSurvey isEqualToString:@""] ||
		(idSurvey == nil)) { 
		
		/*NSMutableDictionary * myData;
		 [myData setObject:@"0" forKey:@"showSurvey"];
		 SurveyResultsViewController *surveyResultsViewController = [[SurveyResultsViewController alloc] 
		 initWithData:myData
		 nibName:@"SurveyResultsViewController" bundle:[NSBundle mainBundle]];
		 [self.view addSubview:surveyResultsViewController.view];*/
		
		if ([tabbar isEqualToString:@"1"]) {
		} else {		
		}
		
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Survey" message:@"There is no surveys at this moment." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];	
		
	} else {
		
		if ((bgImage != nil) && !([bgImage isEqualToString:@""])) {
			NSURL *url = [NSURL URLWithString:bgImage];
			NSData * imgData = [NSData dataWithContentsOfURL:url];
			UIImage *img = [UIImage imageWithData:imgData];
			UIImageView * imgView = [[UIImageView alloc] initWithImage:img];
			[self.view addSubview:imgView];
			NSLog(@"image %@", bgImage);
            [imgView release];
		}		
		
		/*NSArray *options =[[NSArray alloc]initWithObjects:
		 @"1. My First Test",
		 @"2. Another test. Another test and another test.",
		 @"3. New test...",
		 @"1. My First Test. My First Test.",
		 @"2. Another test.",
		 @"3. New test... New test... New test...",
		 nil];*/
		
		NSArray *options = [[NSArray alloc] initWithArray:optionsText];
		[group removeAll];
		NSLog(@"sel? %i %i %@", [group getSelected], [group total], idSurvey);
		if ([options count])
		[group createButtons:options withColumns:1];
		// group =[[MIRadioButtonGroup alloc] initWithFrame:CGRectMake(0, 100, 320, 240) andOptions:options andColumns:1];
		[options release];
		// [self.view addSubview:group];
		
		// Config * cnf = [[Config alloc] init];
		NSString * value = [cnf loadValue:[NSString stringWithFormat:@"survey_%i_%@_%@", currentQuestion, idSurvey, idModule]];
		NSLog(@"data val: %@, %@", 
			  [NSString stringWithFormat:@"survey_%i_%@_%@", currentQuestion, idSurvey, idModule], value);
		int current = [value intValue];
		if ([group total] && current > 0)
		[group setSelected:current-1];
		
		NSLog(@"sel? %i - %i %i %@", current, [group getSelected], [group total], idSurvey);
	}
	
	NSLog(@"uoiea");
	if (textBox)
	{
		NSLog(@"aeiou %@", textTitle);
		UILabel * textLabel = (UILabel *)[self.view viewWithTag:2006];
		[self.view bringSubviewToFront:textLabel];
		textLabel.text = textTitle;
		
		NSString * value = [cnf loadValue:[NSString stringWithFormat:@"survey_text_%i_%@_%@", currentQuestion, idSurvey, idModule]];
		NSLog(@"data val: %@, %@", 
			  [NSString stringWithFormat:@"survey_text_%i_%@_%@", currentQuestion, idSurvey, idModule], value);

		// SSTextView * txtInfo = (SSTextView *)[self.view viewWithTag:2007];
		UITextField * txtInfo = (UITextField *)[self.view viewWithTag:2007];

		[self.view bringSubviewToFront:txtInfo];
		textLabel.hidden = NO;
		txtInfo.hidden = NO;
		txtInfo.text = value; // @"";

		CGRect newFrame = tmpTitle.frame;
		int h = 0;
		if (newFrame.size.height > 50)
			h = newFrame.size.height-50;

		if ([optionsText count])
		{
			txtInfo.frame = CGRectMake(30, 275+h, 260, 90);
			textLabel.frame = CGRectMake(30, 250+h, 260, 25);
		}
		else
		{
			txtInfo.frame = CGRectMake(30, 125+h, 260, 100);
			textLabel.frame = CGRectMake(30, 100+h, 260, 25);
		}


	}
	else 
	{
		UILabel * textLabel = (UILabel *)[self.view viewWithTag:2006];
		SSTextView * txtInfo = (SSTextView *)[self.view viewWithTag:2007];
		textLabel.hidden = YES;
		txtInfo.hidden = YES;
		txtInfo.text = @"";

	}
	
    [optionsId release];
    [optionsText release];

	[cnf release];
}

- (void) restartSurvey
{
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2001];
	tmpBt.hidden = YES;
	tmpBt = (UIButton *)[self.view viewWithTag:2002];
	tmpBt.hidden = YES;
	[self showXML:1];
	[self showXML:0];
}

- (void) showHome
{
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2001];
	tmpBt.hidden = YES;
	tmpBt = (UIButton *)[self.view viewWithTag:2002];
	tmpBt.hidden = YES;

	[self showXML:1];

	// UILabel * tmpThanks = (UILabel *)[self.view viewWithTag:2004];
	// [tmpThanks setText:@"Welcome to this survey."];
}
- (void) showSurvey
{
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2005];
	tmpBt.hidden = YES;
	[self showXML:0];
}

- (BOOL) goSubmit
{
	UIButton * tmpBt = (UIButton *)[self.view viewWithTag:2005];
	tmpBt.hidden = YES;
	Config * cnf = [[Config alloc] init];

	// NSString * url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/app_builder/services/add_survey_response_answer.aspx";
	NSString *url = [cnf loadValue:@"servicesUrl"];
	url = [NSString stringWithFormat:@"%@/add_survey_response_answer.aspx", url];

	NSString * email = @"cberzolla@isg-marketing.com";
	NSString * pass = @"soccer";
	NSString * app = idModule; // @"1";
	NSString * questionId = idQuestion;
	NSString * responseId = idResponse;
	NSString * answerId = [NSString stringWithFormat:@"%i", [group getSelected]+1];
	SSTextView * txtInfo = (SSTextView *)[self.view viewWithTag:2007];
	// txtInfo.text = @"";
	
	NSString *post =[NSString stringWithFormat:@"email=%@&password=%@&application_id=%@&response_id=%@&answer=%@&question_id=%@&answer_text=%@",
					 email, pass, app, responseId, answerId, questionId, txtInfo.text];
	NSLog(@"%@", post);	
	
	NSData *postData = [post dataUsingEncoding:NSASCIIStringEncoding allowLossyConversion:YES];
	
	NSString *postLength = [NSString stringWithFormat:@"%d", [postData length]];
	
	NSMutableURLRequest *request = [[[NSMutableURLRequest alloc] init] autorelease];
	[request setURL:[NSURL URLWithString:url]];
	[request setHTTPMethod:@"POST"];
	[request setValue:postLength forHTTPHeaderField:@"Content-Length"];
	[request setValue:@"application/x-www-form-urlencoded" forHTTPHeaderField:@"Content-Type"];
	[request setHTTPBody:postData];
	
	NSError *error;
	NSURLResponse *response;
	NSData *urlData=[NSURLConnection sendSynchronousRequest:request returningResponse:&response error:&error];
	NSString *data=[[NSString alloc] initWithData:urlData encoding:NSUTF8StringEncoding];
	NSLog(@"%@", data);	
    [data release];
	
	
	/*	
	 
	 response_id=[returned from above call
	 question_id=[question_id]
	 answer=[1 through 5]	
	 
	 <survey_results>
	 <error></error>
	 </survey_results>
	 
	 */
	// [self showXML:0];
	
	// Config * cnf = [[Config alloc] init];
	NSString * value = [cnf loadValue:[NSString stringWithFormat:@"survey_question_%@_%@", idSurvey, idModule]];
	int current = [value intValue];
	NSString * format = @"survey_%@_%@_%@";
	NSString * currentVal =  [NSString stringWithFormat:@"%i", current];
	//value = [cnf loadValue:[NSString stringWithFormat:format, currentVal, idSurvey, idModule]];
	//if([value isEqualToString:@""] == TRUE)
	//	[cnf insertValue:[NSString stringWithFormat:format, currentVal, idSurvey, idModule] value:answerId];
	//else
		[cnf updateValue:[NSString stringWithFormat:format, currentVal, idSurvey, idModule] value:answerId];

	if (textBox)
	{
		[cnf updateValue:[NSString stringWithFormat:@"survey_text_%@_%@_%@", currentVal, idSurvey, idModule] value:txtInfo.text];	
	}

	[cnf release];
	return YES;
}

-(void) nextSurvey {

	NSLog(@"group %i", [group total]);
	if ([group getSelected] == -1
		&& [group total]) {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" 
														message:@"Please select an answer." 
													   delegate:nil
											  cancelButtonTitle:@"OK"
											  otherButtonTitles:nil];
		[alert show];
		[alert release];	
		return;
	}

	if ([self goSubmit]) 
	{
	Config * cnf = [[Config alloc] init];
	
	NSString * value = [cnf loadValue:[NSString stringWithFormat:@"survey_question_%@_%@", idSurvey, idModule]];
	int current = [value intValue];
	// current += 1;
	
	NSLog(@"-> cur: %i", current);
		current++;
		[cnf updateValue:[NSString stringWithFormat:@"survey_question_%@_%@", idSurvey, idModule] value:[NSString stringWithFormat:@"%i", current]];	
		[cnf release];
		[self showXML:0];
	}
	else
	{
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" 
														message:@"Error sending answer, try again please." 
													   delegate:nil
											  cancelButtonTitle:@"OK"
											  otherButtonTitles:nil];
		[alert show];
		[alert release];	
	}
		
	
}

-(void) prevSurvey {
	NSLog(@"group %i", [group total]);
	if ([group getSelected] == -1
		&& [group total]) {
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" 
														message:@"Please select an answer." 
													   delegate:nil
											  cancelButtonTitle:@"OK"
											  otherButtonTitles:nil];
		[alert show];
		[alert release];	
		return;
	}

	if ([self goSubmit]) 
	{
	Config * cnf = [[Config alloc] init];
	NSString * value = [cnf loadValue:[NSString stringWithFormat:@"survey_question_%@_%@", idSurvey, idModule]];
	int current = [value intValue];
	// current += 1;
	
	NSLog(@"-> cur: %i", current);
	current--;
	NSLog(@"-> cur: %i", current);
	[cnf updateValue:[NSString stringWithFormat:@"survey_question_%@_%@", idSurvey, idModule] value:[NSString stringWithFormat:@"%i", current]];	
	[cnf release];
	[self showXML:0];
	}
	else
	{
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" 
														message:@"Error sending answer, try again please." 
													   delegate:nil
											  cancelButtonTitle:@"OK"
											  otherButtonTitles:nil];
		[alert show];
		[alert release];	
	}
}

- (void) loadAuth:(BOOL)showErr errMsg:(NSString *)txtErr 
{

	NSString *requestString = authUrl;
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
	NSLog(@"sent: %@", requestString);	
	[request startSynchronous];

	NSError *error = [request error];
	self.reqName = @"";
	self.reqType = @"";
	self.reqService = @"";
	// [reqFields release];
	reqFields = [[NSMutableArray alloc] init];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		[self stopAnimated:nil];
		
		TBXML * dataXml = [[TBXML tbxmlWithXMLString:response] retain];
		if (dataXml.rootXMLElement)
		{
			TBXMLElement * childXMLElement = dataXml.rootXMLElement;
			childXMLElement = childXMLElement->firstChild;
			BOOL f = NO;
			do {
				NSLog(@"name: %@", [TBXML elementName:childXMLElement]);
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"authentication_module"]
					&& [[TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement] isEqualToString:auth]
					) {
					f = YES;
					self.reqName = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
					self.reqType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					TBXMLElement * serviceXml = [TBXML childElementNamed:@"service" parentElement:childXMLElement];
					if (serviceXml)
						self.reqService = [TBXML textForElement:serviceXml];
					TBXMLElement * fieldsXml = [TBXML childElementNamed:@"fields" parentElement:childXMLElement];
					if (fieldsXml) 
					{
						TBXMLElement * fieldXml = fieldsXml->firstChild;

						do
						{
							NSString * formName = [TBXML valueOfAttributeNamed:@"display_name" forElement:fieldXml];
							NSString * formField = [TBXML valueOfAttributeNamed:@"form_name" forElement:fieldXml];
							NSArray *field = [NSArray arrayWithObjects: formName, formField, nil];
							[self.reqFields addObject:field];
							// [field release];
						} while ((fieldXml = fieldXml->nextSibling));
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && !f);
			
		}
        [dataXml release];
	}
	else
	{
		// error
	}
	NSLog(@"f:::: %@ +++ %@ --- %@ *** %@", reqFields, reqName, reqType, reqService);

	Config * cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.aut", displayId];
	NSString * value = [NSString stringWithFormat:@"%@", [cnf loadValue:autName] ];
	NSLog(@"aut 1: %@ -- s: %@", autName, idSurvey);
    [cnf release];

	NSString *errMsg = @"";
	if (showErr) 
		if ([txtErr isEqualToString:@""])
			errMsg = @"Error on data.";
		else
			errMsg = [NSString stringWithFormat:@"%@", txtErr];
	
	NSLog(@"err? %@ ? %d", errMsg, showErr);
	
	SilLoginPrompt *newPrompt = [[SilLoginPrompt alloc] initWithTitle:reqName
															  message:errMsg
															 delegate:self
													cancelButtonTitle:@"cancel"
														okButtonTitle:@"login"
														  fieldNumber: [reqFields count]];
	[newPrompt setUserText:value]; 
	[newPrompt setUserPlaceholder:[[reqFields objectAtIndex:0] objectAtIndex:0]]; 
	[newPrompt show];
	[newPrompt release];
}

- (void) doAuth:(BOOL)showErr errMsg:(NSString *)txtErr
{
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	
	NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.aut", displayId];
	NSString * value = [NSString stringWithFormat:@"%@", [cnf loadValue:autName] ];
	NSLog(@"aut 1: %@ -- s: %@", autName, idSurvey);

//	[label setText:@""];
	
	NSString *errMsg = @"";
	if (showErr) 
		if ([txtErr isEqualToString:@""])
			errMsg = @" \nInvalid Information";
		else
			errMsg = [NSString stringWithFormat:@"\n%@", txtErr];
	
	NSLog(@"err? %@ ? %d", errMsg, showErr);
	
	UIAlertView *myAlertView = [[UIAlertView alloc] initWithTitle:@"Enter your email to start." message:errMsg delegate:self cancelButtonTitle:@"Cancel" otherButtonTitles:@"OK", nil];
	UITextField *myTextField = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 35.0, 260.0, 25.0)];
	[myTextField setBackgroundColor:[UIColor whiteColor]];
	myTextField.tag = 2002;
	
	myTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
	myTextField.keyboardType = UIKeyboardTypeAlphabet;
	myTextField.placeholder = @"E-mail";
	myTextField.text = value;
	// myTextField.keyboardAppearance = UIKeyboardAppearanceAlert;
	// myTextField.autocapitalizationType  = UITextAutocapitalizationTypeWords;
	// myTextField.autocorrectionType = UITextAutocapitalizationTypeNone;
	myTextField.textAlignment = UITextAlignmentCenter;
	
	[myAlertView addSubview:myTextField];
	// CGAffineTransform myTransform = CGAffineTransformMakeTranslation(0.0, 130.0);
	// [myAlertView setTransform:myTransform];
	[myAlertView show];
	[myTextField release];
	[myAlertView release];
	
	[cnf release];
}

- (void)alertView:(UIAlertView *)alertView didDismissWithButtonIndex:(NSInteger)buttonIndex {
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}

	NSLog(@"sel: %d", buttonIndex);
    if (buttonIndex == 0) {
		[cnf updateValue:@"displayView" value:@"1"];
		[Functions goMenu:nil];
	} else if (buttonIndex == 1) {
        if ([alertView isKindOfClass:[SilLoginPrompt class]]) {
            NSString * userName = [(SilLoginPrompt *)alertView userName];
            NSString * userPassword = [(SilLoginPrompt *)alertView userPassword];
            NSLog(@"Entered information: %@ - %@", userName, userPassword);
			NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.aut", displayId];
			NSLog(@"aut 2: %@", autName);
			NSString * value = [cnf loadValue:autName];
			if ([value isEqualToString:@""] || value == nil) {
				[cnf insertValue:autName value:userName];
			} else {
				[cnf updateValue:autName value:userName];
			}
			[self callAuth:userName withPassword:userPassword];
        } else {
            for (id subview in alertView.subviews) {
                // write to the log what the subview is
                // NSLog(@"Subview is a %@", [subview description]);
                if ([subview isKindOfClass:[UITextField class]]) {
                    NSLog(@"? %@", [(UITextField *)subview text]);
                    
                    NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.aut", displayId];
                    NSLog(@"aut 2: %@", autName);
                    //NSString * value = [cnf loadValue:autName];
                    //if ([value isEqualToString:@""] || value == nil) {
					// [cnf insertValue:autName value:[(UITextField *)subview text]];
                    //} else {
                        [cnf updateValue:autName value:[(UITextField *)subview text]];
                    //}
                    
                    // [self loadAuth:[(UITextField *)subview text]];
                    // hide all buttons
                    //if ([subview isKindOfClass:[UIButton class]])
                    //   subview.hidden = YES;
                }
            }
		}
    }
	[cnf release];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	[textField resignFirstResponder];
	return YES;
}

- (void) callAuth:(NSString *)text withPassword: (NSString *)password
{
	Config * cnf =[[Config alloc] init];

	NSString *requestString = [NSString 
							   stringWithFormat:@"%@?", reqService];
	
	int $i = 0;
	NSLog(@"req: %@", reqFields);
	
	for (NSArray *field in reqFields) {
		NSLog(@"req: %@", [field objectAtIndex:1]);
		requestString = [NSString stringWithFormat:@"%@%@=%@&", requestString, [field objectAtIndex:1], ($i == 0) ? text: password];
		$i++;
	}

		
	if (![text isEqualToString:@"Anonymous"]) {
		
		ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];
		NSLog(@"++++++++++++++ req: %@", requestString);
		[request startSynchronous];
		NSError *error = [request error];
		if (!error) {
			NSString *response = [request responseString];
			NSLog(@"response: %@", response);
			[self stopAnimated:nil];
			if ([response isEqualToString:@"true"]) 
			{
				// NSString * displayId = [cnf loadValue:@"actualId"];
				//tabbar
				NSString * tabbar = [cnf loadValue:@"useTabBar"];
				NSLog(@"tb: %@", tabbar);
				NSLog(@"title: %@", self.tabBarItem.title);
				// NSLog(@"title: %i", self.tabBarController.selectedIndex);
				if ([tabbar isEqualToString:@"1"]) {
					// displayId = [infoData valueForKey:@"idTab"];
				}
				NSString *autName = [NSString stringWithFormat:@"survey_%@_%@.log", idSurvey, idModule];
				//NSString * value = [cnf loadValue:autName];
				//if ([value isEqualToString:@""] || value == nil) {
				//	[cnf insertValue:autName value:@"true"];
				//} else {
					[cnf updateValue:autName value:@"true"];
				//}
			} else {
				[self loadAuth:TRUE errMsg:@""];
                [cnf release];
				return;
			}
		}
		else 
		{
			// error
            [cnf release];
			[self loadAuth:TRUE errMsg:[error localizedDescription]];
			return;
		}
	}
	
	// NSString *
	// requestString = [NSString 
	//						   stringWithFormat:@"http://widgets.isg-marketing.com/mcgrawhill_mobile/app_builder/services/add_survey_response.aspx"];
	// stringWithFormat:@"http://widgets.isg-marketing.com/mcgrawhill_mobile/app_builder/services/add_survey_response.aspx?user_name=%@&survey_id=%@&", text, idSurvey];
	//							   184.73.161.149:8040/services/events_is_valid_attendee.aspx?user_name=%@", text];

	requestString = [cnf loadValue:@"servicesUrl"];
	requestString = [NSString stringWithFormat:@"%@/add_survey_response.aspx", requestString];
	
	ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:[NSURL URLWithString:requestString ] ];

	// ASIFormDataRequest *request = [ASIFormDataRequest requestWithURL:url];
	[request setPostValue:text forKey:@"user"];
	[request setPostValue:idSurvey forKey:@"survey_id"];
	
	NSLog(@"sent: %@", requestString);	
	NSLog(@"user_name: %@", text);	
	[request startSynchronous];
	NSError *error = [request error];
	if (!error) {
		NSString *response = [request responseString];
		NSLog(@"response: %@", response);
		[self stopAnimated:nil];

		NSString * error = @"";
		TBXML * dataXml = [[TBXML tbxmlWithXMLString:response] retain];
		if (dataXml.rootXMLElement)
		{
			TBXMLElement * infoXml = dataXml.rootXMLElement;
			// dataXml = dataXml->firstChild;
			TBXMLElement * errorXml = [TBXML childElementNamed:@"error" parentElement:infoXml];
			if (errorXml)
			error = [TBXML textForElement:errorXml];
			TBXMLElement * responseIdXml = [TBXML childElementNamed:@"response_id" parentElement:infoXml];
			if (responseIdXml)
			self.idResponse = [TBXML textForElement:responseIdXml];
			else 
				idResponse = @"";
			NSLog(@"error: %@", error);
			NSLog(@"response: %@", idResponse);
		}
        [dataXml release];
		// [cnf release];
		
		if (idResponse) {
			// Config * cnf = [[Config alloc] init];
			NSString *autName = [NSString stringWithFormat:@"survey_%@_%@.log", idSurvey, idModule];
			// NSString * value = [cnf loadValue:autName];
			//if ([value isEqualToString:@""] || value == nil) {
			//	[cnf insertValue:autName value:idResponse];
			//} else {
				[cnf updateValue:autName value:idResponse];
			//}
			// [cnf release];
		}
		else 
		{
			// [cnf release];
			[self loadAuth:TRUE errMsg:error];
		}

		/*
		if ([response isEqualToString:@"true"]) 
		{
			
			
			Config * cnf;
			cnf = [[Config alloc] init];
			NSString * displayId = [cnf loadValue:@"actualId"];
			//tabbar
			NSString * tabbar = [cnf loadValue:@"useTabBar"];
			NSLog(@"tb: %@", tabbar);
			NSLog(@"title: %@", self.tabBarItem.title);
			// NSLog(@"title: %i", self.tabBarController.selectedIndex);
			if ([tabbar isEqualToString:@"1"]) {
				displayId = [infoData valueForKey:@"idTab"];
			}
			NSString *autName = [NSString stringWithFormat:@"tmp_%@_18.log", displayId];
			NSString * value = [cnf loadValue:autName];
			if ([value isEqualToString:@""] || value == nil) {
				[Config insertValue:autName value:@"true"];
			} else {
				[Config updateValue:autName value:@"true"];
			}
			
			[self goDownload];*/
//		} else {
//		[self doAuth:TRUE errMsg:error];
//		}
	}
    [cnf release];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

// http://cocoawithlove.com/2008/10/sliding-uitextfields-around-to-avoid.html

- (void)textFieldDidBeginEditing:(UITextField *)textField
{
	NSLog(@"***");
    CGRect textFieldRect =
	[self.view.window convertRect:textField.bounds fromView:textField];
    CGRect viewRect =
	[self.view.window convertRect:self.view.bounds fromView:self.view];
	
	CGFloat midline = textFieldRect.origin.y + 0.5 * textFieldRect.size.height;
	CGFloat numerator =
    midline - viewRect.origin.y
	- MINIMUM_SCROLL_FRACTION * viewRect.size.height;
	CGFloat denominator =
    (MAXIMUM_SCROLL_FRACTION - MINIMUM_SCROLL_FRACTION)
	* viewRect.size.height;
	CGFloat heightFraction = numerator / denominator;
	if (heightFraction < 0.0)
	{
		heightFraction = 0.0;
	}
	else if (heightFraction > 1.0)
	{
		heightFraction = 1.0;
	}

	UIInterfaceOrientation orientation =
    [[UIApplication sharedApplication] statusBarOrientation];
	if (orientation == UIInterfaceOrientationPortrait ||
		orientation == UIInterfaceOrientationPortraitUpsideDown)
	{
		animatedDistance = floor(PORTRAIT_KEYBOARD_HEIGHT * heightFraction);
	}
	else
	{
		animatedDistance = floor(LANDSCAPE_KEYBOARD_HEIGHT * heightFraction);
	}
	
	CGRect viewFrame = self.view.frame;
    viewFrame.origin.y -= animatedDistance;
	
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationBeginsFromCurrentState:YES];
    [UIView setAnimationDuration:KEYBOARD_ANIMATION_DURATION];
	
    [self.view setFrame:viewFrame];
	
    [UIView commitAnimations];
}

- (void)textFieldDidEndEditing:(UITextField *)textField
{
	NSLog(@"...");
    CGRect viewFrame = self.view.frame;
    viewFrame.origin.y += animatedDistance;
	
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationBeginsFromCurrentState:YES];
    [UIView setAnimationDuration:KEYBOARD_ANIMATION_DURATION];
	
    [self.view setFrame:viewFrame];
	
    [UIView commitAnimations];
}

- (void)textViewDidEndEditing:(UITextView *)textField
{
	NSLog(@"...");
    CGRect viewFrame = self.view.frame;
    viewFrame.origin.y += animatedDistance;
	
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationBeginsFromCurrentState:YES];
    [UIView setAnimationDuration:KEYBOARD_ANIMATION_DURATION];
	
    [self.view setFrame:viewFrame];
	
    [UIView commitAnimations];
}

- (void)textViewDidBeginEditing:(UITextView *)textField {
	NSLog(@"***");
    CGRect textFieldRect =
	[self.view.window convertRect:textField.bounds fromView:textField];
    CGRect viewRect =
	[self.view.window convertRect:self.view.bounds fromView:self.view];
	
	CGFloat midline = textFieldRect.origin.y + 0.5 * textFieldRect.size.height;
	CGFloat numerator =
    midline - viewRect.origin.y
	- MINIMUM_SCROLL_FRACTION * viewRect.size.height;
	CGFloat denominator =
    (MAXIMUM_SCROLL_FRACTION - MINIMUM_SCROLL_FRACTION)
	* viewRect.size.height;
	CGFloat heightFraction = numerator / denominator;
	if (heightFraction < 0.0)
	{
		heightFraction = 0.0;
	}
	else if (heightFraction > 1.0)
	{
		heightFraction = 1.0;
	}
	
	UIInterfaceOrientation orientation =
    [[UIApplication sharedApplication] statusBarOrientation];
	if (orientation == UIInterfaceOrientationPortrait ||
		orientation == UIInterfaceOrientationPortraitUpsideDown)
	{
		animatedDistance = floor(PORTRAIT_KEYBOARD_HEIGHT * heightFraction);
	}
	else
	{
		animatedDistance = floor(LANDSCAPE_KEYBOARD_HEIGHT * heightFraction);
	}
	
	CGRect viewFrame = self.view.frame;
    viewFrame.origin.y -= animatedDistance;
	
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationBeginsFromCurrentState:YES];
    [UIView setAnimationDuration:KEYBOARD_ANIMATION_DURATION];
	
    [self.view setFrame:viewFrame];
	
    [UIView commitAnimations];
	
}

@end
