//
//  TwitterDetailViewController.m
//  app_builder
//
//  Created by ivan bejarano on 7/28/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "TwitterDetailViewController.h"
#import "TBXML.h"
#import "Config.h"
#import "NSString+HTML.h"
#import "FontItem.h"
#import "Functions.h"

@implementation TwitterDetailViewController

@synthesize popover = _popover;
@synthesize twitterViewController;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
/*
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	/*NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	UIImage *tempImg = [[UIImage alloc] initWithData:imgData];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	[tempImg release];
	imageView.frame = CGRectMake(0, 0, 320, 430);
	[self.view addSubview:imageView];
	[imageView release];*/
	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
	
}

- (void) showList:(id)sender
{
    if (twitterViewController == nil) {
        // self.twitterViewController = [[[TwitterViewController alloc] initWithStyle:UITableViewStylePlain] autorelease];
    }
    // _ratingController.game = _game;
    
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
        UIButton *button = (UIButton *)sender;
        if (self.popover == nil) {
            Class classPopoverController = NSClassFromString(@"UIPopoverController");
            if (classPopoverController) {
                self.popover = [[[classPopoverController alloc] initWithContentViewController:twitterViewController] autorelease];
            }
        }
        [self.popover presentPopoverFromRect:button.frame inView:self.view permittedArrowDirections:UIPopoverArrowDirectionAny animated:YES];        
    }
}

- (void) showView
{
	NSString * title = @"Twitter";
	if (!created) {
		created = YES;
		[Functions initToolBar:self.view withTitle:title];
	// [self initStatusBar:self.view];

		/*if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
			UIToolbar * toolbar = (UIToolbar *)[self.view viewWithTag:10001];
			UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
			[backButton setFrame:CGRectMake(10,7,75,26)];
			[backButton setTitle:@"List" forState:UIControlStateNormal];
			[backButton addTarget:self action:@selector(showList:) forControlEvents:UIControlEventTouchUpInside];
			//backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
			[toolbar addSubview:backButton];
		}*/
		
	}

	Config * cnf = [[Config alloc] init];
	NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
	NSString * feedSource = [cnf loadValue:@"feedSource"];
	// NSURL *u = [NSURL URLWithString:feedSource];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	
	// NSMutableArray * detailData = [NSMutableArray arrayWithObjects:@"description", @"pubDate", nil];
	NSMutableArray * detailFields = [[[NSMutableArray alloc] init] autorelease];
	NSMutableArray * detailData = [[[NSMutableArray alloc] init] autorelease];

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;

	NSString  * twtStyleTitle = @"";
	NSString  * twtStyleDate = @"";
	
	BOOL f = FALSE;

	if (root) {
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"text_title"]) {
									// title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								else if ([attribItem isEqualToString:@"data_source"]) {
									// self.twtUrl = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								else if ([attribItem isEqualToString:@"detail_title"]) { // list_item_icon
									twtStyleTitle = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								}
								else if ([attribItem isEqualToString:@"detail_date"]) { // list_item_icon
									twtStyleDate = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					/*if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:twtUrl]) {
						childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									self.twtUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									self.twtUrl = [twtUrl urlUnescapedString];
								}
							}
						} while (childXMLElement = childXMLElement->nextSibling);
					}*/
				}
				
			} while ((appXMLElement = appXMLElement->nextSibling));

		
		}
	}

	UIWebView * webView = (UIWebView *)[self.view viewWithTag:50007];
	if (webView == nil) {
		NSLog(@"create wv");
		//UIWebView * 
		webView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 370)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
		webView.frame = CGRectMake(0, 50, self.view.frame.size.width, self.view.frame.size.height-85);
		webView.tag = 50007;
		webView.autoresizesSubviews = YES;
		webView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
		webView.delegate = self;
		[self.view addSubview:webView];
	}
	
	if (f) {
	NSMutableArray * tmpArray = [NSMutableArray arrayWithObjects:@"detail_title", @"description", @"field_entity", twtStyleTitle, nil];
	[detailFields addObject:tmpArray];
	tmpArray = [NSMutableArray arrayWithObjects:@"detail_desc", @"pubDate", @"field_entity", twtStyleDate, nil];
	[detailFields addObject:tmpArray];
	tmpArray = [NSMutableArray arrayWithObjects:@"detail_desc", @"guid", @"field_entity", twtStyleDate, nil];
	[detailFields addObject:tmpArray];

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
	NSData *myXMLData = [NSData dataWithContentsOfFile:fileName];
	NSLog(@"--*> %@", fileName);
	NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	// NSLog(@"--> %@", unescaped);

	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	
	// NSData *myXMLData   = [NSData dataWithContentsOfURL:u];
	// [myXMLData writeToFile:databasePath atomically:YES];
	// TBXML * tbxml = [[TBXML tbxmlWithXMLData:myXMLData] retain];
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
    [tbxml release];
	// childXMLElement = tbxml.rootXMLElement;
	// detailData = [NSMutableArray arrayWithCapacity:[detailFields count]+1]; 
	// [[NSMutableArray alloc]initWithArray:detailFields copyItems:YES];
	for(int i=0;i<[detailFields count];i++) {
		NSLog(@"1--> %@", [detailFields objectAtIndex:i]);
		// NSLog(@"2--> %@", [[detailFields objectAtIndex:i] objectAtIndex:2]);
		[detailData addObject:[[detailFields objectAtIndex:i] objectAtIndex:2]];
	}
	NSLog(@"data: %@", detailData);
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			
			// if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
			if (
				!([[TBXML elementName:childXMLElement] isEqualToString:@"error"]) &&
				!([[TBXML elementName:childXMLElement] isEqualToString:@"debug"])
				) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
                if (dataXMLElement)
                {
                    int counter = 0;
                    do {
                        NSLog(@"... ??? %@ --- %i %i", selectedListItem, counter, [detailFields count]);
                        if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
                            TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
                            do {
                                for(int i=0;i<[detailFields count];i++) {
                                    NSString * field = [[detailFields objectAtIndex:i] objectAtIndex:1];
                                    field = [field stringByReplacingOccurrencesOfString:@"_" withString:@":"];
                                    // NSLog(@"f: %@ == %@ arr: %@", [TBXML elementName:itemXMLElement], field, detailData);
                                    if ([[TBXML elementName:itemXMLElement] isEqualToString:field]) {
                                        if ([[[detailFields objectAtIndex:i] objectAtIndex:2] isEqualToString:@"image_entity"]) {
                                            // [detailData insertObject:[TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement] atIndex:i];
                                            [detailData replaceObjectAtIndex:i withObject:[TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement]];
                                        } else {
                                            // [detailData insertObject:[TBXML textForElement:itemXMLElement] atIndex:i];
                                            [detailData replaceObjectAtIndex:i withObject:[TBXML textForElement:itemXMLElement]];
                                        }
                                        break;
                                    }
                                }
                            } while ((itemXMLElement = itemXMLElement->nextSibling));
                            break;
                        }
                        counter++;
                    } while ((dataXMLElement = dataXMLElement->nextSibling));
                }
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
	}


	/*
	 UIWebView * webView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 380)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	webView.autoresizesSubviews = YES;
	webView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	webView.delegate = self;
		*/

		NSMutableString * head = [[NSMutableString alloc] init];
	NSMutableString * body = [[NSMutableString alloc] init];
	for(int i=0;i<[detailFields count];i++) {
		// NSLog(@"%i --> %@", i, [detailFields objectAtIndex:i]);
		// NSString * field = [[detailFields objectAtIndex:i] objectAtIndex:0];
		FontItem * font;
		if ([[[detailFields objectAtIndex:i] objectAtIndex:2] isEqualToString:@"image_entity"]) {
			[body appendString:[NSString stringWithFormat:@"<img src='%@' />", [detailData objectAtIndex:i]]];
		} else if ([[[detailFields objectAtIndex:i] objectAtIndex:2] isEqualToString:@"label"]) {
			NSString * aHref = @"";
			if ([[[detailFields objectAtIndex:i] objectAtIndex:0] isEqualToString:@"detail_title"])
				aHref = @"a";
			[body appendString:[NSString stringWithFormat:@"<p id='%@'>%@</p>", [[detailFields objectAtIndex:i] objectAtIndex:0], [[detailFields objectAtIndex:i] objectAtIndex:1]]];
			font = [Functions loadFont:[[detailFields objectAtIndex:i] objectAtIndex:3]]; 
			[head appendString:[NSString stringWithFormat:@"#%@ %@ { \n"
								"font-family:%@; \n"
								"font-size:%@px;\n"
								"color:%@; \n"
								"font-weight: %@; \n"
								"}\n",
								[[detailFields objectAtIndex:i] objectAtIndex:0],
								aHref,
								font.nameFont,
								font.sizeFont,
								font.colorFont,
								font.styleFont]];
		} else {
			NSString * aCss = @"";
			NSString * aHref = @"";
			NSString * aHrefEnd = @"";
			if ([@"detail_desc" isEqualToString:[[detailFields objectAtIndex:i] objectAtIndex:0]]) {
				aHref = [NSString stringWithFormat:@"<a href=\"%@\">", [detailData objectAtIndex:i]];
				aHrefEnd = @"</a>";
				aCss = @"a";
			}
			[body appendString:[NSString stringWithFormat:@"<p id='%@'>%@%@%@</p>", [[detailFields objectAtIndex:i] objectAtIndex:0], aHref, [detailData objectAtIndex:i], aHrefEnd]];
			font = [Functions loadFont:[[detailFields objectAtIndex:i] objectAtIndex:3]]; 
			[head appendString:[NSString stringWithFormat:@"#%@ %@ { \n"
								"font-family:%@; \n"
								"font-size:%@px;\n"
								"color:%@; \n"
								"font-weight: %@; \n"
								"}\n",
								[[detailFields objectAtIndex:i] objectAtIndex:0],
								aCss,
								font.nameFont,
								font.sizeFont,
								font.colorFont,
								font.styleFont]];
		}
	}
	// NSLog(@"b: %@", body);
	
	[webView setOpaque:NO];
	[webView setBackgroundColor:[UIColor clearColor]];
	
	NSString *myHtml = [NSString stringWithFormat:@"<html> \n"
						"<head> \n"
						"<meta name=\"viewport\" content=\"width=320\" />\n"
						"<script>\n"
						"function titleClicked(){\n"
						"	var clicked=true;\n"
						"	window.location=\"/\"+clicked;\n"
						"}\n"
						"</script>\n"
						"<style type=\"text/css\"> \n"
						"* {\n"
						"margin-top: 0em;\n"
						"margin-bottom: 0em;\n"
						"}\n"
						"body{background-color:transparent;}\n"
						"p {\n"
						"margin-top: 0em;\n"
						"margin-bottom: 0em;\n"
						"}\n"
						"%@"
						"</style> \n"
						"</head> \n"
						"<body>%@</body> \n"
						"</html>",
						head,
						body];
        [head release];
        [body release];

	// [webView setDelegate:self];
	// [webView loadHTMLString:myHtml baseURL:nil];
        [webView loadData:[myHtml dataUsingEncoding:NSUTF8StringEncoding]
                 MIMEType:@"text/html"
         textEncodingName:@"UTF-8"
                  baseURL:nil];
        
	}
	[cnf release];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

#pragma mark o

- (void) initStatusBar:(UIView *)actualView withType:(int)type
{
}

-(IBAction)goShare:(id) sender
{
}

-(void)hideShare
{
}

- (void)setParent: (UIViewController *)viewController
{
    parentView = viewController;
}

#pragma mark WebView

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
    if (navigationType == UIWebViewNavigationTypeLinkClicked) {
        [[UIApplication sharedApplication] openURL:request.URL];
        return false;
    }
    return true;
}

#pragma mark List Selection

-(void) ListSelectionChanged
{
	NSLog(@"changed...");
	[self showView];
    if (_popover != nil) {
        [_popover dismissPopoverAnimated:YES];
    }
}

#pragma mark Split View Delegate

- (void)splitViewController: (UISplitViewController*)svc willHideViewController:(UIViewController *)aViewController withBarButtonItem:(UIBarButtonItem*)barButtonItem forPopoverController: (UIPopoverController*)pc {
    barButtonItem.title = @"Sidebar";    
    
    NSLog(@"split 1... ////////////////////////////");
	// UINavigationItem *navItem = [self navigationItem];
	// [navItem setLeftBarButtonItem:barButtonItem animated:YES];
    
    self.popover = pc;
}

- (void)splitViewController: (UISplitViewController*)svc willShowViewController:(UIViewController *)aViewController invalidatingBarButtonItem:(UIBarButtonItem *)barButtonItem {    
    NSLog(@"split 2... ////////////////////////////");

	// UINavigationItem *navItem = [self navigationItem];
	// [navItem setLeftBarButtonItem:nil animated:YES];
    
    self.popover = nil;
    
}

@end
