//
//  TwitterViewController.m
//  app_builder
//
//  Created by ivan bejarano on 6/22/11.
//  Copyright 2011 Animacol. All rights reserved.
//

#import "TwitterViewController.h"
#import "Functions.h"
#import "Config.h"
#import "NSString+HTML.h"
// #import "TwitterTableViewCell.h"
#import "SA_OAuthTwitterEngine.h"
#import "FontItem.h"
#import <QuartzCore/QuartzCore.h>
#import "app_builderAppDelegate.h"
#import "TwitterDetailViewController.h"

@implementation TwitterViewController

// @synthesize tableView;
@synthesize waitLabel, twtUrl, twts;
@synthesize twtStyleTitle, twtStyleDate;
@synthesize twitterTitle, twitterDescription, twitterLink;
@synthesize kAppId, kOAuthConsumerKey, kOAuthConsumerSecret;
@synthesize delegate = _delegate;

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
    waitView.layer.shadowColor = [UIColor grayColor].CGColor;
    waitView.layer.shadowRadius = 1;
    waitView.layer.shadowOpacity = 0.5;
    waitView.layer.shadowOffset = CGSizeMake(0, 1);
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}

- (void) showAnimated:(id)sender{
	NSLog(@"start");
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

- (void) stopAnimated:(id)sender{
	NSLog(@"stop");
	[waitView stopAnimating];
	waitView.hidden=YES;
	waitLabel.text = @"";
}


// The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization.
    }
    return self;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	/*NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *filePath = [documentsDir stringByAppendingPathComponent:@"/gradientBackground.png"];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	// imageView.image = [[UIImage alloc] initWithData:imgData];
	UIImage *tempImg = [[UIImage alloc] initWithData:imgData];
	UIImageView *imageView = [[UIImageView alloc] initWithImage:tempImg];
	[imageView setImage:tempImg];
	[tempImg release];
	imageView.frame = CGRectMake(0, 0, 320, 410);
	[self.view addSubview:imageView];
	[imageView release];*/
    [super viewDidLoad];

	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		[self setContentSizeForViewInPopover:CGSizeMake(320.0, 400.0)];
	}
	
	NSLog(@"parent and self %@ %@", [self parentViewController], self);

	[self initWaitView];
	[self showAnimated:nil];
	[self performSelector:@selector(showView) withObject:nil afterDelay:0.5];
}

- (void) showView {

	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSLog(@"actualId: %@", actualId);

	UITableView * tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 44, 320, 340)]; // 410
	tableView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-85);
	tableView.tag = 5001;
	tableView.delegate = self;
	tableView.dataSource = self;
	tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
	tableView.backgroundColor = [UIColor clearColor];
	tableView.rowHeight = 80;
	tableView.autoresizingMask = (UIViewAutoresizingFlexibleRightMargin 
									   |  UIViewAutoresizingFlexibleHeight
									   | UIViewAutoresizingFlexibleTopMargin 
									   | UIViewAutoresizingFlexibleWidth);

	NSString * title = @"Twitter";
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;

	if (root) {
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				NSLog(@"actualId : %@ | idItem: %@ ", actualId, idItem);
				if ([actualId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				NSLog(@"id %@", [TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"text_title"]) {
									title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
								}
								else if ([attribItem isEqualToString:@"data_source"]) {
									self.twtUrl = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								else if ([attribItem isEqualToString:@"detail_title"]) { // list_item_icon
									self.twtStyleTitle = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								}
								else if ([attribItem isEqualToString:@"detail_date"]) { // list_item_icon
									self.twtStyleDate = [TBXML valueOfAttributeNamed:@"style_id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:twtUrl]) {
						childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"data_source_value"]) {
									self.twtUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									self.twtUrl = [twtUrl urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
				}

			} while ((appXMLElement = appXMLElement->nextSibling));
			NSLog(@"url: %@", twtUrl);
		}
	}
	
	[self.view addSubview:tableView];
	[Functions addToolBar:self.view withTitle:title actualId:actualId];
	[self initStatusBar:self.view withType:1];

	BOOL download = NO;
	
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	//NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	//NSString *documentsDir = [documentPaths objectAtIndex:0];
	//NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId]];
	NSString *displayIdValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId]];

	//if([displayIdValue isEqualToString:@""] || displayIdValue == nil
	//   || !([[NSFileManager defaultManager] fileExistsAtPath:fileName])) {
		NSLog(@"down ... ");
		// myXMLData = [NSData dataWithContentsOfURL:u];
		// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
		[dateFormat setDateFormat:@"YYYYMMddHHmm"];
		NSString *dateString = [dateFormat stringFromDate:date];  
		// [dateFormat release];
		if([displayIdValue isEqualToString:@""] || displayIdValue == nil)
			[cnf insertValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId] value:dateString];
		else
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId] value:dateString];
		// [loadWebService callWebService:webService methodName:callMethod 
		//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
		//[self goDownload];
		// download = NO;
	/*} else {
		
		//NSTimeInterval dateTime;		
		// NSDateFormatter *
		// dateFormat = [[[NSDateFormatter alloc] init] autorelease];
		[dateFormat setDateFormat:@"yyyyMMddHHmm"];
		NSDate *lastCheck = [dateFormat dateFromString:displayIdValue];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		//dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);
		/ *
        NSLog(@"t: %@ - %@", 
		 [dateFormat stringFromDate:date],
		 [dateFormat stringFromDate:[dateFormat dateFromString:@"201010150300"]]
		 );
		 NSLog(@" date = %@", date);
		 NSLog(@" date = %@", lastCheck);
		 * /
		int day1 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:date];
		int day2 = [[NSCalendar currentCalendar] ordinalityOfUnit:NSDayCalendarUnit inUnit:NSEraCalendarUnit forDate:lastCheck];
		NSLog(@"%i - %i * %@ - %@", day1, day2, [dateFormat stringFromDate:date], [dateFormat stringFromDate:lastCheck]);
		
		// if(dateTime > 1) {
		if(day1 != day2) {
			// if ([date timeIntervalSinceDate:lastCheck] >= 1 ) // today is before launch
			NSLog(@"down (2)... ");
			// myXMLData = [NSData dataWithContentsOfURL:u];
			// [dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
			[dateFormat setDateFormat:@"YYYYMMddHHmm"];
			NSString *dateString = [dateFormat stringFromDate:date];  
			// [dateFormat release];
			NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_19.xml", actualId],dateString);
			[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId] value:dateString];
			// [loadWebService callWebService:webService methodName:callMethod 
			//						  keys:keys values:keyvalues delegate:self requestSelector:@selector(dataLoaded:)];
			//download = YES;
			// [self goDownload];
		} else {
			// myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
			// [self processXml:[[NSData alloc] initWithContentsOfFile:fileName]];
			// [self showXML];
			//download = NO;
		}
	}*/
	[dateFormat release];
	[cnf release];
	// [tableView release];

	download = YES;
	
	if (download)
		[self goDownload];
	else
		[self showXML];

}

- (void) goDownload
{
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	NSString * pageSize = @"2";
	NSString * sortStr = @"";
	NSString * filterStr = @"";

	NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug",@"strNumpage",@"strPagesize",@"strSortBy",@"strFilterby",nil];
	NSArray *keyvalues = [NSArray arrayWithObjects:twtUrl, @"true", @"1", pageSize, sortStr, filterStr, nil];	

	// NSString *  = @"http://184.73.161.149:8040/services/get_rss.aspx";
	NSString * loadUrl = [cnf loadValue:@"servicesUrl"];
	loadUrl = [NSString stringWithFormat:@"%@/get_rss.aspx", loadUrl];
	
	NSString * post = @""; // [[NSString alloc] init];
	for (int i=0;i<[keys count];i++)
	{
		post = [post stringByAppendingString:[keys objectAtIndex:i]];
		post = [post stringByAppendingString:@"="];
		NSString * myString = [keyvalues objectAtIndex:i];
		myString = [myString stringByReplacingOccurrencesOfString:@"'" withString:@""];
		post = [post stringByAppendingString:[myString urlEscapedString]];
		post = [post stringByAppendingString:@"&"];
	}

	loadUrl = [loadUrl stringByAppendingString:[NSString stringWithFormat:@"?%@", post]];
	// NSLog(@"loadUrl : %@", loadUrl);
	NSURL *u = [NSURL URLWithString:loadUrl];
	NSMutableData *myXMLData = [NSData dataWithContentsOfURL:u];
	
	// copy from loaded
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"YYYYMMddHHmm"];
	NSString *dateString = [NSString stringWithFormat:@"%@", [dateFormat stringFromDate:date] ];  	
	[dateFormat release];
	NSLog(@"name d: %@ %@", [NSString stringWithFormat:@"tmp_%@_19.xml", actualId],dateString);
	// NSString *displayIdValue = [cnf loadValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId]];
	//if([displayIdValue isEqualToString:@""] || displayIdValue == nil)
	//	[cnf insertValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId] value:dateString];
	//else
	[cnf updateValue:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId] value:dateString];
	
	[cnf release];
	
	[self processXml:myXMLData];

}

- (void) processXml:(NSMutableData *)myXMLData
{
	NSLog(@"process");
	Config * cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	//tabbar
	// cnf = [[Config alloc] initWithName:@"useTabBar"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];// cnf.value;
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		displayId = [infoData valueForKey:@"idTab"];
	}

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_19.xml", displayId]];
	[cnf release];
	[myXMLData writeToFile:fileName atomically:YES];
	[self showXML];
	
}

- (void)showXML
{
	NSLog(@"show");
	Config * cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	//tabbar
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		// displayId = [Functions loadFromTabBar:self.tabBarItem.title];
		displayId = [infoData valueForKey:@"idTab"];
	}

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:[NSString stringWithFormat:@"tmp_%@_19.xml", displayId]];
	
	NSData *XMLData = [NSData dataWithContentsOfFile:fileName];  
	NSString *unescaped = [[[NSString alloc] initWithData:XMLData encoding:NSUTF8StringEncoding] autorelease];
	unescaped = [unescaped htmlUnescapedString];
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	TBXMLElement * childXMLElement;
	// elements = [[NSMutableArray alloc] initWithCapacity:10];
	// rootXMLElement = tbxml.rootXMLElement;
	// TBXMLElement * childXMLElement;
    [tbxml release];

	twts = [[NSMutableArray alloc] init];
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				if (!(childXMLElement->firstChild == nil)) {
					TBXMLElement * dataXMLElement = childXMLElement->firstChild;
					// NSInteger total = 1;
					do {
						TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
						NSMutableDictionary *twt = [[NSMutableDictionary alloc] init];
						do {
							// NSLog(@"sub %@ ?", [TBXML elementName:itemXMLElement]);
							//if ([[TBXML elementName:itemXMLElement] isEqualToString:@"description"]) {
							//	[twt setObject:[TBXML textForElement:itemXMLElement] forKey:@"description"];
							//}
							if ([[TBXML elementName:itemXMLElement] isEqualToString:@"title"]) {
								[twt setObject:[TBXML textForElement:itemXMLElement] forKey:@"description"];
							}
							else if ([[TBXML elementName:itemXMLElement] isEqualToString:@"pubDate"]) {
								[twt setObject:[TBXML textForElement:itemXMLElement] forKey:@"date"];
							}
						} while ((itemXMLElement = itemXMLElement->nextSibling));
						[twts addObject:twt];
						[twt release];
					} while ((dataXMLElement = dataXMLElement->nextSibling));
						
				} else {
					NSLog(@"data null...");
					UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"Empty list." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
					[alert show];
					[alert release];	
					[waitView stopAnimating];
					waitView.hidden=YES;
					waitLabel.hidden=YES;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling));


	}
	
	UITableView * tableView = (UITableView *)[self.view viewWithTag:5001];
	[tableView setContentOffset:CGPointZero animated:YES];
	[tableView reloadData];
	tableView.scrollEnabled = YES;
	[self stopAnimated:nil];
    [cnf release];
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
	{
		[self loadDetail:0];
		NSLog(@"first...");
	}
	
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations.
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc. that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)dealloc {
	self.delegate = nil;
	// [tableView release];
	[twtUrl release];
	[infoData release];
	[waitView release];
	[waitLabel release];
	[twtStyleTitle release];
	[twtStyleDate release];
    [super dealloc];
}

- (void) initStatusBar:(UIView *)actualView withType:(int)type
{

	//if ([self parentViewController] == nil)
	//	return;

	//tabbar
	Config *cnf = [[Config alloc] init];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	int tabSpace = 0;
	if ([tabbar isEqualToString:@"1"])
		tabSpace = 48;
	
	UIToolbar *toolbar = [UIToolbar new];
	toolbar.tag = 3001;
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 34; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	[toolbar setFrame:CGRectMake(0, 425-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 102.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, CGRectGetHeight(mainViewBounds)-tabSpace, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	toolbar.frame = CGRectMake(0, self.view.frame.size.height-toolbarHeight, self.view.frame.size.width, toolbarHeight);

	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	// toolbar.alpha = 0.7;
	
	toolbar.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);
	
	[actualView addSubview:toolbar];
	
	if (type == 1) {

	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goRefresh) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	button.frame = CGRectMake(288, 2, 30, 30);
		[button setFrame:CGRectMake(CGRectGetMaxX(mainViewBounds)-32, 2, 30, 30)];
		[button setFrame:CGRectMake([toolbar frame].size.width -32, 2, 30, 30)];
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage *btnImage = [UIImage imageNamed:@"tabbutton_refresh.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
		button.autoresizingMask = (UIViewAutoresizingFlexibleTopMargin 
								   | UIViewAutoresizingFlexibleLeftMargin);		
	[toolbar addSubview:button];
	
	// [button release];
	
	// info
	UIButton *infoButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[infoButton addTarget:self action:@selector(goInfo) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	infoButton.frame = CGRectMake(14, 2, 30, 30);
	btnImage = [UIImage imageNamed:@"info_icon.png"];
	// infoButton.tag = IMAGE_TAG;
	infoButton.backgroundColor = [UIColor clearColor];
	[infoButton setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	[toolbar addSubview:infoButton];
	// [infoButton release];
	// info

	// twit
	UIButton *twtButton = [UIButton buttonWithType:UIButtonTypeCustom];
	[twtButton addTarget:self action:@selector(goTwt:) forControlEvents:UIControlEventTouchUpInside];
	// const NSInteger IMAGE_TAG = 1003;
	// UIImage * btnImage = [UIImage alloc];
	twtButton.frame = CGRectMake(49, 3, 91, 30);
	btnImage = [UIImage imageNamed:@"button_twitter.png"];
	// infoButton.tag = IMAGE_TAG;
	twtButton.backgroundColor = [UIColor clearColor];
	[twtButton setImage:btnImage forState:UIControlStateNormal];
	btnImage = [UIImage imageNamed:@"button_twitter_hover.png"];
	[twtButton setImage:btnImage forState:UIControlStateSelected];
	// [btnImage release];
	[toolbar addSubview:twtButton];
	// twit

	if ([[infoData valueForKey:@"userConfig"] isEqualToString:@"true"]) {
		
		// config
		UIButton *configButton = [UIButton buttonWithType:UIButtonTypeCustom];
		[configButton addTarget:self action:@selector(goConfig) forControlEvents:UIControlEventTouchUpInside];
		// const NSInteger IMAGE_TAG = 1003;
		// UIImage * btnImage = [UIImage alloc];
		configButton.frame = CGRectMake(56, 2, 30, 30);
		btnImage = [UIImage imageNamed:@"icon_user_settings.png"];
		// infoButton.tag = IMAGE_TAG;
		configButton.backgroundColor = [UIColor clearColor];
		[configButton setImage:btnImage forState:UIControlStateNormal];
		// [btnImage release];
		[toolbar addSubview:configButton];
		// [infoButton release];
		// config
	}
	
	UILabel *
	label = [[UILabel alloc] initWithFrame:
			 CGRectMake(100,3,185,30)];
	label.tag = 3002;
    label.autoresizingMask = UIViewAutoresizingFlexibleWidth;
		label.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								  | UIViewAutoresizingFlexibleRightMargin 
								  | UIViewAutoresizingFlexibleLeftMargin 
								  | UIViewAutoresizingFlexibleTopMargin 
								  | UIViewAutoresizingFlexibleWidth);		[label setFrame:CGRectMake(CGRectGetMaxX(mainViewBounds)-225, 3, 185, 30)];
		[label setFrame:CGRectMake(self.view.frame.size.width-225, 3, 185, 30)];
    /*
	 NSDateFormatter *formatter = [[[NSDateFormatter alloc] init] autorelease];
	 NSDate *date = [NSDate date];
	 [formatter setDateFormat:@"MM/dd/YY HH:mm"];
	 // [label setText:[formatter stringFromDate:date]];
	 [label setText:[NSString stringWithFormat:@"Updated: %@", [formatter stringFromDate:date]]];
	 */
	NSString * displayId = [cnf loadValue:@"actualId"];
	// NSLog(@"tb: %@", tabbar);
	// NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"]) {
		displayId = [infoData valueForKey:@"idTab"];
	}
	NSString *newName = [NSString stringWithFormat:@"tmp_%@_19.xml", displayId];
	// NSLog(@"name 2: %@", newName);
	NSString *newNameValue = [cnf loadValue:newName];
	
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"yyyyMMddHHmm"];
	NSDate *lastCheck = [dateFormat dateFromString:newNameValue];
	// NSLog(@"date: %@", cnf.value);
	// NSLog(@"date 2: %@", [dateFormat stringFromDate:lastCheck]);
	
	[dateFormat setDateFormat:@"MM/dd/YY HH:mm"];
	[label setText:[NSString stringWithFormat:@"Updated: %@", [dateFormat stringFromDate:lastCheck]]];
        [dateFormat release];
	
    label.backgroundColor = [UIColor clearColor];
    // label.backgroundColor = [UIColor blueColor];
    label.textColor = [UIColor whiteColor];
    label.font = [UIFont boldSystemFontOfSize:11];
    label.textAlignment = UITextAlignmentRight;
	
		[toolbar addSubview:label];
		[label release];

	} else if (type == 2) {

		if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad)
		[toolbar setFrame:CGRectMake(0, 460-toolbarHeight, CGRectGetWidth(mainViewBounds), toolbarHeight)];

		// [self hidetabbar];
		/*
		UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
		[button addTarget:self action:@selector(goShare:) forControlEvents:UIControlEventTouchUpInside];
		UIImage * btnImage = [UIImage alloc];
		button.frame = CGRectMake(2, 2, 30, 30);
		btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
		button.backgroundColor = [UIColor clearColor];
		[button setImage:btnImage forState:UIControlStateNormal];
		[toolbar addSubview:button];
		*/
		
		UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
		[backButton setFrame:CGRectMake(260,7,50,26)];
		[backButton setTitle:@"Back" forState:UIControlStateNormal];
		[backButton addTarget:self action:@selector(goList) forControlEvents:UIControlEventTouchUpInside];
		backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
		[toolbar addSubview:backButton];
	}
	
	    [toolbar release];

	[cnf release];
}

- (void) goList
{
	NSLog(@"back...");

	UIView * detailView = (UIView *)[self.view viewWithTag:190001];
	[self hidetabbar];
	[detailView removeFromSuperview];
	detailView = nil;
	[detailView release];
}

- (void) goInfo {
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];*/
	// [Functions updateConfig:@"goInfo" withValue:@"1"];
	app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
	[appDelegate displayView:@"9"];
}

- (void)setParent: (TwitterSplitViewController *)viewController
{
    parentView = viewController;
}

# pragma mark tableView Delegate

//- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
//	return [twts count];
//}

/*- (NSIndexPath *)tableView :(UITableView *)theTableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	return nil;
}*/

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [twts count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
	static NSString *CellIdentifier = @"Cell";

	NSMutableDictionary *twt = (NSMutableDictionary *)[twts objectAtIndex:indexPath.row];
	
	/*TwitterTableViewCell *cell = (TwitterTableViewCell *)[tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if(cell == nil)
	{
		cell = [[[TwitterTableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = @"/bg_cell.png"; // button_right.png";
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	
	CGRect a=CGRectMake(0, 0, 100, 100);
	UIImageView *bImg=[[UIImageView alloc] initWithFrame:a];
	bImg.image=[[UIImage alloc] initWithData:imgData]; 
	// cell.selectedBackgroundView=bImg;
	//cell.backgroundView = bImg;
	
	// cell.imageView.image = [[UIImage alloc] initWithData:imgData];
	// cell.backgroundColor = [UIColor redColor];
	// [self.view addSubview:imgData];

	
	cell.twitText = [twt objectForKey:@"description"];
	cell.twitDate = [twt objectForKey:@"date"];

	[cell setNeedsDisplay];

	return cell;

	 */
	UILabel * topLabel;
	UILabel *bottomLabel;

	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		// cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];

		topLabel = [[[UILabel alloc] init] autorelease];
		topLabel.tag = 4001;
		bottomLabel = [[[UILabel alloc] init] autorelease];
		bottomLabel.tag = 4002;
		
		// Set up the cell...
		CGRect newTopLabelFrame = CGRectMake(10, 10, 275, 40);
		CGRect newBottomLabelFrame = CGRectMake(10, 52, 275, 20);
		// CGRect newThumbnailFrame = CGRectZero;
		// newThumbnailFrame = CGRectMake(5, 5, 60, 60);
		
		topLabel.frame = newTopLabelFrame;
		[cell.contentView addSubview:topLabel];
		topLabel.backgroundColor = [UIColor clearColor];
		
		bottomLabel.backgroundColor = [UIColor clearColor];
		bottomLabel.frame = newBottomLabelFrame;
		[cell.contentView addSubview:bottomLabel];
	
	}
	else {
		topLabel = (UILabel *)[cell viewWithTag:4001];
		bottomLabel = (UILabel *)[cell viewWithTag:4002];
	}

	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = @"/bg_cell.png"; // button_right.png";
	NSString *filePath = [documentsDir stringByAppendingPathComponent:fileName];
	NSData *imgData = [NSData dataWithContentsOfFile:filePath];
	cell.imageView.image = [UIImage imageWithData:imgData];
	topLabel.lineBreakMode = UILineBreakModeWordWrap;
	topLabel.numberOfLines = 2;
	topLabel.backgroundColor = [UIColor clearColor];
	bottomLabel.backgroundColor = [UIColor clearColor];
	topLabel.text = [twt objectForKey:@"description"];
	
	FontItem * font = [Functions loadFont:twtStyleTitle]; 
	NSString * titleFont = font.nameFont;
	NSString * titleSize = font.sizeFont;  
	NSString * titleColor = font.colorFont;
	NSString * titleStyle = font.styleFont;
	if (titleFont != nil) {
		if ([titleStyle isEqualToString:@"bold"]) {
			// element.titleFont = [[element.titleFont autorelease] stringByAppendingString:@"-Bold"];
			titleFont = [titleFont stringByAppendingString:@"-Bold"];
		} else if ([titleStyle isEqualToString:@"italic"]) {
			titleFont = [titleFont stringByAppendingString:@"-Oblique"];
		} else if ([titleStyle isEqualToString:@"bold-italic"]) {
			titleFont = [titleFont stringByAppendingString:@"-BoldOblique"];
		} else {
			// titleFont = titleFont;
		}
		titleFont = [Functions fontName:titleFont fontStyle:titleStyle];
		topLabel.font = [UIFont fontWithName:titleFont size:[titleSize intValue]];
		topLabel.textColor = [Functions colorForHex: titleColor];
	}
	
	bottomLabel.text = [twt objectForKey:@"date"];

	font = [Functions loadFont:twtStyleDate]; 
	titleFont = font.nameFont;
	titleSize = font.sizeFont;  
	titleColor = font.colorFont;
	titleStyle = font.styleFont;
	
	if (titleFont != nil) {
		if ([titleStyle isEqualToString:@"bold"]) {
			// element.titleFont = [[element.titleFont autorelease] stringByAppendingString:@"-Bold"];
			titleFont = [titleFont stringByAppendingString:@"-Bold"];
		} else if ([titleStyle isEqualToString:@"italic"]) {
			titleFont = [titleFont stringByAppendingString:@"-Oblique"];
		} else if ([titleStyle isEqualToString:@"bold-italic"]) {
			titleFont = [titleFont stringByAppendingString:@"-BoldOblique"];
		} else {
			// titleFont = titleFont;
		}
		titleFont = [Functions fontName:titleFont fontStyle:titleStyle];
		bottomLabel.font = [UIFont fontWithName:titleFont size:[titleSize intValue]];
		bottomLabel.textColor = [Functions colorForHex: titleColor];
	}
	
	[cell setBackgroundColor:[UIColor clearColor]];
	
	fileName = @"/indicator.png";
	filePath = [documentsDir stringByAppendingPathComponent:fileName];
	imgData = [NSData dataWithContentsOfFile:filePath];
	UIImage *indicatorImage = [UIImage imageWithData:imgData];
	cell.accessoryView =
	[[[UIImageView alloc]
	  initWithImage:indicatorImage]
	 autorelease];

	return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
	[tableView deselectRowAtIndexPath:indexPath animated:YES];
	[self loadDetail:indexPath.row];
}

- (void) loadDetail: (int) row
{
	NSLog(@"select");
	Config * cnf = [[Config alloc] init];
	NSString * actualId = [cnf loadValue:@"actualId"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	if ([tabbar isEqualToString:@"1"]) {
		actualId = [infoData valueForKey:@"idTab"];
	}
	
	[cnf updateValue:@"selectedListItem" value:[NSString stringWithFormat:@"%i", row]];
	[cnf updateValue:@"goUrl" value:@"---"];
	[cnf updateValue:@"feedSource" value:[NSString stringWithFormat:@"tmp_%@_19.xml", actualId]];
	[cnf release];
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
	{
		NSLog(@"go?");
		if (_delegate != nil) {
			NSLog(@"delegate");
			[_delegate ListSelectionChanged];
		}
		return;
	}
	[self goDetail];
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
	// This method must exist to enable swipe-to-delete
}

#pragma mark twt

// twitter
-(IBAction) goTwt: (id) sender {
	if ([parentView isKindOfClass:[SilSplitViewController class]])
    {
        [parentView goTwt];
        return;
    }

    Config *cnf = [[Config alloc] init];
	// kOAuthConsumerKey = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_key"]];
	// kOAuthConsumerSecret = [NSString stringWithFormat:@"%@", [cnf loadValue:@"twitter_consumer_secret"]];
	kOAuthConsumerKey = [cnf loadValue:@"twitter_consumer_key"];
	kOAuthConsumerSecret = [cnf loadValue:@"twitter_consumer_secret"];
	[cnf release];
	
	NSLog(@"t2:  %@ %@", kOAuthConsumerKey, kOAuthConsumerSecret);
	
	// if (_engine) return;
	_engine = [[SA_OAuthTwitterEngine alloc] initOAuthWithDelegate: self];
	_engine.consumerKey = kOAuthConsumerKey;
	_engine.consumerSecret = kOAuthConsumerSecret;
	
	UIViewController		*controller = [SA_OAuthTwitterController controllerToEnterCredentialsWithTwitterEngine: _engine delegate: self];
	
	if (controller) 
		[self presentModalViewController: controller animated: YES];
	else {
		// snd update
		[self createTwitterView];
	}
}

-(void) closeTwitter {
	if (twitterView != nil) {
		[twitterView removeFromSuperview];
		twitterView = nil;
	} 
}

-(IBAction) sendTwitter: (id) sender {
	NSString *message = [NSString stringWithFormat:@"%@", twitterMessageText.text];
	
	
	NSLog(@"send %@", message);
	[_engine sendUpdate: message];
}

-(void) createTwitterView {
	twitterView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 50, 320, 370)]; //  SCREENWIDTH, SCREENHEIGHT)];//init and create the UIWebView
	twitterView.autoresizesSubviews = YES;
	twitterView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	// [twitterView setBackgroundColor:[Functions colorForHex:@"#9AE4E8"]];
	
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	[button addTarget:self action:@selector(closeTwitter) forControlEvents:UIControlEventTouchUpInside];
	// UIImage * btnImage = [UIImage alloc];
	button.frame = CGRectMake(300, 5, 20, 20);
	UIImage * btnImage = [UIImage imageNamed:@"close.png"];
	button.backgroundColor = [UIColor clearColor];
	[button setImage:btnImage forState:UIControlStateNormal];
	[twitterView addSubview:button];
	
	twitterMessageText = [[UITextView alloc] initWithFrame:CGRectMake(10,30,300,80)];
	// twitterMessageText.delegate = self;
	// twitterMessageText.text = [NSString stringWithFormat:@"%@ : %@ - %@", 
	//						   twitterDescription, twitterTitle, twitterLink];
	twitterMessageText.layer.cornerRadius = 5;
	//twitterMessageText.clipsToBounds = YES;
	//twitterMessageText.layer.masksToBounds = YES;
	twitterMessageText.layer.borderColor = [[UIColor blackColor] CGColor];
	twitterMessageText.layer.borderWidth = 1.0f;
	
	UIButton   * updateButton;
	updateButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[updateButton setFrame:CGRectMake(10,130,60,30)];
	[updateButton setTitle:@"Update" forState:UIControlStateNormal];
	updateButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[updateButton addTarget:self action:@selector(sendTwitter:) forControlEvents:UIControlEventTouchUpInside];
	
	[twitterView addSubview:twitterMessageText];
	[twitterView addSubview:updateButton];
	
	[self.view addSubview:twitterView];
}

- (BOOL)textView:(UITextView *)textView shouldChangeTextInRange:(NSRange)range 
 replacementText:(NSString *)text
{
    // Any new character added is passed in as the "text" parameter
    if ([text isEqualToString:@"\n"]) {
        // Be sure to test for equality using the "isEqualToString" message
        [textView resignFirstResponder];
		
        // Return FALSE so that the final '\n' character doesn't get added
        return FALSE;
    }
    // For any other character return TRUE so that the text gets added to the view
    return TRUE;
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterEngineDelegate
- (void) storeCachedTwitterOAuthData: (NSString *) data forUsername: (NSString *) username {
	NSUserDefaults			*defaults = [NSUserDefaults standardUserDefaults];
	
	[defaults setObject: data forKey: @"authData"];
	[defaults synchronize];
}

- (NSString *) cachedTwitterOAuthDataForUsername: (NSString *) username {
	return [[NSUserDefaults standardUserDefaults] objectForKey: @"authData"];
}

//=============================================================================================================================
#pragma mark SA_OAuthTwitterControllerDelegate
- (void) OAuthTwitterController: (SA_OAuthTwitterController *) controller authenticatedWithUsername: (NSString *) username {
	NSLog(@"Authenicated for %@", username);
    // snd update
    [self createTwitterView];
}

- (void) OAuthTwitterControllerFailed: (SA_OAuthTwitterController *) controller {
	NSLog(@"Authentication Failed!");
}

- (void) OAuthTwitterControllerCanceled: (SA_OAuthTwitterController *) controller {
	NSLog(@"Authentication Canceled.");
}

//=============================================================================================================================
#pragma mark TwitterEngineDelegate
- (void) requestSucceeded: (NSString *) requestIdentifier {
	NSLog(@"Request %@ succeeded", requestIdentifier);
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle:@"Information sent."
						  message:nil
						  delegate:nil
						  cancelButtonTitle:nil
						  otherButtonTitles:@"OK", nil];
	[alert show];
    [alert release];
	[self closeTwitter];
	[self goDownload];
}

- (void) requestFailed: (NSString *) requestIdentifier withError: (NSError *) error {
	NSLog(@"Request %@ failed with error: %@", requestIdentifier, error);
	UIAlertView *alert = [[UIAlertView alloc]
						  initWithTitle:@"Error sending."
						  message:nil
						  delegate:nil
						  cancelButtonTitle:nil
						  otherButtonTitles:@"OK", nil];
	[alert show];
    [alert release];
}

- (void) hidetabbar
{
	if (UI_USER_INTERFACE_IDIOM() != UIUserInterfaceIdiomPad)
	{
	[UIView beginAnimations:nil context:NULL];
	[UIView setAnimationDuration:0.5];
	
	for(UIView *view in self.tabBarController.view.subviews)
	{
		// NSLog(@"%@", view);
		
		if([view isKindOfClass:[UITabBar class]])
		{
			
			if (hiddenTabBar) {
				[view setFrame:CGRectMake(view.frame.origin.x, 411, view.frame.size.width, view.frame.size.height)];
			} else {
				[view setFrame:CGRectMake(view.frame.origin.x, 480, view.frame.size.width, view.frame.size.height)];
			}
		} else {
			if (hiddenTabBar) {
				[view setFrame:CGRectMake(view.frame.origin.x, view.frame.origin.y, view.frame.size.width, 411)];
			} else {
				[view setFrame:CGRectMake(view.frame.origin.x, view.frame.origin.y, view.frame.size.width, 480)];
			}
			
		}
	}
	
	[UIView commitAnimations];
	
	hiddenTabBar = !hiddenTabBar;

	}
}

- (void) goDetail
{
	// int tabSpace = 0;
	[self hidetabbar];
	TwitterDetailViewController * detailView = [[TwitterDetailViewController alloc] 
												initWithData:infoData 
												nibName:@"TwitterDetailViewController" bundle:[NSBundle mainBundle]];
	//									 initWithFrame:CGRectMake(0, 0, 320, 460-44-tabSpace)];
	// sendImg.frame = CGRectMake(0.0f, 0.0f, 320.0f, 460.0f);
	// sendImg.view.frame = CGRectMake(0, 0, 200, 200);
	detailView.view.tag = 190001;
	[detailView setParent:self];
	[self initStatusBar:detailView.view withType:2];
	[self.view addSubview:detailView.view];
	// [detailView release];
}

@end
