//
//  VideoViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 11/10/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "VideoViewController.h"
#import <MediaPlayer/MediaPlayer.h>
#import "app_builderAppDelegate.h"
#import "Functions.h"
#import "Config.h"
#import "NSString+HTML.h"

#define degreesToRadian(x) (M_PI * (x) / 180.0)

@implementation VideoViewController
@synthesize waitLabel;

- (void) moviePlayBackDidFinish:(NSNotification*)notification 
{
	// Stop all notifications
	NSLog(@"end");
	[[NSNotificationCenter defaultCenter] removeObserver:self
													name:NULL
												  object:nil];
		// [movieURL release];
	//[moviePlayer release];
	//[Functions goMenu:nil];
	[self goMenu:nil];
	
}


- (void)goMenu:(id)sender{
	// -(void)goMenu{
	
	NSLog(@"exit...");
	@try {

		[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
		[[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleDefault animated:NO];
		[[UIApplication sharedApplication] setStatusBarHidden:NO withAnimation:UIStatusBarAnimationNone];

		//app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
		if (moviePlayer)
		[moviePlayer stop];
		//[moviePlayer release];
		// [Functions goMenu:nil];
		// detail
		Config * cnf = [[Config alloc] init];
		NSString * displayId = [cnf loadValue:@"displayId"];
		
		NSString * goId;
		NSString * goType;
		
		TBXMLElement * root = [Functions readConfigXmlFile];
		TBXMLElement * childXMLElement;
		TBXMLElement * feedsXMLElement;
		TBXMLElement * appXMLElement;
		
		if (root) {
			
			BOOL f = FALSE;
			childXMLElement = root->firstChild;
			
			do {
				// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
					NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
					// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					if ([displayId isEqualToString:idItem]) {
						f = TRUE;
						feedsXMLElement = childXMLElement;
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
			
			if (f) {
				appXMLElement = feedsXMLElement->firstChild;
				do {
					if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
						
						if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
							TBXMLElement * childXMLElement = appXMLElement->firstChild;;
							do {
								if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"video_done"]) {
										goId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
										if ([goId isEqualToString:@""] || goId ==  nil) goId = @"1";
									}
								}
							} while ((childXMLElement = childXMLElement->nextSibling));
						}				
					}
				} while ((appXMLElement = appXMLElement->nextSibling));
			}
			
			f = FALSE;
			childXMLElement = root->firstChild;
			
			do {
				// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
					NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
					// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					if ([goId isEqualToString:idItem]) {
						f = TRUE;
						goType = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
			
			
			
		}
		NSLog(@"go: %@ - %@", goId, goType);
		[cnf updateValue:@"displayId" value:goId];
		app_builderAppDelegate *appDelegate = [[UIApplication sharedApplication] delegate];
		[appDelegate displayView:goType];
		
		[cnf release];
	}
	@catch (NSException * e) {
		
	}
	@finally {
		
	}
	
}

- (void) initStatusBar:(UIView *)actualView {
	// NSString *title =@"Video";
	UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 108.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	
	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	
	[actualView addSubview:toolbar];
	
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goShare:) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	// btnImage = [UIImage alloc];
	button.frame = CGRectMake(2, 2, 30, 30);
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage * btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	
	// [toolbar addSubview:button];
	/*
	 UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	 [button setFrame:CGRectMake(260,10,50,26)];
	 [button setTitle:@"View" forState:UIControlStateNormal];
	 [button addTarget:self action:@selector(goView:) forControlEvents:UIControlEventTouchUpInside];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 [toolbar addSubview:button];
	 // [button release];
	 */
	
	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,10,50,26)];
	[backButton setTitle:@"Done" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goMenu:) forControlEvents:UIControlEventTouchUpInside];
	backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	[toolbar addSubview:backButton];
	// [backButton release];
	    [toolbar release];

}


- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation {
    [[moviePlayer view] setFrame: [self.view bounds]]; 
}

- (void) showAnimated:(id)sender{
	[waitView startAnimating];
	waitView.hidden=NO;
	waitLabel.text = @"Loading...";
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	// [self initWaitView];
    [Functions initWaitView:self.view];
	/*NSThread *thrAni=[[NSThread alloc] initWithTarget:self
											 selector:@selector(showAnimated:) object:self];
	[thrAni start];*/
	self.view.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;

	NSLog(@"123");

	Config *cnf = [[Config alloc] init];
	NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
	NSString * feedSource = [cnf loadValue:@"feedSource"];
	NSString * displayId = [cnf loadValue:@"displayId"];
	NSString * fieldName = @"";
	
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"idItem: %@ : %@ ", displayId, idItem);
				if ([displayId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));

		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							NSLog(@"item? %@", [TBXML elementName:childXMLElement] );
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"video_done"]) {
									// goId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
								}
								if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"video_url"]) {
									fieldName = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									// goId = [TBXML valueOfAttributeNamed:@"link_to_ref" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}				
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
		}
	}
	
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
	NSData *myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
	NSString *unescaped = [[NSString alloc] initWithData:myXMLData encoding:NSASCIIStringEncoding];
	unescaped = [unescaped htmlUnescapedString];
	// NSLog(@"--> %@", unescaped);
	
	TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
	TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
	NSString * goUrl = @"";
	if (rootXMLElement) {
		childXMLElement = rootXMLElement->firstChild;
		do {
			NSLog(@"data ? %@",[TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
				TBXMLElement * dataXMLElement = childXMLElement->firstChild;
				// NSInteger total = 1;
				int counter = 0;
				do {
					if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
						TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
						do {
							if ([[TBXML elementName:itemXMLElement] isEqualToString:@"media:content"]
								|| [fieldName isEqualToString:[TBXML elementName:itemXMLElement]]) {
								goUrl = [TBXML valueOfAttributeNamed:@"url" forElement:itemXMLElement];
                                if ([goUrl isEqualToString:@""] || goUrl == nil)
                                    goUrl = [TBXML textForElement:itemXMLElement];
                                break;
							}
						} while ((itemXMLElement = itemXMLElement->nextSibling));
					}
					counter++;
				} while ((dataXMLElement = dataXMLElement->nextSibling));
			}
		} while ((childXMLElement = childXMLElement->nextSibling));
	}

	NSLog(@"video... %@", goUrl);
	if (goUrl == nil) return;

	NSRange range = [goUrl rangeOfString:@"mp3"];
	if (range.location == NSNotFound)
	{

		@try {
		moviePlayer = [[MPMoviePlayerController alloc] initWithContentURL:[NSURL URLWithString:goUrl]];
			[self.view addSubview:moviePlayer.view];
            [Functions showAnimated:self.view];
		[[NSNotificationCenter defaultCenter] addObserver:self 
												 selector:@selector(moviePlayBackDidFinish:) 
													 name:MPMoviePlayerPlaybackDidFinishNotification  object:nil];	
            //[[NSNotificationCenter defaultCenter] addObserver:self 
            //                                         selector:@selector(moviePlayerLoadStateChanged:) 
            //                                             name:MPMoviePlayerNowPlayingMovieDidChangeNotification object:nil];

            [[NSNotificationCenter defaultCenter] addObserver:self 
												 selector:@selector(moviePlayerLoadStateChanged:) 
													 name:MPMoviePlayerLoadStateDidChangeNotification object:nil];
		

		if ([moviePlayer respondsToSelector:@selector(view)]){

			//[[UIApplication sharedApplication] setStatusBarHidden:YES withAnimation: UIStatusBarAnimationSlide];
			moviePlayer.view.frame = [[UIScreen mainScreen] applicationFrame];
			moviePlayer.view.transform = CGAffineTransformMakeRotation(1.57079633);
			
			moviePlayer.view.bounds = CGRectMake(30, 0, 480, 320);
			if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
				moviePlayer.view.bounds = CGRectMake(30, 0, 1024, 768);
			//moviePlayer.view.frame = self.view.frame;
			//moviePlayer.view.bounds = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
			moviePlayer.controlStyle = MPMovieControlStyleFullscreen;
			
			// moviePlayer.movieControlMode = MPMovieControlModeDefault;
			moviePlayer.scalingMode = MPMovieScalingModeAspectFill;

 
			// moviePlayer.autoresizingMask = (UIViewAutoresizingFlexibleTopMargin 
			//						   | UIViewAutoresizingFlexibleLeftMargin);

			//[[[UIApplication sharedApplication] keyWindow] addSubview: moviePlayer.view];

		}
		
			/*
			 UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
			 [backButton setFrame:CGRectMake(260,10,50,26)];
			 [backButton setTitle:@"Done" forState:UIControlStateNormal];
			 [backButton addTarget:self action:@selector(goMenu:) forControlEvents:UIControlEventTouchUpInside];
			 backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
			 //[self.view addSubview:backButton];
			 [backButton release];
			 */
			[moviePlayer play];
			//[[UIDevice currentDevice] beginGeneratingDeviceOrientationNotifications];
			//[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(receivedRotate:) name: UIDeviceOrientationDidChangeNotification object: nil];
		}
		@catch (NSException * e) {
			
		}
		@finally {
			
		}
	} else { // mp3
		NSLog(@"mp3...");
		UIWebView *webView = [[UIWebView alloc] initWithFrame: CGRectMake(0.0, 0.0, 320.0, 460.0)];  
		webView.delegate = self;  

		// NSString * myMP3URL = @"http://192.168.0.150/mp3/mj.mp3";
		int myTimeoutValue = 10;
		NSURLRequest *request = [[NSURLRequest alloc] initWithURL:[NSURL URLWithString:goUrl] cachePolicy: NSURLRequestUseProtocolCachePolicy timeoutInterval: myTimeoutValue];  

		[webView loadRequest:request];
		[self.view addSubview:webView];
		
		[request release];  
		[webView release];  
		[self initStatusBar:self.view];
	}
	// Start the movie  
	
	[cnf updateValue:@"goUrl" value:@"---"];
	[cnf release];
}

- (void) viewWillAppear:(BOOL)animated {
	NSLog(@"will...");
}

- (void) viewDidAppear:(BOOL)animated {
	NSLog(@"did");
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[moviePlayer release];
	[movieURL release];
	[waitLabel release];
	[shareView release];
	[waitView release];
    [super dealloc];
}

-(void) initWaitView{
	CGRect progressFrame = CGRectMake(135, 135, 50, 50);
	waitView = [[[UIActivityIndicatorView alloc] initWithFrame:progressFrame] autorelease];
	waitView.activityIndicatorViewStyle=UIActivityIndicatorViewStyleWhiteLarge;
	waitView.hidesWhenStopped=YES;
	[self.view addSubview: waitView];
	
	waitLabel = [[UILabel alloc] initWithFrame:CGRectMake(0, 205, 320, 25)];
	waitLabel.text = @"";
	waitLabel.backgroundColor = [UIColor clearColor];
	[waitLabel setFont:[UIFont fontWithName:[Functions fontName:@"Arial" fontStyle:@"bold"] size:14]];
	waitLabel.textColor = [Functions colorForHex:@"#aaaaaa"];
	waitLabel.textAlignment = UITextAlignmentCenter; // UITextAlignmentLeft; // UIControlContentHorizontalAlignmentLeft;
	waitLabel.lineBreakMode = UILineBreakModeWordWrap;
	waitLabel.numberOfLines = 0;
	waitLabel.shadowColor = [UIColor grayColor];
	waitLabel.shadowOffset = CGSizeMake(1,1);
	// waitLabel.textColor = [UIColor blueColor];
	[self.view addSubview:waitLabel];
}



- (void) moviePlayerLoadStateChanged:(NSNotification*)notification {
	
	
	switch ([moviePlayer loadState]) {
		case MPMovieLoadStatePlayable:
			// [waitView stopAnimating];
			// waitView.hidden=YES;
			// waitLabel.hidden=YES;
            [Functions stopAnimated:self.view];
			[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeRight animated:YES];
			break;
		case MPMovieLoadStateStalled:
			//UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Platts" message:@"You do not have an internet connection. Please check your settings and try again later." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
			//[alert show];
			//[alert release];
			break;
	}
	
	
	
}



- (void) movieFinishedCallback:(NSNotification*) aNotification {
    MPMoviePlayerController *player = [aNotification object];
    [[NSNotificationCenter defaultCenter] 
	 removeObserver:self
	 name:MPMoviePlayerPlaybackDidFinishNotification
	 object:player];    
    //[player autorelease];
	NSLog(@"go?");
}
/*
-(void) receivedRotate: (NSNotification*) notification
{
	UIDeviceOrientation interfaceOrientation = [[UIDevice currentDevice] orientation];
	
	if(interfaceOrientation != UIDeviceOrientationUnknown)
		[self deviceInterfaceOrientationChanged:interfaceOrientation];
}
*/

- (void)deviceInterfaceOrientationChanged:(UIInterfaceOrientation)interfaceOrientation {
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return YES;
}

@end
