//
//  WebViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 11/10/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "WebViewController.h"
#import "Config.h"
#import "Functions.h"
#import "NSString+HTML.h"

@implementation WebViewController

@synthesize openLink;
@synthesize textUrl, textTitle;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

- (id)initWithData:(NSDictionary *)data nibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        infoData = data;
    }
    return self;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	BOOL showStatus = NO;
	NSString * title = @" ";
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"actualId"];
	NSString * goUrl = [cnf loadValue:@"goUrl"];
	NSString * tabbar = [cnf loadValue:@"useTabBar"];
	NSLog(@"tb: %@", tabbar);
	NSLog(@"title: %@", self.tabBarItem.title);
	// NSLog(@"title: %i", self.tabBarController.selectedIndex);
	if ([tabbar isEqualToString:@"1"])
		displayId = [infoData valueForKey:@"idTab"];
	BOOL useShare = NO;
	NSString *twitter = @"";
	NSString *facebook = @"";
	NSString *email = @"";
	
	webView = [[UIWebView alloc] initWithFrame:CGRectMake(0, 44, 320, 410)];//init and create the UIWebView
    // if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
	webView.frame = CGRectMake(0, 44, self.view.frame.size.width, self.view.frame.size.height-80);
	[webView setOpaque:NO];
	[webView setBackgroundColor:[UIColor clearColor]];
	
	if ([displayId isEqualToString:@""] ||
		displayId == nil) {
		displayId = [cnf loadValue:@"displayId"];
		// [self initStatusBar:self.view];
		showStatus = YES;
	}
	
	if ([goUrl isEqualToString:@"---"] || [goUrl isEqualToString:@""]) {
		TBXMLElement * root = [Functions readConfigXmlFile];
		TBXMLElement * childXMLElement;
		TBXMLElement * feedsXMLElement;
		TBXMLElement * appXMLElement;

		if (root) {
			
			BOOL f = FALSE;
			childXMLElement = root->firstChild;
			
			do {
				// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
					NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
					// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					NSLog(@"idItem: %@ : %@ ", displayId, idItem);
					if ([displayId isEqualToString:idItem]) {
						f = TRUE;
						feedsXMLElement = childXMLElement;
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
			
			if (f) {
				appXMLElement = feedsXMLElement->firstChild;
				do {
					NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
					if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
						
						if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
							TBXMLElement * childXMLElement = appXMLElement->firstChild;;
							do {
								if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"web_url"]) {
										goUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"eloqua_url"]) {
										goUrl = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"text_title"]) {
										title = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"twitter"]) {
										twitter = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"facebook"]) {
										facebook = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
									if ([[TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement] isEqualToString:@"email"]) {
										email = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									}
								}
							} while ((childXMLElement = childXMLElement->nextSibling));
						}				
					}
				} while ((appXMLElement = appXMLElement->nextSibling));
			}
			
			if ([twitter isEqualToString:@"true"]
				||
				[facebook isEqualToString:@"true"]
				||
				[email isEqualToString:@"true"])
			{
				useShare = YES;
				
			}

			if ([goUrl isEqualToString:@"link"])
			{

				NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
				NSString * feedSource = [cnf loadValue:@"feedSource"];
				
				NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
				NSString *documentsDir = [documentPaths objectAtIndex:0];
				NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
				NSData *myXMLData = [[NSData alloc] initWithContentsOfFile:fileName];
				NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
				unescaped = [unescaped htmlUnescapedString];
				// NSLog(@"--> %@", unescaped);
				[myXMLData release];

				TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];

				TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
                [tbxml release];

				if (rootXMLElement) {
					childXMLElement = rootXMLElement->firstChild;
					do {
						
						// if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
						if (
							!([[TBXML elementName:childXMLElement] isEqualToString:@"error"]) &&
							!([[TBXML elementName:childXMLElement] isEqualToString:@"debug"])
							) {
							TBXMLElement * dataXMLElement = childXMLElement->firstChild;
							// NSInteger total = 1;
							int counter = 0;
							do {
								// NSLog(@"... ??? %@ --- %i", selectedListItem, counter);
								if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
									TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
									// NSLog(@"ch %@ ", [TBXML elementName:itemXMLElement]);
									// NSLog(@"id %@ ", [TBXML valueOfAttributeNamed:@"id" forElement:dataXMLElement]);
									
									// CGSize titleTextSize;
									// CGSize descriptionTextSize;
									// int imgHeight = 0;
									do {
										if ([[TBXML elementName:itemXMLElement] isEqualToString:goUrl]) {
											// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
											NSString * titleText = [TBXML textForElement:itemXMLElement];
											goUrl = titleText;
										}
									} while ((itemXMLElement = itemXMLElement->nextSibling));
									// CGRect descriptionLabelFrame = CGRectMake(10, titleTextSize.height+imgHeight+60, 300, descriptionTextSize.height);
									// descriptionLabel.frame = descriptionLabelFrame;
									// total++;
									// self.view.frame = CGRectMake(0, 0, 320,titleTextSize.height+imgHeight+descriptionTextSize.height);
								}
								counter++;
							} while ((dataXMLElement = dataXMLElement->nextSibling));
						}
					} while ((childXMLElement = childXMLElement->nextSibling));
				}

				
				
				
			}
			
		}

	}

	// [Functions initToolBar:self.view withTitle:title];
 	[Functions addToolBar:self.view withTitle:title actualId:displayId];
	if (showStatus)
	{
		[Functions addStatusBar:self.view withTabBar:YES];
		[self initStatusBar:self.view useShare:useShare];
	}
	[self.view addSubview:webView];

	webView.scalesPageToFit = YES;
	// webView.autoresizesSubviews = YES;
	webView.autoresizingMask=(UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth);
	[webView setDelegate:self];

	NSLog(@"url: %@", goUrl);
	textUrl = goUrl;
	NSURL *u = [NSURL URLWithString:goUrl];
	[cnf updateValue:@"goUrl" value:@"---"];
	// NSURLRequest *requestObj = [NSURLRequest requestWithURL:u];
	// NSMutableURLRequest *requestObj = [NSMutableURLRequest requestWithURL:u];
	NSMutableURLRequest *requestObj = [NSMutableURLRequest requestWithURL:u
															  cachePolicy:NSURLRequestReturnCacheDataElseLoad
                                                          timeoutInterval:60.0];
	[webView loadRequest:requestObj];
	[webView stringByEvaluatingJavaScriptFromString:@"document.body.style.zoom = 5.0;"];

	[cnf release];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[webView release]; 
    [super dealloc];
}

- (void)webViewDidStartLoad:(UIWebView *)webView {
	// [activityIndicator startAnimating];
}

- (void)webViewDidFinishLoad:(UIWebView *)aWebView {
	// [activityIndicator stopAnimating];
}

- (BOOL)webView:(UIWebView *)webView  
shouldStartLoadWithRequest:(NSURLRequest *)request  
 navigationType:(UIWebViewNavigationType)navigationType; {
	BOOL load = YES;
	
    NSURL *requestURL = [ [ request URL ] retain ];
    // Check to see what protocol/scheme the requested URL is.  

	if ( ( [ [ requestURL scheme ] isEqualToString: @"http" ]  
	 || [ [ requestURL scheme ] isEqualToString: @"https" ] )  
	 && ( navigationType == UIWebViewNavigationTypeLinkClicked ) ) {
	 // alert
	 load = NO;
	 UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Open Safari?" 
	 message :@"Do you want to open this site in Safari?"
	 delegate:self 
	 cancelButtonTitle: @"No"
	 otherButtonTitles:@"Yes"
	 , nil];
	 
	 [alert show];
	 [alert release];
	 
	 openLink = [[request URL] retain];
	 
	 // [requestURL release];
	 // alert
	 // return ![ [ UIApplication sharedApplication ] openURL: [ requestURL autorelease ] ];
	 }  
    // Auto release  
    [ requestURL release ];  
    // If request url is something other than http or https it will open  
    // in UIWebView. You could also check for the other following  
    // protocols: tel, mailto and sms  
    return load;
    return YES;  
}

- (void)webView:(UIWebView *)wv didFailLoadWithError:(NSError *)error {
    NSLog (@"webView:didFailLoadWithError");
    // [activityIndicator stopAnimating];
	/*
	 if (error != NULL) {
	 UIAlertView *errorAlert = [[UIAlertView alloc]
	 initWithTitle: [error localizedDescription]
	 message: [error localizedFailureReason]
	 delegate:nil
	 cancelButtonTitle:@"OK" 
	 otherButtonTitles:nil];
	 [errorAlert show];
	 [errorAlert release];
	 }
	 */
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
	if(buttonIndex == 1)
	{
		[[UIApplication sharedApplication] openURL:openLink];
	}
}

/*
- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType {
	NSLog(@"expected:%d, got:%d", UIWebViewNavigationTypeLinkClicked, navigationType);
	if (navigationType == UIWebViewNavigationTypeLinkClicked) {
		[[UIApplication sharedApplication] openURL:[NSURL URLWithString:@"http://www.google.com"]];
		return NO;
	}
	
	return YES;
}
*/

- (void) initStatusBar:(UIView *)actualView {
}

- (void) initStatusBar:(UIView *)actualView useShare:(BOOL) share
{
		NSLog(@"status");
	// NSString *title =@"Video";
	
	CGRect mainViewBounds = [[UIScreen mainScreen] applicationFrame];

	/*UIToolbar *toolbar = [UIToolbar new];
	[toolbar sizeToFit];
	CGFloat toolbarHeight = 40; // [toolbar frame].size.height;
    toolbar.autoresizingMask = UIViewAutoresizingFlexibleWidth;
	toolbar.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								| UIViewAutoresizingFlexibleRightMargin 
								| UIViewAutoresizingFlexibleLeftMargin 
								| UIViewAutoresizingFlexibleTopMargin 
								| UIViewAutoresizingFlexibleWidth);
	// [toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 200.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	// [toolbar setFrame:CGRectMake(0, CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 500.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	[toolbar setFrame:CGRectMake(0, 420, CGRectGetWidth(mainViewBounds), toolbarHeight)];
	//[toolbar setFrame:CGRectMake(CGRectGetMinX(mainViewBounds), CGRectGetMinY(mainViewBounds) + CGRectGetHeight(mainViewBounds) - 98.0, CGRectGetWidth(mainViewBounds), toolbarHeight)];

	// toolbar.barStyle = UIBarStyleBlackTranslucent;
	// toolbar.tintColor = [UIColor blueColor];
	toolbar.alpha = 0.7;
	toolbar.tintColor = [UIColor colorWithRed:.2 green:.5 blue:.7 alpha:.1];

	[actualView addSubview:toolbar];*/
	UIToolbar *toolbar = (UIToolbar *)[actualView viewWithTag:11003];
	
	// UIButton *button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
	/*
	 [button setFrame:CGRectMake(5,10,20,20)];
	 [button setTitle:@"->" forState:UIControlStateNormal];
	 button.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	 */
	[button addTarget:self action:@selector(goShare:) forControlEvents:UIControlEventTouchUpInside];
	
	// const NSInteger IMAGE_TAG = 1003;
	button.frame = CGRectMake(2, 2, 30, 30);
	[button setFrame:CGRectMake(57, 2, 30, 30)];
	// imageCell.frame = CGRectMake(250, 4, 42, 35);
	UIImage * btnImage = [UIImage imageNamed:@"tabbutton_share.png"];
	// button.tag = IMAGE_TAG;
	button.backgroundColor = [UIColor clearColor];
	// btnImage = [Functions resizeImage:btnImage width:32 height:32];
	[button setImage:btnImage forState:UIControlStateNormal];
	// [btnImage release];
	if (share)
	[toolbar addSubview:button];
	// [button release];
	
	UIButton *backButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	[backButton setFrame:CGRectMake(260,7,50,26)];
	[backButton setFrame:CGRectMake(CGRectGetMaxX(mainViewBounds)-60, 7, 50, 26)];
	[backButton setFrame:CGRectMake(5,4,50,26)];
	[backButton setTitle:@"Back" forState:UIControlStateNormal];
	[backButton addTarget:self action:@selector(goBack:) forControlEvents:UIControlEventTouchUpInside];
	//backButton.autoresizingMask = UIViewAutoresizingFlexibleLeftMargin;
	// backButton.autoresizingMask = UIViewAutoresizingFlexibleRightMargin;
	backButton.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
								   | UIViewAutoresizingFlexibleRightMargin 
								   | UIViewAutoresizingFlexibleTopMargin 
							   );
	[toolbar addSubview:backButton];
	// [backButton release];
	
}

- (IBAction)goBack:(id) sender{
	[Functions goMenu:nil];
}

-(IBAction)goShare:(id) sender {
	
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * displayId = [cnf loadValue:@"displayId"];
	NSLog(@"act: %@", displayId);
	
	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	TBXMLElement * feedsXMLElement;
	TBXMLElement * appXMLElement;
	
	NSString * twitter = @""; // [[NSString alloc] init];
	NSString * email = @""; // [[NSString alloc] init];
	NSString * twitterId = @""; // [[NSString alloc] init];
	NSString * emailId = @""; // [[NSString alloc] init];
	
	NSString * facebook = @""; // [[NSString alloc] init];
	NSString * facebookId = @""; // [[NSString alloc] init];
	NSString * facebookLink = @""; // [[NSString alloc] init];
	NSString * facebookTitle = @""; // [[NSString alloc] init];
	NSString * facebookComment = @""; // [[NSString alloc] init];
	
	NSString * twitterLink = @""; // [[NSString alloc] init];
	NSString * twitterTitle = @""; // [[NSString alloc] init];
	NSString * twitterComment = @""; // [[NSString alloc] init];
	
	NSString * emailSubject = @""; // [[NSString alloc] init];
	NSString * emailSubjectTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyText = @""; // [[NSString alloc] init];
	NSString * emailBodyTitle = @""; // [[NSString alloc] init];
	NSString * emailBodyLink = @""; //  [[NSString alloc] init];
		
	if (root) {
		
		BOOL f = FALSE;
		childXMLElement = root->firstChild;
		
		do {
			// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
			if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
				NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
				// NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
				// NSLog(@"idItem: %@ : %@ ", displayId, idItem);
				if ([displayId isEqualToString:idItem]) {
					f = TRUE;
					feedsXMLElement = childXMLElement;
				}
			}
		} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		
		
		if (f) {
			appXMLElement = feedsXMLElement->firstChild;
			do {
				// NSLog(@"item? %@", [TBXML elementName:appXMLElement] );
				if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
					
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:@"0"]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter"]) {
									twitter = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"facebook"]) {
									facebook = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
								if ([attribItem isEqualToString:@"email"]) {
									email = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailId = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// facebook
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:facebookId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"facebook_subject_entity"]) {
									facebookTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookTitle = [facebookTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_link"]) {
									facebookLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookLink = [facebookLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"facebook_comment"]) {
									facebookComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									facebookComment = [facebookComment urlUnescapedString];
								}
								
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// twitter
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:twitterId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"twitter_title"]) {
									twitterTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterTitle = [twitterTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_link"]) {
									twitterLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterLink = [twitterLink urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"twitter_twitt"]) {
									twitterComment = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									twitterComment = [twitterComment urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					// e-mail
					if ([[TBXML valueOfAttributeNamed:@"id" forElement:appXMLElement] isEqualToString:emailId]) {
						TBXMLElement * childXMLElement = appXMLElement->firstChild;;
						do {
							if ([[TBXML elementName:childXMLElement] isEqualToString:@"field"]) {
								NSString *attribItem = [TBXML valueOfAttributeNamed:@"name" forElement:childXMLElement];
								if ([attribItem isEqualToString:@"email_subject"]) {
									emailSubject = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubject = [emailSubject urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_subject_entity"]) {
									emailSubjectTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailSubjectTitle = [emailSubjectTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body"]) {
									emailBodyText = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyText = [emailBodyText urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_body_entity"]) {
									emailBodyTitle = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyTitle = [emailBodyTitle urlUnescapedString];
								}
								if ([attribItem isEqualToString:@"email_link"]) {
									emailBodyLink = [TBXML valueOfAttributeNamed:@"value" forElement:childXMLElement];
									emailBodyLink = [emailBodyLink urlUnescapedString];
								}
							}
						} while ((childXMLElement = childXMLElement->nextSibling));
					}
					
					
					
				}
			} while ((appXMLElement = appXMLElement->nextSibling));
			
			NSString * selectedListItem = [cnf loadValue:@"selectedListItem"];
			NSString * feedSource = [cnf loadValue:@"feedSource"];
			// NSURL *u = [NSURL URLWithString:feedSource];
			
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:feedSource];
			NSData *myXMLData = [NSData dataWithContentsOfFile:fileName];
			NSString *unescaped = [[[NSString alloc] initWithData:myXMLData encoding:NSUTF8StringEncoding] autorelease];
			unescaped = [unescaped htmlUnescapedString];
			
			TBXML * tbxml = [[TBXML tbxmlWithXMLString:unescaped] retain];
			
			TBXMLElement * rootXMLElement = tbxml.rootXMLElement;
            [tbxml release];
			if (rootXMLElement) {
				childXMLElement = rootXMLElement->firstChild;
				do {
					if ([[TBXML elementName:childXMLElement] isEqualToString:@"data"]) {
						TBXMLElement * dataXMLElement = childXMLElement->firstChild;
						// NSInteger total = 1;
						int counter = 0;
						do {
							if ([selectedListItem isEqualToString:[NSString stringWithFormat:@"%i", counter]]) {
								TBXMLElement * itemXMLElement = dataXMLElement->firstChild;
								do {
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:facebookLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										facebookLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterTitle]) {
										// NSLog(@"tt: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:twitterLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										twitterLink = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailSubjectTitle]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailSubjectTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyTitle]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyTitle = titleText;
									}
									if ([[TBXML elementName:itemXMLElement] isEqualToString:emailBodyLink]) {
										// NSLog(@"ss: %@", [TBXML textForElement:itemXMLElement]);
										NSString * titleText = [TBXML textForElement:itemXMLElement];
										emailBodyLink = titleText;
									}
								} while ((itemXMLElement = itemXMLElement->nextSibling));
								// CGRect descriptionLabelFrame = CGRectMake(10, titleTextSize.height+imgHeight+60, 300, descriptionTextSize.height);
								// descriptionLabel.frame = descriptionLabelFrame;
								// total++;
								// self.view.frame = CGRectMake(0, 0, 320,titleTextSize.height+imgHeight+descriptionTextSize.height);
							}
							counter++;
						} while ((dataXMLElement = dataXMLElement->nextSibling));
					}
				} while ((childXMLElement = childXMLElement->nextSibling));
			}
			
		}
		
	}
	
	NSLog(@"tw: %@", twitter);
	
	
	[shareView.view removeFromSuperview];
	shareView = [ShareViewController sharedManager];
	
	[shareView setMailSubject:[NSString stringWithFormat:@"%@ : %@", emailSubject, emailSubjectTitle]];
	NSString * message = [NSString stringWithFormat:@"<p>%@\n"
						  "<br /><br /> \n"
						  "<a href=\"%@\">%@</a> \n"
						  "<br />%@<br /><br /> \n"
						  "</p>\n",
						  emailBodyText, emailBodyLink, emailBodyTitle, emailBodyLink];
	
	[shareView setMailText:message];
	
	[shareView setTextTitle:textTitle];
	[shareView setTextDescription:textUrl];
	[shareView setTextUrl:textUrl];
	
	[shareView setUseMail:email];
	[shareView setUseFacebook:facebook];
	[shareView setUseTwitter:twitter];
	
	[shareView setFacebookTitle:facebookTitle];
	[shareView setFacebookDescription:facebookComment];
	[shareView setFacebookLink:facebookLink];
	
	[shareView setTwitterTitle:twitterTitle];
	[shareView setTwitterDescription:twitterComment];
	[shareView setTwitterLink:twitterLink];
	
	[self.view addSubview:shareView.view];
	// popupView.view.frame = CGRectMake(0, self.view.frame.size.height,320,100);
	shareView.view.frame = CGRectMake(0,460,320,460);
    // [popupView setFrame:CGRectOffset([popupView frame], 0, popupView.frame.size.height)]; // Move it up top and off screen
	[UIView beginAnimations:@"animateImageOn" context:NULL]; // Begin animation
	[shareView.view setFrame:CGRectOffset([shareView.view frame], 0, -shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
	
	[cnf release];
}

-(void)hideShare {
    [NSObject cancelPreviousPerformRequestsWithTarget: self];
	[UIView beginAnimations:@"animateImageOff" context:NULL]; // Begin animation
	// [shareView.view setFrame:CGRectOffset([shareView.view frame], 0, shareView.view.frame.size.height)]; // Move imageView on screen
	[UIView commitAnimations]; // End animations
}

@end
