//
//  app_builderAppDelegate.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/14/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "app_builderAppDelegate.h"
#import "app_builderViewController.h"
#import "Functions.h"
#import <netinet/in.h>
#include <CoreFoundation/CoreFoundation.h>
#include <SystemConfiguration/SystemConfiguration.h>
#import "Config.h"
#import "ZipArchive.h"

@implementation app_builderAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize appPath;
// @synthesize xml_url;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {    

	// NSMutableArray *array = [[NSMutableArray arrayWithContentsOfFile:finalPath] retain];
	// NSMutableArray *array = [[NSMutableArray alloc] init];
	// [array writeToFile:[@"/path/to/file.plist"] atomically: TRUE];
	
	[super application:application didFinishLaunchingWithOptions:launchOptions];

	NSString *databasePath;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:@"app_builder.xml"];
	NSFileManager *fileManager = [NSFileManager defaultManager];
	[fileManager removeItemAtPath:databasePath error:nil];

	// NSError *error = nil;

	isInternetConnected=[self connectedToNetwork];
	
    if (!isInternetConnected){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Error" message:@"You do not have an internet connection. Please check your settings and try again later." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];	
	}else{
		// first configuration and updates
		// [self checkUpdate];
		// remove lists files
/*		for (NSString *file in [fileManager contentsOfDirectoryAtPath:documentsDir error:&error]) {
//			NSLog(@"file: %@", file);
			if ([file hasPrefix:@"list_"] || [file isEqualToString:@"menu"]) {
//				NSLog(@"list: %@", file);
				for (NSString *images in [fileManager contentsOfDirectoryAtPath:[documentsDir stringByAppendingPathComponent:file] error:&error]) {
//					NSLog(@"dele: %@", [NSString stringWithFormat:@"%@/%@/%@", documentsDir, file, images]);
					BOOL success = [fileManager removeItemAtPath:[NSString stringWithFormat:@"%@/%@/%@", documentsDir, file, images] error:&error];
					if (!success || error) {
						// it failed.
						// NSLog(@"err: %@%@", fileName, file);
					} else {
						// NSLog(@"del: %@%@", fileName, file);
					}
				}
			}
		}
*/
	}

	[self checkAndCreateFile:@"resources.zip"];
	[self checkAndCreateFile:@"app_builder.sql"];
	[self checkAndCreateFile:@"app_builder.xml"];

    if (isInternetConnected)
		[self doUpdate];

	[window addSubview:viewController.view];
    [window makeKeyAndVisible];
	return YES;

}

/*
- (void)applicationDidFinishLaunching:(UIApplication *)application {    
	// appPath = @"/platts/energyweek"; 


	[self checkAndCreateFile:@"app_builder.sql"];
	[self checkAndCreateFile:@"app_builder.xml"];
	[window addSubview:viewController.view];
    [window makeKeyAndVisible];
	isInternetConnected=[self connectedToNetwork];

    if (!isInternetConnected){
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Platts" message:@"You do not have an internet connection. Please check your settings and try again later." delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil];
		[alert show];
		[alert release];	
	}else{
		// first configuration and updates
		// [self checkUpdate];
	}
	
}
*/

#pragma mark -
#pragma mark Memory management

- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
}

- (void)applicationWillTerminate:(UIApplication *)application {
	
	// Fire off "automatic" app terminate event
	[super applicationWillTerminate:application];
	
	// Save data if appropriate
}
- (BOOL) connectedToNetwork
{
    struct sockaddr_in zeroAddress;
    bzero(&zeroAddress, sizeof(zeroAddress));
    zeroAddress.sin_len = sizeof(zeroAddress);
    zeroAddress.sin_family = AF_INET;
	
    SCNetworkReachabilityRef defaultRouteReachability = SCNetworkReachabilityCreateWithAddress(NULL, (struct sockaddr *)&zeroAddress);
    SCNetworkReachabilityFlags flags;
	
    BOOL didRetrieveFlags = SCNetworkReachabilityGetFlags(defaultRouteReachability, &flags);
    CFRelease(defaultRouteReachability);
	
    if (!didRetrieveFlags)
    {
        return 0;
    }
	
    BOOL isReachable = flags & kSCNetworkFlagsReachable;
    BOOL needsConnection = flags & kSCNetworkFlagsConnectionRequired;
    return (isReachable && !needsConnection) ? YES : NO;
}

- (BOOL) isOnLine{
	return isInternetConnected;
	
}

-(void) checkAndCreateFile:(NSString *)file {
	// Check if the SQL database has already been saved to the users phone, if not then copy it over
	BOOL success;
	NSError *error;
	NSString *databaseName;
	NSString *databasePath;
	
	// database file
	// databaseName = @"app_builder.sql";
	databaseName = file;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	// [self loadFirstConfig];
	
	// Create a FileManager object, we will use this to check the status
	// of the database and to copy it over if required
	NSFileManager *fileManager = [NSFileManager defaultManager];
	
	// Check if the database has already been created in the users filesystem
	success = [fileManager fileExistsAtPath:databasePath];
	
	// If the database already exists then return without doing anything
	if(success) return;
	// [fileManager removeItemAtPath:databasePath error:nil];
	
	NSLog(@"First run...");
	
	// If not then proceed to copy the database from the application to the users filesystem
	
	// Get the path to the database in the application package
	NSString *databasePathFromApp = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:databaseName];
	
	// Copy the database from the package to the users filesystem
	// [fileManager copyItemAtPath:databasePathFromApp toPath:databasePath error:nil];
	success = [fileManager copyItemAtPath:databasePathFromApp toPath:databasePath error:&error];
	
	if (!success) {
		// NSAssert1(0, @"Failed to create writable database file with message '%@'.", [error localizedDescription]);
		NSLog(@"Error '%@'.", [error localizedDescription]);
		return;
	}
	
	if ([file isEqualToString:@"resources.zip"]) {
		[self createResources];
	}
	if ([file isEqualToString:@"app_builder.xml"]) {
		[self loadFirstConfig];
		// [self doUpdate];
	}
	
//	[fileManager release];
}

-(void) checkUpdate {
	NSString *value;
	
	// date
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	[dateFormat setDateFormat:@"yyyyMMdd"];
	NSString *dateString = [dateFormat stringFromDate:date];  
	[dateFormat release];
	
//	cnf = [[Config alloc] initWithName:@"lastCheck"];
	Config *cnf = [[Config alloc] init];
	value = [cnf loadValue:@"lastCheck"];
	NSLog(@"update");
	if([value isEqualToString:@""] == TRUE) {
		NSLog(@"insert");
		[cnf updateValue:@"lastCheck" value:dateString];
	} else {
		NSLog(@"value %@", value);
		NSLog(@"date %@", date);
		NSTimeInterval dateTime;		
		// NSDateFormatter *
		dateFormat = [[NSDateFormatter alloc] init];
		[dateFormat setDateFormat:@"yyyyMMdd"];
		NSDate *lastCheck = [dateFormat dateFromString:value];
		date = [dateFormat dateFromString:[dateFormat stringFromDate:date]];
		
		// if ([lastCheck isEqualToDate:date])   //visitDate is a NSDate
		//{
		//	NSLog (@"Dates are equal");
		//	return;
		//} else {
		dateTime = ([date timeIntervalSinceDate:lastCheck] / 86400);  
		if(dateTime > 1) //Check if visit date is a past date, dateTime returns - val
		{
			[self doUpdate];
		}
		// }
		
		[dateFormat release];
	}
	[cnf release];
	// [dateString release];
}

- (void) doUpdate {
	return;
	NSString * xml_url = @"http://services.mghmobileapps.com:8040/general/get_application_xml.aspx?email=cberzolla@isg-marketing.com&password=soccer&application_id=120";

	NSString *databaseName = @"app_builder.xml";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *fileName = [documentsDir stringByAppendingPathComponent:databaseName];
	NSURL *u = [NSURL URLWithString:xml_url];
	// NSError* error;
	/*
	NSString *xmlFile = [NSString stringWithContentsOfURL:u encoding:NSUTF8StringEncoding error:&error];
	[xmlFile writeToFile:fileName 
			  atomically:NO 
				encoding:NSStringEncodingConversionAllowLossy 
				   error:nil];
	*/
	NSData *myXMLData = [NSData dataWithContentsOfURL:u];
	[myXMLData writeToFile:fileName atomically:YES];

	// delete splash new version file
	databaseName = @"/splash.jpg";
	documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	documentsDir = [documentPaths objectAtIndex:0];
	NSString *databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	NSFileManager *fileManager = [NSFileManager defaultManager];
	[fileManager removeItemAtPath:databasePath error:nil];
	// remove icon bar
	databaseName = @"/logo.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// remove skin menu bg
	databaseName = @"/bottomRow.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// 2
	databaseName = @"/gradientBackground.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// 3
	databaseName = @"/middleRow.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// 4
	databaseName = @"/topAndBottomRow.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// 5
	databaseName = @"/topRow.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// 6
	databaseName = @"/indicator.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	// icons
	databaseName = @"/icoList.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	databaseName = @"/icoWeb.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	databaseName = @"/icoMap.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];
	databaseName = @"/icoSlide.png";
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	[fileManager removeItemAtPath:databasePath error:nil];

	[self updateConfig];
	
	// ads
	NSString * ads_url = @"http://widgets.isg-marketing.com/mcgrawhill_mobile/deleted/ads.xml";
	//NSString *databaseName = @"ads.xml";
	//NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	//NSString *documentsDir = [documentPaths objectAtIndex:0];
	fileName = [documentsDir stringByAppendingPathComponent:@"ads.xml"];
	u = [NSURL URLWithString:ads_url];
	myXMLData = [NSData dataWithContentsOfURL:u];
	[myXMLData writeToFile:fileName atomically:YES];
	
}

- (void) oldUpdate {
	Config *cnf;
	NSString *value;
	NSDate *date = [NSDate date];
	NSDateFormatter *dateFormat = [[NSDateFormatter alloc] init];
	NSLog(@"Check for update");
	NSString *url = @"http://www.axul.net/iphone/xcode_input.xml";
	cnf = [[Config alloc] init];
	value = [cnf loadValue:@"version"];
	
	TBXML * tbxml = [[TBXML 
					  tbxmlWithURL:[NSURL URLWithString:url]] retain];
	TBXMLElement * root = tbxml.rootXMLElement;
	    [tbxml release];
	
	if (root) {
		NSLog(@"R: %@",[TBXML elementName:root]);
		
		TBXMLElement * appXMLElement = [TBXML childElementNamed:@"app_settings" parentElement:root];
		TBXMLElement * verXMLElement = [TBXML childElementNamed:@"builder_version" parentElement:appXMLElement];
		NSString * version = [TBXML textForElement:verXMLElement];
		NSLog(@"ver: %@ act: %@", value, version);
		if ([version isEqualToString:value])
			NSLog(@"same");
		else {
			NSLog(@"new ver");
			NSString *databaseName = @"app_builder.xml";
			NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			NSString *documentsDir = [documentPaths objectAtIndex:0];
			NSString *fileName = [documentsDir stringByAppendingPathComponent:databaseName];
			NSURL *u = [NSURL URLWithString:url];
			// NSString *xmlFile = [NSString stringWithContentsOfURL:u];
			NSError* error;
			/*
			 if( text )
			 NSLog(@"Text=%@", text);
			 else 
			 NSLog(@"Error = %@", error);
			 */
			NSString *xmlFile = [NSString stringWithContentsOfURL:u encoding:NSUTF8StringEncoding error:&error];
			[xmlFile writeToFile:fileName 
					  atomically:NO 
						encoding:NSStringEncodingConversionAllowLossy 
						   error:nil];
			[cnf updateValue:@"version" value:version];
			/*
			 TBXMLElement * adsXMLElement = [TBXML childElementNamed:@"ads" parentElement:appXMLElement];
			 NSString * ads = [TBXML textForElement:adsXMLElement];
			 [Config updateValue:@"ads" value:ads];
			 */
			TBXMLElement * nameXMLElement = [TBXML childElementNamed:@"name" parentElement:appXMLElement];
			NSString * name = [TBXML textForElement:nameXMLElement];
			[cnf updateValue:@"name" value:name];
			TBXMLElement * skinXMLElement = [TBXML childElementNamed:@"skin" parentElement:appXMLElement];
			NSString * skin = [TBXML textForElement:skinXMLElement];
			[cnf updateValue:@"skin" value:skin];
			TBXMLElement * logoXMLElement = [TBXML childElementNamed:@"owner_logo" parentElement:appXMLElement];
			NSString * logo = [TBXML textForElement:logoXMLElement];
			[cnf updateValue:@"owner_logo" value:logo];
			NSString *dateString = [dateFormat stringFromDate:date];  
			[cnf updateValue:@"lastCheck" value:dateString];
			// delete splash new version file
			databaseName = @"/splash.jpg";
			documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
			documentsDir = [documentPaths objectAtIndex:0];
			NSString *databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			NSFileManager *fileManager = [NSFileManager defaultManager];
			[fileManager removeItemAtPath:databasePath error:nil];
			// remove icon bar
			databaseName = @"/logo.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// remove skin menu bg
			databaseName = @"/bottomRow.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// 2
			databaseName = @"/gradientBackground.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// 3
			databaseName = @"/middleRow.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// 4
			databaseName = @"/topAndBottomRow.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// 5
			databaseName = @"/topRow.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// 6
			databaseName = @"/indicator.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			// icons
			databaseName = @"/icoList.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			databaseName = @"/icoWeb.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			databaseName = @"/icoMap.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			databaseName = @"/icoSlide.png";
			databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
			// NSLog(@"Path: %@", databasePath);
			[fileManager removeItemAtPath:databasePath error:nil];
			/*
			TBXMLElement * popupXMLElement = [TBXML childElementNamed:@"pop_up_ad" parentElement:root];
			NSString * frequency = [TBXML valueOfAttributeNamed:@"frequency" forElement:popupXMLElement];
			NSString * time = [TBXML valueOfAttributeNamed:@"time" forElement:popupXMLElement];
			[Functions updateConfig:@"adFrequency" withValue:frequency];
			[Functions updateConfig:@"adTime" withValue:time];
			*/
		}
	}
	
	[dateFormat release];
	[cnf release];
}

- (void) loadFirstConfig {
	NSLog(@"First..");
	BOOL success;
	NSError *error;
	Config *cnf = [[Config alloc] init];

	NSString *servicesUrl = @"http://services.mghmobileapps.com:8040/general/";
	NSLog(@"serv %@", servicesUrl);
	NSString *dateCreated = @"test_xml_20120215_211708d";
	NSLog(@"dateCreated %@", dateCreated);
    
	// create skin from resources
	[self checkAndCreateFile:@"bg_cell.png"];
	[self checkAndCreateFile:@"bottomRow.png"];
	[self checkAndCreateFile:@"gradientBackground.png"];
	[self checkAndCreateFile:@"indicator.png"];
	[self checkAndCreateFile:@"middleRow.png"];
	[self checkAndCreateFile:@"topAndBottomRow.png"];
	[self checkAndCreateFile:@"topRow.png"];

    NSString *databaseName = @"app_builder.xml";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	NSFileManager *fileManager = [NSFileManager defaultManager];
	success = [fileManager fileExistsAtPath:databasePath];
	if (!success) {
		NSString *databasePathFromApp = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:databaseName];
		success = [fileManager copyItemAtPath:databasePathFromApp toPath:databasePath error:&error];
		if (!success) {
			// NSAssert1(0, @"Failed to create writable database file with message '%@'.", [error localizedDescription]);
			NSLog(@"Error '%@'.", [error localizedDescription]);
			[cnf release];
			return;
		}
//		[fileManager release];
	}
	
	
	// TBXML * tbxml = [[TBXML tbxmlWithXMLFile:@"app_builder.xml"] retain];
	TBXMLElement * root = [Functions readConfigXmlFile]; // tbxml.rootXMLElement;
	TBXMLElement * child;
	// NSString *value;
	if (root) {
		// NSLog(@"R: %@",[TBXML elementName:root]);
		
		TBXMLElement * appXMLElement = [TBXML childElementNamed:@"app_settings" parentElement:root];
		
		child = appXMLElement->firstChild;
		do {
			/*NSLog(@"%@ %@ = %@",
				  [TBXML elementName:element],
				  [TBXML elementName:child],
				  [TBXML textForElement:child]);*/
			// value = [cnf initWithName:[TBXML elementName:child]];
			// cnf = [[Config alloc] initWithName:[TBXML elementName:child]];
			// value = cnf.value;
			// if([value isEqualToString:@""] == TRUE) {
			NSString * XMLName = [TBXML elementName:child];
			NSString * XMLValue = [TBXML textForElement:child];
			if ([[TBXML elementName:child] isEqualToString:@"icon"] || 
				[[TBXML elementName:child] isEqualToString:@"splash"]) {
				XMLValue = [TBXML valueOfAttributeNamed:@"url" forElement:child];
			}
			// NSString * tmpVal = [cnf loadValue:XMLName];
			// if (![XMLValue isEqualToString:@""] && XMLValue != nil )
				//if (tmpVal == nil || [tmpVal isEqualToString:@""]) {
				//	[cnf insertValue:XMLName value:XMLValue];
				//} else {
					[cnf updateValue:XMLName value:XMLValue];
				//}
			
			//	[Functions updateConfig:XMLName withValue:XMLValue];
			// }
		} while ((child = child->nextSibling) && !([[TBXML elementName:child] isEqualToString:@"styles"]));
	}
	
	[cnf updateValue:@"dateCreated" value:dateCreated];
	[cnf updateValue:@"servicesUrl" value:servicesUrl];
	[cnf release];
	
	// [self updateWebtrends];
}

- (void) updateWebtrends
{
	Config * cnf;
	cnf = [[Config alloc] init];
	NSString * webtrendsKey = [cnf loadValue:@"webtrends_key"]; // [Config loadValue:@"webtrends_key"];
	if (([webtrendsKey isEqualToString:@""] == FALSE) &&
		(webtrendsKey != nil)) {
		// platts dcsco28gcvz5bdfulqcyy6321_9i5r
		
		// create a pointer to a dictionary
		NSMutableDictionary *dictionary;
		
		// read "foo.plist" from application bundle
		NSString *path = [[NSBundle mainBundle] bundlePath];
		NSString *finalPath = [path stringByAppendingPathComponent:@"Webtrends.plist"];
		dictionary = [NSMutableDictionary dictionaryWithContentsOfFile:finalPath];
		
		// dump the contents of the dictionary to the console
		for (id key in dictionary) {
			if ([key isEqualToString:@"wt_dc_dcsid"]) {
				NSLog(@"bundle: key=%@, value=%@", key, [dictionary objectForKey:key]);
				if ([[dictionary objectForKey:key] isEqualToString:@"---"] ||
					([[dictionary objectForKey:key] isEqualToString:webtrendsKey] == FALSE)) {
					[dictionary setValue:webtrendsKey forKey:@"wt_dc_dcsid"];
					[dictionary writeToFile:finalPath atomically: YES];
					NSLog(@"webtrends updated");
					break;
				}
			}
		}
	}
	
	[cnf release];
}

- (void) updateConfig {
	NSLog(@"Update..");
	BOOL success;
	NSError *error;
	
	NSString *databaseName = @"app_builder.xml";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	// NSLog(@"Path: %@", databasePath);
	NSFileManager *fileManager = [NSFileManager defaultManager];
	success = [fileManager fileExistsAtPath:databasePath];
	if (!success) {
		NSString *databasePathFromApp = [[[NSBundle mainBundle] resourcePath] stringByAppendingPathComponent:databaseName];
		success = [fileManager copyItemAtPath:databasePathFromApp toPath:databasePath error:&error];
		if (!success) {
			// NSAssert1(0, @"Failed to create writable database file with message '%@'.", [error localizedDescription]);
			NSLog(@"Error '%@'.", [error localizedDescription]);
			return;
		}
//		[fileManager release];
	}
	
	
	// TBXML * tbxml = [[TBXML tbxmlWithXMLFile:@"app_builder.xml"] retain];
	TBXMLElement * root = [Functions readConfigXmlFile]; // tbxml.rootXMLElement;
//	TBXMLElement * element;
	TBXMLElement * child;
//	Config *cnf;
//	NSString *value;
	if (root) {
//		NSLog(@"R: %@",[TBXML elementName:root]);
//		if (root->firstChild) 
//			element = root->firstChild;
		
		TBXMLElement * appXMLElement = [TBXML childElementNamed:@"app_settings" parentElement:root];
		
		child = appXMLElement->firstChild;
		Config *cnf = [[Config alloc] init];
		do {
			/*NSLog(@"%@ %@ = %@",
			 [TBXML elementName:element],
			 [TBXML elementName:child],
			 [TBXML textForElement:child]);*/
			// value = [cnf initWithName:[TBXML elementName:child]];
			// cnf = [[Config alloc] initWithName:[TBXML elementName:child]];
			// value = cnf.value;
			// if([value isEqualToString:@""] == TRUE) {
			NSString * nameConfig = [TBXML elementName:child]; //retain];
			NSString * valueConfig = [TBXML textForElement:child]; //retain];
			NSLog(@"name %@ ** %@", nameConfig, valueConfig);
			if ([[TBXML elementName:child] isEqualToString:@"icon"] || 
				[[TBXML elementName:child] isEqualToString:@"splash"]) {
				valueConfig = [TBXML valueOfAttributeNamed:@"url" forElement:child];
			}
			// NSString * valueTmp = [cnf loadValue:nameConfig];
			// if([valueTmp isEqualToString:@""] == TRUE) {
			//	[cnf insertValue:nameConfig value:valueConfig];
			// } else {
				[cnf updateValue:nameConfig value:valueConfig];
			// }
			// [nameConfig release];
			// [valueConfig release];
			// [Functions updateConfig:name withValue:value];
			// }
		} while ((child = child->nextSibling) && !([[TBXML elementName:child] isEqualToString:@"styles"]));
		[cnf release];
	}
	[self updateWebtrends];
}

-(void) displayView:(NSString *)sNewView{
	Config *cnf = [[Config alloc] init];
	NSString *value = [cnf loadValue:@"actualId"];
	NSString * useMenuTabBar = [cnf loadValue:@"useMenuTabBar"];
	NSString * displayView = [cnf loadValue:@"displayView"];
	NSLog(@"< %@ - %@ >", sNewView, displayView);

	TBXMLElement * root = [Functions readConfigXmlFile];
	TBXMLElement * childXMLElement;
	BOOL f = FALSE;
	if (root 
		&& ![sNewView isEqualToString:@"7"]
		&& ![sNewView isEqualToString:@"6"]
		&& ![sNewView isEqualToString:@"9"]
		&& ![sNewView isEqualToString:@"11"]
		&& ![sNewView isEqualToString:@"13"]
		&& ![sNewView isEqualToString:@"1"]
		&& ![sNewView isEqualToString:@"5"]
		&& ![displayView isEqualToString:@"7"]
		) {

		if ([useMenuTabBar isEqualToString:@"1"]) {
//			[Functions updateConfig:@"useTabBar" withValue:@"1"];
			[cnf updateValue:@"useTabBar" value:@"1"];
			sNewView = @"10";
			f = TRUE;
		} else { 
//			[Functions updateConfig:@"useTabBar" withValue:@"0"];
			[cnf updateValue:@"useTabBar" value:@"0"];
			childXMLElement = root->firstChild;
			do {
				// NSLog(@"module? %@", [TBXML elementName:childXMLElement] );
				if ([[TBXML elementName:childXMLElement] isEqualToString:@"module"]) {
					NSString *idItem = [TBXML valueOfAttributeNamed:@"id" forElement:childXMLElement];
					NSString *type = [TBXML valueOfAttributeNamed:@"type" forElement:childXMLElement];
					// NSLog(@"idItem: %@ value : %@", idItem, value);
					if ([value isEqualToString:idItem]) {
						f = TRUE;
						sNewView = type;
						TBXMLElement * appXMLElement = childXMLElement->firstChild;
						do {
							// NSLog(@"element: %@", [TBXML elementName:appXMLElement]);
							if ([[TBXML elementName:appXMLElement] isEqualToString:@"field_set"]) {
								TBXMLElement * dataXMLElement = appXMLElement->firstChild;
								do {
									if ([[TBXML valueOfAttributeNamed:@"type" forElement:dataXMLElement] isEqualToString:@"tab_bar"]) {
//										[Functions updateConfig:@"useTabBar" withValue:@"1"];
										[cnf updateValue:@"useTabBar" value:@"1"];
										sNewView = @"10";
									}
								} while ((dataXMLElement = dataXMLElement->nextSibling));
							}
						} while ((appXMLElement = appXMLElement->nextSibling));
					}
				}
			} while ((childXMLElement = childXMLElement->nextSibling) && (f == FALSE));
		}
	}

	if ([sNewView isEqualToString:@"7"] || [sNewView isEqualToString:@"6"]
		|| [sNewView isEqualToString:@"11"]
		|| [sNewView isEqualToString:@"13"]
		|| [sNewView isEqualToString:@"9"]
		|| [sNewView isEqualToString:@"5"]
		|| [displayView isEqualToString:@"7"]) {
		f = TRUE;
	}

	if (f) {
		/*
		cnf = [[Config alloc] initWithName:@"displayId"];
		NSString * displayId = cnf.value;
		if (![displayId isEqualToString:@"0"]) {
			sNewView = @"4";
			[Functions updateConfig:@"displayId" withValue:@"0"];	
		}
		*/
//		[Functions updateConfig:@"displayView" withValue:sNewView];	
		
		NSLog(@"--->loaded view: %@", sNewView);
		
		[cnf updateValue:@"displayView" value:sNewView];
		[viewController displayView:sNewView];
	} else {
//		[Functions updateConfig:@"displayView" withValue:@"1"];
		
		NSLog(@"--->loaded menu" );
		
		[cnf updateValue:@"displayView" value:@"1"];
		[viewController displayView:@"1"];
	}
	
	[cnf release];
}


- (void) createResources
{
	NSString *databaseName = @"resources.zip";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	NSString *databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	ZipArchive* za = [[ZipArchive alloc] init];
	if( [za UnzipOpenFile:databasePath] )
        // OR
		//  if( [za UnzipOpenFile:@"/Volumes/data/testfolder/Archive.zip"] Password:@"password of the zip file"] )
		// if the Password is empty, get same  effect as if( [za UnzipOpenFile:@"/Volumes/data/testfolder/Archive.zip"] )
	{
		BOOL ret = [za UnzipFileTo:documentsDir overWrite:YES];
		if( NO==ret )
		{
			// error handler here
			NSLog(@"error unzipping...");
		}
		[za UnzipCloseFile];
	}
	[za release];
    
    
	NSString * path = @"resources";
	NSArray *homePaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *homePath = [NSString stringWithFormat:@"%@", [homePaths objectAtIndex:0]];
	NSString *homeDir = [NSString stringWithFormat:@"%@/%@", [homePaths objectAtIndex:0], path];
	
	NSFileManager *fileManager = [NSFileManager defaultManager];
	
	NSError *error=nil;
	
	NSArray *contents = [fileManager contentsOfDirectoryAtPath:homeDir error:nil];
	
	for (NSString *file in contents) {
		BOOL success = [fileManager moveItemAtPath:[homeDir stringByAppendingPathComponent:file] toPath:[homePath stringByAppendingPathComponent:file] error:&error];
		
		if(!success){
			NSLog(@"couldn't move file: %@",error);
		}
	}
    
    [fileManager removeItemAtPath:homeDir error:&error];
    // [fileManager removeItemAtPath:databasePath error:&error];
    
}

@end
