//
//  app_builderViewController.m
//  app_builder
//
//  Created by IVAN BEJARANO on 10/14/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "app_builderViewController.h"
#import "SplashViewController.h"
#import "MenuViewController.h"
#import "GalleryViewController.h"
#import "ListViewController.h"
#import "PollViewController.h"
#import "PollResultsViewController.h"
#import "TabBarViewController.h"
#import "DetailViewController.h"
#import "VideoViewController.h"
#import "WebViewController.h"
#import "AboutViewController.h"
#import "MapViewController.h"
#import "ConfigViewController.h"
#import "AddressViewController.h"
#import "LoginViewController.h"
#import "SubmenuViewController.h"
#import "Config.h"

@implementation app_builderViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(displayView2:) name:@"onDisplayView" object:nil];
	
	[self showSplash];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
	[currentView release];
    [super dealloc];
}

// show splash screen
-(void)showSplash
{
	NSLog(@"show");
	/*currentView = [[SplashViewController alloc] initWithNibName:@"SplashViewController" bundle:nil];
	[self.view addSubview: currentView.view];
    [self performSelector:@selector(hideSplash) withObject:nil afterDelay:5.0];*/
	Config *cnf = [[Config alloc] init];
	NSString * authenticationId = [cnf loadValue:@"authentication_id"];
	[cnf release];

	if ([authenticationId intValue] != 0) {
		// Login
		currentView = [[LoginViewController alloc] initWithNibName:@"LoginViewController" bundle:[NSBundle mainBundle]];
		[self.view addSubview: currentView.view];
	} else
	{
		[self displayView:@"1"];
	}
}

// hide splash screen
- (void)hideSplash{
	NSLog(@"hide");
	[self displayView:@"1"];
}

- (void) displayView:(NSString *)sNewView 
{
	
	[currentView.view removeFromSuperview];
//	currentView = nil;
//	[currentView release];
	
	int intNewView = [sNewView intValue];
	
	NSNumber *newViewVal = [NSNumber numberWithInt:intNewView];

	NSDictionary *userInfo = [NSDictionary dictionaryWithObjectsAndKeys:newViewVal, @"intNewView", nil];
	[[NSNotificationCenter defaultCenter] postNotificationName:@"onDisplayView" object:self userInfo:userInfo];
}

-(void) displayView2:(NSNotification *)notification
{
	NSDictionary *userInfo = [notification userInfo];
	NSNumber *newViewVal = (NSNumber *)[userInfo objectForKey:@"intNewView"];
	int intNewView = [newViewVal intValue];
	// intNewView = 6;

	switch (intNewView) {
		case 1:
			// Menu
			currentView = [[MenuViewController alloc] initWithNibName:@"MenuViewController" bundle:[NSBundle mainBundle]];
			break;
		case 2:
			// List
			currentView = [[ListViewController alloc] initWithNibName:@"ListViewController" bundle:[NSBundle mainBundle]];
			// currentView = [ListViewController sharedManager];
			break;
		case 3:
			// Map
			// currentView = [[TabBarViewController alloc] initWithNibName:@"TabBarViewController" bundle:nil];
			// currentView = [[MapViewController alloc] initWithNibName:@"MapViewController" bundle:nil];
			currentView = [[AddressViewController alloc] initWithNibName:@"AddressViewController" bundle:[NSBundle mainBundle]];
			break;
		case 4:
			// Images
			currentView = [[GalleryViewController alloc] initWithNibName:@"GalleryViewController" bundle:[NSBundle mainBundle]];
			break;
		case 5:
			// Web
			currentView = [[WebViewController alloc] initWithNibName:@"WebViewController" bundle:[NSBundle mainBundle]];
			break;
		case 6:
			// Video
			currentView = [[VideoViewController alloc] initWithNibName:@"VideoViewController" bundle:[NSBundle mainBundle]];
			break;
		case 7:
			// Detail
			currentView = [[DetailViewController alloc] initWithNibName:@"DetailViewController" bundle:[NSBundle mainBundle]];
			break;
		case 8:
			// Poll
			currentView = [[PollViewController alloc] initWithNibName:@"PollViewController" bundle:[NSBundle mainBundle]];
			// currentView = [[PollResultsViewController alloc] initWithNibName:@"PollResultsViewController" bundle:nil];
			break;
		case 9:
			// About
			currentView = [[AboutViewController alloc] initWithNibName:@"AboutViewController" bundle:[NSBundle mainBundle]];
			break;
		case 10:
			// tabbar
			currentView = [[TabBarViewController alloc] initWithNibName:@"TabBarViewController" bundle:[NSBundle mainBundle]];
			break;
		case 11:
			// user config
			currentView = [[ConfigViewController alloc] initWithNibName:@"ConfigViewController" bundle:[NSBundle mainBundle]];
			break;
		case 13:
			// Address
			currentView = [[AddressViewController alloc] initWithNibName:@"AddressViewController" bundle:[NSBundle mainBundle]];
			break;
		case 24:
			// Address
			currentView = [[SubmenuViewController alloc] initWithNibName:@"SubmenuViewController" bundle:[NSBundle mainBundle]];
			break;
	}
	currentView.view.frame = CGRectMake(0, 0, 320, 460);
	[self setWantsFullScreenLayout:NO];
	[currentView.view setNeedsLayout];
	[self.view addSubview:currentView.view];
}

@end
