#import "Config.h"


@implementation Config

//@synthesize primaryKey, name, value;

- (void) dealloc {
//	[name release];
//	[value release];
	[super dealloc];
}

/*
-(id)initWithName:(NSString *)n value:(NSString *)v {
	self.name = n;
	self.value = v;
	return self;
}


-(id)initWithPrimaryKey:(NSInteger)i {

	NSString *databaseName;
	NSString *databasePath;
	sqlite3   *database;
	databaseName = @"app_builder.sql";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	if (self = [super init]) {
      primaryKey = i;
			if(sqlite3_open([databasePath UTF8String], &database) == SQLITE_OK) {

        // Compile the query for retrieving book data. See insertNewBookIntoDatabase: for more detail.
        if (init_statement == nil) {
            // Note the '?' at the end of the query. This is a parameter which can be replaced by a bound variable.
            // This is a great way to optimize because frequently used queries can be compiled once, then with each
            // use new variable values can be bound to placeholders.
            const char *sql = "SELECT id, name, value FROM appConfig WHERE id = ?";
            if (sqlite3_prepare_v2(database, sql, -1, &init_statement, NULL) != SQLITE_OK) {
                // NSAssert1(0, @"Error: failed to prepare statement with message '%s'.", sqlite3_errmsg(database));
				NSLog(@"Error: failed to prepare select statement with message '%s'.", sqlite3_errmsg(database));
            }
        }
        // For this query, we bind the primary key to the first (and only) placeholder in the statement.
        // Note that the parameters are numbered from 1, not from 0.
        sqlite3_bind_int(init_statement, 1, primaryKey);
        if (sqlite3_step(init_statement) == SQLITE_ROW) {
            self.name = [NSString stringWithUTF8String:(char *)sqlite3_column_text(init_statement, 1)];
            self.value = [NSString stringWithUTF8String:(char *)sqlite3_column_text(init_statement, 2)];
        } else {
            self.name = @"";
            self.value = @"";
        }
        // Reset the statement for future reuse.
        sqlite3_reset(init_statement);
      }
    }
    return self;
}

-(id)initWithName:(NSString *)n {
	NSString *databaseName;
	NSString *databasePath;
	sqlite3   *database;
	databaseName = @"app_builder.sql";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	if (self = [super init]) {
      name = n;
			if(sqlite3_open([databasePath UTF8String], &database) == SQLITE_OK) {
        // Compile the query for retrieving book data. See insertNewBookIntoDatabase: for more detail.
        if (init_statement == nil) {
            // Note the '?' at the end of the query. This is a parameter which can be replaced by a bound variable.
            // This is a great way to optimize because frequently used queries can be compiled once, then with each
            // use new variable values can be bound to placeholders.
            const char *sql = "SELECT id, name, value FROM appConfig WHERE name=?";
            if (sqlite3_prepare_v2(database, sql, -1, &init_statement, NULL) != SQLITE_OK) {
                // NSAssert1(0, @"Error: failed to prepare statement with message '%s'.", sqlite3_errmsg(database));
				NSLog(@"Error: failed to prepare statement name with message '%s'.", sqlite3_errmsg(database));
            }
        }
        // For this query, we bind the primary key to the first (and only) placeholder in the statement.
        // Note that the parameters are numbered from 1, not from 0.
        sqlite3_bind_text(init_statement, 1, [name UTF8String], -1, SQLITE_TRANSIENT);
        if (sqlite3_step(init_statement) == SQLITE_ROW) {
            self.name = [NSString stringWithUTF8String:(char *)sqlite3_column_text(init_statement, 1)];
            self.value = [NSString stringWithUTF8String:(char *)sqlite3_column_text(init_statement, 2)];
        } else {
            self.value = @"";
        }
        // Reset the statement for future reuse.
        sqlite3_reset(init_statement);
      }
    }
    return self;
}
 
 */



// sql load value
- (NSString *)loadValue:(NSString *)n 
{
	
	// sqlite3_stmt *init_statement = nil;
	sqlite3_stmt *detailStmt = nil;

	NSString *databaseName;
	NSString *databasePath;
	sqlite3  *database;
	NSString *v = @"";
	
	// NSLog(@"connecting...");
	databaseName = @"app_builder.sql";
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	
	// sqlite3 *database;
	if(sqlite3_open([databasePath UTF8String], &database) == SQLITE_OK) {
		
		if(detailStmt == nil) 
		{
			const char *sql = "select value from appConfig where name = ?";
			if(sqlite3_prepare_v2(database, sql, -1, &detailStmt, NULL) != SQLITE_OK) 
			{
				// NSAssert1(0, @"Error while creating detail view statement. '%s'", sqlite3_errmsg(database));
				NSLog(@"Error while creating detail view statement. '%s'", sqlite3_errmsg(database));
			}
		}
		sqlite3_bind_text(detailStmt, 1, [n UTF8String], -1, SQLITE_TRANSIENT);
		
		if(SQLITE_ROW == sqlite3_step(detailStmt)) 
		{
			v = [NSString stringWithUTF8String:(char *)sqlite3_column_text(detailStmt, 0)];
			// NSLog(@"value %@", v);
		} else
			v = @"";
		// else
		// NSAssert1(0, @"Error while getting the price of coffee. '%s'", sqlite3_errmsg(database));
		
		//Reset the detail statement.
		sqlite3_reset(detailStmt);

	}
	sqlite3_close(database);
	
	return v;
}

- (NSInteger)insertValue:(NSString *)n value:(NSString *)v 
{
	NSString *sentence = [NSString stringWithFormat:@"INSERT INTO appConfig (name, value) VALUES('%@', '%@')", n, v];
	[self executeSentence:sentence sentenceIsSelect:NO];
	return 0;
}

- (void)updateValue:(NSString *)n value:(NSString *)v 
{
	//Detect if the given name already exists in the db, otherwise send the insertValue method.
	int nameQty = [self findOutName:n];
	if(nameQty > 0)
	{
		NSString *sentence = [NSString stringWithFormat:@"UPDATE appConfig SET value = '%@' WHERE name = '%@'", v, n];
		[self executeSentence:sentence sentenceIsSelect:NO];
	}
	else
	{
		[self insertValue:n value:v];
	}
}

- (void)deleteValue:(NSString *)n 
{
	NSString *sentence = [NSString stringWithFormat:@"DELETE FROM appConfig WHERE name = '%@'", n];
	[self executeSentence:sentence sentenceIsSelect:NO];
}

- (void)executeSentence:(NSString *)sentence sentenceIsSelect:(BOOL )isSelect
{
	
	// Variables para realizar la consulta
	static sqlite3 *db;     
	sqlite3_stmt *resultado; 
	const char* siguiente;

	NSString *databaseName;
	// NSString *databasePath;
	// sqlite3   *database;
		databaseName = @"app_builder.sql";
	//	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	//	NSString *documentsDir = [documentPaths objectAtIndex:0];
	//	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];

	// Buscar el archivo de base de datos
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    // NSString *path = [documentsDirectory stringByAppendingPathComponent:@"myDB"];
    NSString *path = [documentsDirectory stringByAppendingPathComponent:databaseName];

		
	// Abre el archivo de base de datos
	if (sqlite3_open([path UTF8String], &db) == SQLITE_OK) {		
		
		if (isSelect){				

			// Ejecuta la consulta
			if ( sqlite3_prepare(db,[sentence UTF8String],[sentence length],&resultado,&siguiente) == SQLITE_OK ){

				// Recorre el resultado
				while (sqlite3_step(resultado)==SQLITE_ROW){	
					
					/*
					 NSInteger integer = sqlite3_column_text( resultado, 0);
					NSLog([NSString stringWithFormat:@"ID:%f NAME:%@ INFO:%@",
						   [integer floatValue],
						   [NSString stringWithUTF8String: (char *)sqlite3_column_text(resultado, 1)],	
						   [NSString stringWithUTF8String: (char *)sqlite3_column_text(resultado, 2)] ]						  
						  );
					 */
				}
			}
		}
		else {
			// Ejecuta la consulta
			if ( sqlite3_prepare_v2(db,[sentence UTF8String],[sentence length],&resultado,&siguiente) == SQLITE_OK ){
				sqlite3_step(resultado);				
				sqlite3_finalize(resultado);
			}			
		}
	} 
	// Cierra el archivo de base de datos
	sqlite3_close(db);	
}


- (int)findOutName:(NSString *)n
{
	
	// Variables para realizar la consulta
	static sqlite3 *db;     
	sqlite3_stmt *result; 
	int v = -1;
	
	NSString *databaseName;
	databaseName = @"app_builder.sql";
	/*	NSString *databasePath;
	// sqlite3   *database;
	NSArray *documentPaths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDir = [documentPaths objectAtIndex:0];
	databasePath = [documentsDir stringByAppendingPathComponent:databaseName];
	*/
	// Buscar el archivo de base de datos
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsDirectory = [paths objectAtIndex:0];
    // NSString *path = [documentsDirectory stringByAppendingPathComponent:@"myDB"];
    NSString *path = [documentsDirectory stringByAppendingPathComponent:databaseName];
	
//	NSString *sentence = @"select ISNULL(COUNT(*), -1) FROM appConfig WHERE name = ?";
	NSString *sentence = @"select COUNT(*) from appConfig where name = ?";
	
	// Abre el archivo de base de datos
	if (sqlite3_open([path UTF8String], &db) == SQLITE_OK) 
	{		
			// Ejecuta la consulta
		if ( sqlite3_prepare_v2(db,[sentence UTF8String],[sentence length],&result,NULL) == SQLITE_OK )
		{
			sqlite3_bind_text(result, 1, [n UTF8String], -1, SQLITE_TRANSIENT);

			if(SQLITE_ROW == sqlite3_step(result)) 
			{
				v = sqlite3_column_int(result, 0);
			}
			else
				v = -1;
			
			sqlite3_finalize(result);
		}
	} 
	// Cierra el archivo de base de datos
	sqlite3_close(db);	
	
	return v;
}




@end