//
//  WebServiceHelper.m
//  app_builder
//
//  Created by IVAN BEJARANO on 9/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "WebServiceHelper.h"


@implementation WebServiceHelper

@synthesize webData;
@synthesize delegate;
@synthesize callback;
@synthesize errorCallback;

/*
url - string url of web service (including .asmx)
methodName - string methodname(operation) of webservice
keys = parameters of web service
objects = values of each parameter in web service

example:


NSArray *keys = [NSArray arrayWithObjects:@"USZip", nil];
NSArray *keyvalues = [NSArray arrayWithObjects:@"11235", nil];


[self generateWebServiceURLRequest: @"http://www.mywebsite.com/mywebservice.asmx" : @"getMyData": keys: keyvalues]

* /
+(NSURLRequest *) generateWebServiceURLRequest : (NSString *) url: (NSString *) methodName: (NSArray *) keys: (NSArray *) objects
{
	NSDictionary *params = [NSDictionary dictionaryWithObjects:objects forKeys:keys];
	
	NSString *newMethodName;
	
	// We need to start the methodName with a / - since we are using GET Request method
	newMethodName = @"/";
	newMethodName = [newMethodName stringByAppendingString: methodName];
	
	url=[url stringByAppendingString:newMethodName];
	
	BOOL firstKey=TRUE;
	for (NSString *key in params)
	{
		NSString *value=[params objectForKey:key];
		if (firstKey) url=[url stringByAppendingString:@"?"]; else url=[url stringByAppendingString:@"&"];
		url=[url stringByAppendingString:key];
		url=[url stringByAppendingString:@"="];
		url=[url stringByAppendingString:value];
		firstKey=FALSE;
	}
	
	NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:url]
											  cachePolicy:NSURLRequestUseProtocolCachePolicy
										  timeoutInterval:60.0];
	
	return theRequest;
}


+(NSURL *) generateWebServiceHTTPGetURL : (NSString *) url: (NSString *) methodName: (NSArray *) keys: (NSArray *) objects
{
	NSDictionary *params = [NSDictionary dictionaryWithObjects:objects forKeys:keys];
	
	NSString *newMethodName;
	
	NSURL *resultURL;
	
	// We need to start the methodName with a / - since we are using GET Request method
	newMethodName = @"/";
	newMethodName = [newMethodName stringByAppendingString: methodName];
	
	NSLog(@"generateWebServiceHTTPGetURL: newMethodName: %@",newMethodName);
	
	url=[url stringByAppendingString:newMethodName];
	
	BOOL firstKey=TRUE;
	for (NSString *key in params)
	{
		NSString *value=[params objectForKey:key];
		if (firstKey) url=[url stringByAppendingString:@"?"]; else url=[url stringByAppendingString:@"&"];
		url=[url stringByAppendingString:key];
		url=[url stringByAppendingString:@"="];
		url=[url stringByAppendingString:value];
		firstKey=FALSE;
	}
	
	NSLog(@"generateWebServiceHTTPGetURL: URL: %@",(NSString *)url);
	
	resultURL = [NSURL URLWithString:url];
	
	return resultURL;
}
*/

// -(void)callWebService:(NSString *)url delegate:(id)requestDelegate requestSelector:(SEL)requestSelector {
-(void)callWebService:(NSString *)url 
		   methodName:(NSString *)methodName keys:(NSArray *)keys values:(NSArray *)keyvalues 
			delegate:(id)requestDelegate requestSelector:(SEL)requestSelector {

	self.delegate = requestDelegate;
	self.callback = requestSelector;

	NSString * webService = url; // @"http://widgets.isg-marketing.com/mcgrawhill_mobile/mh_mobile_convert_rss.asmx";
	// NSString * methodName = methodName; @"ConvertRSS";
	// NSArray *keys = [NSArray arrayWithObjects:@"strFileName",@"bInDebug", nil];
	// NSArray *keyvalues = [NSArray arrayWithObjects:url,@"true", nil];	
	
	NSURL *myWebserverURL = [NSURL URLWithString:webService];

	NSDictionary *params = [NSDictionary dictionaryWithObjects:keyvalues forKeys:keys];
	NSString *vars = @""; // [[NSString alloc] ;
	for (NSString *key in params)
	{
		NSString *value=[params objectForKey:key];
		// NSString *data = [NSString stringWithFormat: @"<%@><![CDATA[%@]]></%@>", key, value, key];
		NSString *data = [NSString stringWithFormat: @"<%@>%@</%@>", key, value, key];
		vars=[vars stringByAppendingString:data];
	}
	
	NSMutableString *sRequest = [[NSMutableString alloc]init];
	//create soap envelope
	[sRequest appendString:@"<?xml version=\"1.0\" encoding=\"utf-8\"?>"];
	[sRequest appendString:@"<soap:Envelope xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\" xmlns:soap=\"http://schemas.xmlsoap.org/soap/envelope/\">"];
	[sRequest appendString:@"<soap:Body>"];
	[sRequest appendString:[NSString stringWithFormat: @"<%@ xmlns=\"%@\">", methodName, @"http://tempuri.org/"]];
	[sRequest appendString:[NSString stringWithFormat: @"%@", vars]];
	[sRequest appendString:[NSString stringWithFormat: @"</%@>", methodName]];
	[sRequest appendString:@"</soap:Body>"];
	[sRequest appendString:@"</soap:Envelope>"];
	NSLog(@"req %@", sRequest);
	
	[self request:myWebserverURL:sRequest:methodName];
    [sRequest release];
}

-(void)request:(NSURL *) url: (NSString *) xmlRequest: (NSString *) methodName {
	
	request = [[NSMutableURLRequest alloc] initWithURL:url];
	[request addValue:@"text/xml; charset=utf-8" forHTTPHeaderField:@"Content-Type"];
	[request addValue:@"widgets.isg-marketing.com" forHTTPHeaderField:@"Host"];
	// [request addValue:[NSString stringWithFormat:@"%@/%@", url, methodName] forHTTPHeaderField:@"SOAPAction"];//this is default tempuri.org, I changed mine in the project
	[request addValue:[NSString stringWithFormat:@"http://tempuri.org/%@", methodName] forHTTPHeaderField:@"SOAPAction"];
	
	NSString *contentLengthStr = [NSString stringWithFormat:@"%d", [xmlRequest length]];
	
	// [request addValue:contentLengthStr forHTTPHeaderField:@"Content-Length"];
	[request setValue:contentLengthStr forHTTPHeaderField:@"Content-Length"];
	// Set the action to Post
	[request setHTTPMethod:@"POST"];
	// Set the body
	[request setHTTPBody:[xmlRequest dataUsingEncoding:NSUTF8StringEncoding]];
	
	theConnection = [[NSURLConnection alloc] initWithRequest:request delegate:self];
	
	if (theConnection) {
		webData = [[NSMutableData data] retain];
	} else {
		NSLog(@"Error in Conection");
	}
}

- (void)connection:(NSURLConnection *)connection didReceiveAuthenticationChallenge:(NSURLAuthenticationChallenge *)challenge {
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	[webData setLength:0];
}

- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	// NSLog([[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding]);
	[webData appendData:data];
}

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error{
	[connection release];
	[webData release];
	[request release];
	NSLog(@"Conexion Fallida! Error - %@ %@",
		  [error localizedDescription],
		  [[error userInfo] objectForKey:NSURLErrorFailingURLStringErrorKey]); // NSErrorFailingURLStringKey]);
	if(errorCallback) {
		[delegate performSelector:errorCallback withObject:error];
	}
}

- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
	if(delegate && callback) {
		if([delegate respondsToSelector:self.callback]) {
			[delegate performSelector:self.callback withObject:webData];
		} else {
			NSLog(@"No response from delegate");
		}
	}
	[connection release];
	[webData release];
	[request release];
}

-(void) dealloc {
	[super dealloc];
}

@end
