/*
 
 Copyright (c) 2010, Mobisoft Infotech
 All rights reserved.
 
 Redistribution and use in source and binary forms, with or without modification, are
 permitted provided that the following conditions are met:
 
 Redistributions of source code must retain the above copyright notice, this list of
 conditions and the following disclaimer.
 
 Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation and/or
 other materials provided with the distribution.
 
 Neither the name of Mobisoft Infotech nor the names of its contributors may be used to
 endorse or promote products derived from this software without specific prior written permission.
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
 OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
 OF SUCH DAMAGE.
 
 */

#import "MIRadioButtonGroup.h"
#import "Functions.h"
#import "FontItem.h"

@implementation MIRadioButtonGroup
@synthesize radioButtons;
@synthesize fontStyle;

- (id)initWithFrame:(CGRect)frame andOptions:(NSArray *)options andColumns:(int)columns
{
	
	NSMutableArray *arrTemp =[[NSMutableArray alloc]init];
	self.radioButtons =arrTemp;
	[arrTemp release];
    if ((self = [super initWithFrame:frame])) {
        // Initialization code
		int framex =0;
		framex= frame.size.width/columns;
		int framey = 0;
		framey =frame.size.height/([options count]/(columns));
		int rem =[options count]%columns;
		if(rem !=0){
			framey = frame.size.height/(([options count]/columns)+1);
		}
		int k = 0;
		for(int i=0;i<([options count]/columns);i++){
			for(int j=0;j<columns;j++){
				
				int x = 20; // framex*0.25;
				int y = 50; // framey*0.25;

				NSLog(@"framex : %i %i", framey,framey/2+y);

				UIButton *btTemp = [[UIButton alloc]initWithFrame:CGRectMake(framex*j+x, /*framey**/i+y, framex/columns-(x*2), framey)];
				[btTemp addTarget:self action:@selector(radioButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
				btTemp.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
				[btTemp setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
				[btTemp setImage:[Functions resizeImage:[UIImage imageNamed:@"radio-off.png"] width:40 height:40] forState:UIControlStateNormal];

				
				[btTemp setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
				/*btTemp.titleLabel.font =[UIFont systemFontOfSize:14.f];
				btTemp.titleLabel.frame = CGRectMake(0, 0, 300, 50); //framex/columns-(x*2), framey);
				btTemp.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
				btTemp.titleLabel.numberOfLines = 3;
				[btTemp.titleLabel setBackgroundColor:[UIColor blueColor]];*/
				[btTemp setTitle:[options objectAtIndex:k] forState:UIControlStateNormal];
				/*btTemp.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
										  | UIViewAutoresizingFlexibleRightMargin 
										  | UIViewAutoresizingFlexibleLeftMargin 
										  | UIViewAutoresizingFlexibleTopMargin 
										  | UIViewAutoresizingFlexibleWidth);
				
				*/
				[self.radioButtons addObject:btTemp];
				[self addSubview:btTemp];
				// [btTemp setBackgroundColor:[UIColor redColor]];
		        [btTemp release];
				k++;
				
			}
		}
		/*
		for(int j=0;j<rem;j++) {

			int x = framex*0.25;
			int y = framey*0.25;
			UIButton *btTemp = [[UIButton alloc]initWithFrame:CGRectMake(framex*j+x, framey*([options count]/columns), framex/2+x, framey/2+y)];
			[btTemp addTarget:self action:@selector(radioButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
			btTemp.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
			[btTemp setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
			[btTemp setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
			btTemp.titleLabel.font =[UIFont systemFontOfSize:14.f];
			[btTemp setTitle:[options objectAtIndex:k] forState:UIControlStateNormal];
			[self.radioButtons addObject:btTemp];
			[self addSubview:btTemp];
			[btTemp release];
			k++;

		}*/

        actualSel = -1;
	}
    return self;
}

- (void)dealloc {
	[radioButtons release];
    [super dealloc];
}

-(IBAction) radioButtonClicked:(UIButton *) sender{
	for(int i=0;i<[self.radioButtons count];i++){
		if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
			[[self.radioButtons objectAtIndex:i] setImage:[Functions resizeImage:[UIImage imageNamed:@"radio-off.png"] width:50 height:50] forState:UIControlStateNormal];
		else
			[[self.radioButtons objectAtIndex:i] setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
		
		if ([[self.radioButtons objectAtIndex:i] isEqual:sender]) 	actualSel = i;
	}
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
		[sender setImage:[Functions resizeImage:[UIImage imageNamed:@"radio-on.png"] width:50 height:50] forState:UIControlStateNormal];
	else
		[sender setImage:[UIImage imageNamed:@"radio-on.png"] forState:UIControlStateNormal];

}

-(void) removeButtonAtIndex:(int)index{
	[[self.radioButtons objectAtIndex:index] removeFromSuperview];
	[self.radioButtons removeObjectAtIndex: index];

}

-(void) setSelected:(int) index{
	for(int i=0;i<[self.radioButtons count];i++){
		[[self.radioButtons objectAtIndex:i] setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
		
	}
	actualSel = index;
	[[self.radioButtons objectAtIndex:index] setImage:[UIImage imageNamed:@"radio-on.png"] forState:UIControlStateNormal];


}

-(void)clearAll{
	for(int i=0;i<[self.radioButtons count];i++){
		[[self.radioButtons objectAtIndex:i] setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
		
	}

}

// bh
-(int) getSelected
{
	return actualSel;
}

-(int) total
{
	NSLog(@"?? %@", radioButtons);
	return [radioButtons count];
}

-(void)removeAll
{
int i=[self.radioButtons count]-1;
	while (i > -1) {
		
		[self removeButtonAtIndex:i];
		i--;
	}
	NSMutableArray *arrTemp =[[NSMutableArray alloc]init];
	self.radioButtons =arrTemp;
	[arrTemp release];
	actualSel = -1;
}


-(void) createButtons:(NSArray *)options withColumns:(int)columns
{
	CGRect frame = self.frame;
	int framex =0;
	framex= frame.size.width/columns;
	int framey = 0;
	framey = 50; // frame.size.height/([options count]/(columns));
	int rem =[options count]%columns;
	if(rem !=0){
		framey = 50; //frame.size.height/(([options count]/columns)+1);
	}
	int k = 0;

	FontItem * font = [Functions loadFont:fontStyle]; 
    NSString * titleFont = font.nameFont;
    NSString * titleSize = font.sizeFont;  
    NSString * titleColor = font.colorFont;
    NSString * titleStyle = font.styleFont;
    if (titleFont != nil)
		titleFont = [Functions fontName:titleFont fontStyle:titleStyle];


	for(int i=0;i<([options count]/columns);i++){
		for(int j=0;j<columns;j++){
			
			int x = 20; // framex*0.25;
			int y = framey*0.25;
			
			NSLog(@"framex : %i %i", framey,framey/2+y);
			
			UIButton *btTemp = [[UIButton alloc]initWithFrame:CGRectMake(framex*j+x, framey*i+y, framex/columns-(x*2), framey)];
			[btTemp addTarget:self action:@selector(radioButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
			btTemp.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
			[btTemp setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
			if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad)
			[btTemp setImage:[Functions resizeImage:[UIImage imageNamed:@"radio-off.png"] width:50 height:50] forState:UIControlStateNormal];
			[btTemp setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
			btTemp.titleLabel.font =[UIFont systemFontOfSize:14.f];
			// btTemp.titleLabel.frame = CGRectMake(10, 10, 100, 100); //framex/columns-(x*2), framey);
			btTemp.titleLabel.lineBreakMode = UILineBreakModeWordWrap;
			btTemp.titleLabel.numberOfLines = 3;
			if (titleFont != nil) {
				[btTemp.titleLabel setFont:[UIFont fontWithName:titleFont size:[titleSize intValue]]];
				[btTemp setTitleColor:[Functions colorForHex:titleColor] forState:UIControlStateNormal];
			}
			// [btTemp.titleLabel setBackgroundColor:[UIColor blueColor]];
			// [btTemp.titleLabel setBackgroundColor:[Functions colorForHex:[NSString stringWithFormat:@"00%i%i%i%i", i+2, i, i+3, i]]];
			[btTemp setTitle:[options objectAtIndex:k] forState:UIControlStateNormal];
			[self.radioButtons addObject:btTemp];

			btTemp.autoresizingMask = (UIViewAutoresizingFlexibleBottomMargin 
									   | UIViewAutoresizingFlexibleRightMargin 
									   | UIViewAutoresizingFlexibleLeftMargin 
									   | UIViewAutoresizingFlexibleTopMargin 
									   | UIViewAutoresizingFlexibleWidth);			
			[self addSubview:btTemp];
			// [btTemp setBackgroundColor:[UIColor redColor]];
			// [btTemp setBackgroundColor:[Functions colorForHex:[NSString stringWithFormat:@"00%i%i%i%i", i+1, i+2, i+4, i+3]]];
			[btTemp release];
			k++;
			
		}
	}
/*
	for(int j=0;j<rem;j++) {
		
		int x = framex*0.25;
		int y = framey*0.25;
		UIButton *btTemp = [[UIButton alloc]initWithFrame:CGRectMake(framex*j+x, framey*([options count]/columns), framex/2+x, framey/2+y)];
		[btTemp addTarget:self action:@selector(radioButtonClicked:) forControlEvents:UIControlEventTouchUpInside];
		btTemp.contentHorizontalAlignment = UIControlContentHorizontalAlignmentLeft;
		[btTemp setImage:[UIImage imageNamed:@"radio-off.png"] forState:UIControlStateNormal];
		[btTemp setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
		btTemp.titleLabel.font =[UIFont systemFontOfSize:14.f];
		[btTemp setTitle:[options objectAtIndex:k] forState:UIControlStateNormal];
		[self.radioButtons addObject:btTemp];
		[self addSubview:btTemp];
		[btTemp release];
		k++;
		
	}*/
	
}

// bh

@end
