//
//  SilLoginPrompt.m
//  Alert login window
//
//  Created by Byron Herrera on 4/20/11.
//  Copyright 2011 Silencesoft. All rights reserved.
//

#import "SilLoginPrompt.h"
// #import <QuartzCore/QuartzCore.h>

@implementation SilLoginPrompt

@synthesize textUser, textPassword;
@synthesize userName, userPassword;

-(id) initWithTitle:(NSString *)title message:(NSString *)message delegate:(id)delegate cancelButtonTitle:(NSString *)cancelButtonTitle 
	  okButtonTitle:(NSString *)okButtonTitle fieldNumber: (int) fields {
	if (self = [super initWithTitle:title message:message delegate:delegate cancelButtonTitle:cancelButtonTitle otherButtonTitles:okButtonTitle, nil])
	{

		UITextField *textField = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 70.0, 260.0, 25.0)]; 
		[textField setBackgroundColor:[UIColor whiteColor]]; 
		[textField setPlaceholder:@"Username"];
		textField.autocorrectionType = UITextAutocorrectionTypeNo;
		/*
        textField.textAlignment = UITextAlignmentCenter;
		textField.backgroundColor = [UIColor whiteColor];
		textField.borderStyle = UITextBorderStyleRoundedRect;
		textField.layer.cornerRadius = 8.0f;
		textField.layer.masksToBounds = YES;
		textField.layer.borderColor = [[UIColor blackColor] CGColor];
		textField.layer.borderWidth = 1.0f;
		 */
		[textField setBorderStyle:UITextBorderStyleRoundedRect];
		[textField setBackgroundColor:[UIColor clearColor]]; 
		[self addSubview:textField];
		self.textUser = textField;
		[textField release];

		if (fields == 2) 
		{
			textField = [[UITextField alloc] initWithFrame:CGRectMake(12.0, 95.0, 260.0, 25.0)]; 
			[textField setBackgroundColor:[UIColor whiteColor]]; 
			[textField setPlaceholder:@"Password"];
			[textField setSecureTextEntry:YES];
			[textField setBorderStyle:UITextBorderStyleRoundedRect];
			[textField setBackgroundColor:[UIColor clearColor]]; 
			[self addSubview:textField];
			self.textPassword = textField;
			[textField release];
		}
		
		self.message = [NSString stringWithFormat:@"%@\n\n", message];
		if (fields == 2) 
			self.message = [NSString stringWithFormat:@"%@\n", self.message];
			
	}
	return self;
}

- (void)show
{
	[textUser becomeFirstResponder];
	[super show];
}

-(void) setUserText: (NSString *)userText;
{
	textUser.text = userText;
}

-(void) setUserPlaceholder: (NSString *)placeholder
{
	[textUser setPlaceholder:placeholder];
}

-(void) setPassPlaceholder: (NSString *)placeholder
{
	[textPassword setPlaceholder:placeholder];
}

- (NSString *)userName
{
	return textUser.text;
}

- (NSString *)userPassword
{
	return textPassword.text;
}

- (void)dealloc
{
	[textUser release];
	[textPassword release];
	[super dealloc];
}

@end
