//
//  SilSplitViewController.h
//  Custom Split View
//
//  Created by Byron Herrera on 11/23/11.
//  Copyright 2011 Silencesoft. All rights reserved.
//

#import "SilSplitViewController.h"

static int MV_WIDTH  = 320.0;	// Main view width
static int SV_GAP    =   2.0;	// Gap size
static int SB_HEIGHT =  0.0;	// Status bar height

@implementation SilSplitViewController

@synthesize leftController,rightController;

- (SilSplitViewController*) initwithLeftVC:(UIViewController*)leftvc rightVC:(UIViewController*)rightvc
{
	if(self=[super init])
	{
        /*UINavigationController *lnc=[[UINavigationController alloc] initWithRootViewController:leftvc];
		lnc.navigationBarHidden=NO;
		self.leftController=lnc;
		[lnc release];
		
		UINavigationController *rnc=[[UINavigationController alloc] initWithRootViewController:rightvc];
		rnc.navigationBarHidden=NO;
		self.rightController=rnc;
		[rnc release];*/
        self.leftController = leftvc;
        self.rightController = rightvc;
        
	}
	return self;
}

//---------------------------------------------------------------------------------------- viewDidLoad
- (void)viewDidLoad 
{ 
	[super viewDidLoad];
	self.view.autoresizesSubviews=YES;
	self.view.backgroundColor=[UIColor blackColor];
	
	// [self.leftController viewDidLoad];
	[self.view addSubview:self.leftController.view];
	
	// [self.rightController viewDidLoad];
	[self.view addSubview:self.rightController.view];
}

//---------------------------------------------------------------------------------------- viewDidAppear
- (void)viewDidAppear:(BOOL)animated 
{	
	self.leftController.view.frame=CGRectMake(0,SB_HEIGHT,MV_WIDTH,self.view.frame.size.height-SB_HEIGHT);
	self.leftController.view.frame=CGRectMake(0,0,320,self.view.frame.size.height);
	[self.leftController viewDidAppear:animated];
	[self.view addSubview:self.leftController.view];
	
	self.rightController.view.frame=CGRectMake(MV_WIDTH+SV_GAP,SB_HEIGHT,self.view.frame.size.width-MV_WIDTH-SV_GAP,self.view.frame.size.height-SB_HEIGHT);
	self.rightController.view.frame=CGRectMake(MV_WIDTH+SV_GAP,0,self.view.frame.size.width-MV_WIDTH-SV_GAP,self.view.frame.size.height);
	[self.rightController viewDidAppear:animated];
	[self.view addSubview:self.rightController.view];
}

//---------------------------------------------------------------------------------------- viewWillAppear
- (void)viewWillAppear:(BOOL)animated 
{
	// [super viewWillAppear:animated];
	
	[self layoutViews:UIInterfaceOrientationPortrait initialVerticalOffset:SB_HEIGHT];
	
	[self.leftController viewWillAppear:animated];
	[self.rightController viewWillAppear:animated];
}

- (void)layoutSubviews 
{
	
}

//---------------------------------------------------------------------------------------- layoutViews
- (void)layoutViews:(UIInterfaceOrientation)orientation initialVerticalOffset:(float)offset {
	
	self.leftController.view.autoresizingMask=UIViewAutoresizingFlexibleHeight;
	
	//dvc.view.autoresizingMask=UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth;
	
	// get split view frame size, ..for things like a tab bar
	CGRect svf = self.view.frame;
	//
	// currently, starting the app in portrait mode and a status bar will fail to offset the view
	// this takes care of the problem, but it's not the way i like to code
	//
	if (offset > 0.0) 
	{
		svf.origin.y = offset;
		[self.view setFrame:svf];
	}
	return;
	CGRect mvf = self.leftController.view.frame;
	CGRect dvf = self.rightController.view.frame;
	
	mvf.origin.x		= 0;
	mvf.origin.y		= SB_HEIGHT;
	mvf.size.width  = MV_WIDTH;
	mvf.size.height = svf.size.height;
	
	[self.leftController.view setFrame:mvf];
	
	if (orientation==UIInterfaceOrientationLandscapeLeft || orientation==UIInterfaceOrientationLandscapeRight) {
		return; // the detail view will be properly sized, so don't mess with it
	}
    
	dvf.origin.x		= MV_WIDTH + SV_GAP;
	dvf.origin.y		= SB_HEIGHT;
	dvf.size.width	= svf.size.width - MV_WIDTH - SV_GAP;
	dvf.size.height = svf.size.height;
	
	[self.rightController.view setFrame:dvf];
}

//
//
// ROTATION
//
//---------------------------------------------------------------------------------------- shouldAutorotateToInterfaceOrientation
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation 
{
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {      
		return YES;
	} else {
		return (toInterfaceOrientation==UIInterfaceOrientationPortrait); //
	}
	//return ([self.leftController shouldAutorotateToInterfaceOrientation:toInterfaceOrientation] && [self.rightController shouldAutorotateToInterfaceOrientation:toInterfaceOrientation]);
}

//---------------------------------------------------------------------------------------- didRotateFromInterfaceOrientation
- (void)didRotateFromInterfaceOrientation:(UIInterfaceOrientation)fromInterfaceOrientation 
{
	[self.leftController didRotateFromInterfaceOrientation:fromInterfaceOrientation];
	[self.rightController didRotateFromInterfaceOrientation:fromInterfaceOrientation];
}

//---------------------------------------------------------------------------------------- willAnimateRotationToInterfaceOrientation
- (void)willRotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation duration:(NSTimeInterval)duration 
{
	[self.leftController willRotateToInterfaceOrientation:toInterfaceOrientation duration:duration];
	[self.rightController willRotateToInterfaceOrientation:toInterfaceOrientation duration:duration];
}

//
//
// CLEANUP
//
//---------------------------------------------------------------------------------------- didReceiveMemoryWarning
- (void)didReceiveMemoryWarning 
{
    // Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

//---------------------------------------------------------------------------------------- viewDidUnload
- (void)viewDidUnload 
{
	[super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

//---------------------------------------------------------------------------------------- dealloc
- (void)dealloc 
{
	[leftController release];
	[rightController release];
	[super dealloc];
}

@end
